<?php
  /**
   * Init
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');
?>
<?php error_reporting(E_ALL);

	date_default_timezone_set('America/Argentina/Buenos_Aires');
	set_time_limit(0);
	ini_set('memory_limit', '-1');
	ini_set('max_execution_time', 600);
	ini_set('fastcgi_read_timeout', 600);
	ini_set('session.gc_maxlifetime', 3*60*60); // 3 hours
	ini_set('session.gc_probability', 0);
	ini_set('session.gc_divisor', 100);
	ini_set('session.cookie_secure', false);
	ini_set('session.use_only_cookies', true);
  
  if (substr(PHP_OS, 0, 3) == "WIN") {
      $BASEPATH = str_replace("init.php", "", realpath(__FILE__));
  } else {
      $BASEPATH = str_replace("init.php", "", realpath(__FILE__));
  }
  define("BASEPATH", $BASEPATH);
  
  $configFile = BASEPATH . "lib/config.ini.php";
  
  if (file_exists($configFile)) {
      require_once($configFile);
  } else {
      header("Location: _error/");
  }
  
  require_once(BASEPATH . "lib/class_db.php");
  
  require_once(BASEPATH . "lib/class_registry.php");
  Registry::set('Database',new Database(DB_SERVER, DB_USER, DB_PASS, DB_DATABASE));
  $db = Registry::get("Database");
  $db->connect();

  //Include Functions
  require_once(BASEPATH . "lib/functions.php");
  include(BASEPATH . "lib/headerRefresh.php");
  
  require_once(BASEPATH . "lib/class_filter.php");
  $request = new Filter();  
  
  //Start Core Class 
  require_once(BASEPATH . "lib/class_core.php");
  Registry::set('Core',new Core());
  $core = Registry::get("Core");
  
  //StartUser Class 
  require_once(BASEPATH . "lib/class_usuario.php");
  Registry::set('Usuario',new Usuario());
  $usuario = Registry::get("Usuario");

  //Load Gestao
  require_once(BASEPATH . "lib/class_gestao.php");
  Registry::set('Gestao',new Gestao());
  $gestao = Registry::get("Gestao");
  
  //Load Financeiro
  require_once(BASEPATH . "lib/class_despesa.php");
  Registry::set('Despesa',new Despesa());
  $despesa = Registry::get("Despesa");
  
  //Load Financeiro
  require_once(BASEPATH . "lib/class_faturamento.php");
  Registry::set('Faturamento',new Faturamento());
  $faturamento = Registry::get("Faturamento");
  
  //Load Tabela
  require_once(BASEPATH . "lib/class_tabela.php");
  Registry::set('Tabela',new Tabela());
  $tabela = Registry::get("Tabela");
  
  //Load Cadastro
  require_once(BASEPATH . "lib/class_cadastro.php");
  Registry::set('Cadastro',new Cadastro());
  $cadastro = Registry::get("Cadastro");
  
  //Load Paciente
  require_once(BASEPATH . "lib/class_paciente.php");
  Registry::set('Paciente',new Paciente());
  $paciente = Registry::get("Paciente");

  //Load Extrato
  require_once(BASEPATH . "lib/class_extrato.php");
  Registry::set('Extrato',new Extrato());
  $extrato = Registry::get("Extrato");

  //Load Empresa
  require_once(BASEPATH . "lib/class_empresa.php");
  Registry::set('Empresa',new Empresa());
  $empresa = Registry::get("Empresa");

  //Load Atendimento
  require_once(BASEPATH . "lib/class_atendimento.php");
  Registry::set('Atendimento',new Atendimento());
  $atendimento = Registry::get("Atendimento");
  
  $sistemaurl = (isset($_SERVER['SERVER_NAME'])) ? $_SERVER['SERVER_NAME'] : $core->site_url;
  define("SISTEMAURL", $sistemaurl);
  define("SITEURL", $core->site_url);
  define("ADMINURL", $core->site_url);
  define("UPLOADS", BASEPATH."uploads/data/");
  define("UPLOADSHTML", "./uploads/data/");
  define("UPLOADS_SLIDES", BASEPATH."painel/slides/");
  define("UPLOADSHTML_SLIDES", "./painel/slides/");
  define("UPLOADURL", SITEURL."/uploads/");
?>