<?php
  /**
   * Classe Atendimento
   *
   * @package Sistemas Divulgao Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe no  permitido.');

  class Atendimento
  {
      const uTable = "atendimento";
      public $did = 0;
      public $medicoid = 0;
      private static $db;
      private static $cancelado;

      /**
       * Atendimento::__construct()
       * 
       * @return
       */
      function __construct()
      {
          self::$db = Registry::get("Database");
		  $id_empresa = (session('idempresa')) ? session('idempresa') : 1;
		  self::$cancelado = getValue('cancelado', 'empresa', 'id='.$id_empresa);
      }
	  
	/**
	* Atendimento::processarAtendimento()
	   * REALIZADO = 0 - AGENDADO
	   * REALIZADO = 1 - REALIZADO
	   * REALIZADO = 2 - LIBERADO / CHEGADA
	   * REALIZADO = 3 - CONFIRMADO
	   * REALIZADO = 6 - CHAMADA
	   * REALIZADO = 8 - BLOQUEADA
	   * REALIZADO = 9 - CANCELADO
	   * 
	   * ID_LOTE: LOTE ENVIADO
	   * PAGO_LOTE: LOTE RECEBIDO
	   *
	   * GUIA: 1 - GUIA AGENDADA
	   * GUIA: 2 - GUIA AGUARDANDO AGENDAMENTO
	   *
	   * REPASSE: 0 - PRODUO PENDENTE
	   * REPASSE: 1 - PRODUO PAGA
	   * REPASSE: 2 - PRODUO LIBERADA PARA PAGAMENTO
	   * 
	   * RETORNO: 1 - RETORNO DO ATENDIMENTO REALIZADO
	   * RETORNO: 2 - ATENDIMENTO FOI UM RETORNO
	   * RETORNO: 9 - ATENDIMENTO TEM UM RETORNO PARA REALIZAR
	   * @return
	*/	
	public function processarAtendimento()
	{
		  $guia = 0;
		  $id_guia = 0;
		  $id_especialidade = 0;
		  $aviso = "";
		  $id_empresa = (post('id_empresa')) ? post('id_empresa') : session('idempresa');
		  $duasagendas = getValue('duasagendas', 'empresa', 'id='.$id_empresa);
		  $id_paciente = sanitize(post('id_paciente'));
		  $id_medico = post('id_medico');
		  $id_tabela = post('id_tabela');
		  $id_convenio = post('id_convenio');
		  $agenda_livre = post('agenda_livre');
		  $data_agenda = dataMySQL(post('data_agenda'));
		  
		  if($agenda_livre) {
			  if (empty($_POST['hora_agenda'])) {
				  Filter::$msgs['hora_agenda'] = lang('MSG_ERRO_HORA'); 
			  } else {
				  $hora_agenda = post('hora_agenda');
				  $data_agenda = $data_agenda.' '.$hora_agenda;
			  }
		  }

		  if (empty($_POST['bloqueio'])) {
			  if (empty($_POST['id_paciente'])) {				  
				  if (empty($_POST['nome']))
					  Filter::$msgs['nome'] = lang('MSG_ERRO_NOME'); 
			  }
			  
			  if (empty($_POST['data_agenda']))
				  Filter::$msgs['data_agenda'] = lang('MSG_ERRO_DATA');  
			  
			  if (empty($_POST['id_medico']))
				  Filter::$msgs['id_medico'] = lang('MSG_ERRO_MEDICO');  
			  
			  if (empty($_POST['id_tabela'])) {
				  Filter::$msgs['id_tabela'] = lang('MSG_ERRO_PROCEDIMENTO'); 
			  } else {
				  $guia = getValue('guia', 'tabela', 'id='.$id_tabela);
				  $id_especialidade = getValue('id_especialidade', 'tabela', 'id='.$id_tabela);
				  if($guia) {
					$id_guia = ($id_paciente) ? $this->verificarGuia($id_paciente, $id_tabela, $id_convenio) : 0;
					if($id_guia == 0) {
						$aviso = lang('MSG_ERRO_SEM_GUIA');
					}
				  }
			  }
		  }
		  $whereagenda = ($duasagendas) ? " WHERE realizado not in (1,9) AND data_agenda > CURDATE() AND id_paciente = '$id_paciente' AND bloqueio = 0 AND id_tabela = '$id_tabela' " : " WHERE realizado <> 9 AND bloqueio = 0 AND id_medico = '$id_medico' AND data_agenda = '$data_agenda' ";
		  $sql = "SELECT id_paciente, id_medico, data_agenda FROM atendimento $whereagenda ";
		  $row = self::$db->first($sql);
		  if ($row) {
			if($duasagendas) {
				$nome_medico = getValue('nome', 'usuario', 'id='.$row->id_medico);
				$mensagem = str_replace("[DATA]", exibedataHora($row->data_agenda), lang('MSG_ERRO_AGENDA_DUAS'));
				$mensagem = str_replace("[MEDICO]", $nome_medico, $mensagem);
				Filter::$msgs['agenda'] = $mensagem;
			} else {
				$nome_paciente = getValue('nome', 'paciente', 'id='.$row->id_paciente);
				Filter::$msgs['agenda'] = str_replace("[NOME]", $nome_paciente, lang('MSG_ERRO_AGENDA_CADASTRADA')." : ".exibedataHora($data_agenda));
			}
		  }
		  			  
		  if (empty(Filter::$msgs)) {
			
			if($id_convenio == -1) {
				$id_convenio = 0;
			}
			if(empty($_POST['id_convenio'])) {
				$id_convenio = ($id_convenio) ? $id_convenio : $this->getConvenioMedico($id_paciente, $id_medico);
				$id_paciente_convenio = ($id_convenio > 0) ? getValue("id", "paciente_convenio", "id_paciente=$id_paciente AND id_convenio=$id_convenio AND inativo = 0") : 0;
				$id_convenio = ($id_convenio > 0 and $id_paciente_convenio > 0) ? $id_convenio : $this->getConvenioPaciente($id_paciente);
			}
			$id_agenda = post('id_agenda');	
			$id_consultorio = ($id_agenda > 0) ? getValue("id_consultorio", "agenda", "id=$id_agenda") : 0;	
			$tempo = ($id_agenda > 0) ? getValue("tempo", "agenda", "id=$id_agenda") : 30;
			$tempo = ($tempo > 0) ? $tempo : 30;
			$hora_fim = ($id_agenda > 0) ? getValue("horafim", "agenda", "id=$id_agenda") : 18;
			$repeticoes = post('repeticoes');
			$quant = ($repeticoes) ? post('quant') : 0;	
			$observacao = sanitize(post('observacao'));
			$bloqueio = post('bloqueio');
			$confirmar_agenda = getValue('confirmar_agenda', 'empresa', 'id='.$id_empresa);
			$liberar_agenda = getValue('liberar_agenda', 'empresa', 'id='.$id_empresa);
			$realizado = ($confirmar_agenda) ? 3 : 0;
			$realizado = ($liberar_agenda) ? 2 : $realizado;
			if($bloqueio) {
				$data = array(
					'id_empresa' => $id_empresa,
					'id_medico' => $id_medico,
					'id_agenda' => $id_agenda,
					'id_consultorio' => $id_consultorio,
					'bloqueio' => 1,
					'observacao' => $observacao,
					'data_agenda' => $data_agenda,
					'usuario_agenda' => session('nomeusuario'),
					'usuario_cadastro' => session('nomeusuario'),
					'data_cadastro' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->insert(self::uTable, $data);	
				if($quant > 0) {	
					$data_rep = array(
					'id_empresa' => $id_empresa,
					'id_medico' => $id_medico,
					'id_agenda' => $id_agenda,
					'id_consultorio' => $id_consultorio,
					'bloqueio' => 1,
					'observacao' => $observacao,
					'usuario_agenda' => session('nomeusuario'),
					'usuario_cadastro' => session('nomeusuario'),
					'data_cadastro' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
					);
					$data_temp = explode(' ', $data_agenda);
					$dataagenda = explode('-', $data_temp[0]);
					$horaagenda = explode(':', $data_temp[1]);
					for($i=1;$i<$quant+1;$i++)
					{
						$ano = 0;
						$mes = 0;
						$dia = 0;
						switch($repeticoes) {
							case 360: $ano = $i    ; break;
							case 180: $mes = $i*6  ; break;
							case 90:  $mes = $i*3  ; break;
							case 60:  $mes = $i*2  ; break;
							case 30:  $mes = $i    ; break;
							case 28:  $mes = $i    ; break;
							case 15:  $dia = $i*15 ; break;
							case 14:  $dia = $i*14 ; break;
							case 7:   $dia = $i*7  ; break;
							case 1:   $dia = $i    ; break;
							default:  $mes = $i    ; break;
						}
						$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia, $dataagenda[0] + $ano) );
						if($repeticoes == 28) {
							$diasemana1 = date('w', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1], $dataagenda[2], $dataagenda[0]) );
							$diasemana2 = date('w', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia, $dataagenda[0] + $ano) );
							$dif = ($diasemana1 - $diasemana2);
							$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia + $dif, $dataagenda[0] + $ano) );
						}
						if($repeticoes == 'h') {
							$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1] + ($i*$tempo), 0, $dataagenda[1], $dataagenda[2], $dataagenda[0]) );
						}
						$data_rep['data_agenda'] = $newData;
						$hora_newData = date('H',strtotime($newData));
						if($hora_newData <= $hora_fim)
							self::$db->insert(self::uTable, $data_rep);
					}
				}
				if (self::$db->affected()) {
					$message = lang('AGENDA_BLOQUEADA_OK');
					Filter::msgReload($message); 
				}				
			} elseif($id_guia) {
				$data_convenio = array(
					'principal' => 0
				);
				self::$db->update("paciente_convenio", $data_convenio, "id_paciente=$id_paciente");
				if($id_convenio > 0) {
					$data_convenio = array(
						'principal' => 1
					);
					self::$db->update("paciente_convenio", $data_convenio, "id_convenio=$id_convenio AND id_paciente=$id_paciente");
				}
				$data = array(
					'id_empresa' => $id_empresa,
					'id_paciente' => $id_paciente,
					'id_medico' => $id_medico,
					'id_agenda' => $id_agenda,
					'id_consultorio' => $id_consultorio,
					'id_convenio' => $id_convenio,
					'id_tabela' => $id_tabela,
					'id_especialidade' => $id_especialidade,
					'observacao' => $observacao,
					'realizado' => $realizado,
					'guia' => 1,
					'extra' => 0,
					'repasse' => 2,
					'data_agenda' => $data_agenda,
					'usuario_agenda' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update(self::uTable, $data, "id=$id_guia");
				if($id_guia > 0) {
					$nomeempresa = getValue('nome', 'empresa', 'id='.$id_empresa);
					$nomemedico = getValue('nome', 'usuario', 'id='.$id_medico);
					$nometabela = ($id_tabela) ? getValue('procedimento', 'tabela', 'id='.$id_tabela) : '';
					$nomeconvenio = ($id_convenio) ? getValue('nome', 'cadastro', 'id='.$id_convenio) : '';
					$row_paciente = Core::getRowById("paciente", $id_paciente);
					$dados = [
						'id_atendimento' => $id_guia,
						'id_empresa' => $id_empresa,
						'empresa' => $nomeempresa,
						'id_medico' => $id_medico,
						'medico' => $nomemedico,
						'id_paciente' => $id_paciente,
						'paciente' => $row_paciente->nome,
						'email' => $row_paciente->email,
						'celular' => $row_paciente->celular,
						'id_tabela' => $id_tabela,
						'tabela' => $nometabela,
						'convenio' => $nomeconvenio,
						'data_agenda' => $data_agenda,
						'usuario' => session('nomeusuario')
					];
					agendamento($dados);
				}
				if($quant > 0) {
					$data_rep = array(
						'id_empresa' => $id_empresa,
						'id_paciente' => $id_paciente,
						'id_medico' => $id_medico,
						'id_agenda' => $id_agenda,
						'id_consultorio' => $id_consultorio,
						'id_convenio' => $id_convenio,
						'id_tabela' => $id_tabela,
						'id_especialidade' => $id_especialidade,
						'observacao' => $observacao,
						'realizado' => $realizado,
						'guia' => 1,
						'extra' => 0,
						'repasse' => 2,
						'usuario_agenda' => session('nomeusuario'),
						'usuario' => session('nomeusuario'),
						'data' => "NOW()"
					);
					$data_temp = explode(' ', $data_agenda);
					$dataagenda = explode('-', $data_temp[0]);
					$horaagenda = explode(':', $data_temp[1]);
					for($i=1;$i<$quant+1;$i++)
					{
						$ano = 0;
						$mes = 0;
						$dia = 0;
						switch($repeticoes) {
							case 360: $ano = $i    ; break;
							case 180: $mes = $i*6  ; break;
							case 90:  $mes = $i*3  ; break;
							case 60:  $mes = $i*2  ; break;
							case 30:  $mes = $i    ; break;
							case 28:  $mes = $i    ; break;
							case 15:  $dia = $i*15 ; break;
							case 14:  $dia = $i*14 ; break;
							case 7:   $dia = $i*7  ; break;
							case 1:   $dia = $i    ; break;
							default:  $mes = $i    ; break;
						}
						$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia, $dataagenda[0] + $ano) );
						if($repeticoes == 28) {
							$diasemana1 = date('w', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1], $dataagenda[2], $dataagenda[0]) );
							$diasemana2 = date('w', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia, $dataagenda[0] + $ano) );
							$dif = ($diasemana1 - $diasemana2);
							$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia + $dif, $dataagenda[0] + $ano) );
						}
						if($repeticoes == 'h') {
							$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1] + ($i*$tempo), 0, $dataagenda[1], $dataagenda[2], $dataagenda[0]) );
						}
						$data_rep['data_agenda'] = $newData;
						$hora_newData = date('H',strtotime($newData));
						if($hora_newData <= $hora_fim) {
							$id_atendimento = ($id_paciente) ? $this->verificarGuia($id_paciente, $id_tabela, $id_convenio) : 0;
							if($id_atendimento > 0) {
								self::$db->update(self::uTable, $data_rep, "id=$id_atendimento");
							} else {
								$data_rep['usuario_cadastro'] = session('nomeusuario');
								$data_rep['data_cadastro'] = "NOW()";
								$id_atendimento = self::$db->insert(self::uTable, $data_rep);
							}
							if($id_atendimento > 0) {
								$nomeempresa = getValue('nome', 'empresa', 'id='.$id_empresa);
								$nomemedico = getValue('nome', 'usuario', 'id='.$id_medico);
								$nometabela = ($id_tabela) ? getValue('procedimento', 'tabela', 'id='.$id_tabela) : '';
								$nomeconvenio = ($id_convenio) ? getValue('nome', 'cadastro', 'id='.$id_convenio) : '';
								$row_paciente = Core::getRowById("paciente", $id_paciente);
								$dados = [
									'id_atendimento' => $id_atendimento,
									'id_empresa' => $id_empresa,
									'empresa' => $nomeempresa,
									'id_medico' => $id_medico,
									'medico' => $nomemedico,
									'id_paciente' => $id_paciente,
									'paciente' => $row_paciente->nome,
									'email' => $row_paciente->email,
									'celular' => $row_paciente->celular,
									'id_tabela' => $id_tabela,
									'tabela' => $nometabela,
									'convenio' => $nomeconvenio,
									'data_agenda' => $newData,
									'usuario' => session('nomeusuario')
								];
								agendamento($dados);
							}
						}
					}
				}
				if (self::$db->affected()) {
					$message = lang('ATENDIMENTO_ADICIONADO_OK');
					Filter::msgReload($message); 
				}				
			} else {	
				if(!$id_paciente) {
					$nome = cleanSanitize(post('nome'));	
					$id_paciente = getValue("id", "paciente", "nome='$nome'");
						if(!$id_paciente) {	
						$data_paciente = array(
							'nome' => cleanSanitize(post('nome')),
							'celular' => sanitize(post('celular')),
							'data_nasc' => dataMySQL($_POST['data_nasc']),
							'data_cadastro' => "NOW()",
							'usuario' => session('nomeusuario'),
							'data' => "NOW()"
						);
						$id_paciente = self::$db->insert("paciente", $data_paciente);
						$data_convenio = array(
							'id_paciente' => $id_paciente,
							'id_convenio' => $id_convenio,
							'principal' => 1,
							'usuario' => session('nomeusuario'),
							'data' => "NOW()"
						);
						self::$db->insert("paciente_convenio", $data_convenio);
					}
				}
				if($id_paciente > 0) {
					if(!empty($_POST['celular'])) {
						$data_paciente = array(
							'celular' => sanitize(post('celular'))
						);
						self::$db->update("paciente", $data_paciente, "id=$id_paciente");
					}
					$data_convenio = array(
						'principal' => 0
					);
					self::$db->update("paciente_convenio", $data_convenio, "id_paciente=$id_paciente");
					if($id_convenio > 0) {
						$data_convenio = array(
							'principal' => 1
						);
						self::$db->update("paciente_convenio", $data_convenio, "id_convenio=$id_convenio AND id_paciente=$id_paciente");
					}
					$data = array(
						'id_empresa' => $id_empresa,
						'id_paciente' => $id_paciente,
						'id_medico' => $id_medico,
						'id_agenda' => $id_agenda,
						'id_consultorio' => $id_consultorio,
						'id_convenio' => $id_convenio,
						'id_tabela' => $id_tabela,
						'id_especialidade' => $id_especialidade,
						'observacao' => $observacao,
						'realizado' => $realizado,
						'repasse' => 2,
						'data_agenda' => $data_agenda,
						'usuario_agenda' => session('nomeusuario'),
						'usuario' => session('nomeusuario'),
						'data' => "NOW()"
					);
					$id_retorno = 0;
					$retorno = getValue('retorno', 'tabela', 'id='.$id_tabela);
					$sem_retorno = $this->validaRetornoMedico($id_tabela, $id_medico, $id_convenio);
					if($retorno > 0 and $sem_retorno == 0) {
						$id_retorno = $this->verificarRetorno($data_agenda, $id_paciente, $id_tabela, $id_medico);
						if($id_retorno) {
							$data['pago'] = 1;
							$data['data_pagamento'] = "NOW()";
							$data['usuario_pagamento'] = "retorno1";
							$data['retorno'] = 2;
							$data['id_retorno'] = $id_retorno;
							$data_retorno = array(
								'retorno' => 1,
								'data_retorno' => $data_agenda,
							);
							self::$db->update(self::uTable, $data_retorno, "id=$id_retorno");
						} else {
							$dias_retorno = getValue('retorno', 'empresa', 'id='.$id_empresa);
							$dias_retorno = ($dias_retorno > 0) ? $dias_retorno : 30;
							$data['retorno'] = 9;
							$data_temp = explode(' ', $data_agenda);
							$array_data = explode('-', $data_temp[0]);
							$newData = novadata($array_data[1], $array_data[2]+$dias_retorno, $array_data[0]);	
							$data['data_retorno'] = $newData;						
						}
					}
					$tipo_convenio = ($id_convenio) ? getValue('convenio', 'cadastro', 'id='.$id_convenio) : 0;
					$valor_credito = $this->getTotalCredito($id_paciente);
					if($tipo_convenio == 2 and $id_retorno == 0) {
						$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
						$valor = ($valor_convenio) ? $valor_convenio : getValue('valor', 'tabela', 'id='.$id_tabela);
						$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
						$producao = getValue('producao', 'usuario', 'id='.$id_medico);
						$valor_repasse = 0;
						$row_tabela = Core::getRowById("tabela", $id_tabela);	
						if($producao == 2) {
							$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
							$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
							$valor_repasse = $valor*$percentual_repasse/100;
						} elseif($producao == 1) {
							$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
							$valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
						}
						
						$data['valor_tabela'] = $valor;
						$data['valor_pago'] = $valor;
						$data['valor_repasse'] = $valor_repasse;
						$data['guia'] = 1;
						$data['pago'] = 9;
						$data['data_pagamento'] = "NOW()";
						$data['usuario_pagamento'] = "convenio1";
					} elseif($valor_credito > 0 and $id_retorno == 0) {
						$valor_tabela = 0;
						$valor = 0;
						$row_tabela = Core::getRowById("tabela", $id_tabela);	
						if($id_convenio > 0) {
							$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
							$valor_tabela = ($valor_convenio) ? $valor_convenio : $row_tabela->valor;
						} else {
							$valor_tabela = $row_tabela->valor;
						}
						if($valor_credito < $valor_tabela) {
							$pago = 2;
							$valor = $valor_credito;
						} else {
							$pago = 1;
							$valor = $valor_tabela;
						}
						$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
						$producao = getValue('producao', 'usuario', 'id='.$id_medico);
						$valor_repasse = 0;
						if($producao == 2) {
							$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
							$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
							$valor_repasse = $valor*$percentual_repasse/100;
						} elseif($producao == 1) {
							$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
							$valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
						}					
						$data['valor_tabela'] = $valor_tabela;
						$data['valor_pago'] = $valor;
						$data['valor_repasse'] = $valor_repasse;
						$data['pago'] = $pago;
						$data['data_pagamento'] = "NOW()";
						$data['usuario_pagamento'] = "credito1";
						$valor_debito = $valor*(-1);
						$data_debito = array(
							'id_empresa' => $id_empresa,
							'id_paciente' => $id_paciente,
							'tipo' => 0, 
							'valor' => $valor_debito,
							'valor_pago' => $valor_debito,
							'total_parcelas' => 1, 
							'observacao' => 'DEBITO PARA O CLIENTE',
							'data_caixa' => "NOW()",
							'data_vencimento' => "NOW()",
							'data_pagamento' => "NOW()",
							'pago' => 4,
							'usuario_caixa' => session('nomeusuario'),
							'usuario' => session('nomeusuario'),
							'data' => "NOW()"
						);
						self::$db->insert("paciente_financeiro", $data_debito);
					}
					$data['usuario_cadastro'] = session('nomeusuario');
					$data['data_cadastro'] = "NOW()";
					$id_atendimento = self::$db->insert(self::uTable, $data);
					if($id_atendimento > 0) {
						$nomeempresa = getValue('nome', 'empresa', 'id='.$id_empresa);
						$nomemedico = getValue('nome', 'usuario', 'id='.$id_medico);
						$nometabela = ($id_tabela) ? getValue('procedimento', 'tabela', 'id='.$id_tabela) : '';
						$nomeconvenio = ($id_convenio) ? getValue('nome', 'cadastro', 'id='.$id_convenio) : '';
						$row_paciente = Core::getRowById("paciente", $id_paciente);
						$dados = [
							'id_atendimento' => $id_atendimento,
							'id_empresa' => $id_empresa,
							'empresa' => $nomeempresa,
							'id_medico' => $id_medico,
							'medico' => $nomemedico,
							'id_paciente' => $id_paciente,
							'paciente' => $row_paciente->nome,
							'email' => $row_paciente->email,
							'celular' => $row_paciente->celular,
							'id_tabela' => $id_tabela,
							'tabela' => $nometabela,
							'convenio' => $nomeconvenio,
							'data_agenda' => $data_agenda,
							'usuario' => session('nomeusuario')
						];
						agendamento($dados);
					}
					if($quant > 0) {
						$data_rep = array(
							'id_empresa' => $id_empresa,
							'id_paciente' => $id_paciente,
							'id_medico' => $id_medico,
							'id_agenda' => $id_agenda,
							'id_consultorio' => $id_consultorio,
							'id_convenio' => $id_convenio,
							'id_tabela' => $id_tabela,
							'id_especialidade' => $id_especialidade,
							'observacao' => $observacao,
							'realizado' => $realizado,
							'repasse' => 2,
							'usuario_agenda' => session('nomeusuario'),
							'usuario' => session('nomeusuario'),
							'data' => "NOW()"
						);						
						$tipo_convenio = ($id_convenio) ? getValue('convenio', 'cadastro', 'id='.$id_convenio) : 0;
						$valor_credito = $this->getTotalCredito($id_paciente);
						if($tipo_convenio == 2 and $id_retorno == 0) {			
							$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
							$valor = ($valor_convenio) ? $valor_convenio : getValue('valor', 'tabela', 'id='.$id_tabela);
							$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
							$producao = getValue('producao', 'usuario', 'id='.$id_medico);
							$valor_repasse = 0;
							$row_tabela = Core::getRowById("tabela", $id_tabela);	
							if($producao == 2) {
								$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
								$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
								$valor_repasse = $valor*$percentual_repasse/100;
							} elseif($producao == 1) {
								$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
								$valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
							}							
							$data_rep['valor_tabela'] = $valor;
							$data_rep['valor_pago'] = $valor;
							$data_rep['valor_repasse'] = $valor_repasse;
							$data_rep['guia'] = 1;
							$data_rep['pago'] = 9;
							$data_rep['data_pagamento'] = "NOW()";
							$data_rep['usuario_pagamento'] = "convenio2";
						} elseif($valor_credito > 0 and $id_retorno == 0) {
							$valor_tabela = 0;
							$valor = 0;
							$row_tabela = Core::getRowById("tabela", $id_tabela);	
							if($id_convenio > 0) {
								$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
								$valor_tabela = ($valor_convenio) ? $valor_convenio : $row_tabela->valor;
							} else {
								$valor_tabela = $row_tabela->valor;
							}
							if($valor_credito < $valor_tabela) {
								$pago = 2;
								$valor = $valor_credito;
							} else {
								$pago = 1;
								$valor = $valor_tabela;
							}
							$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
							$producao = getValue('producao', 'usuario', 'id='.$id_medico);
							$valor_repasse = 0;
							if($producao == 2) {
								$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
								$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
								$valor_repasse = $valor*$percentual_repasse/100;
							} elseif($producao == 1) {
								$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
								$valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
							}							
							$data_rep['valor_tabela'] = $valor_tabela;
							$data_rep['valor_pago'] = $valor;
							$data_rep['valor_repasse'] = $valor_repasse;
							$data_rep['pago'] = $pago;
							$data_rep['data_pagamento'] = "NOW()";
							$data_rep['usuario_pagamento'] = "credito2";		
							$valor_debito = $valor*(-1);
							$data_debito = array(
								'id_empresa' => $id_empresa,
								'id_paciente' => $id_paciente,
								'tipo' => 0, 
								'valor' => $valor_debito,
								'valor_pago' => $valor_debito,
								'total_parcelas' => 1, 
								'observacao' => 'DEBITO PARA O CLIENTE',
								'data_caixa' => "NOW()",
								'data_vencimento' => "NOW()",
								'data_pagamento' => "NOW()",
								'pago' => 4,
								'usuario_caixa' => session('nomeusuario'),
								'usuario' => session('nomeusuario'),
								'data' => "NOW()"
							);
							self::$db->insert("paciente_financeiro", $data_debito);
						}
						$data_temp = explode(' ', $data_agenda);
						$dataagenda = explode('-', $data_temp[0]);
						$horaagenda = explode(':', $data_temp[1]);
						for($i=1;$i<$quant+1;$i++)
						{
							$ano = 0;
							$mes = 0;
							$dia = 0;
							switch($repeticoes) {
								case 360: $ano = $i    ; break;
								case 180: $mes = $i*6  ; break;
								case 90:  $mes = $i*3  ; break;
								case 60:  $mes = $i*2  ; break;
								case 30:  $mes = $i    ; break;
								case 28:  $mes = $i    ; break;
								case 15:  $dia = $i*15 ; break;
								case 14:  $dia = $i*14 ; break;
								case 7:   $dia = $i*7  ; break;
								case 1:   $dia = $i    ; break;
								default:  $mes = $i    ; break;
							}
							$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia, $dataagenda[0] + $ano) );
							if($repeticoes == 28) {
								$diasemana1 = date('w', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1], $dataagenda[2], $dataagenda[0]) );
								$diasemana2 = date('w', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia, $dataagenda[0] + $ano) );
								$dif = ($diasemana1 - $diasemana2);
								$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1], 0, $dataagenda[1] + $mes, $dataagenda[2] + $dia + $dif, $dataagenda[0] + $ano) );
							}
							if($repeticoes == 'h') {
								$newData = date('Y-m-d H:i', mktime($horaagenda[0], $horaagenda[1] + ($i*$tempo), 0, $dataagenda[1], $dataagenda[2], $dataagenda[0]) );
							}
							$data_rep['data_agenda'] = $newData;
							$hora_newData = date('H',strtotime($newData));
							if($hora_newData <= $hora_fim) {
								$data_rep['usuario_cadastro'] = session('nomeusuario');
								$data_rep['data_cadastro'] = "NOW()";
								$id_atendimento = self::$db->insert(self::uTable, $data_rep);
								if($id_atendimento > 0) {
									$nomeempresa = getValue('nome', 'empresa', 'id='.$id_empresa);
									$nomemedico = getValue('nome', 'usuario', 'id='.$id_medico);
									$nometabela = ($id_tabela) ? getValue('procedimento', 'tabela', 'id='.$id_tabela) : '';
									$nomeconvenio = ($id_convenio) ? getValue('nome', 'cadastro', 'id='.$id_convenio) : '';
									$row_paciente = Core::getRowById("paciente", $id_paciente);
									$dados = [
										'id_atendimento' => $id_atendimento,
										'id_empresa' => $id_empresa,
										'empresa' => $nomeempresa,
										'id_medico' => $id_medico,
										'medico' => $nomemedico,
										'id_paciente' => $id_paciente,
										'paciente' => $row_paciente->nome,
										'email' => $row_paciente->email,
										'celular' => $row_paciente->celular,
										'id_tabela' => $id_tabela,
										'tabela' => $nometabela,
										'convenio' => $nomeconvenio,
										'data_agenda' => $newData,
										'usuario' => session('nomeusuario')
									];
									agendamento($dados);
								}
							}
						}
					}				
					if (self::$db->affected()) {
						$message = lang('ATENDIMENTO_ADICIONADO_OK');
						Filter::msgReload("<strong>".$aviso."</strong><br/>".$message); 
					} else
						Filter::msgAlert(lang('NAOPROCESSADO'));
				}
			}
          } else
              print Filter::msgStatus();
	}
	  
	/**
	* Atendimento::processarAtendimentoExtra()
	* 
	* LOTE: 1 - LOTE ENVIADO
	* LOTE: 2 - LOTE RECEBIDO
	* @return
	*/	
	public function processarAtendimentoExtra()
	{
		  $id_medico = sanitize(post('id_medico')); 
		  
		  if (empty($_POST['id_medico']))
              Filter::$msgs['id_medico'] = lang('MSG_ERRO_MEDICO');  
		  
		  if (empty($_POST['id_tabela']))
              Filter::$msgs['id_tabela'] = lang('MSG_ERRO_PROCEDIMENTO');  	
		  
		  // if (empty($_POST['data_vencimento_guia']))
              // Filter::$msgs['data_vencimento_guia'] = lang('MSG_ERRO_DATA_VENCIMENTO');  
		   
		  			  
		  if (empty(Filter::$msgs)) {
			  			
			$data_agenda = (empty($_POST['data_agenda'])) ? 'NULL' :  dataMySQL(post('data_agenda'));	
			$id_empresa = (post('id_empresa')) ? post('id_empresa') : session('idempresa');
			$id_convenio = post('id_convenio');	
			$id_paciente = sanitize(post('id_paciente'));
			$id_tabela = sanitize(post('id_tabela'));
			$observacao = sanitize(post('observacao'));
			$quantidade = (post('quantidade')) ? post('quantidade') : 1;
			$quantidade = ($quantidade > 20) ? 20 : $quantidade;
			$redirecionar = "index.php?do=paciente&acao=procedimento&id=$id_paciente";
			
			$tipo_convenio = ($id_convenio) ? getValue('convenio', 'cadastro', 'id='.$id_convenio) : 0;
			
			$data_receber_guia = (empty($_POST['data_receber_guia']) or post('data_receber_guia') == '-') ? "NOW()" : dataMySQL(post('data_receber_guia'));
			$data_vencimento_guia = (empty($_POST['data_vencimento_guia']) or post('data_vencimento_guia') == '-') ? "NOW()" : dataMySQL(post('data_vencimento_guia'));
			
			for($i=0;$i<$quantidade;$i++) {
				$data = array(
					'id_empresa' => $id_empresa,
					'id_paciente' => $id_paciente,
					'id_medico' => $id_medico,
					'id_convenio' => $id_convenio,
					'id_tabela' => $id_tabela,
					'observacao' => $observacao,
					'extra' => 1,
					'repasse' => 2,
					'data_agenda' => $data_agenda,
					'numero_guia' => sanitize(post('numero_guia')),
					'autorizacao' => sanitize(post('autorizacao')),
					'cid' => sanitize(post('cid')),
					'data_receber_guia' => $data_receber_guia,
					'data_vencimento_guia' => $data_vencimento_guia,
					'usuario_guia' => session('nomeusuario'),
					'data_guia' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				$valor_credito = $this->getTotalCredito($id_paciente);
				if($tipo_convenio == 2) {
					$redirecionar = "index.php?do=paciente&acao=guias&id=$id_paciente";
					$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
					$valor = ($valor_convenio) ? $valor_convenio : getValue('valor', 'tabela', 'id='.$id_tabela);
					$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
					$producao = getValue('producao', 'usuario', 'id='.$id_medico);
					$valor_repasse = 0;
					$row_tabela = Core::getRowById("tabela", $id_tabela);	
					if($producao == 2) {
						$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
						$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
						$valor_repasse = $valor*$percentual_repasse/100;
					} elseif($producao == 1) {
						$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
						$valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
					}
					
					$data['valor_tabela'] = $valor;
					$data['valor_pago'] = $valor;
					$data['valor_repasse'] = $valor_repasse;
					$data['guia'] = 2;
					$data['pago'] = 9;
					$data['data_pagamento'] = "NOW()";
					$data['usuario_pagamento'] = "convenio3";
				} elseif($valor_credito > 0) {
					$valor_tabela = 0;
					$valor = 0;
					$row_tabela = Core::getRowById("tabela", $id_tabela);	
					if($id_convenio > 0) {
						$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
						$valor_tabela = ($valor_convenio) ? $valor_convenio : $row_tabela->valor;
					} else {
						$valor_tabela = $row_tabela->valor;
					}
					if($valor_credito < $valor_tabela) {
						$pago = 2;
						$valor = $valor_credito;
					} else {
						$pago = 1;
						$valor = $valor_tabela;
					}
					$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
					$producao = getValue('producao', 'usuario', 'id='.$id_medico);
					$valor_repasse = 0;
					if($producao == 2) {
						$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
						$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
						$valor_repasse = $valor*$percentual_repasse/100;
					} elseif($producao == 1) {
						$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
						$valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
					}						
					$data['valor_tabela'] = $valor_tabela;
					$data['valor_pago'] = $valor;
					$data['valor_repasse'] = $valor_repasse;
					$data['pago'] = $pago;
					$data['data_pagamento'] = "NOW()";
					$data['usuario_pagamento'] = "credito3";
					$valor_debito = $valor*(-1);
					$data_debito = array(
						'id_empresa' => $id_empresa,
						'id_paciente' => $id_paciente,
						'tipo' => 0, 
						'valor' => $valor_debito,
						'valor_pago' => $valor_debito,
						'total_parcelas' => 1, 
						'observacao' => 'DEBITO PARA O CLIENTE',
						'data_caixa' => "NOW()",
						'data_vencimento' => "NOW()",
						'data_pagamento' => "NOW()",
						'pago' => 4,
						'usuario_caixa' => session('nomeusuario'),
						'usuario' => session('nomeusuario'),
						'data' => "NOW()"
					);
					self::$db->insert("paciente_financeiro", $data_debito);
				}
				$data['usuario_cadastro'] = session('nomeusuario');
				$data['data_cadastro'] = "NOW()";
				$id_atendimento = self::$db->insert("atendimento", $data);
			}
			if (self::$db->affected()) {
				$message = lang('ATENDIMENTO_ADICIONADO_OK');
				Filter::msgOk($message,$redirecionar); 
			} else
				Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
	}
	  
	/**
	* Atendimento::processarEditarAtendimento()
	* @return
	*/	
	public function processarEditarAtendimento()
	{
		  if (empty($_POST['id_paciente']))
			  Filter::$msgs['id_paciente'] = lang('MSG_ERRO_NOME');  		  
		  
		  if (empty(Filter::$msgs)) {
			$id_empresa = (post('id_empresa')) ? post('id_empresa') : session('idempresa');	
			$id_agenda = post('id_agenda');	
			$id_tabela = post('id_tabela');	
			$id_paciente = sanitize(post('id_paciente'));
			$observacao = sanitize(post('observacao'));

			if($id_paciente > 0) {
				$data = array(
					'id_empresa' => $id_empresa,
					'id_tabela' => $id_tabela,
					'observacao' => $observacao,
					'usuario_agenda' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update(self::uTable, $data, "id=".$id_agenda);
														
				if (self::$db->affected()) {
					$message = lang('ATENDIMENTO_ADICIONADO_OK');
					Filter::msgReload($message); 
				} else
					Filter::msgAlert(lang('NAOPROCESSADO'));
			} else
				Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
	}

      /**
       * Atendimento::getAgendaPeriodo()
       * 
       * @return
       */
      public function getAgendaPeriodo($dataini = 0, $datafim = 0, $id_medico = false, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
		  $wcancelado = (self::$cancelado) ? "AND (a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') OR a.data_agenda_cancelada BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i'))" : " AND a.realizado < 9 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i')";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.guia as guia_procedimento, t.valor_repasse AS tabela_repasse, c.nome as convenio, e.liberar_pagamento, e.validar_guias, a.data_agenda < CURDATE() AS atrasado, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer, IF(a.data_agenda IS NULL, a.data_agenda_cancelada, a.data_agenda) AS data_agenda " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.id_empresa = '$id_empresa' $wid_medico $wcancelado"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaPeriodo()
       * 
       * @return
       */
      public function getAgendaPeriodoImpressao($dataini = 0, $datafim = 0, $id_medico = false, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
          $sql = "SELECT a.*, u.nome as medico, u.crm, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.guia as guia_procedimento, t.valor_repasse AS tabela_repasse, c.nome as convenio, e.liberar_pagamento, e.validar_guias, a.data_agenda < CURDATE() AS atrasado, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer, IF(a.data_agenda IS NULL, a.data_agenda_cancelada, a.data_agenda) AS data_agenda " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.id_empresa = '$id_empresa' $wid_medico AND a.realizado < 9 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i')"
		  . "\n ORDER BY u.nome, a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaPeriodoMedico()
       * 
       * @return
       */
      public function getAgendaPeriodoMedico($dataini = 0, $datafim = 0, $id_medico = false, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.guia as guia_procedimento, t.valor_repasse AS tabela_repasse, c.nome as convenio, e.liberar_pagamento, e.validar_guias, a.data_agenda < CURDATE() AS atrasado, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') AND a.id_medico = '$id_medico' AND a.realizado < 9"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaPendentes()
       * 
       * @return
       */
      public function getAgendaPendentes($dataini = 0, $datafim = 0, $id_medico = false, $id_empresa = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_repasse AS tabela_repasse, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, DATE_FORMAT(a.data_agenda, '%Y%m%d%H%i') as controle, IF(a.valor_tabela > 0, a.valor_tabela, IF(a.id_convenio > 0, co.valor_convenio, t.valor)) AS valor_atendimento, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN tabela_convenio AS co ON co.id_tabela = a.id_tabela AND co.id_cadastro = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado NOT IN (1,9) AND a.bloqueio = 0 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') AND a.data_agenda < DATE_ADD(CURDATE(), INTERVAL 1 DAY) $wid_medico $wempresa"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaProntuario()
       * 
       * @return
       */
      public function getAgendaProntuario($dataini = 0, $datafim = 0, $id_medico = false, $id_empresa = false, $prontuario = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
		  $wprontuario = "";
		  if($prontuario == 1) {
			$wprontuario = " AND DATE_FORMAT(pa.data, '%Y%m%d%H%i') = DATE_FORMAT(a.data_agenda, '%Y%m%d%H%i') ";
		  } elseif($prontuario == 2) {
			$wprontuario = " AND DATE_FORMAT(pa.data, '%Y%m%d%H%i') <> DATE_FORMAT(a.data_agenda, '%Y%m%d%H%i') ";
		  }
          $sql = "SELECT a.*, u.producao, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_repasse AS tabela_repasse, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, DATE_FORMAT(a.data_agenda, '%Y%m%d%H%i') as controle, pa.data AS data_prontuario, (DATE_FORMAT(pa.data, '%Y%m%d') = DATE_FORMAT(a.data_agenda, '%Y%m%d')) AS prontuario, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer" 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN paciente_atendimento AS pa ON pa.id = a.id_prontuario "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado = 1 AND a.id_cancelamento = 0 AND a.bloqueio = 0 AND a.bloqueio = 0 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wid_medico $wempresa $wprontuario"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaNaoPagos()
       * 
       * @return
       */
      public function getAgendaNaoPagos($dataini = 0, $datafim = 0, $id_medico = false, $id_empresa = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
		  $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_repasse AS tabela_repasse, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, DATE_FORMAT(a.data_agenda, '%Y%m%d%H%i') as controle, IF(a.valor_tabela > 0, a.valor_tabela, IF(a.id_convenio > 0, co.valor_convenio, t.valor)) AS valor_atendimento, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN tabela_convenio AS co ON co.id_tabela = a.id_tabela AND co.id_cadastro = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado < 9 AND a.bloqueio = 0 AND a.guia = 0 AND a.pago = 0 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') AND a.data_agenda < DATE_ADD(CURDATE(), INTERVAL 1 DAY) $wid_medico $wempresa"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgenda()
       * 
       * @return
       */
      public function getAgenda($dia, $hora, $id_medico = 0, $id_empresa = false)
      {
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, c.nome as convenio, t.procedimento, t.valor, t.guia as guia_procedimento, t.valor_cartao, a.data_agenda < CURDATE() as atrasado, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n WHERE a.realizado < 9 AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y %H:%i') = '$dia $hora' "
		  . "\n $wid_medico "
		  . "\n ORDER BY a.id DESC ";
		  
          $row = ($id_medico) ? self::$db->first($sql) : null;

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaPaciente()
       * 
       * @return
       */
      public function getAgendaPaciente($id_paciente = 0, $id_medico = false, $dataini = false, $datafim = false)
      {		  
		 $wmedico = ($id_medico) ? "AND a.id_medico = $id_medico " : "";
		 $datafim = ($datafim) ? $datafim : $dataini;
		 $wdata = "AND (a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') OR a.data_agenda_cancelada BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i'))";
		  
		 $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.guia as guia_procedimento, t.valor_cartao, t.valor_repasse AS tabela_repasse, t.percentual_repasse, c.nome as convenio, tc.valor_convenio, e.nome as empresa, e.liberar_pagamento, e.validar_guias, a.data_agenda < CURDATE() AS atrasado, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer, IF(a.data_agenda IS NULL, a.data_agenda_cancelada, a.data_agenda) AS data_agenda " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.id_paciente = $id_paciente "
		  . "\n $wmedico "
		  . "\n $wdata "
		  . "\n ORDER BY a.data_agenda DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getPagamentosPaciente()
       * 
       * @return
       */
      public function getPagamentosPaciente($id_paciente = 0)
      {
         $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.guia as guia_procedimento, t.valor_cartao, t.valor_repasse AS tabela_repasse, t.percentual_repasse, c.nome as convenio, tc.valor_convenio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.pago = 0 AND a.realizado < 9 AND a.bloqueio = 0 AND a.data_agenda <> '0000-00-00 00:00:00' AND a.id_paciente = $id_paciente "
		  . "\n ORDER BY a.data_agenda DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getCancelamentoPaciente()
       * 
       * @return
       */
      public function getCancelamentoPaciente($id_paciente = 0)
      {
         $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.guia as guia_procedimento, c.nome as convenio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.pago = 0 AND a.realizado <> 1 AND a.realizado < 9 AND a.bloqueio = 0 AND a.data_agenda <> '0000-00-00 00:00:00' AND a.id_paciente = $id_paciente "
		  . "\n ORDER BY a.data_agenda DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      public function getTotalAgendaPaciente($id_paciente = 0)
      {		  
          $sql = "SELECT a.id_tabela, t.procedimento, COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.data_agenda <> '0000-00-00 00:00:00' AND a.realizado < 9 AND a.bloqueio = 0 AND a.id_paciente = $id_paciente "
		  . "\n GROUP BY a.id_tabela "
		  . "\n ORDER BY t.procedimento ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaMedico()
       * 
       * @return
       */
      public function getAgendaMedico($id_medico = 0, $data = false, $id_empresa = false)
      {	
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $wdata = ($data) ? " AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' " : "";
          $sql = "SELECT a.*, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.data_agenda <> '0000-00-00 00:00:00' AND a.id_empresa = '$id_empresa' AND a.id_medico = $id_medico "
		  . "\n $wdata "
		  . "\n ORDER BY a.id DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaDia()
       * 
       * @return
       */
      public function getAgendaDia($data, $id_medico = false, $id_empresa = false)
      {	
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
		  $wcancelado = (self::$cancelado) ? "AND (DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' OR DATE_FORMAT(a.data_agenda_cancelada,'%d/%m/%Y') = '$data')" : " AND a.realizado < 9 AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'";
		  
          $sql = "SELECT a.*, u.nome as medico, u.producao, u.salario, p.nome as paciente, p.telefone, p.celular, c.nome as convenio, t.procedimento, t.valor, t.guia as guia_procedimento, t.valor_cartao, t.valor_repasse AS tabela_repasse, e.liberar_pagamento, e.validar_guias, a.data_agenda < CURDATE() as atrasado, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer, IF(a.data_agenda IS NULL, a.data_agenda_cancelada, a.data_agenda) AS data_agenda " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.id_empresa = '$id_empresa' $wid_medico $wcancelado"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaRealizada()
       * 
       * @return
       */
      public function getAgendaRealizada($data, $id_medico = false, $id_empresa = false)
      {	
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wid_medico = ($id_medico) ? " AND a.id_medico = $id_medico " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, e.nome as clinica, e.liberar_pagamento, e.validar_guias, c.nome as convenio " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' $wid_medico"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentoDocumentos()
       * 
       * @return
       */
      public function getAtendimentoDocumentos($id_atendimento = 0, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.* " 
		  . "\n FROM atendimento_documentos as a "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND a.id_atendimento = $id_atendimento AND a.id_status < 7 "
		  . "\n ORDER BY a.id DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getMedicoPeriodo()
       * 
       * @return
       */
      public function getMedicoPeriodo($dataini = 0, $datafim = 0, $id_empresa = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.id_medico, u.nome as medico, u.cpf, u.banco, u.codigo, u.agencia, u.conta, u.producao, u.salario, SUM(IF(a.id_convenio > 0, tc.valor_convenio, t.valor)) AS valor_tabela, SUM(a.valor_repasse) AS valor_repasse, COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.repasse = 2 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n GROUP BY u.nome "
		  . "\n ORDER BY u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaMedicoPeriodo()
       * 
       * @return
       */
      public function getListaMedicoPeriodo($id_medico, $dataini = 0, $datafim = 0, $id_empresa = false, $id_convenio = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wconvenio = ($id_convenio) ? " AND a.id_convenio = '$id_convenio' " : "";
		  if($id_convenio == '-1') {
			$wconvenio = " AND a.id_convenio = '0' ";
		  }
          $sql = "SELECT a.*, u.nome as medico, u.cpf, u.banco, u.codigo, u.agencia, u.conta, u.producao, u.salario, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, IF(a.id_convenio > 0, tc.valor_convenio, a.valor_pago) AS valor_procedimento " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.id_medico = $id_medico AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa $wconvenio"
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaMedicoProducao()
       * 
       * @return
       */
      public function getListaMedicoProducao($id_medico, $dataini = 0, $datafim = 0, $id_empresa = false, $id_convenio = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wconvenio = ($id_convenio) ? " AND a.id_convenio = '$id_convenio' " : "";
		  if($id_convenio == '-1') {
			$wconvenio = " AND a.id_convenio = '0' ";
		  }
          $sql = "SELECT a.*, u.nome as medico, u.cpf, u.banco, u.codigo, u.agencia, u.conta, u.producao, u.salario, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, IF(a.id_convenio > 0, tc.valor_convenio, a.valor_pago) AS valor_procedimento " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.repasse in (0,2) AND a.id_medico = $id_medico AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa $wconvenio"
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getTotalMedicoProducao()
       * 
       * @return
       */
      public function getTotalMedicoProducao($id_medico, $dataini = 0, $datafim = 0, $id_empresa = false, $id_convenio = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wconvenio = ($id_convenio) ? " AND a.id_convenio = '$id_convenio' " : "";
		  if($id_convenio == '-1') {
			$wconvenio = " AND a.id_convenio = '0' ";
		  }
          $sql = "SELECT a.id_tabela, a.id_convenio, a.id_medico, SUM(IF(a.id_convenio > 0, tc.valor_convenio, a.valor_pago)) AS valor_pago, IF(a.id_convenio > 0, tc.valor_convenio, a.valor_pago) AS valor_procedimento, COUNT(1) AS quant, u.nome as medico, u.producao, u.salario, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio "
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.repasse = 2 AND a.id_medico = $id_medico AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa $wconvenio"
		  . "\n GROUP BY a.id_tabela, a.id_convenio ASC "
		  . "\n ORDER BY t.procedimento, c.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaMedicoPagamento()
       * 
       * @return
       */
      public function getListaMedicoPagamento($id_medico, $dataini = 0, $datafim = 0, $id_empresa = false, $id_convenio = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wconvenio = ($id_convenio) ? " AND a.id_convenio = '$id_convenio' " : "";
		  if($id_convenio == '-1') {
			$wconvenio = " AND a.id_convenio = '0' ";
		  }
          $sql = "SELECT a.*, u.nome as medico, u.cpf, u.banco, u.codigo, u.agencia, u.conta, u.producao, u.salario, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, IF(a.id_convenio > 0, tc.valor_convenio, a.valor_pago) AS valor_procedimento " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.repasse = 2 AND a.id_medico = $id_medico AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa $wconvenio"
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaMedicoPago()
       * 
       * @return
       */
      public function getListaMedicoPago($id_medico, $dataini = 0, $datafim = 0, $id_empresa = false, $id_convenio = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
		  $wconvenio = ($id_convenio) ? " AND a.id_convenio = '$id_convenio' " : "";
		  if($id_convenio == '-1') {
			$wconvenio = " AND a.id_convenio = '0' ";
		  }
          $sql = "SELECT a.*, u.nome as medico, u.cpf, u.banco, u.codigo, u.agencia, u.conta, u.producao, u.salario, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado = 1 AND a.repasse = 1 AND a.id_medico = $id_medico AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa $wconvenio"
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getConvenioPeriodo()
       * 
       * @return
       */
      public function getConvenioPeriodo($dataini = 0, $datafim = 0, $id_empresa = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.id_convenio, c.nome as convenio, SUM(a.valor_tabela) AS valor_tabela, COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n WHERE a.realizado = 1 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n GROUP BY c.nome "
		  . "\n ORDER BY c.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaConvenioPeriodo()
       * 
       * @return
       */
      public function getListaConvenioPeriodo($id_convenio, $dataini = 0, $datafim = 0, $id_empresa = false)
      {		  
		  $id_convenio = ($id_convenio) ? $id_convenio : 0;
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, r.referencia, v.titular, v.numero, v.data_validade " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN paciente_convenio AS v ON v.id_convenio = a.id_convenio AND v.id_paciente = a.id_paciente AND v.inativo = 0 "
		  . "\n LEFT JOIN referencia AS r ON r.id = v.id_referencia "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado = 1 AND a.id_convenio = $id_convenio AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentosCancelados()
       * 
       * @return
       */
      public function getAtendimentosCancelados($dataini = 0, $datafim = 0, $id_empresa = false)
      {	
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, e.liberar_pagamento, e.validar_guias, r.referencia, v.titular, v.numero, v.data_validade " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN paciente_convenio AS v ON v.id_convenio = a.id_convenio AND v.id_paciente = a.id_paciente AND v.inativo = 0 "
		  . "\n LEFT JOIN referencia AS r ON r.id = v.id_referencia "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.id_cancelamento > 0 AND a.data_agenda_cancelada BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n ORDER BY a.data_agenda_cancelada, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaGuiasPendentes()
       * 
       * @return
       */
      public function getListaGuiasPendentes($id_convenio, $id_empresa = false)
      {
		  $wconvenio = ($id_convenio) ? " AND a.id_convenio = '$id_convenio' " : "";
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, r.referencia, v.titular, v.numero, v.data_validade, DATE_FORMAT(a.data_agenda, '%Y%m%d%H%i') as controle " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN paciente_convenio AS v ON v.id_convenio = a.id_convenio AND v.id_paciente = a.id_paciente AND v.inativo = 0 "
		  . "\n LEFT JOIN referencia AS r ON r.id = v.id_referencia "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado = 1 AND a.guia > 0 AND a.numero_guia = '' AND a.id_convenio > 0 $wconvenio $wempresa "
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaAtendimentoIsencao()
       * 
       * @return
       */
      public function getListaAtendimentoIsencao($id_convenio, $dataini = 0, $datafim = 0, $id_empresa = false)
      {		  
		  $id_convenio = ($id_convenio) ? $id_convenio : 0;
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, c.nome as convenio, e.nome as clinica, r.referencia, v.titular, v.numero, v.data_validade " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN paciente_convenio AS v ON v.id_convenio = a.id_convenio AND v.id_paciente = a.id_paciente AND v.inativo = 0 "
		  . "\n LEFT JOIN referencia AS r ON r.id = v.id_referencia "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado = 1 AND a.valor_pago = 0 AND a.id_convenio = $id_convenio AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getLaboratorioPeriodo()
       * 
       * @return
       */
      public function getLaboratorioPeriodo($dataini = 0, $datafim = 0, $id_empresa = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT c.nome AS laboratorio, t.id_laboratorio, t.valor_pago_lab, SUM(a.valor_tabela) AS valor_tabela, COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = t.id_laboratorio "
		  . "\n WHERE a.realizado = 1 AND t.id_laboratorio > 0 AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n GROUP BY t.id_laboratorio "
		  . "\n ORDER BY c.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getListaLaboratorioPeriodo()
       * 
       * @return
       */
      public function getListaLaboratorioPeriodo($id_laboratorio, $dataini = 0, $datafim = 0, $id_empresa = false)
      {		  
		  $wempresa = ($id_empresa) ? " AND a.id_empresa = '$id_empresa' " : "";
          $sql = "SELECT a.*, u.nome as medico, u.cpf, u.banco, u.codigo, u.agencia, u.conta, u.producao, u.salario, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_pago_lab, c.nome as convenio, e.nome as clinica " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado = 1 AND t.id_laboratorio = $id_laboratorio AND a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') $wempresa "
		  . "\n ORDER BY a.data_agenda, p.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	/**
	* Atendimento::processarAgenda()
	* @return
	*/	
	public function processarAgenda()
	{
		  $id_empresa = (post('id_empresa')) ? post('id_empresa') : session('idempresa');	
		  if (!$id_empresa)
              Filter::$msgs['id_empresa'] = lang('MSG_ERRO_EMPRESA');  
		  
		  if (empty($_POST['data_agenda']))
              Filter::$msgs['data_agenda'] = lang('MSG_ERRO_DATA');  
		  
		  if (empty($_POST['id_medico']))
              Filter::$msgs['id_medico'] = lang('MSG_ERRO_MEDICO');  		  
		  
		  if (empty(Filter::$msgs)) {	
			$id_medico = sanitize(post('id_medico'));
			$id_consultorio = sanitize(post('id_consultorio'));
			$quantidade = intval(post('quantidade'));	
			$dataagenda = post('data_agenda');
			$data_sms = dataMySQL($dataagenda);
			$hora_ini = (post('hora_ini')) ? post('hora_ini') : '08:00';		
			$hora_fim = (post('hora_fim')) ? post('hora_fim') : '18:00';
			$hora_ini = (substr_count(':', $hora_ini)) ? $hora_ini : $hora_ini.':00';
			$hora_fim = (substr_count(':', $hora_fim)) ? $hora_fim : $hora_fim.':00';
			$tempo = (post('tempo')) ? post('tempo') : 30;	
			$observacao = sanitize(post('observacao'));
			
			$data = array(
				'id_empresa' => $id_empresa,
				'id_medico' => $id_medico,
				'id_consultorio' => $id_consultorio,
				'data_agenda' => $data_sms,
				'horaini' => $hora_ini,
				'horafim' => $hora_fim,
				'tempo' => $tempo,
				'quantidade' => $quantidade,
				'observacao' => $observacao,
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			);
			self::$db->insert("agenda", $data);
			if (empty($_POST['medico'])) {
				$redirecionar = "index.php?do=agenda&acao=gerenciar&id_medico=".$id_medico."&id_empresa=".$id_empresa;
			} else {
				$redirecionar = "index.php?do=medico&acao=gerenciar&id_medico=".$id_medico."&id_empresa=".$id_empresa;
			}
							
			if (self::$db->affected()) {
				$message = lang('AGENDA_ADICIONADA_OK');
				Filter::msgOk($message,$redirecionar); 
			} else
				Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
	}

      /**
       * Atendimento::getGerenciarAgenda()
       * 
       * @return
       */
      public function getGerenciarAgenda($id_medico = false, $data = false, $id_empresa = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wmedico = ($id_medico) ? "AND a.id_medico = $id_medico " : "";
		  $wdata = ($data) ? "AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' " : "AND a.data_agenda >= CURDATE()";
          $sql = "SELECT a.*, u.nome as medico, e.nome as empresa, c.consultorio " 
		  . "\n FROM agenda as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN consultorio AS c ON c.id = a.id_consultorio "
		  . "\n WHERE a.id_empresa = '$id_empresa' "
		  . "\n $wdata"
		  . "\n $wmedico"
		  . "\n ORDER BY e.nome, a.data_agenda, u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getMedicosMes()
       * 
       * @return
       */
      public function getMedicosMes($mesano, $id_empresa = false, $id_medico  = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wmedico = ($id_medico) ? "AND a.id_medico = $id_medico " : "";
          $sql = "SELECT DISTINCT u.id, u.nome " 
		  . "\n FROM agenda as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%m/%Y') = '$mesano' "
		  . "\n ORDER BY u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getMedicosAgendas()
       * 
       * @return
       */
      public function getMedicosAgendas($id_empresa = false, $id_medico  = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wmedico = ($id_medico) ? "AND a.id_medico = $id_medico " : "";
          $sql = "SELECT DISTINCT u.id, u.nome " 
		  . "\n FROM agenda as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND a.data_agenda >= CURDATE() AND u.id IS NOT NULL "
		  . "\n ORDER BY u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getDataMedico()
       * 
       * @return
       */
      public function getDataMedico($id_medico = 0, $data = false, $id_empresa = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $wdata = ($data) ? "AND a.data_agenda = STR_TO_DATE('$data','%d/%m/%Y') " : " AND a.data_agenda = CURDATE() ";
          $sql = "SELECT a.id, a.id_consultorio, a.data_agenda, a.horaini, a.horafim, a.tempo, a.quantidade, a.observacao, DATE_FORMAT(a.data_agenda,'%d/%m/%Y') AS data, a.data_agenda < CURDATE() as atrasado " 
		  . "\n FROM agenda as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND a.id_medico = $id_medico $wdata "
		  . "\n ORDER BY a.data_agenda, u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getTodasDataMedico()
       * 
       * @return
       */
      public function getTodasDataMedico($id_medico = 0, $id_empresa = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT DATE_FORMAT(a.data_agenda,'%d/%m/%Y') AS data " 
		  . "\n FROM agenda as a "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND a.id_medico = '$id_medico' AND a.data_agenda >= CURDATE() "
		  . "\n GROUP BY DATE_FORMAT(a.data_agenda,'%d/%m/%Y') "
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	/**
	* Atendimento::processarAgenda()
	* @return
	*/	
	public function processarAgendaMes()
	{				  
		  $id_empresa = (post('id_empresa')) ? post('id_empresa') : session('idempresa');	
		  if (!$id_empresa)
              Filter::$msgs['id_empresa'] = lang('MSG_ERRO_EMPRESA'); 
		  
		  if (empty($_POST['id_medico']))
              Filter::$msgs['id_medico'] = lang('MSG_ERRO_MEDICO');  		  
		  
		  if (empty(Filter::$msgs)) {
			$id_medico = sanitize(post('id_medico'));
			$id_consultorio = sanitize(post('id_consultorio'));
			$mesano = post('mesano');
			$dia = post('dia');
			$hora_ini = (post('hora_ini')) ? post('hora_ini') : '08:00';
			$hora_fim = (post('hora_fim')) ? post('hora_fim') : '18:00';
			$hora_ini = (substr_count(':', $hora_ini)) ? $hora_ini : $hora_ini.':00';
			$hora_fim = (substr_count(':', $hora_fim)) ? $hora_fim : $hora_fim.':00';
			$quantidade = intval(post('quantidade'));
			$tempo = (post('tempo')) ? post('tempo') : 30;	
			$observacao = sanitize(post('observacao'));
			$contar = count($dia);
			for($i=0;$i<$contar;$i++) {
				$dataagenda = $dia[$i].'/'.$mesano;
				$data = array(
					'id_empresa' => $id_empresa,
					'id_medico' => $id_medico,
					'id_consultorio' => $id_consultorio,
					'data_agenda' => dataMySQL($dataagenda),
					'horaini' => $hora_ini,
					'horafim' => $hora_fim,
					'tempo' => $tempo,
					'quantidade' => $quantidade,
					'observacao' => $observacao,
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->insert("agenda", $data);
			}
					
			$redirecionar = "index.php?do=agenda&acao=gerenciar&id_medico=".$id_medico."&id_empresa=".$id_empresa;
							
			if (self::$db->affected()) {
				$message = lang('AGENDA_ADICIONADA_OK');
				Filter::msgOk($message,$redirecionar); 
			} else
				Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
	}

      /**
       * Atendimento::getAgendaStatus()
       * 
       * @return
       */
      public function getAgendaStatus($data, $id_medico = 0, $id_empresa = false)
      {	
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.realizado, COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.bloqueio = 0 AND a.realizado < 9 AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' AND a.id_medico = '$id_medico'"
		  . "\n GROUP BY a.realizado "
		  . "\n ORDER BY a.realizado ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getTotalAgenda()
       * 
       * @return
       */
      public function getTotalAgenda($id_agenda)
      {	
          $sql = "SELECT COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.realizado < 9 AND a.id_agenda = '$id_agenda'";
		  
          $row = self::$db->first($sql);

          return ($row and $row->quant) ? $row->quant : 0;
      }

      /**
       * Atendimento::verificarAgenda()
       * 
       * @return
       */
      public function verificarAgenda($data = false, $id_medico = false, $id_empresa = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.id " 
		  . "\n FROM agenda as a "
		  . "\n WHERE a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' AND a.id_medico = '$id_medico' ";
		  
          $row = self::$db->first($sql);

          return ($row) ? $row->id : 0;
      }

      /**
       * Atendimento::verificarAgendaEspecialidade()
       * 
       * @return
       */
      public function verificarAgendaEspecialidade($data = false, $id_especialidade = false)
      {
          $sql = "SELECT a.*, u.nome " 
		  . "\n FROM agenda as a "
		  . "\n LEFT JOIN usuario as u ON u.id = a.id_medico "
		  . "\n WHERE DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' "
		  . "\n AND (u.id_especialidade = $id_especialidade OR u.id_especialidade2 = $id_especialidade OR u.id_especialidade3 = $id_especialidade OR u.id_especialidade4 = $id_especialidade OR u.id_especialidade5 = $id_especialidade) ";
		  
          $row = ($id_especialidade) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::verificarRetorno()
       * 
       * @return
       */
      public function verificarRetorno($data, $id_paciente, $id_tabela, $id_medico)
      {	 
          $sql = "SELECT a.id " 
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.retorno = 9 AND a.realizado = 1 AND a.id_paciente = '$id_paciente' AND a.id_tabela = '$id_tabela' AND a.id_medico = '$id_medico' AND '$data' <= a.data_retorno";
		  
          $row = self::$db->first($sql);

          return ($row and $row->id) ? $row->id : 0;
      }

      /**
       * Atendimento::verificarGuia()
       * 
       * @return
       */
      public function verificarGuia($id_paciente, $id_tabela, $id_convenio)
      {	 
          $sql = "SELECT a.id " 
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.guia = 2 AND a.realizado = 0 AND a.id_paciente = '$id_paciente' AND a.id_tabela = '$id_tabela' AND a.id_convenio = '$id_convenio'";
		  
          $row = self::$db->first($sql);

          return ($row and $row->id) ? $row->id : 0;
      }

      /**
       * Atendimento::verificarQuantidadeGuia()
       * 
       * @return
       */
      public function verificarQuantidadeGuia($id_paciente, $id_tabela)
      {	 
          $sql = "SELECT COUNT(1) AS quant " 
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.guia > 0 AND a.realizado = 0 AND a.id_paciente = '$id_paciente' AND a.id_tabela = '$id_tabela'";
		  
          $row = self::$db->first($sql);

          return ($row and $row->quant) ? $row->quant : 0;
      }

      /**
       * Atendimento::getAgendaTV()
       * 
       * @return
       */
      public function getAgendaTV($data = false, $id_empresa = false, $limit = false)
      {
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $data = ($data) ? $data : date('d/m/Y');
		  $limit = ($limit) ? $limit : "LIMIT 0,5";
          $sql = "SELECT a.*, t.procedimento, u.nome as medico, u.nome as profissional, p.nome as paciente, p.telefone, p.celular, c.consultorio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN consultorio AS c ON c.id = a.id_consultorio "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado = 6 AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' "
		  . "\n ORDER BY a.data_chamada DESC $limit ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaChegada()
       * 
       * @return
       */
      public function getAgendaChegada($data = false, $id_empresa = false, $limit = false)
      {
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
		  $data = ($data) ? $data : date('d/m/Y');
		  $limit = ($limit) ? $limit : "LIMIT 0,5";
          $sql = "SELECT a.*, t.procedimento, u.nome as medico, p.nome as paciente, p.telefone, p.celular, c.consultorio, e.nome as empresa, e.liberar_pagamento, e.validar_guias " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN consultorio AS c ON c.id = a.id_consultorio "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado NOT IN (1,9) AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' "
		  . "\n ORDER BY a.data_chegada DESC $limit ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getProximasAgenda()
       * 
       * @return
       */
      public function getProximasAgenda($data = false, $id_empresa = false, $limit = false)
      {
		  $id_empresa = ($id_empresa) ? $id_empresa : 1;
		  $data = ($data) ? $data : date('d/m/Y');
		  $limit = ($limit) ? $limit : "LIMIT 0,10";
          $sql = "SELECT a.*, t.procedimento, u.nome as medico, p.nome as paciente, p.telefone, p.celular, c.consultorio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN consultorio AS c ON c.id = a.id_consultorio "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado NOT IN (1,9) AND a.bloqueio = 0 AND a.id_empresa = '$id_empresa' AND a.data_agenda > DATE_SUB(NOW(), INTERVAL 1 HOUR) "
		  . "\n AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' "
		  . "\n ORDER BY a.data_agenda ASC $limit ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Atendimento::getConsultorios()
       * 
       * @return
       */
      public function getConsultorios()
      {		
		  $sql = "SELECT c.id, c.id_empresa, c.consultorio, c.codigo, e.nome " 
		  . "\n FROM consultorio AS c "
		  . "\n LEFT JOIN empresa AS e ON e.id = c.id_empresa "
		  . "\n WHERE c.inativo = 0 "
		  . "\n ORDER BY c.consultorio ";
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Atendimento::getConsultoriosEmpresa()
       * 
       * @return
       */
      public function getConsultoriosEmpresa($id_empresa = false)
      {		
		  $wempresa = ($id_empresa) ? "AND c.id_empresa = $id_empresa" : "AND c.id_empresa =".session('idempresa');
		  $sql = "SELECT c.id, c.id_empresa, c.consultorio, c.codigo, e.nome " 
		  . "\n FROM consultorio AS c "
		  . "\n LEFT JOIN empresa AS e ON e.id = c.id_empresa "
		  . "\n WHERE c.inativo = 0 $wempresa"
		  . "\n ORDER BY c.consultorio ";
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
   	  
	  /**
       * Atendimento::processarConsultorio()
       * 
       * @return
       */
      public function processarConsultorio()
      {
		  $id_empresa = (post('id_empresa')) ? post('id_empresa') : session('idempresa');	
		  if (!$id_empresa)
              Filter::$msgs['id_empresa'] = lang('MSG_ERRO_EMPRESA'); 
		  
		  if (empty($_POST['consultorio']))
              Filter::$msgs['consultorio'] = lang('MSG_ERRO_NOME');

		  if (empty(Filter::$msgs)) {
              $data = array(
					'id_empresa' => $id_empresa,
					'consultorio' => sanitize(post('consultorio')),
					'codigo' => sanitize(post('codigo'))
			  );

              (Filter::$id) ? self::$db->update("consultorio", $data, "id=" . Filter::$id) : self::$db->insert("consultorio", $data);
              
			  $message = (Filter::$id) ? lang('CONSULTORIO_AlTERADO_OK') : lang('CONSULTORIO_ADICIONADO_OK');

              if (self::$db->affected()) {
                  Filter::msgOk($message, "index.php?do=consultorio&acao=listar");
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
   	  
	  /**
       * Atendimento::mudarConsultorio()
       * 
       * @return
       */
      public function mudarConsultorio($id_medico, $id_consultorio)
      {
			unset($_SESSION['idconsultorio']);
            $data = array(
				'id_consultorio' => $id_consultorio
			);
			self::$db->update("usuario", $data, "id=".$id_medico);
			$_SESSION['idconsultorio'] = $id_consultorio;
            
			$message = lang('CONSULTORIO_AlTERADO_OK');
			
            if (self::$db->affected()) {
				redirect_to("index.php?do=medico&acao=agenda");
            }
      }
   	  
	  /**
       * Atendimento::getConsultorioMedico()
       * 
       * @return
       */
      public function getConsultorioMedico($id_medico = 0)
      {
         $sql = "SELECT c.consultorio " 
		  . "\n FROM usuario as u "
		  . "\n LEFT JOIN consultorio AS c ON c.id = u.id_consultorio "
		  . "\n WHERE u.id = '$id_medico' ";
		  
          $row = self::$db->first($sql);

          return ($row and $row->consultorio) ? $row->consultorio : '';
      }

      /**
       * Atendimento::getAtendimentoGuiasPaciente()
       * 
       * @return
       */
      public function getAtendimentoGuiasPaciente($id_paciente = 0, $id_medico = false, $dataini = false, $datafim = false)
      {		  
		 $wmedico = ($id_medico) ? "AND a.id_medico = $id_medico " : "";
		 $datafim = ($datafim) ? $datafim : $dataini;
		 $wdata = ($dataini) ? "AND (a.data_agenda BETWEEN STR_TO_DATE('$dataini 00:00','%d/%m/%Y %H:%i') AND STR_TO_DATE('$datafim 23:59','%d/%m/%Y %H:%i') OR a.data_agenda = '0000-00-00 00:00:00' OR a.data_agenda IS NULL) " : "";
		 $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_repasse AS tabela_repasse, t.percentual_repasse, c.nome as convenio, tc.valor_convenio, e.nome as empresa, e.validar_guias, l.nome as laboratorio, (a.data_agenda > DATE_ADD(a.data_vencimento_guia, INTERVAL 1 DAY)) AS vencida, (a.data_vencimento_guia < CURDATE()) AS venceu, (a.data_vencimento_guia < DATE_ADD(CURDATE(), INTERVAL 7 DAY)) AS vencer" 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS l ON l.id = t.id_laboratorio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.realizado < 9 AND a.bloqueio = 0 AND a.guia > 0 AND a.id_paciente = $id_paciente "
		  . "\n $wmedico "
		  . "\n $wdata "
		  . "\n ORDER BY a.data_agenda DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getMedicosAtendimento()
       * 
       * @return
       */
      public function getMedicosAtendimento($id_paciente = 0)
      {		  
         $sql = "SELECT DISTINCT a.id_medico, u.nome as medico " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n WHERE a.realizado < 9 AND a.id_paciente = $id_paciente "
		  . "\n ORDER BY u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentosExtraPaciente()
       * 
       * @return
       */
      public function getAtendimentosExtraPaciente($id_paciente = 0)
      {		  
         $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_repasse AS tabela_repasse, t.percentual_repasse, c.nome as convenio, tc.valor_convenio, e.nome as empresa, e.validar_guias, l.nome as laboratorio " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS l ON l.id = t.id_laboratorio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.extra = 1 AND a.guia = 0 AND a.id_paciente = $id_paciente "
		  . "\n ORDER BY a.data_agenda DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentosOrcamentoPaciente()
       * 
       * @return
       */
      public function getAtendimentosOrcamentoPaciente($id_paciente = 0)
      {		  
         $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.valor_repasse AS tabela_repasse, t.percentual_repasse, c.nome as convenio, tc.valor_convenio, e.nome as empresa, l.nome as laboratorio " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN cadastro AS l ON l.id = t.id_laboratorio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela_convenio AS tc ON tc.id_tabela = a.id_tabela AND tc.id_cadastro = a.id_convenio "
		  . "\n WHERE a.extra = 1 AND a.guia = 0 AND a.realizado = 0 AND a.id_paciente = $id_paciente "
		  . "\n ORDER BY a.data_agenda DESC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Atendimento::getModelos()
       * 
       * @return
       */
      public function getModelos()
      {	 
          $sql = "SELECT m.id, m.titulo, m.descricao, m.texto, m.id_medico, m.laudo, u.nome AS medico " 
		  . "\n FROM modelo as m "
		  . "\n LEFT JOIN usuario AS u ON u.id = m.id_medico "
		  . "\n WHERE m.inativo = 0 "
		  . "\n ORDER BY m.titulo ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Atendimento::getModelosMedico()
       * 
       * @return
       */
      public function getModelosMedico($id_medico = 0)
      {	 
          $sql = "SELECT m.id, m.titulo, m.descricao, m.texto, m.laudo, m.id_medico " 
		  . "\n FROM modelo as m "
		  . "\n WHERE m.inativo = 0 AND m.laudo = 0 AND (m.id_medico = 0 OR m.id_medico = '$id_medico') "
		  . "\n ORDER BY m.titulo ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Atendimento::getLaudosMedico()
       * 
       * @return
       */
      public function getLaudosMedico($id_medico = 0)
      {	 
          $sql = "SELECT m.id, m.titulo, m.descricao, m.texto, m.laudo, m.id_medico " 
		  . "\n FROM modelo as m "
		  . "\n WHERE m.inativo = 0 AND m.laudo = 1 AND (m.id_medico = 0 OR m.id_medico = '$id_medico') "
		  . "\n ORDER BY m.titulo ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
   	  
	  /**
       * Atendimento::processarModelo()
       * 
       * @return
       */
      public function processarModelo()
      {
			if (empty($_POST['titulo']))
              Filter::$msgs['titulo'] = lang('MSG_ERRO_TITULO');

			if (empty(Filter::$msgs)) {
              $data = array(
					'id_medico' => sanitize(post('id_medico')),
					'titulo' => sanitize(post('titulo')),
					'descricao' => sanitize(post('descricao')),
					'texto' => cleanOut(post('texto')),
					'laudo' => sanitize(post('laudo')),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );

              (Filter::$id) ? self::$db->update("modelo", $data, "id=" . Filter::$id) : self::$db->insert("modelo", $data);
              
			  $message = (Filter::$id) ? lang('MODELO_AlTERADO_OK') : lang('MODELO_ADICIONADO_OK');

              if (self::$db->affected()) {
                  Filter::msgOk($message, "index.php?do=modelo&acao=listar");
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::validaRetornoMedico()
	   *
       * @return
       */
	  public function validaRetornoMedico($id_tabela, $id_medico, $id_convenio)
      {
		 $sql = "SELECT u.sem_retorno " 
		  . "\n FROM usuario_producao as u"
		  . "\n WHERE u.inativo = 0 AND u.id_usuario = '$id_medico' AND (u.id_tabela = '$id_tabela' OR u.id_tabela = 0) AND (u.id_convenio = '$id_convenio' OR u.id_convenio = 0) "
		  . "\n ORDER BY u.id_tabela, u.id_convenio DESC";
          $row = self::$db->first($sql);

          return ($row and $row->sem_retorno) ? $row->sem_retorno : 0;
      }
	  
	  /**
       * Atendimento::getConvenioPaciente()
	   *
       * @return
       */
	  public function getConvenioPaciente($id_paciente)
      {
		 $sql = "SELECT p.id_convenio " 
		  . "\n FROM paciente_convenio AS p"
		  . "\n WHERE p.inativo = 0 AND p.id_convenio > 0 AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY p.principal ";
          $row = ($id_paciente) ? self::$db->first($sql) : null;

          return ($row and $row->id_convenio) ? $row->id_convenio : 0;
      }
	  
	  /**
       * Atendimento::getConvenioMedico()
	   *
       * @return
       */
	  public function getConvenioMedico($id_paciente, $id_medico)
      {
		 $sql = "SELECT a.id_convenio " 
		  . "\n FROM atendimento AS a"
		  . "\n WHERE a.realizado < 9 AND a.bloqueio = 0 AND a.id_convenio > 0 AND a.id_paciente = '$id_paciente' AND a.id_medico = '$id_medico'"
		  . "\n ORDER BY a.id DESC ";
          $row = ($id_paciente and $id_medico) ? self::$db->first($sql) : null;

          return ($row and $row->id_convenio) ? $row->id_convenio : 0;
      }
   	  
	  /**
       * Atendimento::processarGuiaAgenda()
       * 
       * @return
       */
      public function processarGuiaAgenda()
      {				  
		  if (empty($_POST['numero_guia']))
              Filter::$msgs['numero_guia'] = lang('MSG_ERRO_NUMERO_GUIA');  
		  
		  // if (empty($_POST['data_vencimento_guia']))
              // Filter::$msgs['data_vencimento_guia'] = lang('MSG_ERRO_DATA_VENCIMENTO');  
		  
		  if (empty(Filter::$msgs)) {
				
			  $id = post('id');
			  $data_receber_guia = (empty($_POST['data_receber_guia']) or post('data_receber_guia') == '-') ? "NOW()" : dataMySQL(post('data_receber_guia'));
			  $data_vencimento_guia = (empty($_POST['data_vencimento_guia']) or post('data_vencimento_guia') == '-') ? "NOW()" : dataMySQL(post('data_vencimento_guia'));
			  
              $data = array(
					'numero_guia' => sanitize(post('numero_guia')),
					'autorizacao' => sanitize(post('autorizacao')),
					'cid' => sanitize(post('cid')),
					'data_receber_guia' => $data_receber_guia,
					'data_vencimento_guia' => $data_vencimento_guia,
					'usuario_guia' => session('nomeusuario'),
					'data_guia' => "NOW()"
			  );
			  self::$db->update("atendimento", $data, "id=".$id);
              
			  $message = lang('ATENDIMENTO_AlTERADO_OK');

              if (self::$db->affected()) {
                  Filter::msgReload($message);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
   	  
	  /**
       * Atendimento::processarGuias()
       * 
       * @return
       */
      public function processarGuias()
      {
		  if (empty($_POST['numero_guia']))
			Filter::$msgs['numero_guia'] = lang('MSG_ERRO_NUMERO');
		  
		  // if (empty($_POST['data_vencimento_guia']))
              // Filter::$msgs['data_vencimento_guia'] = lang('MSG_ERRO_DATA_VENCIMENTO');  
		
		  if (empty(Filter::$msgs)) {
				
			  $id_atendimento = post('id_atendimento');
			  $data_receber_guia = (empty($_POST['data_receber_guia']) or post('data_receber_guia') == '-') ? "NOW()" : dataMySQL(post('data_receber_guia'));
			  $data_vencimento_guia = (empty($_POST['data_vencimento_guia']) or post('data_vencimento_guia') == '-') ? "NOW()" : dataMySQL(post('data_vencimento_guia'));
			  
			  $contar = count($id_atendimento);
			  for($i=0;$i<$contar;$i++) {
				  $data = array(
						'numero_guia' => sanitize(post('numero_guia')),
						'autorizacao' => sanitize(post('autorizacao')),
						'cid' => sanitize(post('cid')),
						'data_receber_guia' => $data_receber_guia,
						'data_vencimento_guia' => $data_vencimento_guia,
						'usuario_guia' => session('nomeusuario'),
						'data_guia' => "NOW()"
				  );
				  self::$db->update("atendimento", $data, "id=".$id_atendimento[$i]);
			  }             
			  $message = lang('ATENDIMENTO_AlTERADO_OK');

              if (self::$db->affected()) {
                  Filter::msgReload($message);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Atendimento::getValorRepasse()
	   *
       * @return
       */
	  public function getValorRepasse($id_tabela, $id_medico, $id_convenio)
      {
		 $sql = "SELECT u.valor_repasse, u.percentual_repasse " 
		  . "\n FROM usuario_producao as u"
		  . "\n WHERE u.inativo = 0 AND u.id_usuario = '$id_medico' AND (u.id_tabela = '$id_tabela' OR u.id_tabela = 0) AND (u.id_convenio = '$id_convenio' OR u.id_convenio = 0) "
		  . "\n ORDER BY u.id_tabela DESC, u.id_convenio DESC";
          $row = self::$db->first($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Atendimento::getProducao()
	   *
       * @return
       */
	  public function getProducao($id_medico, $dataini = 0, $datafim = 0, $id_empresa = false, $id_convenio = false)
      {		  
		$retorno_row = $this->getListaMedicoPagamento($id_medico, $dataini, $datafim, $id_empresa, $id_convenio);
		$quantidade_producao = 0;
		$valor_producao = 0;
		if($retorno_row) {
			foreach ($retorno_row as $exrow) {
				$producao = $exrow->producao;
				$id_atendimento = $exrow->id;	
				$valor = $exrow->valor_procedimento;	
				$valor_repasse = 0;
				if($exrow->id_retorno == 0) {
					$repasse = $this->getValorRepasse($exrow->id_tabela, $exrow->id_medico, $exrow->id_convenio);
					if($producao == 2) {
						$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
						$valor_repasse = $valor*$percentual_repasse/100;
						if($valor_repasse == 0) {
							$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
						}
					} elseif($producao == 1) {
						$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
						if($valor_repasse == 0) {
							$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
							$valor_repasse = $valor*$percentual_repasse/100;
						}
					}
					$valor_producao += $valor_repasse;
					$quantidade_producao++;
				}
			}
		}
		$array_retorno = array(
			'valor_producao' => $valor_producao,
			'quantidade_producao' => $quantidade_producao
		);
		return $array_retorno;
      }

      /**
       * Atendimento::pagarProducao()       * 
       * tipo = 1: DINHEIRO
       * tipo = 2: CHEQUE
       * tipo = 3: BANCO
       * tipo > 3: CARTOES
       * @return
       */
      public function pagarProducao()
      {		  
		  $id_empresa = post('id_empresa');
		  $id_convenio = post('id_convenio');
		  $nome_medico = post('nome_medico');
		  $id_medico = post('id_medico');
		  $dataini = post('dataini');
		  $datafim = post('datafim');
		  // $quantidade_producao = post('quantidade_producao');
		  // $valor_producao = converteMoeda(post('valor_producao'));
		  
		  $wempresa = ($id_empresa) ? " AND id_empresa = '$id_empresa' " : "";
		  $wconvenio = ($id_convenio) ? " AND id_convenio = '$id_convenio' " : "";
		  if($id_convenio == '-1') {
			$wconvenio = " AND id_convenio = '0' ";
		  }
		  
          if (empty(Filter::$msgs)) {
			  
			$retorno_row = $this->getListaMedicoPagamento($id_medico, $dataini, $datafim, $id_empresa, $id_convenio);
		    $quantidade_producao = 0;
		    $valor_producao = 0;
			if($retorno_row) {
				foreach ($retorno_row as $exrow) {
					$producao = $exrow->producao;
					$id_atendimento = $exrow->id;	
					$valor = $exrow->valor_procedimento;	
					$valor_repasse = 0;
					if($exrow->id_retorno == 0) {
						$repasse = $this->getValorRepasse($exrow->id_tabela, $exrow->id_medico, $exrow->id_convenio);
						if($producao == 2) {
							$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
							$valor_repasse = $valor*$percentual_repasse/100;
							if($valor_repasse == 0) {
								$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
							}
						} elseif($producao == 1) {
							$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
							if($valor_repasse == 0) {
								$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
								$valor_repasse = $valor*$percentual_repasse/100;
							}
						}
						$valor_producao += $valor_repasse;
						$quantidade_producao++;
						$data_atendimento = array(
							'valor_repasse' => $valor_repasse,
							'repasse' => 1,
							'data_repasse' => "NOW()",
							'usuario_repasse' => session('nomeusuario'),
							'usuario' => session('nomeusuario'),
							'data' => "NOW()"
						);
						self::$db->update("atendimento", $data_atendimento, "id=".$id_atendimento);
					}
				}
			}
			$descricao = "PRODUCAO $nome_medico [$quantidade_producao ATENDIMENTOS] ENTRE [$dataini a $datafim]";
			$id_cadastro = getValue('id_cadastro', 'usuario', 'id='.$id_medico);
			$id_cadastro = ($id_cadastro) ? $id_cadastro : getValue("id", "cadastro", "nome='$nome_medico'");
			if($id_cadastro == 0) {
				$row = Core::getRowById("usuario", $id_medico);
				$cpf_cnpj = ($row->cpf) ? limparCPF_CNPJ($row->cpf) : "NULL";
				$data_cadastro = array(
					'id_empresa' => $row->id_empresa,
					'nome' => $row->nome,
					'documento' => $row->identidade,
					'id_especialidade' => $row->id_especialidade,
					'tipo' => 2, 
					'cpf_cnpj' => $cpf_cnpj,  
					'email' => $row->email,
					'cep' => $row->cep,
					'endereco' => $row->endereco,
					'numero' => $row->numero,
					'complemento' => $row->complemento,
					'bairro' => $row->bairro,
					'cidade' => $row->cidade,
					'estado' => $row->estado,
					'telefone' => $row->telefone,
					'celular' => $row->celular,
					'data_cadastro' => "NOW()",
					'inativo' => '0',
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				  );
				  $id_cadastro = self::$db->insert("cadastro", $data_cadastro);
				  $data_update = array(
					'id_cadastro' => $id_cadastro
				  );
				  self::$db->update("usuario", $data_update, "id=".$id_medico);
			}
			
			$data = array(
				'id_empresa' => $id_empresa,
				'id_conta' => 57,
				'id_cadastro' => $id_cadastro,
				'tipo' => 1,
				'descricao' => $descricao,
				'valor' => $valor_producao,
				'valor_pago' => $valor_producao,
				'data_vencimento' => "NOW()",
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  $id_despesa = self::$db->insert("despesa", $data);
			  $data_update = array(
				'agrupar' => $id_despesa
			  );
			  self::$db->update("despesa", $data_update, "id=".$id_despesa);			
			if (self::$db->affected()) {				  
				$message = lang('FINANCEIRO_DESPESAS_ADICIONADO_OK');
				Filter::msgReload($message);
			  } else Filter::msgAlert(lang('NAOPROCESSADO'));
              
          } else
              print Filter::msgStatus();
      }

      /**
       * Atendimento::verificarConsultorio()
       * 
       * @return
       */
      public function verificarConsultorio($data = 0, $id_consultorio = 0, $id_empresa = false)
      {	  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT COUNT(1) AS quant "
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.realizado < 9 AND a.bloqueio = 0 AND a.id_consultorio = '$id_consultorio' AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'";
		  
          $row = self::$db->first($sql);

          return ($row and $row->quant) ? $row->quant : 0;
      }

      /**
       * Atendimento::getAgendaConsultorio()
       * 
       * @return
       */
      public function getAgendaConsultorio($data = 0, $id_consultorio = 0, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.valor_cartao, t.guia as guia_procedimento, t.valor_repasse AS tabela_repasse, c.nome as convenio " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado < 9 AND a.id_consultorio = '$id_consultorio' AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getMedicosDia()
       * 
       * @return
       */
      public function getMedicosDia($data = 0, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.id_medico, u.nome, c.consultorio " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN consultorio AS c ON c.id = u.id_consultorio "
		  . "\n WHERE a.realizado < 9 AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'"
		  . "\n GROUP BY a.id_medico "
		  . "\n ORDER BY c.consultorio, u.nome ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentosDia()
       * 
       * @return
       */
      public function getAtendimentosDia($data = 0, $id_medico = 0, $id_empresa = false)
      {		  
		  $id_empresa = ($id_empresa) ? $id_empresa : session('idempresa');
          $sql = "SELECT a.*, p.nome as paciente, p.telefone, p.celular, c.nome as convenio, e.liberar_pagamento, e.validar_guias, a.data_agenda < CURDATE() AS atrasado, t.procedimento " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado < 9 AND a.id_medico = '$id_medico' AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaPacienteApp()
       * 
       * @return
       */
      public function getAgendaPacienteApp($id_paciente = 0)
      {
         $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.guia as guia_procedimento, c.nome as convenio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado < 9 AND a.id_paciente = $id_paciente "
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAgendaMedico()
       * 
       * @return
       */
      public function getAgendaMedicoApp($id_medico = 0, $data = false)
      {	
         $sql = "SELECT a.*, u.nome as medico, p.nome as paciente, p.telefone, p.celular, t.procedimento, t.valor, t.guia as guia_procedimento, c.nome as convenio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n WHERE a.realizado < 9 AND a.data_agenda > CURDATE() AND a.id_medico = $id_medico "
		  . "\n ORDER BY a.data_agenda ASC ";
		  		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Atendimento::getTotalCredito()
	   *
       * @return
       */
	  public function getTotalCredito($id_paciente = 0)
      {
          $sql = "SELECT SUM(f.valor_pago) AS total " 
		  . "\n FROM paciente_financeiro AS f "
		  . "\n WHERE f.inativo = 0 AND f.pago > 2 AND f.id_paciente = $id_paciente ";
          $row = self::$db->first($sql);

          return ($row and $row->total) ? $row->total : 0;
      }

      /**
       * Atendimento::getAtendimentosData()
       * 
       * @return
       */
      public function getAtendimentosData($data = 0)
      {	
          $sql = "SELECT a.*, p.nome as paciente, p.telefone, p.celular, c.nome as convenio, e.nome AS empresa, e.celular AS celular_empresa, DATE_FORMAT(a.data_agenda,'%H:%i') AS hora, e.whatsapp, t.procedimento, u.nome AS medico " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado < 9 AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentosAgendaManha()
       * 
       * @return
       */
      public function getAtendimentosAgendaManha($data = 0)
      {	
		  $sql = "SELECT a.*, p.nome as paciente, p.telefone, p.celular, c.nome as convenio, e.nome AS empresa, e.celular AS celular_empresa, DATE_FORMAT(a.data_agenda,'%H:%i') AS hora, e.whatsapp, t.procedimento, u.nome AS medico " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado < 9 AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'"
		  . "\n AND HOUR(a.data_agenda) <= 12 "
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentosAgendaTarde()
       * 
       * @return
       */
      public function getAtendimentosAgendaTarde($data = 0)
      {	
		  $sql = "SELECT a.*, p.nome as paciente, p.telefone, p.celular, c.nome as convenio, e.nome AS empresa, e.celular AS celular_empresa, DATE_FORMAT(a.data_agenda,'%H:%i') AS hora, e.whatsapp, t.procedimento, u.nome AS medico " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado < 9 AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data'"
		  . "\n AND HOUR(a.data_agenda) > 12 "
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Atendimento::getAtendimentoPacienteMedico()
       * 
       * @return
       */
      public function getAtendimentoPacienteMedico($id_paciente, $id_medico, $data_agenda)
      {	
          $sql = "SELECT a.id " 
		  . "\n FROM atendimento as a "
		  . "\n WHERE a.realizado IN (2,6) AND a.id_paciente = '$id_paciente' AND a.id_medico = '$id_medico' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data_agenda'"
		  . "\n ORDER BY a.data_agenda ASC ";
		  
          $row = self::$db->first($sql);

          return ($row and $row->id) ? $row->id : 0;
      }
  }
?>