<?php
  /**
   * Classe Core
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');

  class Core
  {
      const sTable = "configuracao";
      public $ano = null;
      public $mes = null;
      public $dia = null;
      public $empresa = "";
      public $whatsapp = "";
      public $primeira_cor = "";
      public $segunda_cor = "";
      public $terceira_cor = "";
      public $site_url = "";
      public $site_sistema = "";
      public $site_email = "";
      public $mailer = "";
      public $smtp_host = "";
      public $smtp_user = "";
      public $smtp_pass = "";
      public $smtp_port = "";
      public $zoom = "";
      public $lat = "";
      public $lng = "";
      public $hora_ini = "";
      public $hora_fim = "";
      public $tempo = "";
      public $linha1 = "";
      public $linha2 = "";
      public $linha3 = "";
      public $fonte = 0;
	  public $language;


      /**
       * Core::__construct()
       * 
       * @return
       */
      function __construct()
      {
          $this->getSettings();
		  $this->getLanguage();
      }

      /**
       * Core::getSettings()
       * 
       * @return
       */
      private function getSettings()
      {
          $sql = "SELECT * FROM " . self::sTable;
          $row = Registry::get("Database")->first($sql);

          $this->empresa = $row->empresa;
          $this->whatsapp = $row->whatsapp;
          $this->primeira_cor = $row->primeira_cor;
          $this->segunda_cor = $row->segunda_cor;
          $this->terceira_cor = $row->terceira_cor;
          $this->site_url = $row->site_url;
          $this->site_sistema = $row->site_sistema;
          $this->site_email = $row->site_email;
          $this->file_types = $row->file_types;
          $this->file_max = $row->file_max;
          $this->mailer = $row->mailer;
          $this->smtp_host = $row->smtp_host;
          $this->smtp_user = $row->smtp_user;
          $this->smtp_pass = $row->smtp_pass;
          $this->smtp_port = $row->smtp_port;
          $this->zoom = $row->zoom;
          $this->lat = $row->lat;
          $this->lng = $row->lng;
          $this->hora_ini = $row->hora_ini;
          $this->hora_fim = $row->hora_fim;
          $this->tempo = $row->tempo;
          $this->linha1 = $row->header_linha1;
          $this->linha2 = $row->header_linha2;
          $this->linha3 = $row->header_linha3;
          $this->fonte = $row->fonte;
      }	  

      /**
       * Core::whatsapp()
       * 
       * @return
       */
      public static function whatsapp()
      {
          return $this->whatsapp;
      } 

      /**
       * Core::fonte()
       * 
       * @return
       */
      public static function fonte()
      {
          return $this->fonte;
      } 

      /**
       * Core::configuracoes()
       * 
       * @return
       */
      public static function configuracoes()
      {
          $sql = "SELECT * FROM " . self::sTable;
          return $row = Registry::get("Database")->first($sql);
      }

	  /**
	   * Core:::getLanguage()
	   * 
	   * @return
	   */
	  private function getLanguage()
	  {
		  $this->langdir = BASEPATH . "lang/";		  
		  include($this->langdir . "pt-br.lang.php");
	  }

      /**
       * Core::getRowById()
       * 
       * @param mixed $table
       * @param mixed $id
       * @param bool $and
       * @param bool $is_admin
       * @return
       */
      public static function getRowById($table, $id, $and = false, $is_admin = true)
      {
          $id = sanitize($id, 8, true);
          if ($and) {
              $sql = "SELECT * FROM " . (string )$table . " WHERE id = '" . Registry::get("Database")->escape((int)$id) . "' AND " . Registry::get("Database")->escape($and) . "";
          } else
              $sql = "SELECT * FROM " . (string )$table . " WHERE id = '" . Registry::get("Database")->escape((int)$id) . "'";

          $row = Registry::get("Database")->first($sql);

          if ($row) {
              return $row;
          } else {
              if ($is_admin)
                  Filter::error("ID selecionado inválido na tabela [$table] - #" . $id, "Core::getRowById()");
          }
      }
	  	  
      /**
       * Core::doForm()
       * 
       * @param mixed $data
       * @param string $url
       * @param integer $reset
       * @param integer $clear
       * @param string $form_id
       * @param string $msgholder
       * @return
       */
      public static function doForm($data, $form_id = "admin_form", $url = "controller.php")
      {
			$display = '<script type="text/javascript">
						$(document).ready(function() {
							$("#' . $form_id . '").submit(function(){
								var dados = $( this ).serialize();
                                var verificaModal = $("#' . $form_id .'").parents().map(function() { return this.className;  }).get().join( ", " );
                                var vinculo = "body";

                                if (verificaModal.indexOf("modal") >= 0)
                                {
                                    vinculo = "#' . $form_id .'";
                                }

								$.ajax({
									type: "POST",
									url: "' . $url . '",
									data: dados+ "&' . $data . '=1",
									success: function( data )
									{
										var response = data.split("#");
										$.bootstrapGrowl(response[0], {
											ele: "body", 
											type: response[1], 
											offset: {
												from: "top",
												amount: 50
											}, 
											align: "left", 
											width: "auto",
											delay: 10000,
											allow_dismiss: true,
											stackup_spacing: 10 
										});
										if(response[2] == 1)
											setTimeout(function(){
												window.location.href=response[3];
											}, 1000);
										if(response[2] == 2)
											setTimeout(function(){
												location.reload();
											}, 1000);
										
									}
								});
								
								return false;
							});
						});
						</script>';
          print $display;
      }

  }
?>