<?php
  /**
   * Classe Despesa
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');

  class Despesa
  {
      const uTable = "despesa";
	  private static $db;

      /**
       * Despesa::__construct()
       * 
       * @return
       */
      function __construct()
      {
          self::$db = Registry::get("Database");
	  }
	  
	  /**
       * Despesa::processarDespesas()
       * id_banco = 0 : RETIRADA EM DINHEIRO DO CAIXA
       * cheque = 1 : PAGAMENTO EM CHEQUE DO BANCO
       * 
       * @return
       */
      public function processarDespesas()
      {
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
			if (empty($_POST['id_cadastro']))
              Filter::$msgs['id_cadastro'] = lang('MSG_ERRO_CADASTRO');
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');
				
			if (empty($_POST['valor']))
              Filter::$msgs['valor'] = lang('MSG_ERRO_VALOR');
				
			if (empty(Filter::$msgs)) {
				
				$dias = (empty($_POST['dias'])) ? 30 : $_POST['dias'];
				
				$data_venc = (empty($_POST['data_vencimento'])) ? date('d/m/Y') : sanitize($_POST['data_vencimento']);
				$id_empresa = (empty($_POST['id_empresa'])) ? session('idempresa') : sanitize($_POST['id_empresa']);
				
				$data_repeticoes = explode('/', $data_venc);	

				$repeticoes = (is_numeric($_POST['repeticoes']) and $_POST['repeticoes'] > 0) ? $_POST['repeticoes'] : 1;
				$repeticoes = ($repeticoes > 60) ? 60 : $repeticoes;
				
				for($i=0;$i<$repeticoes;$i++)
				{
					$mes = ($dias == 30) ? $i : 0;
					$dia = ($dias != 30) ? $dias*$i : 0;
					$newData = date('Y-m-d', mktime(0, 0, 0, $data_repeticoes[1] + $mes, $data_repeticoes[0] + $dia, $data_repeticoes[2]) );
					
					$parc = $i+1;
					
					$descricao = sanitize($_POST['descricao'])." - PARCELA [". $parc . "/".$repeticoes."]";
					
					$data = array(
						'id_empresa' => $id_empresa,
						'id_conta' => sanitize($_POST['id_conta']),
						'id_banco' => sanitize($_POST['id_banco']),
						'id_cadastro' => sanitize($_POST['id_cadastro']),
						'tipo' => sanitize($_POST['tipo']),
						'descricao' => $descricao,
						'valor' => converteMoeda(($_POST['valor'])),
						'valor_pago' => converteMoeda(($_POST['valor'])),
						'data_vencimento' => $newData,
						'nro_documento' => sanitize(post('nro_documento')),
						'cheque' => sanitize(post('cheque')),
						'usuario' => session('nomeusuario'),
						'data' => "NOW()"
					  );					  
					  if ($i == 0) {
						if (post('pago') == 1) {
							$data['pago'] = 1;
							$data_pagamento = (empty($_POST['data_pagamento'])) ? $newData : dataMySQL($_POST['data_pagamento']);
							$data['data_pagamento'] = $data_pagamento;
						}
					  }
					  $id_despesa = self::$db->insert(self::uTable, $data);
					  $data_update = array(
						'agrupar' => $id_despesa
					  );
					  self::$db->update(self::uTable, $data_update, "id=".$id_despesa);
				}
				  
			  $message = lang('FINANCEIRO_DESPESAS_ADICIONADO_OK');
			  if (isset($_POST["novo"])) {
				$redirecionar = "index.php?do=despesa&acao=adicionar&id_despesa=".$id_despesa;
			  } else {				
				$redirecionar = "index.php?do=despesa&acao=despesas&id_despesa=".$id_despesa;
			  }

              if (self::$db->affected()) {
                  Filter::msgOk($message,$redirecionar);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::processarNovaDespesas()
       * id_banco = 0 : RETIRADA EM DINHEIRO DO CAIXA
       * cheque = 1 : PAGAMENTO EM CHEQUE DO BANCO
       * 
       * @return
       */
      public function processarNovaDespesas()
      {			
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
			if (empty($_POST['id_cadastro']))
              Filter::$msgs['id_cadastro'] = lang('MSG_ERRO_CADASTRO');
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');
		  
			if (empty($_POST['id_banco']))
              Filter::$msgs['id_banco'] = lang('MSG_ERRO_BANCO');
		  
			if (empty($_POST['valor']))
              Filter::$msgs['valor'] = lang('MSG_ERRO_VALOR');

			if (empty(Filter::$msgs)) {
				
				$dias = (empty($_POST['dias'])) ? 30 : $_POST['dias'];
				$id_empresa = (empty($_POST['id_empresa'])) ? session('idempresa') : sanitize($_POST['id_empresa']);
				
				$data_venc = (empty($_POST['data_vencimento'])) ? date('Y-m-d') : dataMySQL($_POST['data_vencimento']);
				$data_pag = (empty($_POST['data_pagamento'])) ? date('Y-m-d') : dataMySQL($_POST['data_pagamento']);
				
				$data = array(
						'id_empresa' => $id_empresa,
						'id_conta' => sanitize($_POST['id_conta']),
						'id_banco' => sanitize($_POST['id_banco']),
						'id_cadastro' => sanitize($_POST['id_cadastro']),
						'tipo' => sanitize($_POST['tipo']),
						'descricao' => sanitize($_POST['descricao']),
						'valor' => converteMoeda(($_POST['valor'])),
						'valor_pago' => converteMoeda(($_POST['valor'])),
						'data_vencimento' => $data_venc,
						'data_pagamento' => $data_pag,
						'nro_documento' => $nro_documento,
						'pago' => 1,
						'cheque' => sanitize(post('cheque')),
						'usuario' => session('nomeusuario'),
						'data' => "NOW()"
					  );	
					  
					  $id_despesa = self::$db->insert(self::uTable, $data);
					  $data_update = array(
						'agrupar' => $id_despesa
					  );
					  self::$db->update(self::uTable, $data_update, "id=".$id_despesa);
				
				  
			  $message = lang('FINANCEIRO_DESPESAS_ADICIONADO_OK');

              if (self::$db->affected()) {
				  fecharjanela();
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::editarDespesasPagas()
       * 
       * @return
       */
      public function editarDespesasPagas()
      {
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');
								
			if (empty(Filter::$msgs)) {			
				$id_empresa = (empty($_POST['id_empresa'])) ? session('idempresa') : sanitize($_POST['id_empresa']);
				
				$data = array(
					'id_empresa' => $id_empresa,
					'id_cadastro' => sanitize($_POST['id_cadastro']),
					'tipo' => sanitize($_POST['tipo']),
					'id_conta' => sanitize($_POST['id_conta']),
					'id_banco' => sanitize($_POST['id_banco']),
					'descricao' => sanitize($_POST['descricao']),
					'data_vencimento' => dataMySQL($_POST['data_vencimento']),
					'data_pagamento' => dataMySQL($_POST['data_pagamento']),
					'pago' => post('pago'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update(self::uTable, $data, "id=".$_POST['id']);
				  
			  $message = lang('FINANCEIRO_DESPESAS_AlTERADO_OK');
			  
			  $redirecionar = "index.php?do=despesa&acao=despesaspagas";

              if (self::$db->affected()) {
                  Filter::msgOk($message, $redirecionar);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::agruparDespesas()
       * 
       * @return
       */
      public function agruparDespesas()
      {
			if (empty($_POST['agrupar']))
				Filter::$msgs['agrupar'] = lang('MSG_ERRO_DESPESA');

			if (empty(Filter::$msgs)) {			
				
			  $agrupar = $_POST['agrupar'];
			  $contar = count($agrupar);
			  
			  for ($i=0; $i<$contar; $i++) 
			  {
				$data = array(
					'agrupar' => $agrupar[0],
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update(self::uTable, $data, "id=".$agrupar[$i]);
			  }
				  
			  $message = lang('FINANCEIRO_DESPESAS_AGRUPAR_OK');
			  
			  $redirecionar = "index.php?do=despesa&acao=agrupar";

              if (self::$db->affected()) {
                  Filter::msgOk($message, $redirecionar);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::agruparPagarDespesasCartoes()
       * 
       * @return
       */
      public function agruparPagarDespesasCartoes()
      {
			if (empty($_POST['agrupar']))
				Filter::$msgs['agrupar'] = lang('MSG_ERRO_DESPESA');
			
			if (empty($_POST['id_banco']))
				Filter::$msgs['id_banco'] = lang('MSG_ERRO_BANCO');				

			if (empty($_POST['data_pagamento']))
				Filter::$msgs['data_pagamento'] = lang('MSG_ERRO_DATA');

			if (empty(Filter::$msgs)) {			
				
			  $agrupar = $_POST['agrupar'];
			  $contar = count($agrupar);
			  
			  for ($i=0; $i<$contar; $i++) 
			  {
				$data = array(				
					'id_banco' => sanitize($_POST['id_banco']),
					'data_pagamento' => dataMySQL($_POST['data_pagamento']),
					'pago' => '1',
					'agrupar' => $agrupar[0],
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update(self::uTable, $data, "id=".$agrupar[$i]);
			  }
				  
			  $message = lang('FINANCEIRO_DESPESAS_AGRUPAR_OK');
			  
			  $redirecionar = "index.php?do=despesa&acao=despesaspagas";

              if (self::$db->affected()) {
                  Filter::msgOk($message, $redirecionar);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::editarDespesas()
       * 
       * @return
       */
      public function editarDespesas()
      {
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');

			if (empty($_POST['data_vencimento']))
				Filter::$msgs['data_vencimento'] = lang('MSG_ERRO_DATA');

			if (empty(Filter::$msgs)) {			
				$id_empresa = (empty($_POST['id_empresa'])) ? session('idempresa') : sanitize($_POST['id_empresa']);
				
				$data = array(
					'id_empresa' => $id_empresa,
					'id_cadastro' => sanitize($_POST['id_cadastro']),
					'tipo' => sanitize($_POST['tipo']),
					'id_conta' => sanitize($_POST['id_conta']),
					'id_banco' => sanitize($_POST['id_banco']),
					'descricao' => sanitize($_POST['descricao']),	
					'valor' => converteMoeda($_POST['valor']),			
					'valor_pago' => converteMoeda($_POST['valor']),			
					'cheque' => sanitize(post('cheque')),				
					'nro_documento' => sanitize($_POST['nro_documento']),
					'data_vencimento' => dataMySQL($_POST['data_vencimento']),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update(self::uTable, $data, "id=".$_POST['id']);
				  
			  $message = lang('FINANCEIRO_DESPESAS_AlTERADO_OK');

              if (self::$db->affected()) {
                  Filter::msgReload($message);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::duplicarDespesas()
       * 
       * @return
       */
      public function duplicarDespesas()
      {
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');

			if (empty($_POST['data_vencimento']))
				Filter::$msgs['data_vencimento'] = lang('MSG_ERRO_DATA');

			if (empty(Filter::$msgs)) {			
				$id_empresa = (empty($_POST['id_empresa'])) ? session('idempresa') : sanitize($_POST['id_empresa']);
				
				$data = array(
					'id_empresa' => $id_empresa,
					'id_cadastro' => sanitize($_POST['id_cadastro']),
					'tipo' => sanitize($_POST['tipo']),
					'id_conta' => sanitize($_POST['id_conta']),
					'id_banco' => sanitize($_POST['id_banco']),
					'descricao' => sanitize($_POST['descricao']),	
					'valor' => converteMoeda($_POST['valor']),			
					'valor_pago' => converteMoeda($_POST['valor']),			
					'cheque' => sanitize(post('cheque')),				
					'nro_documento' => sanitize($_POST['nro_documento']),
					'data_vencimento' => dataMySQL($_POST['data_vencimento']),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				$id_despesa = self::$db->insert(self::uTable, $data);
				$data_update = array(
					'agrupar' => $id_despesa
				);
				 self::$db->update(self::uTable, $data_update, "id=".$id_despesa);
				  
			  $message = lang('FINANCEIRO_DESPESAS_DUPLICADA_OK');
			$redirecionar = "index.php?do=despesa&acao=despesas";		

              if (self::$db->affected()) {
                  Filter::msgOk($message, $redirecionar);
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::processarPagamentoDespesas()
       * 
       * @return
       */
      public function processarPagamentoDespesas($pag)
      {
		if (empty($_POST['id_banco']))
			Filter::$msgs['id_banco'] = lang('MSG_ERRO_BANCO');	

		if (empty(Filter::$msgs)) {	
			
			$novo = false;
			$data_pagamento = (empty($_POST['data_pagamento'])) ? "NOW()" : dataMySQL($_POST['data_pagamento']);
			$valor_pago = 0;
			$valor = getValue("valor", "despesa", "id=".$pag);
			if(empty($_POST['valor_pago'])) {				
				$valor_pago = $valor;
			} else {
				$valor_pago = converteMoeda(post('valor_pago'));
				if($valor_pago < $valor) {
					$valor = $valor - $valor_pago;
					$novo = true;
				}
			}

			$data = array(
					'id_banco' => sanitize($_POST['id_banco']),				
					'nro_documento' => sanitize($_POST['nro_documento']),				
					'cheque' => sanitize(post('cheque')),				
					'data_pagamento' => $data_pagamento,
					'valor_pago' => $valor_pago,
					'pago' => '1',
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );

              self::$db->update(self::uTable, $data, "id=".$pag);
              $message = lang('FINANCEIRO_DESPESAS_PAGAMENTO_OK');

              if (self::$db->affected()) {
				  if($novo) {
                  Filter::msgOk($message, "index.php?do=despesa&acao=adicionar&novo=1&id_despesa=".$pag."&valor=".$valor);
				  } else {
                  Filter::msgOk($message, "index.php?do=despesa&acao=despesas");
				  }				  
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
		} else
			print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::getContasDespesas()
       * 
       * @return
       */
      public function getContasDespesas($mes_ano)
      {		  
		  $sql = "SELECT pai.id, pai.conta " 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta"
		  . "\n LEFT JOIN conta as pai ON pai.id = c.id_pai" 
		  . "\n WHERE f.inativo = 0 AND DATE_FORMAT(f.data_vencimento, '%m/%Y') = '$mes_ano' "
		  . "\n GROUP BY pai.conta"
		  . "\n ORDER BY pai.conta";
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Despesa::getDespesas()
       * 
       * @return
       */
      public function getDespesas($dataini = false, $datafim = false, $id_banco = false, $id_conta = false , $id_cadastro = false, $valor = false)
      {
          
          $dataini = ($dataini) ? $dataini : date('d/m/Y', strtotime('-5 days')); 
          $datafim = ($datafim) ? $datafim : date('d/m/Y', strtotime('35 days'));
		  $where = "AND f.data_vencimento BETWEEN STR_TO_DATE('$dataini 00:00:00','%d/%m/%Y %H:%i:%s') AND STR_TO_DATE('$datafim 23:59:59','%d/%m/%Y %H:%i:%s')";
		  $wherebanco = ($id_banco) ? "AND f.id_banco = $id_banco" : "";
		  $wherecadastro = ($id_cadastro) ? "AND f.id_cadastro = $id_cadastro" : "";
		  $whereconta = ($id_conta) ? "AND (c.id = $id_conta OR c.id_pai = $id_conta)" : "";
		  $wherevalor = ($valor) ? "AND f.valor = ".converteMoeda($valor) : "";
		  		  
		  $sql = "SELECT f.id, f.id_conta, f.id_banco, c.conta, b.banco, fr.nome as cadastro, f.descricao, f.valor, f.cheque, f.id_cadastro, f.data_vencimento, f.nro_documento, f.data_vencimento < CURDATE() as atrasado, f.data_vencimento = CURDATE() as hoje, DATE_FORMAT(f.data_vencimento, '%Y%m%d') as controle, e.nome as empresa" 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN empresa as e ON e.id = f.id_empresa" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.inativo = 0 AND f.pago = 0 "
		  . "\n $where"
		  . "\n $wherebanco"
		  . "\n $wherecadastro"
		  . "\n $whereconta"
		  . "\n $wherevalor"
		  . "\n ORDER BY f.data_vencimento";
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }	  
	  
	  /**
       * Despesa::totalDespesas()
       * 
       * @return
       */
      public function totalDespesas($dataini = false, $datafim = false, $emp = false)
      {
          $where = "";
		  if ($dataini)
		  {
			$datafim = ($datafim) ? $datafim : date("d/m/Y");	 
			$where = "AND f.data_vencimento BETWEEN STR_TO_DATE('$dataini 00:00:00','%d/%m/%Y %H:%i:%s') AND STR_TO_DATE('$datafim 23:59:59','%d/%m/%Y %H:%i:%s')";
		  }	
		  
		  $sql = "SELECT SUM(f.valor) as total" 
		  . "\n FROM despesa as f" 
		  . "\n WHERE inativo = 0 AND pago = 0 AND f.id_cadastro > 0  AND f.id_cadastro < 99999 "
		  . "\n $where";
		  $row = self::$db->first($sql);

          return ($row) ? $row->total : 0;
      }
	  
	  /**
       * Despesa::getDetalhesDespesa()
       * 
       * @return
       */
      public function getDetalhesDespesa($id_despesa = 0)
      {		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome as cadastro, f.agrupar, f.descricao, f.valor, f.valor_pago, f.cheque, f.data_vencimento, f.data_pagamento, f.conciliado, f.nro_documento, e.nome as empresa, f.pago, f.usuario, f.id_cadastro, f.id_empresa, f.tipo, t.tipo as pagamento " 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN empresa as e ON e.id = f.id_empresa" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = f.tipo " 
		  . "\n WHERE f.id = '$id_despesa' ";
		  //echo $sql;
		  $row = self::$db->first($sql);

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::getDespesasPagas()
       * 
       * @return
       */
      public function getDespesasPagas($dataini = false, $datafim = false, $id_banco = false, $id_conta = false , $id_cadastro = false, $valor = false, $numero = false)
      {
          $dataini = ($dataini) ? $dataini : date('d/m/Y', strtotime('-15 days')); 
          $datafim = ($datafim) ? $datafim : date("d/m/Y");
		  $where = "AND f.data_pagamento BETWEEN STR_TO_DATE('$dataini 00:00:00','%d/%m/%Y %H:%i:%s') AND STR_TO_DATE('$datafim 23:59:59','%d/%m/%Y %H:%i:%s')";
		  $wherebanco = ($id_banco) ? "AND f.id_banco = $id_banco" : "";
		  //PARA NÃO APARECER AS TRANSFERENCIAS BANCARIAS
		  //$wherecadastro = ($id_cadastro) ? "AND f.id_cadastro = $id_cadastro" : "AND f.id_cadastro > 0 ";
		  $wherecadastro = ($id_cadastro) ? "AND f.id_cadastro = $id_cadastro" : "";
		  $whereconta = ($id_conta) ? "AND (c.id = $id_conta OR c.id_pai = $id_conta)" : "";
		  $wherevalor = ($valor) ? "AND f.valor = ".converteMoeda($valor) : "";
		  $wherenumero = ($numero) ? "AND f.nro_documento like '%$numero%'" : "";
		  
		  $sql = "SELECT f.id, f.id_caixa, c.conta, b.banco, fr.nome as cadastro, f.agrupar, f.descricao, f.valor, f.valor_pago, f.cheque, f.data_vencimento, f.data_pagamento, f.conciliado, f.nro_documento, DATE_FORMAT(f.data_pagamento, '%Y%m%d') as controle, e.nome as empresa, f.id_cadastro " 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN empresa as e ON e.id = f.id_empresa" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.inativo = 0 AND f.pago = 1 "
		  . "\n $where"
		  . "\n $wherebanco"
		  . "\n $wherecadastro"
		  . "\n $whereconta"
		  . "\n $wherevalor"
		  . "\n $wherenumero"
		  . "\n ORDER BY f.data_pagamento";
		  // echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::getDespesasCartoes()
       * 
       * @return
       */
      public function getDespesasCartoes($numero = false)
      {
		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome as cadastro, f.agrupar, f.descricao, f.valor, f.valor_pago, f.cheque, f.data_vencimento, f.data_pagamento, f.conciliado, f.nro_documento, DATE_FORMAT(f.data_vencimento, '%Y%m%d') as controle, e.nome as empresa, f.id_cadastro " 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN empresa as e ON e.id = f.id_empresa" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.inativo = 0 AND f.pago = 0 "
		  . "\n AND f.nro_documento = '$numero' "
		  . "\n ORDER BY f.data_vencimento";
		  //echo $sql;
		  $row = ($numero) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::getDespesascadastro()
       * 
       * @return
       */
      public function getDespesascadastro($id_cadastro = 0)
      {		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome as cadastro, f.agrupar, f.descricao, f.valor, f.valor_pago, f.cheque, f.data_vencimento, f.id_cadastro, f.data_pagamento, f.conciliado, f.nro_documento, f.pago, f.inativo, DATE_FORMAT(f.data_pagamento, '%Y%m%d') as controle, e.nome as empresa" 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN empresa as e ON e.id = f.id_empresa" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.id_cadastro = '$id_cadastro' "
		  . "\n ORDER BY f.data_pagamento";
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::getDespesasDia()
       * 
       * @return
       */
      public function getDespesasDia($consdata = false)
      {
          $data = ($consdata) ? $consdata : date("d/m/Y");	  
		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome, f.descricao, f.valor, f.data_pagamento" 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta"
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro"
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco"
		  . "\n WHERE f.inativo = 0  AND f.id_cadastro > 0 AND f.id_cadastro < 99999 "
		  . "\n AND DATE_FORMAT(f.data_pagamento, '%d/%m/%Y') = '$data'"
		  . "\n ORDER BY f.data_pagamento";
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Despesa::totalDespesas()
       * 
       * @return
       */
      public function totalDespesasPagas($consdata = false)
      {		  
          $data = ($consdata) ? $consdata : date("d/m/Y");
		  
		  $sql = "SELECT SUM(valor) as total FROM despesa"
		  . "\n WHERE pago = 1 AND inativo = 0  AND id_cadastro = 0 AND DATE_FORMAT(data_pagamento, '%d/%m/%Y') = '$data'";
		  $row = self::$db->first($sql);

          return ($row) ? $row->total : 0;
      }
	  
	  /**
       * Despesa::totalDespesasMes()
       * 
       * @return
       */
      public function totalDespesasMes($consdata = false, $id_conta = false, $pago = 1)
      {		  
          $data = ($consdata) ? $consdata : date("m/Y");
          $conta = ($id_conta) ? "AND id_conta = '$id_conta'" : "";
		  
		  $sql = "SELECT SUM(valor) as total FROM despesa"
		  . "\n WHERE inativo = 0 AND pago = $pago  AND id_cadastro = 0 AND DATE_FORMAT(data_vencimento, '%m/%Y') = '$data' $conta";
		  //echo $sql;
		  $row = self::$db->first($sql);

          return ($row) ? $row->total : 0;
      }
	  
	  /**
       * Despesa::totalDespesasPaiMes()
       * 
       * @return
       */
      public function totalDespesasPaiMes($id_conta, $consdata = false, $pago = 1)
      {		  
          $data = ($consdata) ? $consdata : date("m/Y");
		  
		  $sql = "SELECT SUM(valor) as total FROM despesa as f, conta as c"
		  . "\n WHERE f.id_conta = c.id AND c.id_pai = $id_conta AND inativo = 0 AND pago = $pago AND DATE_FORMAT(data_vencimento, '%m/%Y') = '$data'";
		  //echo $sql;
		  $row = self::$db->first($sql);

          return ($row) ? $row->total : 0;
      }  
	  
	  /**
       * Despesa::getDespesasDRE()
       * 
       * @return
       */
      public function getDespesasDRE($dataini = false, $datafim = false, $id_conta = false)
      {
          $dataini = ($dataini) ? $dataini : date('01/m/Y'); 
          $datafim = ($datafim) ? $datafim : date("31/m/Y");
		  $where = "AND f.data_pagamento BETWEEN STR_TO_DATE('$dataini 00:00:00','%d/%m/%Y %H:%i:%s') AND STR_TO_DATE('$datafim 23:59:59','%d/%m/%Y %H:%i:%s')";
		  $whereconta = ($id_conta) ? "AND (c.id = $id_conta OR c.id_pai = $id_conta)" : "";
		  
		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome as cadastro, f.agrupar, f.descricao, f.valor, f.cheque, f.data_vencimento, f.data_pagamento, f.nro_documento, DATE_FORMAT(f.data_pagamento, '%Y%m%d') as controle" 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.inativo = 0 AND f.pago = 1 AND c.dre = 1 AND c.exibir = 1 AND f.id_cadastro > 0 AND f.id_cadastro < 99999 " 
		  . "\n $where" 
		  . "\n $whereconta" 
		  . "\n ORDER BY f.data_pagamento ASC ";
		  
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::processarRetirarCaixa()
       * 
       * @return
       */
      public function processarRetirarCaixa()
      {
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');
				
			if (empty($_POST['valor']))
              Filter::$msgs['valor'] = lang('MSG_ERRO_VALOR');

		if (empty(Filter::$msgs)) {	

			$data = array(		
				'id_empresa' => session('idempresa'),				
				'id_caixa' => 1,				
				'id_conta' => sanitize(post('id_conta')),			
				'id_cadastro' => sanitize(post('id_cadastro')),	
				'tipo' => 1,		
				'descricao' => sanitize(post('descricao')),				
				'valor' => converteMoeda(post('valor')),				
				'valor_pago' => converteMoeda(post('valor')),		
				'data_caixa' => "NOW()",
				'data_vencimento' => "NOW()",
				'data_pagamento' => "NOW()",
				'pago' => '1',
				'usuario_caixa' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			);
            $id_despesa = self::$db->insert(self::uTable, $data);
			$data_update = array(
				'agrupar' => $id_despesa
			);
			self::$db->update(self::uTable, $data_update, "id=".$id_despesa);
            $message = lang('FINANCEIRO_DESPESAS_PAGAMENTO_OK');

            if (self::$db->affected()) {
                Filter::msgOk($message, "index.php?do=caixa&acao=listar");	
            } else
				Filter::msgAlert(lang('NAOPROCESSADO'));
		} else
			print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::processarDebitoBanco()
       * 
       * @return
       */
      public function processarDebitoBanco()
      {
			if (empty($_POST['id_conta']))
				Filter::$msgs['id_conta'] = lang('MSG_ERRO_CONTA');	
				
			if (empty($_POST['id_banco']))
              Filter::$msgs['id_banco'] = lang('MSG_ERRO_BANCO');
				
			if (empty($_POST['id_cadastro']))
              Filter::$msgs['id_cadastro'] = lang('MSG_ERRO_CADASTRO');
				
			if (empty($_POST['descricao']))
              Filter::$msgs['descricao'] = lang('MSG_ERRO_DESCRICAO');
				
			if (empty($_POST['valor']))
              Filter::$msgs['valor'] = lang('MSG_ERRO_VALOR');

		if (empty(Filter::$msgs)) {	
		
			$data = array(					
				'id_banco' => sanitize($_POST['id_banco']),				
				'id_conta' => sanitize($_POST['id_conta']),				
				'id_cadastro' => sanitize($_POST['id_cadastro']),			
				'tipo' => sanitize($_POST['tipo']),			
				'descricao' => sanitize($_POST['descricao']),				
				'valor' => converteMoeda($_POST['valor']),				
				'valor_pago' => converteMoeda($_POST['valor']),				
				'data_vencimento' => "NOW()",
				'data_pagamento' => "NOW()",
				'pago' => '1',
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			);
            $id_despesa = self::$db->insert(self::uTable, $data);	
			$data_update = array(
				'agrupar' => $id_despesa
			);
			self::$db->update(self::uTable, $data_update, "id=".$id_despesa);
            $message = lang('BANCO_TRANSACAO_OK');

            if (self::$db->affected()) {
                Filter::msgOk($message, "index.php?do=banco&acao=listar");	
            } else
				Filter::msgAlert(lang('NAOPROCESSADO'));
		} else
			print Filter::msgStatus();
      }
	  
	  /**
       * Despesa::totalDebitoBanco()
       * 
       * @return
       */
      public function totalDebitoBanco($id_banco)
      {		  
	  
		  $sql = "SELECT SUM(valor) as total FROM despesa "
		  . "\n WHERE id_banco = '$id_banco' AND pago = 1 AND inativo = 0";
		  $row = self::$db->first($sql);

          return ($row) ? $row->total : 0;
      }
	  
	  /**
       * Despesa::detalhesDespesa()
       * 
       * @return
       */
      public function detalhesDespesa($id_despesa = 0)
      {
		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome as cadastro, f.descricao, f.valor, f.cheque, f.data_vencimento, f.data_pagamento, f.nro_documento, DATE_FORMAT(f.data_pagamento, '%Y%m%d') as controle" 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.id = $id_despesa ";
		  //echo $sql;
		  $row = self::$db->first($sql);

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::getDREMes()
       * 
       * @return
       */
      public function getDREMes($mes_ano = 0)
      {
		  $sql = "SELECT c.id, c.id_pai, p.conta AS conta_pai, c.conta, SUM(d.valor) as total, SUM(m.meta) as meta " 
		  . "\n FROM conta AS c" 
		  . "\n LEFT JOIN conta AS p ON p.id = c.id_pai" 
		  . "\n LEFT JOIN despesa AS d ON c.id = d.id_conta AND d.inativo = 0 " 
		  . "\n 	AND d.pago = 1 " 
		  . "\n 	AND DATE_FORMAT(d.data_pagamento, '%m/%Y') = '$mes_ano' " 
		//  . "\n 	AND d.id_cadastro > 0 " 
		  . "\n LEFT JOIN conta_meta AS m ON c.id = m.id_conta  "
		  . "\n 	AND DATE_FORMAT(m.mes_ano, '%m/%Y') = '$mes_ano' " 
		  . "\n WHERE  c.id_pai IS NOT NULL AND c.tipo = 'D' AND p.dre = 1 AND c.dre = 1 AND p.exibir = 1 AND c.exibir = 1 " 
		  . "\n GROUP BY c.id_pai , c.id " 
		  . "\n ORDER BY p.ordem, c.ordem, p.conta , c.conta ASC ";
		  
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	  } 
	  
	  /**
       * Despesa::getDREPrevisaoMes()
       * 
       * @return
       */
      public function getDREPrevisaoMes($mes_ano = 0)
      {
		  $sql = "SELECT c.id, c.id_pai, p.conta AS conta_pai, c.conta, SUM(d.valor) as total, SUM(m.meta) as meta " 
		  . "\n FROM conta AS c" 
		  . "\n LEFT JOIN conta AS p ON p.id = c.id_pai" 
		  . "\n LEFT JOIN despesa AS d ON c.id = d.id_conta AND d.inativo = 0 "
		  . "\n 	AND DATE_FORMAT(d.data_vencimento, '%m/%Y') = '$mes_ano' " 
		  //. "\n 	AND d.id_cadastro > 0 " 
		  . "\n LEFT JOIN conta_meta AS m ON c.id = m.id_conta  "
		  . "\n 	AND DATE_FORMAT(m.mes_ano, '%m/%Y') = '$mes_ano' " 
		  . "\n WHERE  c.id_pai IS NOT NULL AND c.tipo = 'D' AND p.dre = 1 AND c.dre = 1 AND p.exibir = 1 AND c.exibir = 1 " 
		  . "\n GROUP BY c.id_pai , c.id " 
		  . "\n ORDER BY p.ordem, c.ordem, p.conta , c.conta ASC ";
		  
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	  } 
	  
	  /**
       * Despesa::getContas()
       * 
       * @return
       */
      public function getContas()
      {
		  
		  $sql = "SELECT c.id, c.id_pai, p.conta AS conta_pai, c.conta " 
		  . "\n FROM conta AS c" 
		  . "\n LEFT JOIN conta AS p ON p.id = c.id_pai" 
		  . "\n WHERE c.exibir = 1 AND c.id_pai IS NOT NULL AND c.tipo = 'D' AND p.dre = 1 AND c.dre = 1 AND p.exibir = 1 AND c.exibir = 1 " 
		  . "\n ORDER BY p.ordem, c.ordem, p.conta , c.conta ASC ";
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	}
	  
	  /**
       * Despesa::getListaDespesasDRE()
       * 
       * @return
       */
      public function getListaDespesasDRE($id_conta, $mes, $ano)
      {		  
		  $sql = "SELECT f.id, c.conta, b.banco, fr.nome as cadastro, f.agrupar, f.descricao, f.valor, f.cheque, f.data_vencimento, f.data_pagamento, f.conciliado, f.nro_documento, f.id_caixa, DATE_FORMAT(f.data_pagamento, '%Y%m%d') as controle" 
		  . "\n FROM despesa as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN cadastro as fr ON fr.id = f.id_cadastro" 
		  . "\n WHERE f.inativo = 0 AND f.pago = 1 "
		  . "\n AND f.id_conta = $id_conta "
		  . "\n AND MONTH(f.data_pagamento) = $mes "
		  . "\n AND YEAR(f.data_pagamento) = $ano "
		  . "\n ORDER BY f.data_pagamento";
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
	} 
	  
	  /**
       * Despesa::getCaixaTotalRetirada()
	   *
       * @return
       */
	  public function getCaixaTotalRetirada($data, $nomeusuario)
      {
         $sql = "SELECT SUM(f.valor_pago) AS valor_total" 
		  . "\n FROM despesa as f" 
		  . "\n WHERE DATE_FORMAT(f.data_caixa, '%d/%m/%Y') = '$data' AND f.usuario_caixa = '$nomeusuario' AND f.inativo = 0 AND f.id_caixa = 1 AND f.pago = 1 ";
          $row = self::$db->first($sql);

          return ($row) ? $row->valor_total : 0;
      }
	  
	  /**
       * Despesa::getCaixaListaRetiradaData()
       * 
       * @return
       */
      public function getCaixaListaRetiradaData($data, $nomeusuario)
      {		  
		  $sql = "SELECT d.id_caixa, d.id_conta, d.id_cadastro, d.descricao, d.valor, f.nome as cadastro, c.conta  " 
		  . "\n FROM despesa as d" 
		  . "\n LEFT JOIN conta as c ON c.id = d.id_conta"
		  . "\n LEFT JOIN cadastro as f ON f.id = d.id_cadastro" 
		  . "\n WHERE d.inativo = 0 AND DATE_FORMAT(d.data_caixa, '%d/%m/%Y') = '$data' AND d.usuario_caixa = '$nomeusuario' AND d.id_caixa = 1 AND d.pago = 1 "
		  . "\n ORDER BY f.nome ";
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Despesa::getCaixaListaRetirada()
       * 
       * @return
       */
      public function getCaixaListaRetirada($data, $id_empresa)
      {		  
		  $sql = "SELECT d.id_caixa, d.id_conta, d.id_cadastro, d.descricao, d.valor, d.usuario_caixa, f.nome as cadastro, c.conta  " 
		  . "\n FROM despesa as d" 
		  . "\n LEFT JOIN conta as c ON c.id = d.id_conta"
		  . "\n LEFT JOIN cadastro as f ON f.id = d.id_cadastro" 
		  . "\n WHERE d.inativo = 0 AND DATE_FORMAT(d.data_caixa, '%d/%m/%Y') = '$data' AND d.id_empresa = '$id_empresa' AND d.id_caixa = 1 AND d.pago = 1 "
		  . "\n ORDER BY f.nome ";
		  //echo $sql;
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Despesa::getContasDRE()
       * 
       * @return
       */
      public function getContasDRE()
      {
		  $sql = "SELECT c.id_pai, p.id, p.conta " 
		  . "\n FROM conta AS c" 
		  . "\n LEFT JOIN conta AS p ON p.id = c.id_pai"
		  . "\n WHERE  c.id_pai IS NOT NULL AND c.tipo = 'D' AND p.dre = 1 AND c.dre = 1 AND p.exibir = 1 AND c.exibir = 1 " 
		  . "\n GROUP BY c.id_pai" 
		  . "\n ORDER BY c.id_pai ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
  }
?>