<?php
  /**
   * Classe Empresa
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');

  class Empresa
  {
      const uTable = "empresa";
      public $did = 0;
      public $empresaid = 0;
      private static $db;

      /**
       * Empresa::__construct()
       * 
       * @return
       */
      function __construct()
      {
          self::$db = Registry::get("Database");
      }

      /**
       * Empresa::getEmpresas()
       * 
       * @return
       */
      public function getEmpresas()
      {
		  $where = "";
		  if (Registry::get("Usuario")->nivel < 2) {
              $where = "AND id = ".session('idempresa');
          }
		 $sql = "SELECT id, nome, telefone, email, endereco, numero, cidade, iss_aliquota, cfop, retorno, convenio, enotas FROM empresa WHERE inativo = 0 $where ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Empresa::getEmpresasTodas()
       * 
       * @return
       */
      public function getEmpresasTodas()
      {
		 $sql = "SELECT id, nome, telefone, email, endereco, numero, cidade, iss_aliquota, cfop, retorno, convenio, enotas FROM empresa WHERE inativo = 0 ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Empresa::processarEmpresa()
       * 
       * @return
       */
      public function processarEmpresa()
      {
		  if (empty($_POST['nome']))
              Filter::$msgs['nome'] = lang('MSG_ERRO_NOME');	  

          if (empty(Filter::$msgs)) {

              $data = array(
					'nome' => sanitize(post('nome')), 
					'razao_social' => sanitize(post('nome')), 
					'sigla' => sanitize(post('sigla')), 
					'cnpj' => limparCPF_CNPJ(post('cnpj')), 
					'endereco' => sanitize(post('endereco')), 
					'numero' => sanitize(post('numero')), 
					'complemento' => sanitize(post('complemento')),  
					'bairro' => sanitize(post('bairro')),  
					'cidade' => sanitize(post('cidade')),  
					'estado' => sanitize(post('estado')),  
					'cep' => sanitize(post('cep')), 
					'responsavel' => sanitize(post('responsavel')), 
					'telefone' => sanitize(post('telefone')),  
					'celular' => sanitize(post('celular')),   
					'email' => sanitize(post('email')),
					'agenda_clara' => sanitize(post('agenda_clara')),  
					// 'retorno' => sanitize(post('retorno')),  COLOCA A OPÇÃO PARA O MEDICO
					'iss_aliquota' => converteMoeda(post('iss_aliquota')),  
					'cfop' => sanitize(post('cfop')),  
					'whatsapp' => sanitize(post('whatsapp')),  
					'confirmar_agenda' => sanitize(post('confirmar_agenda')),  
					'liberar_agenda' => sanitize(post('liberar_agenda')),  
					'liberar_pagamento' => sanitize(post('liberar_pagamento')),  
					'validar_paciente' => sanitize(post('validar_paciente')),  
					'convenio' => sanitize(post('convenio')),  
					'repeticao' => sanitize(post('repeticao')),  
					'duasagendas' => sanitize(post('duasagendas')),  
					'desconto' => sanitize(post('desconto')),  
					'relatorio_medico' => sanitize(post('relatorio_medico')),  
					'recibo_medico' => sanitize(post('recibo_medico')),  
					'permitir_prontuario' => sanitize(post('permitir_prontuario')),  
					'validar_guias' => sanitize(post('validar_guias')),  
					'cancelado' => sanitize(post('cancelado')),  
					'agenda_livre' => sanitize(post('agenda_livre')),  
					// 'aso' => sanitize(post('aso')),  COLOCADA A OPÇÃO PARA MEDICO
					// 'cirurgico' => sanitize(post('cirurgico')),  COLOCADA A OPÇÃO PARA O MEDICO
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );
			  if (!empty($_POST['enotas'])) {
				  $data['enotas'] = post('enotas');
			  }
              (Filter::$id) ? self::$db->update(self::uTable, $data, "id=" . Filter::$id) : self::$db->insert(self::uTable, $data);
              $message = (Filter::$id) ? lang('EMPRESA_ALTERADO_OK') : lang('EMPRESA_ADICIONADO_OK');

              if (self::$db->affected()) {
				  Filter::msgOk($message, "index.php?do=empresa&acao=listar");
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }

      /**
       * Empresa::getEmpresasDistancia()
       * 
       * @return
       */
      public function getEmpresasDistancia()
      {
		  $sql = "SELECT e.id, e.id_empresa_origem, e.id_empresa_destino, o.nome as origem, d.nome as destino "
		  . "\n FROM empresa_distancia as e"
		  . "\n LEFT JOIN empresa as o on o.id = e.id_empresa_origem "
		  . "\n LEFT JOIN empresa as d on d.id = e.id_empresa_destino ";
		  
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Empresa::processarEmpresaDistancia()
       * 
       * @return
       */
      public function processarEmpresaDistancia()
      {
          if (empty(Filter::$msgs)) {

              $data = array(
					'id_empresa_origem' => sanitize($_POST['id_empresa_origem']), 
					'id_empresa_destino' => sanitize($_POST['id_empresa_destino'])
			  );

              self::$db->insert("empresa_distancia", $data);
              $message = lang('EMPRESA_ADICIONADO_OK');

              if (self::$db->affected()) {
			  
                  Filter::msgOk($message);                  
				  redirecionar("index.php?do=empresa&acao=distancia");
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
  }
?>