<?php
  /**
   * Classe Extrato
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');

  class Extrato
  {
	  private static $db;

      /**
       * Extrato::__construct()
       * 
       * @return
       */
      function __construct()
      {
          self::$db = Registry::get("Database");
      }
	  
	  /**
       * Extrato::processarArquivoBanco()
       * 
       * @return
       */
      public function processarArquivoBanco()
      {	

		  if (empty($_POST['id_banco']))
              Filter::$msgs['id_banco'] = lang('MSG_ERRO_BANCO');
		  
			if (empty(Filter::$msgs)) {
				$id_banco = post('id_banco');
				$codigo_banco = getValue("codigo","banco","id = ".$id_banco);
				self::$db->delete("extrato_bancos", "id_banco=" . $id_banco);
				foreach($_POST as $nome_campo => $valor){
					$valida = strpos($nome_campo, "tmpname");
					if($valida) {
						$nomearquivo = explode(".",$valor);
						$extensao = $nomearquivo[1];
						if(strtolower($extensao) == 'ofx') { // ARQUIVO OFX
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								if (strstr($linha, "<STMTTRN>") !== false) {
									$txn = array();
								}
								elseif (strstr($linha, "<TRNTYPE>") !== false) {
									$txn['tipo'] = sanitize($linha);
								}
								elseif (strstr($linha, "<DTPOSTED>") !== false) {
									$txn['data'] = sanitize($linha);
								}
								elseif (strstr($linha, "<TRNAMT>") !== false) {
									$txn['valor'] = sanitize($linha);
								}
								elseif (strstr($linha, "<NAME>") !== false) {
									$txn['nome'] = sanitize($linha);
								}
								elseif (strstr($linha, "<MEMO>") !== false) {
									$txn['historico'] = sanitize($linha);
								}
								elseif (strstr($linha, "<FITID>") !== false) {
									$txn['id'] = sanitize($linha);
								}
								elseif (strstr($linha, "<REFNUM>") !== false) {
									$txn['refnum'] = sanitize($linha);
								}
								elseif (strstr($linha, "<CHECKNUM>") !== false) {
									$txn['checknum'] = sanitize($linha);
								}
								// End of transaction.
								elseif (strstr($linha, "</STMTTRN>") !== false) {
									$txns[]= $txn;
								}
							}
							fclose ($ponteiro);
							if($txns) {
								foreach($txns as $txrow) {
									$valor = $txrow['valor'];
									$valor = str_replace(",",".",$valor);
									$data_extrato = dataExtrato($txrow['data']);
									$tipo = ($txrow['tipo'] == 'OTHER') ? ($valor < 0) ? 'D' : 'C' : ($txrow['tipo'] == 'DEBIT') ? 'D' : 'C';
									$valor = abs($valor);
									$documento = (array_key_exists('checknum',$txrow)) ? $txrow['checknum'] : '';
									$documento = (array_key_exists('refnum',$txrow)) ? $txrow['refnum'] : $documento;
									$data = array(
										'id_banco' => $id_banco, 
										'data' => $data_extrato,
										'historico' => $txrow['historico'],
										'documento' => $documento, 
										'valor' => $valor,
										'tipo' => $tipo,
										'conciliado' => 0,
										'id_ref' => 0
									);
									self::$db->insert("extrato_bancos", $data);
								}
							}
						} elseif($codigo_banco == '033') { // SANTANDER
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								$linha = str_replace("\"","",$linha);
								$campos = explode(";",$linha);
								$isData = substr_count($campos[0], "/20");
								if(strlen(trim($campos[4])) > 0) {
									$valor = converteMoeda($campos[4]);
									$tipo = 'C';
								} else {
									$valor = converteMoeda($campos[5]);
									$tipo = 'D';
								}
								$isExtrato = is_numeric($valor);
								if($isData and $isExtrato) {
									$isData = false;
									$isExtrato = false;		
									$data = array(
										'id_banco' => $id_banco, 
										'data' => dataMySQL($campos[0]),
										'historico' => sanitize($campos[2]),
										'documento' => $campos[3], 
										'valor' => $valor,
										'tipo' => $tipo,
										'conciliado' => 0,
										'id_ref' => 0
									);
									self::$db->insert("extrato_bancos", $data);
								}
							}
							fclose ($ponteiro);
						} elseif($codigo_banco == '104') { //CAIXA ECONOMICA FEDERAL
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								$linha = str_replace("\"","",$linha);
								$campos = explode(";",$linha);
								if(is_numeric($campos[0])) {	
									$data = array(
										'id_banco' => $id_banco, 
										'data' => dataExtrato($campos[1]),
										'historico' => sanitize($campos[3]),
										'documento' => $campos[2], 
										'valor' => $campos[4],
										'tipo' => $campos[5],
										'conciliado' => 0,
										'id_ref' => 0
									);
									self::$db->insert("extrato_bancos", $data);
								}
							}
							fclose ($ponteiro);		
						} elseif($codigo_banco == '237') {  //BRADESCO
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								$linha = str_replace("\"","",$linha);
								$campos = explode(";",$linha);
								$isData = substr_count($campos[0], "/20");
								$valor = 0;
								$tipo = 'C';
								if(strlen(trim($campos[3])) > 0) {
									$valor = converteMoeda($campos[4]);
								} else {
									$tipo = 'D';
									$valor = converteMoeda($campos[4]);
									if($valor < 0) {
										$valor = $valor * (-1);
									}
								}
								if($isData) {	
									$data = array(
										'id_banco' => $id_banco, 
										'data' => dataMySQL($campos[0]),
										'historico' => sanitize($campos[1]),
										'documento' => $campos[2], 
										'valor' => $valor,
										'tipo' => $tipo,
										'conciliado' => 0,
										'id_ref' => 0
									);
									self::$db->insert("extrato_bancos", $data);
								}
							}
							fclose ($ponteiro);		
						} elseif($codigo_banco == '001') { // BANCO DO BRASIL
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								$linha = str_replace("\"","",$linha);
								$campos = explode(";",$linha);
								$isData = substr_count($campos[3], "20");
								$doc = $campos[7];
								$isExtrato = is_numeric($doc);
								if($isData and $isExtrato and $doc > 0) {
									$isData = false;
									$isExtrato = false;
									$dataSQL = substr($campos[3],4,4)."-".substr($campos[3],2,2)."-".substr($campos[3],0,2);
									$valor = substr($campos[10],0,-2).".".substr($campos[10],-2);
									$data = array(
										'id_banco' => $id_banco, 
										'data' => $dataSQL,
										'historico' => sanitize($campos[9]),
										'documento' => $campos[7], 
										'valor' => $valor,
										'tipo' => $campos[11],
										'conciliado' => 0,
										'id_ref' => 0
									);
									self::$db->insert("extrato_bancos", $data);
								}
							}
							fclose ($ponteiro);
						} else {
							Filter::msgAlert(lang('MSG_ERRO_CODDIGO_BANCO'));
						}
					}
				}
				(self::$db->affected()) ? Filter::msgOk(lang('ARQUIVO_PROCESSADO'), "index.php?do=extrato&acao=conciliardespesas&ordernar=dataasc&id_banco=$id_banco") : Filter::msgAlert(lang('NAOPROCESSADO'));
			} else
              print Filter::msgStatus();
      }	  
	  
	  /**
       * Extrato::processarArquivoCartoes()
       * Função para cartões GNET (Santander) - Detalhado
       * Função para cartões ELO (Cielo) - Detalhado
       * @return
       */
      public function processarArquivoCartoes()
      {	
		  if (empty($_POST['id_banco']))
              Filter::$msgs['id_banco'] = lang('MSG_ERRO_BANCO');
		  
		  if (empty($_POST['tipo']))
              Filter::$msgs['tipo'] = lang('MSG_ERRO_TIPO');
		  
          if (empty(Filter::$msgs)) {
				$id_banco = $_POST['id_banco'];
				$tipo = $_POST['tipo'];
				self::$db->delete("extrato_cartoes", "id_banco= '$id_banco' AND tipo='$tipo' ");
				foreach($_POST as $nome_campo => $valor){
					$valida = strpos($nome_campo, "tmpname");
					if($valida) {
						if($tipo == 'santander') {
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));		
							$produto = '';									
							$valor_bruto = 0;									
							$valor_liquido = 0;		
							$percentual = 0;
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								$linha = str_replace("\"","",$linha);
								$campos = explode(";",$linha);
								$isCartao = substr_count($campos[8], "***");
								$isData = substr_count($campos[3], "/20");
								if($isData) {
									$isCartao = false;							
									$isData = false;							
									$valor_transacao = converteMoeda($campos[9]);					
									$valor_bruto = converteMoeda($campos[5]);									
									$valor_liquido = converteMoeda($campos[6]);
									$percentual = ($valor_bruto - $valor_liquido)/$valor_bruto*100;
									$data = array(
										'id_banco' => $_POST['id_banco'], 
										'data_lancamento' => dataMySQL($campos[3]), 
										'data_transacao' => dataMySQL($campos[7]),
										'produto' => $campos[2],
										'numero_cartao' => $campos[8], 
										'valor_bruto' => $valor_bruto,
										'valor_liquido' => $valor_liquido,
										'percentual' => $percentual,
										'valor_transacao' => $valor_transacao,
										'total_parcelas' => $campos[10],
										'tipo' => 'santander'
									);
									self::$db->insert("extrato_cartoes", $data);
								}
							}
							fclose ($ponteiro);
						}elseif($tipo == 'cielo') {
							$ponteiro = fopen (UPLOADS.$valor, "r");
							if ($ponteiro == false) die(lang('FORM_ERROR13'));								
							$produto = '';									
							$valor_bruto = 0;									
							$valor_liquido = 0;		
							$percentual = 0;
							while (!feof ($ponteiro)) {
								$linha = fgets($ponteiro, 4096);
								$linha = str_replace("\"","",$linha);
								$campos = explode(";",$linha);
								$isData = substr_count($campos[0], "/20");
								$isCartao = substr_count($campos[9], "Pago");
								if($isCartao) {				
									$isCartao = false;
									$isData = false;
									$valor_bruto = converteMoeda($campos[6]);									
									$valor_liquido = converteMoeda($campos[8]);
									$percentual = ($valor_bruto - $valor_liquido)/$valor_bruto*100;
									$data = array(
										'id_banco' => $_POST['id_banco'], 
										'data_lancamento' => dataMySQL($campos[0]), 
										'data_transacao' => dataMySQL($campos[1]),
										'produto' => sanitize(utf8_decode($campos[3])),
										'valor_bruto' => $valor_bruto,
										'valor_liquido' => $valor_liquido,
										'percentual' => $percentual,
										'valor_transacao' => $valor_bruto,
										'total_parcelas' => $campos[5],
										'tipo' => 'cielo'
									);
									self::$db->insert("extrato_cartoes", $data);
								}
							}
							fclose ($ponteiro);
						}
					}
				}
			  (self::$db->affected()) ? Filter::msgOk(lang('ARQUIVO_PROCESSADO'), "index.php?do=extrato&acao=arquivocartoes") : Filter::msgAlert(lang('NAOPROCESSADO'));
		  } else
              print Filter::msgStatus();
      }	  
	  
	  /**
       * Extrato::getExtrato_view()
       * 
       * @return
       */
      public function getExtrato_view($dataini = false, $datafim = false, $id_banco = 0)
      {
         $dataini = ($dataini) ? $dataini : date('d/m/Y', strtotime('-15 days')); 
         $datafim = ($datafim) ? $datafim : date('d/m/Y');
		 $wview_data = "AND v.data_pagamento BETWEEN STR_TO_DATE('$dataini 00:00:00','%d/%m/%Y %H:%i:%s') AND STR_TO_DATE('$datafim 23:59:59','%d/%m/%Y %H:%i:%s')";
	
	echo	 $sql = "SELECT v.data_pagamento, DATE_FORMAT(v.data, '%Y%m%d%H%i%s') AS controle, v.ti_ch, v.tipo, v.id, v.id_conta, v.id_banco, v.id_empresa, v.cli_for, v.valor, v.descricao, v.data_vencimento, v.pago, cad.nome as cadastro, c.conta, t.tipo as pagamento " 
		  . "\n FROM extrato_view as v" 
		  . "\n LEFT JOIN conta as c ON c.id = v.id_conta" 
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = v.ti_ch " 
		  . "\n LEFT JOIN cadastro as cad ON cad.id = v.cli_for " 
		  . "\n WHERE v.id_banco = '$id_banco' AND v.inativo = 0 AND v.pago = 1 "
		  . "\n $wview_data"
		  . "\n ORDER BY 1,2,3 ASC";
		  $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::conciliarBanco()
       * 
       * @return
       */
      public function conciliarBanco()
      {	
          if (empty(Filter::$msgs)) {
			  $id_banco = post('id_banco');			  
			  $alterado = false;
			  $sql = "SELECT id " 
			  . "\n FROM extrato_bancos "
			  . "\n WHERE conciliado = 1 AND id_banco = '$id_banco' ";
			  $row = self::$db->first($sql);
			  if(!$row) {
				  $ini = $this->getDataInicial($id_banco);
				  $fim = $this->getDataFinal($id_banco);			
				  $data_limpar = array(
					'extrato_data' => '',
					'extrato_doc' => '',
					'conciliado' => 0
				  );
				  self::$db->update("despesa", $data_limpar, "id_banco = $id_banco AND conciliado = 1 AND data_pagamento BETWEEN STR_TO_DATE('$ini','%Y-%m-%d') AND STR_TO_DATE('$fim','%Y-%m-%d')");
			  }	
			  foreach ( $_POST as $name => $value ) {
				  //echo "<br/>[$name]>>[$value]<br/>";
				if(strpos($value, "#")) {
					$campos = explode("#", $value);					
					$data_limpar = array(
						'extrato_data' => '',
						'extrato_doc' => '',
						'conciliado' => 0
					);
					self::$db->update("despesa", $data_limpar, "agrupar = '".$campos[2]."'");
					$data_despesa = array(
						'extrato_data' => $campos[1],
						'extrato_doc' => $campos[3],
						'conciliado' => 1
					);
					self::$db->update("despesa", $data_despesa, "conciliado = 0 AND agrupar = '".$campos[2]."'");
					$alterado = self::$db->affected();
					$data_extrato = array(
						'id_ref' => $campos[2],
						'conciliado' => 1
					);					
					self::$db->update("extrato_bancos", $data_extrato, "conciliado = 0 AND id = '".$campos[3]."'");
				}
			  }			  
			  if ($alterado) {
				Filter::msgOk(lang('EXTRATO_CONCILIADO'), "index.php?do=extrato&acao=conciliardespesas&id_banco=".$id_banco);
			  } else
				Filter::msgAlert(lang('NAOPROCESSADO'));
			
			} else
              print Filter::msgStatus();
      }
	  
	  
	  /**
       * Extrato::getTotalBanco()
       * 
       * @return
       */
	  public function getTotalBanco($data = '', $id_banco)
      {
			  $sql = "SELECT SUM(valor) as total " 
			  . "\n FROM extrato_bancos "
			  . "\n WHERE data = '$data' AND tipo = 'C' AND historico like 'LANCAMENTO A CREDITO%' AND id_banco = '$id_banco' ";
			  $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }
	  
	  
	  /**
       * Extrato::getDatasExtrato()
       * 
       * @return
       */
	  public function getDatasExtrato($id_banco)
      {          
			$sql = "SELECT DISTINCT data " 
			  . "\n FROM extrato_bancos "
			  . "\n ORDER BY 1 ASC";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  
	  /**
       * Extrato::getExtratoData()
       * 
       * @return
       */
	  public function getExtratoData($data = '', $condicao = '', $id_banco)
      {
		  $sql = "SELECT * " 
		  . "\n FROM extrato_bancos "
		  . "\n WHERE data = '$data' $condicao AND id_banco = '$id_banco'"
		  . "\n ORDER BY tipo, historico ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  
	  /**
       * Extrato::getDataInicial()
       * 
       * @return
       */
	  public function getDataInicial($id_banco)
      {          
			$sql = "select min(data) as inicial from extrato_bancos where id_banco = '$id_banco'";
			$row = self::$db->first($sql);
			$inicial = $row->inicial;
          return $inicial;
      }
	  
	  
	  /**
       * Extrato::getDataFinal()
       * 
       * @return
       */
	  public function getDataFinal($id_banco)
      {          
			$sql = "select max(data) as fim from extrato_bancos where id_banco = '$id_banco'";
			$row = self::$db->first($sql);
			$fim = $row->fim;
          return $fim;
      }
	  
	  /**
       * Extrato::getDataInicialCartoes()
       * 
       * @return
       */
	  public function getDataInicialCartoes($id_banco)
      {          
			$sql = "select min(data_transacao) as inicial from extrato_cartoes where id_banco = '$id_banco'";
			$row = self::$db->first($sql);
			$inicial = $row->inicial;
          return $inicial;
      }
	  
	  /**
       * Extrato::totalExtratoDinheiro()
       * 
       * @return
       */
	  public function totalExtratoDinheiro($data = '', $id_banco)
      {
		  $sql = "SELECT sum(e.valor) as total" 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.historico like 'DEPOSITO EM DINHEIRO%' AND data = '$data' AND e.id_banco = '$id_banco'";
          $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }	  
	  
	  /**
       * Extrato::totalExtratoDespesa()
       * 
       * @return
       */
	  public function totalExtratoDespesa($data = '', $id_banco)
      {
		  $sql = "SELECT sum(e.valor) as total" 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.tipo = 'D' AND data = '$data' AND e.id_banco = '$id_banco'";
          $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }  
	  
	  /**
       * Extrato::totalExtratoCredito()
       * 
       * @return
       */
	  public function totalExtratoCredito($data = '', $id_banco)
      {
		  $sql = "SELECT SUM(e.valor) as total" 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.tipo = 'C' AND e.data = '$data' AND e.id_banco = '$id_banco'";
          $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }	  
	  
	  /**
       * Extrato::getListaClinicaCredito()
       * 
       * @return
       */
	  public function getListaClinicaCredito($data = '', $id_banco)
      {
		  $sql = "SELECT c.historico, c.plano_contas, c.dt_vencimento, c.valor_credito " 
			  . "\n FROM financeiro_clinica_parcelas as c " 
			  . "\n WHERE c.tipo_movimento = 'C' AND c.id_banco = '$id_banco'  AND c.dt_vencimento = '$data' ";
			  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  	  
	  /**
       * Extrato::totalCartoesRecebidoBanco()
       * 
       * @return
       */
	  public function totalCartoesRecebidoBanco($data = '', $id_banco)
      {
		 $sql = "SELECT SUM(valor) as total " 
		  . "\n FROM extrato_bancos "
		  . "\n WHERE data = '$data' AND tipo = 'C' AND historico like 'LANCAMENTO A CREDITO%' AND id_banco = '$id_banco' ";
			  $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }
	  
	  /**
       * Extrato::totalCartoesRecebido()
       * 
       * @return
       */	  
	  public function totalCartoesRecebido($data = '', $id_banco)
      {
		  $sql = "SELECT SUM(valor_liquido) as total " 
			  . "\n FROM extrato_cartoes " 
			  . "\n WHERE data_lancamento = '$data' AND id_banco = '$id_banco' ";
			  $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }
	  
	  /**
       * Extrato::totalCartoesRecebidoClinica()
       * 
       * @return
       */	  
	  public function totalCartoesRecebidoClinica($data = '', $id_banco)
      {
		  $sql = "SELECT SUM(juros_cartao) as total " 
			  . "\n FROM financeiro_paciente_parcelas " 
			  . "\n WHERE pg_cd_tipo_pagamento in ('L00000020100620202855','L20120705222521') AND dt_vencimento= '$data'  AND id_banco = '$id_banco'";
			  $row = self::$db->first($sql);
          return ($row->total) ? $row->total : 0;
      }
	  
	  /**
       * Extrato::getListaCartoesRecebidoBanco()
       * 
       * @return
       */		  
	  public function getListaCartoesRecebidoBanco($data = '', $id_banco)
      {
		 $sql = "SELECT * " 
		  . "\n FROM extrato_bancos "
		  . "\n WHERE data = '$data' AND tipo = 'C' AND historico like 'LANCAMENTO A CREDITO%' AND id_banco = '$id_banco' ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getListaCartoesRecebido()
       * 
       * @return
       */	
	  public function getListaCartoesRecebido($data = '', $id_banco)
      {
		  $sql = "SELECT data_transacao, data_lancamento as data_pago, valor_bruto, valor_liquido, total_parcelas as parcelas  " 
		  . "\n FROM extrato_cartoes "
		  . "\n WHERE data_lancamento = '$data' AND id_banco = '$id_banco'"
		  . "\n ORDER BY data_lancamento ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getListaCartoesRecebidoClinica()
       * 
       * @return
       */	
	  public function getListaCartoesRecebidoClinica($data = '', $id_banco)
      {
		  $sql = "SELECT chave, dt_vencimento as data_pago, valor_parcela as valor_bruto, juros_cartao as valor_liquido, historico as parcelas  " 
		  . "\n FROM financeiro_paciente_parcelas "
			  . "\n WHERE pg_cd_tipo_pagamento in ('L00000020100620202855','L20120705222521') AND dt_vencimento= '$data'  AND id_banco = '$id_banco'"
		  . "\n ORDER BY dt_vencimento ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getExtratoCartoes()
       * 
       * @return
       */	
	  public function getExtratoCartoes($id_banco)
      {
		  $order = "e.data ASC";
		  $ordenar = get('ordernar');
		  if($ordenar == "datadesc") {
			  $order = "e.data DESC";
		  } elseif($ordenar == "valorasc") {
			  $order = "e.valor ASC";			  
		  } elseif($ordenar == "valordesc") {
			  $order = "e.valor DESC";			  
		  }
		  $sql = "SELECT produto, numero_cartao, data_transacao, data_lancamento as data_pago, valor_bruto, valor_liquido, total_parcelas as parcelas " 
			  . "\n FROM extrato_cartoes as e "
			  . "\n WHERE e.conciliado = 0 AND e.id_banco = '$id_banco'"
			  . "\n ORDER BY $order";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::pesquisarCartoes()
       * 
       * @return
       */	
	  public function pesquisarCartoes($data, $valor, $id_banco)
      {			  
		  $sql = "SELECT chave, dt_vencimento as data_pago, valor_parcela as valor_bruto, juros_cartao as valor_liquido, historico as parcelas  " 
		      . "\n FROM financeiro_paciente_parcelas "
			  . "\n WHERE pg_cd_tipo_pagamento in ('L00000020100620202855','L20120705222521')"
			  . "\n AND dt_vencimento BETWEEN DATE_SUB(STR_TO_DATE('$data','%Y-%m-%d'), INTERVAL 10 DAY) AND DATE_ADD(STR_TO_DATE('$data','%Y-%m-%d'), INTERVAL 10 DAY) "
			  . "\n AND id_banco = '$id_banco' AND valor_parcela = '$valor' "
		      . "\n ORDER BY dt_vencimento ";
		  $row = self::$db->fetch_all($sql);
		  
          return ($row) ? $row : 0;
      }	 
	  
	  /**
       * Extrato::getExtratoDespesas()
       * 
       * @return
       */	
	  public function getExtratoDespesas($id_banco)
      {
		  $order = "e.data, historico ASC";
		  $ordenar = get('ordernar');
		  if($ordenar == "datadesc") {
			  $order = "e.data, historico DESC";
		  } elseif($ordenar == "valorasc") {
			  $order = "e.valor, historico ASC";			  
		  } elseif($ordenar == "valordesc") {
			  $order = "e.valor, historico DESC";			  
		  }
		  $sql = "SELECT * " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.tipo = 'D' AND e.id_banco = '$id_banco'"
			  . "\n ORDER BY $order";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::pesquisarDespesas()
       * 
       * @return
       */	
	  public function pesquisarDespesas($data, $valor, $id_banco)
      {
		
		 //$sql = "SELECT d.id, d.id_conta, d.id_banco, d.descricao, d.valor, d.cheque, d.data_vencimento, d.data_pagamento, d.nro_documento, d.conciliado, d.extrato_data, d.extrato_doc " 
		 // . "\n FROM despesa as d" 
		 // . "\n WHERE d.inativo = 0 AND d.pago = 1 "
		 // . "\n AND DATE_FORMAT(d.data_pagamento, '%Y-%m-%d') = '$data' "
		 // . "\n AND d.id_banco = '$id_banco' AND d.valor = '$valor' "
		 // . "\n ORDER BY d.data_vencimento";
		 $sql = "SELECT a.id, a.valor, d.id_conta, d.id_banco, d.descricao, d.cheque, d.data_vencimento, d.data_pagamento, d.nro_documento, d.conciliado, d.extrato_data, d.extrato_doc " 
		  . "\n FROM despesa_agrupar as a" 
		  . "\n LEFT JOIN despesa as d ON d.id = a.id" 
		  . "\n WHERE DATE_FORMAT(a.data_pagamento, '%Y-%m-%d') = '$data' "
		  . "\n AND a.id_banco = '$id_banco' AND a.valor = '$valor' "
		  . "\n ORDER BY a.data_pagamento";
		  $row = self::$db->fetch_all($sql);
		  
		  
          return ($row) ? $row : 0;
      }	  
	  
	  /**
       * Extrato::pesquisarExtrato()
       * 
       * @return
       */	
	  public function pesquisarExtrato($data, $valor, $id_banco)
      {
		  $sql = "SELECT * " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.conciliado = 0 AND e.tipo = 'D' AND e.id_banco = '$id_banco'"
			  . "\n AND e.data BETWEEN DATE_SUB(STR_TO_DATE('$data','%Y-%m-%d'), INTERVAL 5 DAY) AND DATE_ADD(STR_TO_DATE('$data','%Y-%m-%d'), INTERVAL 5 DAY) "
			  . "\n AND e.valor = '$valor' ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getDespesasConciliadas()
       * 
       * @return
       */	
	  public function getDespesasConciliadas($id_banco)
      {
		 $order = "c.dt_vencimento ASC";
		  $ordenar = get('ordernar');
		  if($ordenar == "datadesc") {
			  $order = "c.dt_vencimento DESC";
		  } elseif($ordenar == "valorasc") {
			  $order = "c.valor_parcela ASC";			  
		  } elseif($ordenar == "valordesc") {
			  $order = "c.valor_parcela DESC";			  
		  }
		  
		 $ini = (get('dataini')) ? get('dataini') : date('d/m/Y', strtotime('-15 days'));
		 $fim = (get('datafim')) ? get('datafim') : date('d/m/Y');
		 
		 $conciliado = get('conciliado');
		 $conciliar = "";
		 if($conciliado == "sim") {
			  $conciliar = "AND c.conciliado = 1 ";
		  } elseif($conciliado == "nao") {
			  $conciliar = "AND c.conciliado = 0 ";
		  }
		  
		$sql = "SELECT c.chave, p.nm_categoria_plano_conta, c.historico, c.plano_contas, c.dt_vencimento, c.valor_parcela, c.extrato_data, c.extrato_doc, c.conciliado " 
			  . "\n FROM financeiro_clinica_parcelas as c " 
			  . "\n LEFT JOIN categoria_plano_conta as p ON p.chave = c.plano_contas " 
			  . "\n WHERE c.tipo_movimento = 'D' $conciliar "
			  . "\n AND c.id_banco = '$id_banco' AND c.dt_vencimento BETWEEN STR_TO_DATE('$ini','%d/%m/%Y') AND STR_TO_DATE('$fim','%d/%m/%Y') "
			  . "\n ORDER BY $order";
			  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getExtratoReceitas()
       * 
       * @return
       */	
	  public function getExtratoReceitas($id_banco)
      {
		  $sql = "SELECT e.data, e.historico, SUM(e.valor) as total " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.conciliado = 0 AND e.tipo = 'C' AND e.id_banco = '$id_banco'"
			  . "\n GROUP BY e.data , e.historico "
			  . "\n ORDER BY e.data , e.historico ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getExtratoBoletos()
       * 
       * @return
       */	
	  public function getExtratoBoletos($id_banco = 0, $data = '')
      {		  
		  $sql = "SELECT SUM(e.valor) as total " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.id_banco = '$id_banco' AND e.data = '$data' AND e.historico like '%CR COB%'";
		  $row = self::$db->first($sql);
          return ($row) ? $row->total : 0;
      }
	  
	  /**
       * Extrato::getVerBoletos()
       * 
       * @return
       */	
	  public function getVerBoletos($id_banco = 0, $data = '')
      {		  
		  $sql = "SELECT e.historico, e.valor, e.data " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.tipo = 'C' AND e.id_banco = '$id_banco' AND e.data = '$data' AND e.historico like '%CR COB%'"
			  . "\n ORDER BY e.data , e.historico ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getVerSistema()
       * 
       * @return
       */	
	  public function getVerSistema($id_banco = 0, $data = '', $historico = '')
      {		  
		  $where = "AND r.pago = 1 AND r.id_banco = '$id_banco' ";
		  if (substr_count($historico, "DEPOSITO EM DINHEIRO")) {
			  $where = "AND r.pago = 1 AND r.id_banco = '$id_banco' AND b.id = r.id_banco AND r.tipo = 0 AND r.id_conta = 114 ";	
		  } elseif (substr_count($historico, "TRANSFERENCIA ENTRE CONTAS")) {
			  $where = "AND r.pago = 1 AND r.id_banco = '$id_banco' AND b.id = r.id_banco AND r.tipo = 0 AND r.id_conta = 114 ";			  
		  } elseif (substr_count($historico, "DEPOSITO EM CHEQUE")) {
			  $where = "AND r.pago = 1 AND r.id_banco = '$id_banco' AND b.id = r.id_banco  AND r.tipo = 2 ";			  
		  } elseif (substr_count($historico, "CR COB")) {
			  $where = "AND r.pago = 1 AND r.id_banco = '$id_banco' AND b.id = r.id_banco AND r.tipo = 3 ";			  
		  } elseif (substr_count($historico, "CIELO CARTAO DE CREDITO BAND ELO")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 1 ";			  
		  } elseif (substr_count($historico, "CIELO CARTAO DE CREDITO BAND MASTER")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 5 ";				  
		  } elseif (substr_count($historico, "CIELO CARTAO DE CREDITO BAND VISA")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 3 ";				  
		  } elseif (substr_count($historico, "CIELO CARTAO DE DEBITO BAND ELO")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 2 ";				  
		  } elseif (substr_count($historico, "CIELO CARTAO DE DEBITO BAND MASTER")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 6 ";				  
		  } elseif (substr_count($historico, "CIELO CARTAO DE DEBITO BAND VISA")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 4 ";				  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE CREDITO BAND MASTER")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 9 ";				  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE CREDITO BAND VISA")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 7 ";				  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE DEBITO BAND MASTER")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 10 ";				  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE DEBITO BAND VISA")) {
			  $where = "AND r.pago = 1 AND b.id = '$id_banco' AND p.id_cartoes = 8 ";				  
		  }      
		  
		  $sql = "SELECT r.id, r.id_cliente, f.numero_cartao, r.nossonumero, c.nome as cliente, b.banco, r.id_caixa, p.tipo, r.data_pagamento, r.data_recebido, r.valor_pago " 
			  . "\n FROM receita as r "
			  . "\n LEFT JOIN cliente as c on c.id = r.id_cliente "
			  . "\n LEFT JOIN cliente_financeiro as f on f.id = r.id_pagamento "
			  . "\n LEFT JOIN tipo_pagamento as p on p.id = r.tipo "
			  . "\n LEFT JOIN banco as b on b.id_empresa = r.id_empresa "
			  . "\n WHERE r.inativo = 0 AND r.conciliado = 0 AND b.id = r.id_banco AND r.data_recebido = '$data' $where "
			  . "\n ORDER BY c.nome ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getVerCartoes()
       * 
       * @return
       */	
	  public function getVerCartoes($id_banco = 0, $data = '', $historico = '')
      {		  		  
		  $where = "";
		  if (substr_count($historico, "CIELO CARTAO DE CREDITO BAND ELO")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'cielo' AND (produto like 'Elo par%' OR produto like 'Elo cr%') ";			  
		  } elseif (substr_count($historico, "CIELO CARTAO DE CREDITO BAND MASTER")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'cielo' AND (produto like 'MC par%' OR produto like 'MC cr%') ";	  
		  } elseif (substr_count($historico, "CIELO CARTAO DE CREDITO BAND VISA")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'cielo' AND (produto like 'Visa par%' OR produto like 'Visa cr%') ";			  
		  } elseif (substr_count($historico, "CIELO CARTAO DE DEBITO BAND ELO")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'cielo' AND produto like 'MC maestro%' ";			  
		  } elseif (substr_count($historico, "CIELO CARTAO DE DEBITO BAND MASTER")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'cielo' AND (produto like 'Elo par%' OR produto like 'Elo cr%') ";				  
		  } elseif (substr_count($historico, "CIELO CARTAO DE DEBITO BAND VISA")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'cielo' AND produto like 'Visa ele%' ";			  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE CREDITO BAND MASTER")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'santander' AND produto = 'MASTERCARD' ";		  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE CREDITO BAND VISA")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'santander' AND produto = 'VISA' ";			  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE DEBITO BAND MASTER")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'santander' AND produto = 'MAESTRO' ";		  
		  } elseif (substr_count($historico, "SANTANDER ADQ CARTAO DE DEBITO BAND VISA")) {
			  $where = "AND e.id_banco = '$id_banco' AND e.tipo = 'santander' AND produto = 'VISA ELECTRON' ";			  
		  } 
		  if($where) {			  
			$sql = "SELECT e.data_lancamento, e.data_transacao, e.produto, e.numero_cartao, e.valor_liquido, e.valor_bruto, e.percentual " 
			  . "\n FROM extrato_cartoes as e "
			  . "\n WHERE e.conciliado = 0 AND e.data_lancamento = '$data' $where "
			  . "\n ORDER BY e.produto , e.numero_cartao ";
			$row = self::$db->fetch_all($sql);
		  } else {
			  $row = false;
		  }		  
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getVerBanco()
       * 
       * @return
       */	
	  public function getVerBanco($id_banco = 0, $data = '', $historico = '')
      {
		  $sql = "SELECT e.historico, e.valor, e.data " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.conciliado = 0 AND e.tipo = 'C' AND e.data = '$data' AND e.id_banco = '$id_banco' AND e.historico = '".$historico."'"
			  . "\n ORDER BY e.data , e.historico ";
		  $row = self::$db->fetch_all($sql);
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Extrato::getDataExtrato()
       * 
       * @return
       */	
	  public function getDataExtrato($id_banco = 0)
      {
		  $sql = "SELECT MAX(e.data) as data " 
			  . "\n FROM extrato_bancos as e "
			  . "\n WHERE e.tipo = 'C' AND e.id_banco = '$id_banco' ";
		  $row = self::$db->first($sql);
          return ($row) ? $row->data : 0;
      }

  }
?>
