<?php
  /**
   * Classe Paciente
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');

  class Paciente
  {
      const uTable = "paciente";
      public $did = 0;
      private static $db;

      /**
       * Paciente::__construct()
       * 
       * @return
       */
      function __construct()
      {
          self::$db = Registry::get("Database");
      }

	  /**
       * Paciente::getPacientes()
	   *
       * @return
       */
	  public function getTodosPacientes()
      {
         $sql = "SELECT c.id, c.nome, c.nome_mae, c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc, c.inativo " 
		  . "\n FROM paciente as c"
		  . "\n WHERE c.inativo = 0 "
		  . "\n ORDER BY c.nome ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getPacientesConvenio()
	   *
       * @return
       */
	  public function getPacientesConvenio($id_convenio)
      {
         $sql = "SELECT c.id, c.nome, c.nome_mae, c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc, c.inativo " 
		  . "\n FROM paciente_convenio AS p"
		  . "\n LEFT JOIN paciente AS c ON c.id = p.id_paciente"
		  . "\n WHERE c.inativo = 0 AND p.inativo = 0 AND p.id_convenio = '$id_convenio'"
		  . "\n ORDER BY c.nome ";
          $row = ($id_convenio) ? self::$db->fetch_all($sql) : null;
		  
          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getListaConvenios()
	   *
       * @return
       */
	  public function getListaConvenios($id_paciente)
      {
		 $lista_convenios = '';
		 $sql = "SELECT c.nome as convenio " 
		  . "\n FROM paciente_convenio AS p"
		  . "\n LEFT JOIN cadastro AS c ON c.id = p.id_convenio"
		  . "\n WHERE c.inativo = 0 AND p.inativo = 0 AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY c.nome ";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;
		  if($row) {
			foreach ($row as $lrow) {
				$lista_convenios .= $lrow->convenio.', ';
			}
			$lista_convenios = substr($lista_convenios, 0, -2);
		  }

          return $lista_convenios;
      }

      /**
       * Paciente::getPacientes()
       * 
       * @return
       */
      public function getPacientes($tipo = false, $nome = false, $limit = '')
      {
		  $where = "";		  
		  if($nome) {
			$cli = explode(" ", $nome);
			$count = count($cli);
			for ($i = 0; $i < $count; $i++) {
				$where .= " AND (c.nome LIKE '".$cli[$i]."%')";
			}
		  }
		  $sql = "SELECT c.id, c.nome, c.nome_mae, c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc FROM paciente AS c WHERE c.inativo = 0 $where ORDER BY c.nome $limit ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
		
		/**
		* Paciente::getPacienteFacebook()
		*
		* @return
		*/
		public function getPacienteFacebook($email)
		{
			$sql = "SELECT c.id, c.nome, c.celular, c.data_nasc, c.edicao "
			. "\n FROM paciente as c"
			. "\n WHERE c.inativo = 0 AND c.email = '$email' OR c.facebook = '$email'";
			$row = self::$db->first($sql);
			
			return ($row) ? $row : 0;
		}
		
		/**
		* Paciente::getPacientePIN()
		* Sugestão para o PIN : 3 primeiros digitos do CPF e dia de nascimento
		* @return
		*/
		public function getPacientePIN($pin)
		{
			$sql = "SELECT c.id, c.nome, c.celular, c.data_nasc, c.edicao "
			. "\n FROM paciente as c"
			. "\n WHERE c.inativo = 0 AND c.pin = '$pin'";
			$row = self::$db->first($sql);
			
			return ($row) ? $row : 0;
		}

	  /**
       * Paciente::getPacientesTeste()
	   *
       * @return
       */
	  public function getPacientesTeste()
      {
         $sql = "SELECT c.nome, c.celular, c.email " 
		  . "\n FROM paciente as c"
		  . "\n WHERE inativo = 0 " 
		  . "\n ORDER BY c.nome ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

	  /**
       * Paciente::getPacientes()
	   *
       * @return
       */
	  public function getAniversarios($data)
      {
         $sql = "SELECT c.id, c.nome, c.nome_mae, c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc " 
		  . "\n FROM paciente as c"
		  . "\n WHERE inativo = 0 AND DATE_FORMAT(c.data_nasc, '%m') = '$data' " 
		  . "\n ORDER BY DAY(c.data_nasc) ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getListaAniversarios()
       * 
       * @return
       */
      public function getListaAniversarios()
      {		  
          $sql = "SELECT DATE_FORMAT(c.data_nasc, '%m') as mes_ano "
		  . "\n FROM paciente AS c "
		  . "\n WHERE DATE_FORMAT(c.data_nasc, '%m/%Y') <> '00/0000' AND c.inativo = 0  "
		  . "\n GROUP BY mes_ano "
		  . "\n ORDER BY mes_ano ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getEmailAniversarios()
       * 
       * @return
       */
      public function getEmailAniversarios($dataini = false, $datafim = false)
      {
		  $row = null;
		  if ($dataini and $datafim) {	
			$sql = "SELECT p.id, p.nome, p.celular, p.cpf, p.email, p.telefone, p.bairro, p.cidade, p.usuario, p.data_cadastro, p.sexo, p.data_nasc " 
			  . "\n FROM paciente as p"
			  . "\n WHERE p.inativo = 0 AND p.email LIKE '%@%' AND DATE_FORMAT(p.data_nasc, '%m%d') "
			  . "\n BETWEEN DATE_FORMAT(STR_TO_DATE('$dataini', '%d/%m'), '%m%d') "
			  . "\n AND DATE_FORMAT(STR_TO_DATE('$datafim', '%d/%m'), '%m%d') "
			  . "\n ORDER BY p.nome ";
			$row = self::$db->fetch_all($sql);
		  }

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getCelularAniversarios()
       * 
       * @return
       */
      public function getCelularAniversarios($dataini = false, $datafim = false)
      {
		  $row = null;
		  if ($dataini and $datafim) {	
			$sql = "SELECT p.id, p.nome, p.celular, p.cpf, p.email, p.telefone, p.bairro, p.cidade, p.usuario, p.data_cadastro, p.sexo, p.data_nasc " 
			  . "\n FROM paciente as p"
			  . "\n WHERE p.inativo = 0 AND p.celular <> '' AND DATE_FORMAT(p.data_nasc, '%m%d') "
			  . "\n BETWEEN DATE_FORMAT(STR_TO_DATE('$dataini', '%d/%m'), '%m%d') "
			  . "\n AND DATE_FORMAT(STR_TO_DATE('$datafim', '%d/%m'), '%m%d') "
			  . "\n ORDER BY p.nome ";
			$row = self::$db->fetch_all($sql);
		  }

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::enviarWhatsappAniversario()
       * 
       * @return
       */
      public function enviarWhatsappAniversario()
      {
		if (empty(Filter::$msgs)) {
			$dataini = (post('dataini')) ? post('dataini') : date('d/m/Y'); 
			$datafim = (post('datafim')) ? post('datafim') : date('d/m/Y'); 
			$token_whatsapp = (session('idempresa')) ? getValue('whatsapp', 'empresa', 'id='.session('idempresa')) : '';
			$retorno_row = $this->getCelularAniversarios($dataini, $datafim);
			$total = ($retorno_row) ? count($retorno_row) : 0;
			$sucesso = 0;
			$erro = 0;
			$mensagem_retorno = '';
			if($retorno_row) {
				foreach ($retorno_row as $exrow) {
					$nome = capitalize($exrow->nome);
					$site_url = SISTEMAURL;	
					$saudacao = saudacao();	
					$texto = "Olá *$nome*, $saudacao, tudo bem 😉? \nParabéns pelo seu aniversário!!!";
					$celular = ($exrow->celular) ? telefoneSMS($exrow->celular) : telefoneSMS($exrow->telefone);
					$mensagem = urlencode($texto);
					$origem = "NIVER";
					$params = 'cmd=media&link=https://'.$site_url.'/email/aniversario.jpg&id='.$origem.'&to='.$celular.'@c.us&msg='.$mensagem;
					if($token_whatsapp == '') {
							$erro++;
							$mensagem_retorno .= "Mensagem nao enviada, TOKEN_WHATSAPP não cadastrado.<br/>";
					} elseif($celular) {
						$retorno = enviarURL($token_whatsapp, $params);
						$json_array = json_decode($retorno,true);
						$status = (is_array($json_array) and array_key_exists('status',$json_array)) ? $json_array['status'] : 'OK';
						if($status == 'offline') {
							$erro++;
							$mensagem_retorno .= "Mensagem nao enviada, retorno [offline] para o paciente [$nome].<br/>";
						} else {
							$sucesso++;
							$mensagem_retorno .= "Mensagem enviada para telefone [$celular], paciente [$nome] - Retorno: [$retorno].<br/>";	
						}
					} else {
						$erro++;
						$mensagem_retorno .= "<span style='font-red'> >> ERRO! Mensagem nao enviada, celular não cadastrado para o paciente [$nome].</span><br/>";
					}
				 }
			}
			if ($sucesso) {
                  Filter::msgOk($mensagem_retorno);
            } else
                Filter::msgAlert($mensagem_retorno);
          } else
              print Filter::msgStatus();
      }

	  /**
       * Paciente::getListaPacientes()
	   *
       * @return
       */
	  public function getListaPacientes($nome = '')
      {	  
		  $where = "";		  
		  if($nome) {
			$cli = explode(" ", $nome);
			$count = count($cli);
			for ($i = 0; $i < $count; $i++) {
				$where .= " AND (c.nome LIKE '".$cli[$i]."%')";
			}
		  }
		  $sql = "SELECT c.id, c.nome, c.nome_mae, c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc FROM paciente AS c WHERE c.inativo = 0 AND c.nome LIKE '".$nome."%' ORDER BY c.nome LIMIT 0,30";
          $row = self::$db->fetch_all($sql);
		  
          return ($row) ? $row : 0;
      }
	  

	  /**
       * Paciente::getPacientesNome()
	   *
       * @return
       */
	  public function getPacientesNome($nome, $limit = 0)
      {
        $limit = ($limit) ? $limit : 10;
		$sql = "SELECT c.id, c.nome, c.id_contrato, c.data_nasc " 
		  . "\n FROM paciente as c"
		  . "\n WHERE inativo = 0 AND c.nome LIKE '$nome%' " 
		  . "\n ORDER BY c.nome "
		  . "\n LIMIT $limit ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

	  /**
       * Paciente::getPacientesID()
	   *
       * @return
       */
	  public function getPacientesID($id)
      {
         $sql = "SELECT c.id, c.nome, c.id_contrato, c.data_nasc " 
		  . "\n FROM paciente as c"
		  . "\n WHERE id = $id " ;
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Paciente::getBuscarPacientes()
       * 
       * @return
       */
      public function getBuscarPacientes()
      {
		  $row = false;
		  $paciente = post('nome');
		  $cpf = limparCPF_CNPJ(post('cpf')); 
		  if($paciente) {
			$cli = explode(" ", $paciente);
			$wherecli = "";
			$count = count($cli);
			for ($i = 0; $i < $count; $i++) {
				$wherecli .= " AND c.nome LIKE '%".$cli[$i]."%'";
			}
		  }
		  if($cpf) {
			$sql = "SELECT c.id, c.nome, c.nome_mae, c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc, c.inativo " 
		  . "\n FROM paciente as c"
		  . "\n WHERE cpf = '$cpf' " 
		  . "\n ORDER BY c.nome ";
			$row = self::$db->fetch_all($sql);
		  } elseif($paciente) {
			$sql = "SELECT c.id, c.nome,c.nome_mae,  c.celular, c.cpf, c.email, c.telefone, c.bairro, c.cidade, c.usuario, c.data_cadastro, c.sexo, c.data_nasc, c.inativo " 
		  . "\n FROM paciente as c"
		  . "\n WHERE c.id > 0 $wherecli " 
		  . "\n ORDER BY c.nome ";
			$row = self::$db->fetch_all($sql);
		  }

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarPaciente()
		* Sugestão para o PIN : 3 primeiros digitos do CPF e dia de nascimento
       * 
       * @return
       */
      public function processarPaciente()
      {
		  $cpf = limparCPF_CNPJ(post('cpf'));
		  $cpf_responsavel = limparCPF_CNPJ(post('cpf_responsavel'));
		  $id_empresa = session('idempresa');
		  $validar_paciente = getValue('validar_paciente', 'empresa', 'id='.$id_empresa);
		  
		  if (empty($_POST['nome']))
              Filter::$msgs['nome'] = lang('MSG_ERRO_NOME');	

		  if ((empty($_POST['celular'])) && (empty($_POST['telefone'])))
				  Filter::$msgs['telefone'] = lang('MSG_ERRO_TELEFONE');	  
		  
		  if($validar_paciente) {		  
			if (!empty($_POST['cpf'])) {
				if($cpf == '11111111111') {
					$cpf = 'NULL';
				} elseif(!validaCPF($cpf)) {
					Filter::$msgs['cpf'] = lang('MSG_ERRO_CPF_INVALIDO');
				} else {
					$where = (Filter::$id) ? "AND id <> ".Filter::$id : "";
					$sql = "SELECT p.nome " 
					. "\n FROM paciente as p "
					. "\n WHERE p.cpf = '$cpf' $where ";
					$row = self::$db->first($sql);
					if ($row)
						Filter::$msgs['cpf'] = str_replace("[NOME]", $row->nome, lang('MSG_ERRO_CPF_CADASTRADO'));
				}	
			}
		  } else {
			  if (empty($_POST['cpf'])) {
				if (empty($_POST['cpf_responsavel'])) {
					 Filter::$msgs['cpf'] = lang('MSG_ERRO_CPF');  
				} elseif(!validaCPF($cpf_responsavel)) {
					Filter::$msgs['cpf_responsavel'] = lang('MSG_ERRO_CPF_INVALIDO');
				} else {
					$cpf = 'NULL';
				}
			  } else {
				if($cpf == '11111111111') {
					$cpf = 'NULL';
				} elseif(!validaCPF($cpf)) {
					Filter::$msgs['cpf'] = lang('MSG_ERRO_CPF_INVALIDO');
				} else {
					$where = (Filter::$id) ? "AND id <> ".Filter::$id : "";
					$sql = "SELECT p.nome " 
					. "\n FROM paciente as p "
					. "\n WHERE p.cpf = '$cpf' $where ";
					$row = self::$db->first($sql);
					if ($row)
						Filter::$msgs['cpf'] = str_replace("[NOME]", $row->nome, lang('MSG_ERRO_CPF_CADASTRADO'));
				}	
			  }		  
			  if (empty($_POST['sexo']))
				  Filter::$msgs['sexo'] = lang('MSG_ERRO_SEXO');	
			  
			  if (empty($_POST['endereco']))
				  Filter::$msgs['endereco'] = lang('MSG_ERRO_ENDERECO');	
			  
			  if (empty($_POST['cidade']))
				  Filter::$msgs['cidade'] = lang('MSG_ERRO_CIDADE');	
		  }	
		  
          if (empty(Filter::$msgs)) {
			  
			if($cpf == '11111111111' or $cpf == '') {
				$cpf = 'NULL';
			}
			$data_nasc = post('data_nasc');
			$pin = substr($cpf,0,3).substr($data_nasc,0,2);
			$celular = post('celular');
			$telefone = post('telefone');
			$endereco = post('endereco');
			$numero = post('numero');
			$complemento = post('complemento');
			$bairro = post('bairro');
			$cidade = post('cidade');
			$estado = post('estado');
			$cep = post('cep');
			  
			$data = array(
				'nome' => cleanSanitize(post('nome')),
				'pin' => $pin,  
				'cpf' => $cpf,  
				'responsavel' => sanitize(post('responsavel')),
				'cpf_responsavel' => $cpf_responsavel,  
				'cep' => $cep,  
				'endereco' => $endereco,  
				'numero' => $numero,  
				'complemento' => $complemento,  
				'bairro' => $bairro,  
				'cidade' => $cidade,  
				'estado' => $estado,  
				'telefone' => $telefone,  
				'celular' => $celular,  
				'identidade' => sanitize(post('identidade')),
				'nome_mae' => sanitize(post('nome_mae')),
				'nome_pai' => sanitize(post('nome_pai')),
				'id_origem' => sanitize(post('id_origem')),
				'sexo' => sanitize(post('sexo')),
				'data_nasc' => dataMySQL(post('data_nasc')),
				'email' => sanitize(post('email')),
				'facebook' => sanitize(post('facebook')),
				'instagram' => sanitize(post('instagram')),
				'observacao' => sanitize(post('observacao')),
				'estado_civil' => sanitize(post('estado_civil')),
				'profissao' => sanitize(post('profissao')),
				'indicacao' => sanitize(post('indicacao')),
				'edicao' => sanitize(post('edicao')),
				'inativo' => "0",
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			);
			if (Filter::$id)
			{
				$id_paciente = Filter::$id;
				self::$db->update(self::uTable, $data, "id='" . Filter::$id . "'");
				$message = lang('PACIENTE_AlTERADO_OK');
			} else {
				$data['data_cadastro'] = "NOW()";
				$id_paciente = self::$db->insert(self::uTable, $data);
				$message = lang('PACIENTE_ADICIONADO_OK');
			}			
			$id_convenio = post('id_convenio');
			if($id_convenio > 0) {
					$data_convenio = array(
						'id_paciente' => $id_paciente,
						'id_convenio' => $id_convenio,
						'numero' => sanitize(post('numero_convenio')),
						'principal' => 1,
						'usuario' => session('nomeusuario'),
						'data' => "NOW()"
					);
					self::$db->insert("paciente_convenio", $data_convenio);
			}
			$redirecionar = (empty($_POST['novo'])) ? "index.php?do=paciente&acao=editar&id=".$id_paciente : "index.php?do=paciente&acao=adicionar";
			if (self::$db->affected()) {
				Filter::msgOk($message,$redirecionar);   
			} else Filter::msgAlert(lang('NAOPROCESSADO'));
                  
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getTipoPagamento()
	   *
       * @return
       */
	  public function getTipoPagamento()
      {
          $sql = "SELECT p.id, p.tipo " 
		  . "\n FROM tipo_pagamento as p "
		  . "\n ORDER BY p.tipo ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Paciente::processarPagamento()       * 
       * tipo = 1: DINHEIRO
       * tipo = 2: CHEQUE
       * tipo = 3: BANCO
       * tipo > 3: CARTOES
       * @return
       */
      public function processarPagamento()
      {	  
		  $parcial = post('parcial');
		  $id_atendimento = post('id_atendimento');
		  $id_tabela = post('id_tabela');
		  $row_tabela = Core::getRowById("tabela", $id_tabela);	
		  $total_parcelas = (is_numeric(post('total_parcelas')) and post('total_parcelas') > 0) ? post('total_parcelas') : 1;
		  
		  $pago = getValue('pago', 'atendimento', 'id='.$id_atendimento);		  
		  if($pago == 1) {
              Filter::$msgs['realizado'] = lang('PAGAMENTO_REALIZADO_OK');			  
		  }
		  
		  $id_convenio = getValue('id_convenio', 'atendimento', 'id='.$id_atendimento);
		  $valor = 0;
		  if($id_convenio > 0) {
			$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
			$valor = ($valor_convenio) ? $valor_convenio : $row_tabela->valor;
		  } else {
			$valor = $row_tabela->valor;				  
		  }
		  $valor_pago = converteMoeda(post('valor_pago'));
		  $valor_desconto = converteMoeda(post('valor_desconto'));
		  if($parcial != 1) {
			  $pago = 1;
			  $valor_pagar = round($valor - $valor_desconto, 2);
			  $valor_pago = round($valor_pago, 2);
			  if($valor_pago == 0) {
				  $valor_pago = $valor_pagar;
			  } elseif($valor_pagar != $valor_pago) {
				  $erro_pagamento = str_replace("[VALOR_PAGAR]", moeda($valor_pagar), lang('MSG_ERRO_PAGAMENTO_VALOR_DIFERENTE'));
				  $erro_pagamento = str_replace("[VALOR_PAGO]", moeda($valor_pago), $erro_pagamento);
				  Filter::$msgs['valor_pagar'] = $erro_pagamento;
			  }
			  
		  } else {
			  $valor_pagar = round($valor - $valor_desconto, 2);
			  $valor_pago = round($valor_pago, 2);
			  $pago = 2;
		  }
		  
		  if (empty($_POST['tipo_pagamento'])) {
              Filter::$msgs['tipo_pagamento'] = lang('MSG_ERRO_TIPO');			  
		  } else {
			  $num_parcelas = getValue("parcelas","tipo_pagamento","id = ".post('tipo_pagamento'));
			  if($total_parcelas > $num_parcelas)
				  Filter::$msgs['total_parcelas'] = lang('MSG_ERRO_PARCELAS');
		  }		  

          if (empty(Filter::$msgs)) {
			  
			  $id_paciente = (empty($_POST['id_paciente'])) ? getValue('id_paciente', 'atendimento', 'id='.$id_atendimento) : post('id_paciente');
			  $data_vencimento = (empty($_POST['data_vencimento'])) ? date('Y-m-d') : dataMySQL($_POST['data_vencimento']);
              $tipo = post('tipo_pagamento');
			  $id_medico = getValue('id_medico', 'atendimento', 'id='.$id_atendimento);
			  $descricao = $row_tabela->procedimento;
			  //VALOR DO REPASSE SEM DESCONTO
			  $repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
			  $producao = getValue('producao', 'usuario', 'id='.$id_medico);
			  $valor_repasse = 0;
			  if($producao == 2) {
				  $percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
				  $percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
				  $valor_repasse = $valor*$percentual_repasse/100;
			  } elseif($producao == 1) {
				  $valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
				  $valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
			  }
              $id_pagamento = 0;
			  
			  $data = array(
				'id_empresa' => session('idempresa'),
				'id_paciente' => $id_paciente,
				'id_atendimento' => $id_atendimento,
				'id_tabela' => $id_tabela,
                'tipo' => $tipo, 
				'valor' => $valor_pagar,
				'valor_desconto' => $valor_desconto,
				'valor_pago' => $valor_pago,
                'id_banco' => post('id_banco'), 
                'numero_cartao' => post('numero_cartao'), 
                'total_parcelas' => $total_parcelas, 
                'nome_cheque' => post('nome_cheque'), 
                'banco_cheque' => post('banco_cheque'), 
                'agencia_cheque' => post('agencia_cheque'), 
                'numero_cheque' => post('numero_cheque'),
				'observacao' => sanitize(post('observacao')),
                'data_caixa' => "NOW()",
				'data_vencimento' => $data_vencimento,
				'data_pagamento' => "NOW()",
				'pago' => $pago,
				'usuario_caixa' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  $id_pagamento = self::$db->insert("paciente_financeiro", $data);
			  $data_atendimento = array(
				'id_pagamento' => $id_pagamento,
				'valor_tabela' => $valor_pagar,
				'valor_repasse' => $valor_repasse,
				'valor_pago' => $valor_pago,
				'pago' => $pago,
				'data_pagamento' => "NOW()",
				'usuario_pagamento' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  $realizado = getValue('realizado', 'atendimento', 'id='.$id_atendimento);
			  if($realizado == 0) {
				  $data_agenda = getValue('data_agenda', 'atendimento', 'id='.$id_atendimento);
				  if(hoje($data_agenda)) {
					  $data_atendimento['realizado'] = '3';
				  }
			  }
			  self::$db->update("atendimento", $data_atendimento, "id=".$id_atendimento);
			  
			  $row_cartoes = Core::getRowById("tipo_pagamento", $tipo);
			  $descricao = $row_cartoes->tipo;
			  $dias = $row_cartoes->dias;
			  $taxa = $row_cartoes->taxa;
			  $pago_receita = $row_cartoes->pago;
			  $prazo = $row_cartoes->prazo;
			  			
			  $valor_parcela = round($valor_pago/$total_parcelas, 2);
			  $valor_parcela_pago = $valor_parcela;	
			  $diferenca = $valor_pago - ($valor_parcela*$total_parcelas);
			  
			  if($taxa > 0) {
				$valor_taxa = $valor_parcela*$taxa/100;
				$valor_parcela_pago = $valor_parcela - $valor_taxa;
			  }
			  
			  $data_parcela = explode('-', $data_vencimento);
			  for($i=0;$i<$total_parcelas;$i++)
			  {
				  $fator = $i+$prazo;
				  if($dias == 30) {
					$newData = novadata($data_parcela[1] + $fator, $data_parcela[2], $data_parcela[0]);	
				  } else {
					$newData = novadata($data_parcela[1], $data_parcela[2] + ($fator*$dias), $data_parcela[0]);	
				  }	
				  $parc = ($i+1);
				  $p = $parc."/".$total_parcelas;		
					
				  $data_receita = array(
					'id_empresa' => session('idempresa'), 
					'id_conta' => 19, 
					'id_banco' => post('id_banco'), 
					'id_paciente' => $id_paciente, 
					'id_pagamento' => $id_pagamento, 
					'id_atendimento' => $id_atendimento, 
					'descricao' => $descricao." - PARCELA [$p]",
					'tipo' => $tipo, 
					'data_vencimento' => $newData,
					'data_caixa' => "NOW()",
					'pago' => $pago_receita,
					'parcela' => $parc,
					'total_parcelas' => $total_parcelas, 
					'usuario_caixa' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				  );
				  if($pago_receita) {
					$data_receita['data_pagamento'] = $newData;
				  }
				  if($i == 0) {
					$data_receita['valor'] = $valor_parcela + $diferenca;
					$data_receita['valor_pago'] = $valor_parcela_pago + $diferenca;
				  } else {
					$data_receita['valor'] = $valor_parcela;
					$data_receita['valor_pago'] = $valor_parcela_pago;
				  }
				  self::$db->insert("receita", $data_receita);
			  }
			
			if (self::$db->affected()) {				  
				$message = lang('PACIENTE_PAGAMENTO_OK');
				Filter::msgReload($message);
			  } else Filter::msgAlert(lang('NAOPROCESSADO'));
              
          } else
              print Filter::msgStatus();
      }

      /**
       * Paciente::processarPagamentoExtra()       * 
       * tipo = 1: DINHEIRO
       * tipo = 2: CHEQUE
       * tipo = 3: BANCO
       * tipo > 3: CARTOES
       * @return
       */
      public function processarPagamentoExtra()
      {		  
		  $parcial = post('parcial');
		  $id_atendimento = post('id_atendimento');
		  $id_tabela = post('id_tabela');
		  $row_tabela = Core::getRowById("tabela", $id_tabela);	
		  $total_parcelas = (is_numeric(post('total_parcelas')) and post('total_parcelas') > 0) ? post('total_parcelas') : 1;
		  
		  $id_convenio = getValue('id_convenio', 'atendimento', 'id='.$id_atendimento);
		  $valor = 0;
		  if($id_convenio > 0) {
			$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
			$valor = ($valor_convenio) ? $valor_convenio : $row_tabela->valor;
		  } else {
			$valor = $row_tabela->valor;				  
		  }
		  $valor_pago = converteMoeda(post('valor_pago'));
		  $valor_desconto = converteMoeda(post('valor_desconto'));
		  $pago = 1;
		  $valor_pagar = round($valor - $valor_desconto, 2);
		  $valor_pago = round($valor_pago, 2);
		  if($valor_pago == 0) {
			  $valor_pago = $valor_pagar;
		  } elseif($valor_pagar != $valor_pago) {
			  $erro_pagamento = str_replace("[VALOR_PAGAR]", moeda($valor_pagar), lang('MSG_ERRO_PAGAMENTO_VALOR_DIFERENTE'));
			  $erro_pagamento = str_replace("[VALOR_PAGO]", moeda($valor_pago), $erro_pagamento);
			  Filter::$msgs['valor_pagar'] = $erro_pagamento;
		  }
		  
		  if (empty($_POST['tipo_pagamento'])) {
              Filter::$msgs['tipo_pagamento'] = lang('MSG_ERRO_TIPO');			  
		  } else {
			  $num_parcelas = getValue("parcelas","tipo_pagamento","id = ".post('tipo_pagamento'));
			  if($total_parcelas > $num_parcelas)
				  Filter::$msgs['total_parcelas'] = lang('MSG_ERRO_PARCELAS');
		  }		  

          if (empty(Filter::$msgs)) {
			  
			  $id_paciente = (empty($_POST['id_paciente'])) ? getValue('id_paciente', 'atendimento', 'id='.$id_atendimento) : post('id_paciente');
			  $data_vencimento = (empty($_POST['data_vencimento'])) ? date('Y-m-d') : dataMySQL($_POST['data_vencimento']);
              $tipo = post('tipo_pagamento');
			  $id_medico = getValue('id_medico', 'atendimento', 'id='.$id_atendimento);
			  $descricao = $row_tabela->procedimento;
			  $id_laboratorio = $row_tabela->id_laboratorio;
			  $valor_pago_lab = $row_tabela->valor_pago_lab;
			  //VALOR DO REPASSE SEM DESCONTO
			  $repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
			  $producao = getValue('producao', 'usuario', 'id='.$id_medico);
			  $valor_repasse = 0;
			  if($producao == 2) {
				  $percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
				  $percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row_tabela->percentual_repasse;
				  $valor_repasse = $valor*$percentual_repasse/100;
			  } elseif($producao == 1) {
				  $valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
				  $valor_repasse = ($valor_repasse) ? $valor_repasse : $row_tabela->valor_repasse;
			  }
              $id_pagamento = 0;
			  
			  $data = array(
				'id_empresa' => session('idempresa'),
				'id_paciente' => $id_paciente,
				'id_atendimento' => $id_atendimento,
				'id_tabela' => $id_tabela,
                'tipo' => $tipo, 
				'valor' => $valor_pagar,
				'valor_desconto' => $valor_desconto,
				'valor_pago' => $valor_pago,
                'id_banco' => post('id_banco'), 
                'numero_cartao' => post('numero_cartao'), 
                'total_parcelas' => $total_parcelas, 
                'nome_cheque' => post('nome_cheque'), 
                'banco_cheque' => post('banco_cheque'), 
                'agencia_cheque' => post('agencia_cheque'), 
                'numero_cheque' => post('numero_cheque'),
				'observacao' => sanitize(post('observacao')),
                'data_caixa' => "NOW()",
				'data_vencimento' => $data_vencimento,
				'data_pagamento' => "NOW()",
				'pago' => $pago,
				'usuario_caixa' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  $id_pagamento = self::$db->insert("paciente_financeiro", $data);
			  $data_atendimento = array(
				'id_laboratorio' => $id_laboratorio,
				'id_pagamento' => $id_pagamento,
				'valor_tabela' => $valor_pagar,
				'valor_repasse' => $valor_repasse,
				'valor_pago' => $valor_pago,
				'valor_pago_lab' => $valor_pago_lab,
				'pago' => 1,
				'data_pagamento' => "NOW()",
				'usuario_pagamento' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  $realizado = getValue('realizado', 'atendimento', 'id='.$id_atendimento);
			  if($realizado == 0) {
				  $data_agenda = getValue('data_agenda', 'atendimento', 'id='.$id_atendimento);
				  if(hoje($data_agenda)) {
					  $data_atendimento['realizado'] = '3';
				  }
			  }
			  self::$db->update("atendimento", $data_atendimento, "id=".$id_atendimento);
			  
			  $pago_receita = getValue('pago', 'tipo_pagamento', 'id='.$tipo);
			  $valor_parcela = round($valor_pago/$total_parcelas, 2);
			  $diferenca = $valor_pago - ($valor_parcela*$total_parcelas);
			  $data_parcela = explode('-', $data_vencimento);
			  for($i=0;$i<$total_parcelas;$i++)
			  {
				  $newData = novadata($data_parcela[1] + $i, $data_parcela[2], $data_parcela[0]);		
				  $parc = ($i+1);
				  $p = $parc."/".$total_parcelas;		
					
				  $data_receita = array(
					'id_empresa' => session('idempresa'), 
					'id_conta' => 18, 
					'id_banco' => post('id_banco'), 
					'id_paciente' => $id_paciente, 
					'id_pagamento' => $id_pagamento, 
					'id_atendimento' => $id_atendimento, 
					'descricao' => $descricao." - PARCELA [$p]",
					'tipo' => $tipo, 
					'data_vencimento' => $newData,
					'data_caixa' => "NOW()",
					'pago' => $pago_receita,
					'parcela' => $parc,
					'total_parcelas' => $total_parcelas, 
					'usuario_caixa' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				  );
				  if($pago_receita) {
					$data_receita['data_pagamento'] = $newData;
				  }
				  if($i == 0) {
					$data_receita['valor'] = $valor_parcela + $diferenca;
					$data_receita['valor_pago'] = $valor_parcela + $diferenca;
				  } else {
					$data_receita['valor'] = $valor_parcela;
					$data_receita['valor_pago'] = $valor_parcela;
				  }
				  self::$db->insert("receita", $data_receita);
			  }
			
			if (self::$db->affected()) {				  
				$message = lang('PACIENTE_PAGAMENTO_OK');
				Filter::msgReload($message);
			  } else Filter::msgAlert(lang('NAOPROCESSADO'));
              
          } else
              print Filter::msgStatus();
      }

      /**
       * Paciente::processarPagamentoParcial()       * 
       * tipo = 1: DINHEIRO
       * tipo = 2: CHEQUE
       * tipo = 3: BANCO
       * tipo > 3: CARTOES
       * @return
       */
      public function processarPagamentoParcial()
      {		  

		  if (empty($_POST['tipo_pagamento'])) {
              Filter::$msgs['tipo_pagamento'] = lang('MSG_ERRO_TIPO');			  
		  }
		  
		  if (empty($_POST['valor_pago']))
              Filter::$msgs['valor_pago'] = lang('MSG_ERRO_VALOR');
		  
		  $parcial = post('parcial');
		  $valor = converteMoeda(post('valor_pago'));	
          $id_pagamento = post('id_pagamento');
		  $row_financeiro = Core::getRowById("paciente_financeiro",  $id_pagamento);
		  $id_paciente = $row_financeiro->id_paciente;
		  $id_atendimento = $row_financeiro->id_atendimento;
		  $valor_pago = $row_financeiro->valor_pago;
		  $valor_atendimento = $row_financeiro->valor;
		  $valor_pagar = $valor_atendimento - $valor_pago;
		  if($parcial != 1) {
			  $pago = 1;
			  $valor_pagar = round($valor_pagar, 2);
			  $valor = round($valor, 2);
			  if($valor_pagar != $valor) {
				  $erro_pagamento = str_replace("[VALOR_PAGAR]", moeda($valor_pagar), lang('MSG_ERRO_PAGAMENTO_VALOR_DIFERENTE'));
				  $erro_pagamento = str_replace("[VALOR_PAGO]", moeda($valor), $erro_pagamento);
				  Filter::$msgs['valor_pagar'] = $erro_pagamento;
			  }			  
		  } else {
			  $valor_pagar = round($valor_pagar, 2);
			  $valor = round($valor, 2);
			  if($valor_pagar == $valor) {
				$pago = 1;
			  } else {
				$pago = 2;
			  }
		  }			  

          if (empty(Filter::$msgs)) {
			  
			  $total_parcelas = (is_numeric(post('total_parcelas')) and post('total_parcelas') > 0) ? post('total_parcelas') : 1;
			  $data_vencimento = (empty($_POST['data_vencimento'])) ? date('Y-m-d') : dataMySQL($_POST['data_vencimento']);		  
              $tipo = post('tipo_pagamento');
			  $procedimento = getValue('procedimento', 'tabela', 'id='.$row_financeiro->id_tabela);

			  $pago_receita = getValue('pago', 'tipo_pagamento', 'id='.$tipo);
			  $valor_parcela = round($valor/$total_parcelas, 2);
			  $diferenca = $valor - ($valor_parcela*$total_parcelas);
			  $data_parcela = explode('-', $data_vencimento);
			  for($i=0;$i<$total_parcelas;$i++)
			  {
				  $newData = novadata($data_parcela[1] + $i, $data_parcela[2], $data_parcela[0]);		
				  $parc = ($i+1);
				  $p = $parc."/".$total_parcelas;		
					
				  $data_receita = array(
					'id_empresa' => session('idempresa'), 
					'id_conta' => 19, 
					'id_banco' => post('id_banco'), 
					'id_paciente' => $id_paciente, 
					'id_pagamento' => $id_pagamento, 
					'id_atendimento' => $id_atendimento, 
					'descricao' => $procedimento." - PARCIAL - PARCELA [$p]",
					'tipo' => $tipo, 
					'data_vencimento' => $newData,
					'data_caixa' => "NOW()",
					'pago' => $pago_receita,
					'parcela' => $parc,
					'total_parcelas' => $total_parcelas, 
					'usuario_caixa' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				  );
				  if($pago_receita) {
					$data_receita['data_pagamento'] = $newData;
				  }
				  if($i == 0) {
					$data_receita['valor'] = $valor_parcela + $diferenca;
					$data_receita['valor_pago'] = $valor_parcela + $diferenca;
				  } else {
					$data_receita['valor'] = $valor_parcela;
					$data_receita['valor_pago'] = $valor_parcela;
				  }
				  self::$db->insert("receita", $data_receita);
			  }
			  $valor_total = $valor + $valor_pago;
			  
			  $data = array(
				'valor_pago' => $valor_total,
				'data_pagamento' => "NOW()",
				'pago' => $pago,
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  self::$db->update("paciente_financeiro", $data, "id=".$id_pagamento);
			  $data_atendimento = array(
				'valor_pago' => $valor_total,
				'pago' => $pago,
				'data_pagamento' => "NOW()",
				'usuario_pagamento' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  self::$db->update("atendimento", $data_atendimento, "id=".$id_atendimento);
			
			if (self::$db->affected()) {				  
				$message = lang('PACIENTE_PAGAMENTO_OK');
				Filter::msgReload($message);
			  } else Filter::msgAlert(lang('NAOPROCESSADO'));
              
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getPacienteFinanceiro()
	   *
       * @return
       */
	  public function getPacienteFinanceiro($id_paciente)
      {
          $sql = "SELECT f.id, t.tipo, f.valor, f.valor_pago, f.data_vencimento, f.data_pagamento, f.total_parcelas, f.usuario" 
		  . "\n FROM paciente_financeiro AS f "
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = f.tipo"
		  . "\n WHERE f.inativo = 0 AND f.id_paciente = $id_paciente "
		  . "\n ORDER BY f.data_vencimento DESC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getPacienteFinanceiroDetalhes()
	   *
       * @return
       */
	  public function getPacienteFinanceiroDetalhes($id)
      {
          $sql = "SELECT f.id, t.tipo, p.nome, f.id_paciente, f.valor, f.valor_pago, f.data_vencimento, f.data_pagamento, f.total_parcelas, f.usuario" 
		  . "\n FROM paciente_financeiro AS f "
		  . "\n LEFT JOIN paciente as p ON p.id = f.id_paciente"
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = f.tipo"
		  . "\n WHERE f.id = $id ";
          $row = self::$db->first($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getPacienteReceitas()
	   *
       * @return
       */
	  public function getPacienteReceitas($id_paciente)
      {
          $sql = "SELECT r.id, r.descricao, r.valor, r.valor_pago, r.pago, r.data_vencimento, r.data_pagamento, r.parcela, r.total_parcelas, t.tipo, r.usuario " 
		  . "\n FROM receita as r "
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = r.tipo"
		  . "\n WHERE r.inativo = 0 AND r.id_paciente = $id_paciente "
		  . "\n ORDER BY r.data_vencimento DESC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getPacienteReceitaDetalhes()
	   *
       * @return
       */
	  public function getPacienteReceitaDetalhes($id)
      {
          $sql = "SELECT r.id, r.descricao, p.nome, r.id_paciente, r.valor, r.valor_pago, r.pago, r.data_vencimento, r.data_pagamento, r.parcela, r.total_parcelas, t.tipo, r.usuario " 
		  . "\n FROM receita as r "
		  . "\n LEFT JOIN paciente as p ON p.id = r.id_paciente"
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = r.tipo"
		  . "\n WHERE r.id = $id ";
          $row = self::$db->first($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarPacienteRetorno()
       * 
       * @return
       */
      public function processarPacienteRetorno()
      {
		  if (empty($_POST['id_status']))
              Filter::$msgs['id_status'] = lang('MSG_ERRO_STATUS');	
		  
		  // if (!empty($_POST['data_retorno'])) {
			  // $hoje = date('d/m/Y');
			  // $data_retorno = post('data_retorno');
			  // $dias = contarDias($hoje, $data_retorno);
			  // if($dias < 0 or $dias > 180) {
				// Filter::$msgs['data_retorno'] = lang('MSG_ERRO_DATA_RETORNO'); 
			  // }			  
		  // }

          if (empty(Filter::$msgs)) {			  
			  
              $data_ativo = array(
					'ativo' => "0"
			  );
              self::$db->update("paciente_retorno", $data_ativo, "id_paciente=" . post('id_paciente'));
				
              $data = array(
					'id_empresa' => session('idempresa'),
					'id_status' => sanitize(post('id_status')), 
					'id_paciente' => sanitize(post('id_paciente')),  
					'observacao' => sanitize(post('observacao')), 
					'ativo' => "1",
					'data_retorno' => dataMySQL(post('data_retorno')),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );
              self::$db->insert("paciente_retorno", $data);
			  
              $data_paciente = array(
					'id_status' => sanitize(post('id_status')),
					'data_retorno' => dataMySQL(post('data_retorno')),
					'data_contato' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );

              self::$db->update("paciente", $data_paciente, "id=" . post('id_paciente'));
			  
              $message = lang('CONTATO_RETORNO_ADICIONADO_OK');

              if (self::$db->affected()) {		
				  if (empty($_POST['contato'])) {	  
					Filter::msgOk($message, "index.php?do=paciente&acao=agenda&id=".post('id_paciente'));
				  } else {	  
					Filter::msgOk($message, "index.php?do=paciente&acao=contato&id=".post('id_paciente'));
				  }
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }

      /**
       * Paciente::getPacienteRetorno()
       * 
       * @return
       */
      public function getPacienteRetorno($id_paciente)
      {
          $sql = "SELECT p.*, s.status, s.tipo, p.data_retorno < CURDATE() as atrasado, p.data_retorno > CURDATE() as agendado, p.data_retorno = CURDATE() as hoje, DATE_FORMAT(p.data, '%Y%m%d') as controle " 
		  . "\n FROM paciente_retorno AS p"
		  . "\n LEFT JOIN paciente_status AS s ON s.id = p.id_status "
		  . "\n WHERE p.id_paciente = ".$id_paciente
		  . "\n ORDER BY p.id DESC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getPacienteReceitasAbertas()
	   *
       * @return
       */
	  public function getPacienteReceitasAbertas($id_paciente)
      {
		  
		  $sql = "SELECT f.id, c.conta, f.id_conta, f.id_banco, f.parcela, f.total_parcelas, b.banco, f.descricao, f.tipo, f.id_paciente, f.id_cadastro, f.valor,  f.valor_pago, f.conciliado, f.data_pagamento, f.data_vencimento, f.pago, t.tipo as pagamento, DATE_FORMAT(f.data_vencimento, '%Y%m%d') as controle, f.data_vencimento < CURDATE() as atrasado, ca.nome as cadastro, p.nome as paciente , p.celular, e.nome AS empresa, e.nome as empresa, e.sigla, e.whatsapp" 
		  . "\n FROM receita as f" 
		  . "\n LEFT JOIN conta as c ON c.id = f.id_conta" 
		  . "\n LEFT JOIN empresa as e ON e.id = f.id_empresa" 
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = f.tipo" 
		  . "\n LEFT JOIN banco as b ON b.id = f.id_banco" 
		  . "\n LEFT JOIN cadastro as ca ON ca.id = f.id_cadastro" 
		  . "\n LEFT JOIN paciente as p ON p.id = f.id_paciente"
		  . "\n WHERE f.inativo = 0 AND f.pago = 0 AND f.id_paciente = $id_paciente "
		  . "\n ORDER BY f.data_vencimento DESC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Paciente::getPacienteAvisos()
       * 
       * @return
       */
      public function getPacienteAvisos($id_paciente)
      {
          $sql = "SELECT p.*, s.status, s.tipo, p.data_retorno < CURDATE() as atrasado, p.data_retorno > CURDATE() as agendado, p.data_retorno = CURDATE() as hoje, DATE_FORMAT(p.data, '%Y%m%d') as controle " 
		  . "\n FROM paciente_retorno AS p"
		  . "\n LEFT JOIN paciente_status AS s ON s.id = p.id_status "
		  . "\n WHERE p.id_status = 9 AND p.id_paciente = ".$id_paciente;
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

      /**
       * Paciente::getStatus()
       * 
       * @return
       */
      public function getStatus($tipo = 1)
      {
		  $where = ($tipo) ? " AND tipo = $tipo " : "";
		  $sql = "SELECT * FROM paciente_status WHERE id > 1 ORDER BY status ASC";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getOrigem()
	   *
       * @return
       */
	  public function getOrigem()
      {
          $sql = "SELECT id, origem, inativo  " 
		  . "\n FROM origem "
		  . "\n WHERE inativo = 0 "
		  . "\n ORDER BY origem ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getTodasOrigem()
	   *
       * @return
       */
	  public function getTodasOrigem()
      {
          $sql = "SELECT id, origem, inativo  " 
		  . "\n FROM origem "
		  . "\n ORDER BY origem ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getTotalOrigem()
	   *
       * @return
       */
	  public function getTotalOrigem($id_origem = 0)
      {
          $sql = "SELECT COUNT(1) AS quant  " 
		  . "\n FROM paciente "
		  . "\n WHERE inativo = 0 AND id_origem = $id_origem ";
          $row = self::$db->first($sql);

          return ($row) ? $row->quant : 0;
      }
	  
      /**
       * Paciente::processarOrigem()
       * 
       * @return
       */
      public function processarOrigem()
      {
		  if (empty($_POST['origem']))
              Filter::$msgs['origem'] = lang('MSG_ERRO_ORIGEM'); 

          if (empty(Filter::$msgs)) {

              $data = array(
					'origem' => sanitize($_POST['origem'])
			  );

              self::$db->insert("origem", $data);
			  
              $message = lang('ADICIONAR_OK');

              if (self::$db->affected()) {
			  
                  Filter::msgOk($message, "index.php?do=paciente&acao=origem"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getReferencia()
	   *
       * @return
       */
	  public function getReferencia()
      {
          $sql = "SELECT id, referencia, inativo  " 
		  . "\n FROM referencia "
		  . "\n WHERE inativo = 0 "
		  . "\n ORDER BY referencia ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarReferencia()
       * 
       * @return
       */
      public function processarReferencia()
      {
		  if (empty($_POST['referencia']))
              Filter::$msgs['referencia'] = lang('MSG_ERRO_NOME'); 

          if (empty(Filter::$msgs)) {

              $data = array(
					'referencia' => post('referencia')
			  );

              self::$db->insert("referencia", $data);
			  
              $message = lang('ADICIONAR_OK');

              if (self::$db->affected()) {
			  
                  Filter::msgOk($message, "index.php?do=paciente&acao=referencia"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getCancelamentos()
	   *
       * @return
       */
	  public function getCancelamentos()
      {
          $sql = "SELECT id, cancelamento, inativo  " 
		  . "\n FROM cancelamento "
		  . "\n WHERE inativo = 0 "
		  . "\n ORDER BY cancelamento ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarCancelamento()
       * 
       * @return
       */
      public function processarCancelamento()
      {
		  if (empty($_POST['cancelamento']))
              Filter::$msgs['cancelamento'] = lang('MSG_ERRO_NOME'); 

          if (empty(Filter::$msgs)) {

              $data = array(
					'cancelamento' => post('cancelamento')
			  );

              self::$db->insert("cancelamento", $data);
			  
              $message = lang('ADICIONAR_OK');

              if (self::$db->affected()) {
			  
                  Filter::msgOk($message, "index.php?do=paciente&acao=cancelamento"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }

      /**
       * Paciente::getProcedimentosPaciente()
       * 
       * @return
       */
      public function getProcedimentosPaciente($id_paciente)
      {
			$sql = "SELECT p.*, d.nome as medico, t.procedimento, c.nome as convenio, s.status, s.cor " 
		  . "\n FROM paciente_procedimento AS p"
		  . "\n LEFT JOIN usuario AS d ON d.id = p.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = p.id_tabela "
		  . "\n LEFT JOIN cadastro AS c ON c.id = p.id_convenio "
		  . "\n LEFT JOIN paciente_status AS s ON s.id = p.id_status "
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente'";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }

      /**
       * Paciente::getDetalhesProcedimento()
       * 
       * @return
       */
      public function getDetalhesProcedimento($id)
      {
			$sql = "SELECT p.*, d.nome as medico, t.procedimento, c.nome as convenio, e.nome as tabela, s.status, s.cor " 
		  . "\n FROM paciente_procedimento AS p"
		  . "\n LEFT JOIN usuario AS d ON d.id = p.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = p.id_tabela "
		  . "\n LEFT JOIN especialidade as e ON e.id = t.id_especialidade"
		  . "\n LEFT JOIN cadastro AS c ON c.id = p.id_convenio "
		  . "\n LEFT JOIN paciente_status AS s ON s.id = p.id_status "
		  . "\n WHERE p.id = '$id'";
          $row = ($id) ? self::$db->first($sql) : null;

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarProcedimento()
       * 
       * @return
       */
      public function processarProcedimento()
      {
		  if (empty($_POST['id_tabela']))
              Filter::$msgs['id_tabela'] = lang('MSG_ERRO_PROCEDIMENTO');

          if (empty(Filter::$msgs)) {
				
              $id_paciente = post('id_paciente');
              $id_tabela = post('id_tabela');
              $id_convenio = post('id_convenio');
              $id_medico = post('id_medico');
			  $row_tabela = Core::getRowById("tabela", $id_tabela);	
			  $desconto = getValue('desconto', 'especialidade', 'id='.$row_tabela->id_especialidade);
			  $valor = ($id_convenio) ? getValue('valor_convenio', 'tabela_convenio', 'id_cadastro='.$id_convenio.' AND id_tabela='.$id_tabela) : $row_tabela->valor;
			  if($valor == 0) {
				$valor = $row_tabela->valor;
				$id_convenio = 0;
			  }			  
			  $data = array(
				'id_empresa' => session('idempresa'),
				'id_paciente' => $id_paciente,
				'id_tabela' => $id_tabela,
				'id_convenio' => $id_convenio,
				'id_medico' => $id_medico,
				'id_laboratorio' => $row_tabela->id_laboratorio,
				'valor_laboratorio' => $row_tabela->valor_pago_lab,
				'valor' => $valor,
				'valor_total' => $valor,
				'id_status' => "11",
				'desconto' => $desconto,
				'data_cadastro' => "NOW()",
				'usuario_cadastro' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
              self::$db->insert("paciente_procedimento", $data);	  
			  
              $message = lang('PACIENTE_SOLICITACAO_ADICIONADO_OK');

              if (self::$db->affected()) {		
				  Filter::msgOk($message, "index.php?do=paciente&acao=procedimentos&id=$id_paciente"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getArquivosPaciente()
	   *
       * @return
       */
	  public function getArquivosPaciente($id_paciente, $is_master = false)
      {
		$where = ($is_master) ? "" : " AND p.id_medico = 0";
		$sql = "SELECT p.* " 
		  . "\n FROM paciente_arquivo AS p"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente' $where";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getArquivosMedicoPaciente()
	   *
       * @return
       */
	  public function getArquivosMedicoPaciente($id_paciente, $id_medico)
      {
		$sql = "SELECT p.* " 
		  . "\n FROM paciente_arquivo AS p"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente' AND p.id_medico = '$id_medico'";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::processarArquivoPaciente()
       * 
       * @return
       */
      public function processarArquivoPaciente()
      {			  
			if (empty(Filter::$msgs)) {
				$id_paciente = post('id_paciente');
				$id_medico = post('id_medico');
				foreach($_POST as $nome_campo => $valor){
					$valida = strpos($nome_campo, "tmpname");
					if($valida) {						
						$nome = $valor;
						$caminho = UPLOADS.$valor;
						$tamanho = filesize($caminho);
						$temp = explode(".", $nome);
						$extensao = $temp[1];
						$data = array(
							'id_paciente' => $id_paciente,
							'id_medico' => $id_medico,
							'nome_arquivo' => $nome, 
							'caminho_arquivo' => $caminho, 
							'extensao_arquivo' => $extensao, 
							'tamanho_arquivo' => $tamanho, 
							'data_arquivo' => "NOW()",
							'usuario' => session('nomeusuario'),
							'data' => "NOW()"
						);
						self::$db->insert("paciente_arquivo", $data);
					}
				}
				if (self::$db->affected()) {
					$message = lang('PACIENTE_ADICIONADO_ARQUIVO_OK');
					if($id_medico > 0) {
						$redirecionar = "index.php?do=paciente&acao=arquivosmedico&id=".$id_paciente;
					} else {
						$redirecionar = "index.php?do=paciente&acao=arquivos&id=".$id_paciente;
					}
					Filter::msgOk($message, $redirecionar);
				} else Filter::msgAlert(lang('NAOPROCESSADO'));
				
			} else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::processarProntuario()
       * 
       * @return
       */
      public function processarProntuario()
      {			  
			if (empty(Filter::$msgs)) {
				$id_paciente = post('id_paciente');
				$id_medico = post('id_medico');
				$id_atendimento = intval(post('id_atendimento'));
				$id_consultorio = post('id_consultorio');
			    $id_medico = (empty($_POST['id_prontuario'])) ? post('id_medico') : post('id_prontuario');
			    $data_prontuario = (empty($_POST['data_prontuario'])) ? "NOW()" : dataMySQL($_POST['data_prontuario']).' '.date('h:i');
				
				$data = array(
					'id_paciente' => sanitize(post('id_paciente')),
					'id_medico' => $id_medico,
					'id_atendimento' => post('id_atendimento'),
					'prontuario' => cleanOut(post('prontuario')),
					'usuario' => session('nomeusuario'),
					'data' => $data_prontuario
				);
				$id_prontuario = self::$db->insert("paciente_atendimento", $data);
				
				$data_realizado = array(
					'realizado' => 1,
					'id_prontuario' => $id_prontuario,
					'usuario_realizada' => session('nomeusuario'),
					'data_realizada' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				if($id_consultorio > 0) {
					$data_realizado['id_consultorio'] = $id_consultorio;
				}
				if($id_atendimento > 0) {
					self::$db->update("atendimento", $data_realizado, "id=".$id_atendimento);
					$data_agenda = getValue("data_agenda", "atendimento", "id=".$id_atendimento);
					self::$db->update("atendimento", $data_realizado, "id_cancelamento = 0 AND DATE_FORMAT(data_agenda, '%Y-%m-%d') = STR_TO_DATE('$data_agenda', '%Y-%m-%d') AND id_medico='$id_medico' AND id_paciente='$id_paciente'");
				} else {
					self::$db->update("atendimento", $data_realizado, "id_cancelamento = 0 AND DATE_FORMAT(data_agenda, '%Y-%m-%d') = CURDATE() AND id_medico='$id_medico' AND id_paciente='$id_paciente'");
				}
				$message = lang('ATENDIMENTO_PRONTUARIO_OK');
				Filter::msgReload($message);				
			} else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getProntuario()
	   *
       * @return
       */
	  public function getProntuario($id_paciente, $id_medico, $is_master = false, $id_medico_prontuario = false)
      {
		 $is_prontuario = getValue("prontuario", "usuario", "id='$id_medico'");
		 $where = ($is_prontuario != 2) ? " AND p.id_medico = '$id_medico' " : "";
		 $where = ($is_master) ? "" : $where;
		 if($is_master) {
			$where = ($id_medico_prontuario) ? " AND p.id_medico = '$id_medico_prontuario' " : "";
		 }
		 $sql = "SELECT p.*, u.nome, a.data_agenda, a.id_convenio, a.numero_guia, a.autorizacao, a.data_receber_guia, a.data_vencimento_guia, c.nome AS convenio " 
		  . "\n FROM paciente_atendimento AS p"
		  . "\n LEFT JOIN atendimento AS a ON a.id = p.id_atendimento"
		  . "\n LEFT JOIN cadastro AS c ON c.id = a.id_convenio"
		  . "\n LEFT JOIN usuario AS u ON u.id = p.id_medico"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente' $where "
		  . "\n ORDER BY data DESC";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getDocumentos()
	   *
       * @return
       */
	  public function getDocumentos($id_paciente, $id_medico)
      {
		$sql = "SELECT p.*, m.titulo " 
		  . "\n FROM paciente_documentos AS p"
		  . "\n LEFT JOIN modelo AS m ON m.id = p.modelo"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente' AND p.id_medico = '$id_medico'"
		  . "\n ORDER BY p.id DESC";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getTodosDocumentos()
	   *
       * @return
       */
	  public function getTodosDocumentos($id_paciente)
      {
		$sql = "SELECT p.*, m.titulo " 
		  . "\n FROM paciente_documentos AS p"
		  . "\n LEFT JOIN modelo AS m ON m.id = p.modelo"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY p.id DESC";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarDocumento()
	   * MODELO: 1 - ATESTADOS
	   * MODELO: 2 - ENCAMINHAMENTOS
	   * MODELO: 3 - SOLICITACOES_PROCEDIMENTO
	   * MODELO: 4 - PRESCRICOES
       * @return
       */
      public function processarDocumento()
      {		  
		  if (empty($_POST['texto']))
              Filter::$msgs['texto'] = lang('MSG_ERRO_TEXTO');
		  
		  if (empty($_POST['cid']) and post('modelo') == '1')
              Filter::$msgs['cid'] = lang('MSG_ERRO_CID');

          if (empty(Filter::$msgs)) {
			$id_paciente = post('id_paciente');
			$id_atendimento = post('id_atendimento');
			$id_documento = post('id_documento');
			if($id_documento) {
				$data = array(
					'texto' => cleanOut(post('texto')),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update("paciente_documentos", $data, "id=".$id_documento);
			} else {
				$data = array(
					'id_paciente' => post('id_paciente'),
					'id_medico' => post('id_medico'),
					'id_atendimento' => post('id_atendimento'),
					'cid' => post('cid'),
					'texto' => cleanOut(post('texto')),
					'modelo' => post('modelo'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->insert("paciente_documentos", $data);
			}
			if (self::$db->affected()) {
				$message = lang('ATENDIMENTO_DOCUMENTO_OK');
				Filter::msgOk($message, "index.php?do=paciente&acao=documentos&id=$id_paciente&id_atendimento=$id_atendimento"); 
			} else Filter::msgAlert(lang('NAOPROCESSADO'));
                 
          } else
              print Filter::msgStatus();
      }
	  
      /**
       * Paciente::processarPacienteCirurgico()
       * 
       * @return
       */
      public function processarPacienteCirurgico()
      {
          if (empty(Filter::$msgs)) {
				
              $id = post('id');	  
			  $data = array(
				'queixa' => sanitize(post('queixa')),
				'peso' => sanitize(post('peso')),
				'altura' => sanitize(post('altura')),
				'icm' => sanitize(post('icm')),
				'exame' => sanitize(post('exame')),
				'cirurgia' => sanitize(post('cirurgia')),
				'data_cirurgia' => dataMySQL(post('data_cirurgia')),
				'plano' => sanitize(post('plano')),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
              self::$db->update("paciente", $data, "id=".$id);	  
			  
              $message = lang('PACIENTE_SOLICITACAO_ADICIONADO_OK');

              if (self::$db->affected()) {		
				  Filter::msgOk($message, "index.php?do=paciente&acao=cirurgico&id=$id"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getValorRepasse()
	   *
       * @return
       */
	  public function getValorRepasse($id_tabela, $id_medico, $id_convenio)
      {
		 $sql = "SELECT u.valor_repasse, u.percentual_repasse " 
		  . "\n FROM usuario_producao as u"
		  . "\n WHERE u.inativo = 0 AND u.id_usuario = '$id_medico' AND (u.id_tabela = '$id_tabela' OR u.id_tabela = 0) AND (u.id_convenio = '$id_convenio' OR u.id_convenio = 0) "
		  . "\n ORDER BY u.id_tabela DESC, u.id_convenio DESC";
          $row = self::$db->first($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getNatureza()
	   *
       * @return
       */
	  public function getNatureza()
      {
          $sql = "SELECT *  " 
		  . "\n FROM aso_natureza "
		  . "\n ORDER BY id ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getExames()
	   *
       * @return
       */
	  public function getExames()
      {
          $sql = "SELECT *  " 
		  . "\n FROM aso_exames "
		  . "\n ORDER BY exames ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getRiscos()
	   *
       * @return
       */
	  public function getRiscos()
      {
          $sql = "SELECT *  " 
		  . "\n FROM aso_riscos "
		  . "\n ORDER BY id ASC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::processarAtestado()
       * 
       * @return
       */
      public function processarAtestado()
      {			  
		  if (empty($_POST['nome_empresa']))
              Filter::$msgs['nome_empresa'] = lang('MSG_ERRO_NOME_EMPRESA');
		  
		  if (empty($_POST['id_natureza']))
              Filter::$msgs['id_natureza'] = lang('MSG_ERRO_NATUREZA');
		  
			if (empty(Filter::$msgs)) {
				$id_paciente = post('id_paciente');
				$id_medico = post('id_medico');
				
				$data = array(
					'id_paciente' => sanitize(post('id_paciente')),
					'id_medico' => sanitize(post('id_medico')),
					'id_natureza' => sanitize(post('id_natureza')),
					'nome_empresa' => sanitize(post('nome_empresa')),
					'matricula' => sanitize(post('matricula')),
					'funcao' => sanitize(post('funcao')),
					'apto' => sanitize(post('apto')),
					'observacao' => cleanOut(post('observacao')),
					'data_atestado' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				$id_aso = self::$db->insert("paciente_aso", $data);
				
				$cont_exame = count(post('id_exame'));
				$id_exame = post('id_exame');
				$data_exame = post('data_exame');
				for($e = 0; $e < $cont_exame; $e++) {
					$data = array(
						'id_paciente' => sanitize(post('id_paciente')),
						'id_medico' => sanitize(post('id_medico')),
						'id_aso' => $id_aso,
						'id_exame' => $id_exame[$e],
						'data_exame' => dataMySQL($data_exame[$e]),
						'observacao' => cleanOut(post('observacao')),
						'data' => "NOW()"
					);
					self::$db->insert("paciente_aso_exames", $data);
				}
				
				$cont_risco = count(post('id_risco'));
				$id_risco = post('id_risco');
				$codigo_risco = post('codigo_risco');
				for($r = 0; $r < $cont_risco; $r++) {
					$data = array(
						'id_paciente' => sanitize(post('id_paciente')),
						'id_medico' => sanitize(post('id_medico')),
						'id_aso' => $id_aso,
						'id_risco' => $id_risco[$r],
						'codigo' => $codigo_risco[$r],
						'observacao' => cleanOut(post('observacao')),
						'data' => "NOW()"
					);
					self::$db->insert("paciente_aso_riscos", $data);
				}
		
				if ($id_aso > 0) {
					$message = lang('ATENDIMENTO_ATESTADO_OK');
					$redirecionar = "index.php?do=paciente&acao=atestado&id=".$id_paciente;
					Filter::msgOk($message, $redirecionar);
				} else Filter::msgAlert(lang('NAOPROCESSADO'));
				
			} else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getAtestados()
	   *
       * @return
       */
	  public function getAtestados($id_paciente)
      {
		 $sql = "SELECT p.*, u.nome, a.natureza " 
		  . "\n FROM paciente_aso AS p"
		  . "\n LEFT JOIN aso_natureza AS a ON a.id = p.id_natureza"
		  . "\n LEFT JOIN usuario AS u ON u.id = p.id_medico"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY id DESC";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getExamesASO()
	   *
       * @return
       */
	  public function getExamesASO($id_aso)
      {
		 $sql = "SELECT p.*, a.exames " 
		  . "\n FROM paciente_aso_exames AS p"
		  . "\n LEFT JOIN aso_exames AS a ON a.id = p.id_exame"
		  . "\n WHERE p.id_aso = '$id_aso'"
		  . "\n ORDER BY a.exames DESC";
          $row = ($id_aso) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getRiscosASO()
	   *
       * @return
       */
	  public function getRiscosASO($id_aso)
      {
		 $sql = "SELECT p.*, a.riscos " 
		  . "\n FROM paciente_aso_riscos AS p"
		  . "\n LEFT JOIN aso_riscos AS a ON a.id = p.id_risco"
		  . "\n WHERE p.id_aso = '$id_aso'"
		  . "\n ORDER BY p.id_risco DESC";
          $row = ($id_aso) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::processarRiscoCirurgico()
       * 
       * @return
       */
      public function processarRiscoCirurgico()
      {			  
			if (empty(Filter::$msgs)) {
				$id_paciente = post('id_paciente');
				$id_medico = post('id_medico');
				
				$data = array(
					'id_paciente' => sanitize(post('id_paciente')),
					'id_medico' => sanitize(post('id_medico')),
					'hma' => sanitize(post('hma')),
					'queixas_cardiologicas' => sanitize(post('queixas_cardiologicas')),
					'hppregressa' => sanitize(post('hppregressa')),
					'cardiopatia' => sanitize(post('cardiopatia')),
					'sedentarismo' => sanitize(post('sedentarismo')),
					'hipertensao' => sanitize(post('hipertensao')),
					'internacoes' => sanitize(post('internacoes')),
					'discrasia' => sanitize(post('discrasia')),
					'alergia' => sanitize(post('alergia')),
					'patologia' => sanitize(post('patologia')),
					'alcoolismo' => sanitize(post('alcoolismo')),
					'diabetes' => sanitize(post('diabetes')),
					'tabagismo' => sanitize(post('tabagismo')),
					'hepatopatias' => sanitize(post('hepatopatias')),
					'medicacao' => sanitize(post('medicacao')),
					'cirurgias' => sanitize(post('cirurgias')),
					'drogas' => sanitize(post('drogas')),
					'ectoscopia' => sanitize(post('ectoscopia')),
					'dados_vitais' => sanitize(post('dados_vitais')),
					'peso' => sanitize(post('peso')),
					'altura' => sanitize(post('altura')),
					'pa' => sanitize(post('pa')),
					'tireoide' => sanitize(post('tireoide')),
					'perifericos' => sanitize(post('perifericos')),
					'digestivo' => sanitize(post('digestivo')),
					'respiratorio' => sanitize(post('respiratorio')),
					'cardiovascular' => sanitize(post('cardiovascular')),
					'normais' => sanitize(post('normais')),
					'anormais' => sanitize(post('anormais')),
					'ecg' => sanitize(post('ecg')),
					'rx' => sanitize(post('rx')),
					'conclusao' => cleanOut(post('conclusao')),
					'data_risco' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				$id_risco = self::$db->insert("paciente_risco", $data);
		
				if ($id_risco > 0) {
					$message = lang('ATENDIMENTO_RISCO_OK');
					$redirecionar = "index.php?do=paciente&acao=risco&id=".$id_paciente;
					Filter::msgOk($message, $redirecionar);
				} else Filter::msgAlert(lang('NAOPROCESSADO'));
				
			} else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getRiscoCirurgico()
	   *
       * @return
       */
	  public function getRiscoCirurgico($id_paciente)
      {
		 $sql = "SELECT p.*, u.nome " 
		  . "\n FROM paciente_risco AS p"
		  . "\n LEFT JOIN usuario AS u ON u.id = p.id_medico"
		  . "\n WHERE p.inativo = 0 AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY id DESC";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarConvenio()
       * 
       * @return
       */
      public function processarConvenio()
      {
		  if (empty($_POST['id_convenio']))
              Filter::$msgs['id_convenio'] = lang('MSG_ERRO_CONVENIO');
		  
          if (empty(Filter::$msgs)) {
				
			  $id_paciente = post('id_paciente');	
			  $data_convenio = array(
				'principal' => 0
			  );
			  self::$db->update("paciente_convenio", $data_convenio, "id_paciente=$id_paciente");
			  $data = array(
				'id_paciente' => sanitize(post('id_paciente')),
				'id_convenio' => sanitize(post('id_convenio')),
				'id_referencia' => sanitize(post('id_referencia')),
				'principal' => 1,
				'numero' => sanitize(post('numero')),
				'titular' => sanitize(post('titular')),
				'data_validade' => dataMySQL(post('data_validade')),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );

              (Filter::$id) ? self::$db->update("paciente_convenio", $data, "id=" . Filter::$id) : self::$db->insert("paciente_convenio", $data);
              
			  $message = (Filter::$id) ? lang('CONVENIO_ALTERADO_OK') : lang('CONVENIO_ADICIONADO_OK');			  
			  
              $message = lang('CONVENIO_ADICIONADO_OK');

              if (self::$db->affected()) {		
				  Filter::msgReload($message); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getPacienteConvenios()
	   *
       * @return
       */
	  public function getPacienteConvenios($id_paciente)
      {
		 $sql = "SELECT p.*, c.nome as convenio, r.referencia " 
		  . "\n FROM paciente_convenio AS p"
		  . "\n LEFT JOIN cadastro AS c ON c.id = p.id_convenio"
		  . "\n LEFT JOIN referencia AS r ON r.id = p.id_referencia"
		  . "\n WHERE c.inativo = 0 AND p.inativo = 0 AND p.id_convenio > 0 AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY c.nome ";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getConveniosValidados()
	   *
       * @return
       */
	  public function getConveniosValidados($id_paciente)
      {
		 $sql = "SELECT p.*, c.nome as convenio " 
		  . "\n FROM paciente_convenio AS p"
		  . "\n LEFT JOIN cadastro AS c ON c.id = p.id_convenio"
		  . "\n WHERE c.inativo = 0 AND p.inativo = 0 AND p.data_validade > CURDATE() AND p.id_paciente = '$id_paciente'"
		  . "\n ORDER BY c.nome ";
          $row = ($id_paciente) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::ProcessarUniaoPaciente()
	   *
       * @return
       */
      public function ProcessarUniaoPaciente()
      {
          $id_paciente = post('id_paciente');
          $id_novo_paciente = post('id_novo_paciente');
		  
		  if (empty($_POST['id_novo_paciente']))
              Filter::$msgs['id_novo_paciente'] = lang('MSG_ERRO_PACIENTE');
			  
		  if (empty(Filter::$msgs)) {
				$sql = "UPDATE atendimento SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";	
				self::$db->insertSQL($sql);
				$sql = "UPDATE atendimento_espera SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE atendimento_extra SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE convenio SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_arquivo SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_aso SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_aso_exames SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_aso_riscos SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_atendimento SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_convenio SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_documentos SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_financeiro SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_orcamento SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_procedimento SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_prontuario SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_recibo SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE paciente_retorno SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE receita SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$sql = "UPDATE sms SET id_paciente = $id_paciente WHERE id_paciente = $id_novo_paciente;";
				self::$db->insertSQL($sql);
				$data = array(
					'cpf' => "NULL",
					'observacao' => "PACIENTE UNIDO COM O ID: $id_paciente ",
					'inativo' => 1,
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update("paciente", $data, "id=".$id_novo_paciente);
				$message = lang('PACIENTE_AlTERADO_OK');
				
				if (self::$db->affected()) {		
				  Filter::msgOk($message, "index.php?do=paciente&acao=editar&id=".$id_paciente); 
				} else
					Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::getPacientesMedico()
	   *
       * @return
       */
	  public function getPacientesMedico($id_medico)
      {
		 $sql = "SELECT a.id_paciente, p.id, p.nome, p.data_nasc " 
		  . "\n FROM atendimento AS a"
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente"
		  . "\n WHERE p.inativo = 0 AND a.id_medico = '$id_medico'"
		  . "\n GROUP BY a.id_paciente "
		  . "\n ORDER BY p.nome ";
          $row = ($id_medico) ? self::$db->fetch_all($sql) : null;

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Paciente::getTotalCredito()
	   *
       * @return
       */
	  public function getTotalCredito($id_paciente = 0)
      {
          $sql = "SELECT SUM(f.valor_pago) AS total " 
		  . "\n FROM paciente_financeiro AS f "
		  . "\n WHERE f.inativo = 0 AND f.pago > 2 AND f.id_paciente = $id_paciente ";
          $row = self::$db->first($sql);

          return ($row and $row->total) ? $row->total : 0;
      }
	  
	  /**
       * Paciente::getPacienteCredito()
	   *
       * @return
       */
	  public function getPacienteCredito($id_paciente)
      {
          $sql = "SELECT f.id, t.tipo, f.valor, f.valor_pago, f.data_vencimento, f.data_pagamento, f.total_parcelas, f.usuario, f.pago" 
		  . "\n FROM paciente_financeiro AS f "
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = f.tipo"
		  . "\n WHERE f.inativo = 0 AND f.pago > 2 AND f.id_paciente = $id_paciente "
		  . "\n ORDER BY f.data_pagamento DESC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarPacienteCredito()
       * PAGO = 3 : CREDITO
       * PAGO = 4 : DEBITO
       * 
       * @return
       */
      public function processarPacienteCredito()
      {	
		  $total_parcelas = (is_numeric(post('total_parcelas')) and post('total_parcelas') > 0) ? post('total_parcelas') : 1;
		  
		  $valor_pago = converteMoeda(post('valor_pago'));
		  
		  if (empty($_POST['valor_pago']))
              Filter::$msgs['valor_pago'] = lang('MSG_ERRO_VALOR');
		  
		  if (empty($_POST['tipo_pagamento'])) {
              Filter::$msgs['tipo_pagamento'] = lang('MSG_ERRO_TIPO');			  
		  } else {
			  $num_parcelas = getValue("parcelas","tipo_pagamento","id = ".post('tipo_pagamento'));
			  if($total_parcelas > $num_parcelas)
				  Filter::$msgs['total_parcelas'] = lang('MSG_ERRO_PARCELAS');
		  }		  

          if (empty(Filter::$msgs)) {
			  
			  $id_paciente = post('id_paciente');
			  $data_vencimento = (empty($_POST['data_vencimento'])) ? date('Y-m-d') : dataMySQL($_POST['data_vencimento']);
              $tipo = post('tipo_pagamento');
			  $observacao = (empty($_POST['observacao'])) ? 'CREDITO PARA O PACIENTE' : sanitize(post('observacao'));
              $id_pagamento = 0;
			  
			  $data = array(
				'id_empresa' => session('idempresa'),
				'id_paciente' => $id_paciente,
                'tipo' => $tipo, 
				'valor' => $valor_pago,
				'valor_pago' => $valor_pago,
                'id_banco' => post('id_banco'), 
                'numero_cartao' => post('numero_cartao'), 
                'total_parcelas' => $total_parcelas, 
                'nome_cheque' => post('nome_cheque'), 
                'banco_cheque' => post('banco_cheque'), 
                'agencia_cheque' => post('agencia_cheque'), 
                'numero_cheque' => post('numero_cheque'),
				'observacao' => $observacao,
                'data_caixa' => "NOW()",
				'data_vencimento' => $data_vencimento,
				'data_pagamento' => "NOW()",
				'pago' => 3,
				'usuario_caixa' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );
			  $id_pagamento = self::$db->insert("paciente_financeiro", $data);
			  	
			  $row_cartoes = Core::getRowById("tipo_pagamento", $tipo);
			  $descricao = $row_cartoes->tipo;
			  $dias = $row_cartoes->dias;
			  $taxa = $row_cartoes->taxa;
			  $pago_receita = $row_cartoes->pago;
			  $prazo = $row_cartoes->prazo;
			  			
			  $valor_parcela = round($valor_pago/$total_parcelas, 2);
			  $valor_parcela_pago = $valor_parcela;	
			  $diferenca = $valor_pago - ($valor_parcela*$total_parcelas);
			  
			  if($taxa > 0) {
				$valor_taxa = $valor_parcela*$taxa/100;
				$valor_parcela_pago = $valor_parcela - $valor_taxa;
			  }
			  
			  $data_parcela = explode('-', $data_vencimento);
			  for($i=0;$i<$total_parcelas;$i++)
			  {
				  $fator = $i+$prazo;
				  if($dias == 30) {
					$newData = novadata($data_parcela[1] + $fator, $data_parcela[2], $data_parcela[0]);	
				  } else {
					$newData = novadata($data_parcela[1], $data_parcela[2] + ($fator*$dias), $data_parcela[0]);	
				  }	
				  $parc = ($i+1);
				  $p = $parc."/".$total_parcelas;		
					
				  $data_receita = array(
					'id_empresa' => session('idempresa'), 
					'id_conta' => 19, 
					'id_banco' => post('id_banco'), 
					'id_paciente' => $id_paciente, 
					'id_pagamento' => $id_pagamento, 
					'descricao' => $descricao." - PARCELA [$p]",
					'tipo' => $tipo, 
					'data_vencimento' => $newData,
					'data_caixa' => "NOW()",
					'pago' => $pago_receita,
					'parcela' => $parc,
					'total_parcelas' => $total_parcelas, 
					'usuario_caixa' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				  );
				  if($pago_receita) {
					$data_receita['data_pagamento'] = $newData;
				  }
				  if($i == 0) {
					$data_receita['valor'] = $valor_parcela + $diferenca;
					$data_receita['valor_pago'] = $valor_parcela_pago + $diferenca;
				  } else {
					$data_receita['valor'] = $valor_parcela;
					$data_receita['valor_pago'] = $valor_parcela_pago;
				  }
				  self::$db->insert("receita", $data_receita);
			  }
			
			if (self::$db->affected()) {				  
				$message = lang('PACIENTE_PAGAMENTO_OK');
				Filter::msgReload($message);
			  } else Filter::msgAlert(lang('NAOPROCESSADO'));
              
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Paciente::processarPagamentoSelecionados()
       * @param 
       * @return
       */
	  public function processarPagamentoSelecionados()
      {
		  $valor_total = converteMoeda(post('valor_total'));
		  $valor_desconto = converteMoeda(post('valor_desconto'));
		  $valor_pagar = $valor_total-$valor_desconto;
		  $percentual = 1-($valor_desconto/$valor_total);
		  
		  $data_vencimento = (empty($_POST['data_vencimento'])) ? date('Y-m-d') : dataMySQL(post('data_vencimento'));
		  $tipo = post('tipo_pagamento');		  
		  $pago_receita = getValue('pago', 'tipo_pagamento', 'id='.$tipo);
		  $taxa = getValue('taxa', 'tipo_pagamento', 'id='.$tipo);
		  $total_parcelas = (is_numeric(post('total_parcelas')) and post('total_parcelas') > 0) ? post('total_parcelas') : 1;
		  $num_parcelas = getValue('parcelas', 'tipo_pagamento', 'id='.$tipo);
		  
		  $lista = post('lista');
		  $lista = substr($lista,0, -1);
		  $sql = "SELECT a.*, u.nome as medico, u.producao, t.procedimento, t.valor, t.guia as guia_procedimento, t.valor_cartao, t.valor_repasse AS tabela_repasse, t.percentual_repasse " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.pago = 0 AND a.realizado < 9 AND a.data_agenda <> '0000-00-00 00:00:00' AND a.id in ($lista) "
		  . "\n ORDER BY a.data_agenda DESC ";
          $retorno_row = self::$db->fetch_all($sql);
		  if($retorno_row) {	
			foreach ($retorno_row as $row) {				
				$id_atendimento = $row->id;
				$id_empresa = $row->id_empresa;
				$id_tabela = $row->id_tabela;
				$id_paciente = $row->id_paciente;
				$id_medico = $row->id_medico;
				$id_convenio = $row->id_convenio;
				$descricao = $row->procedimento;
				$valor_tabela = $row->valor;
				$producao = $row->producao;
				
				if($id_convenio > 0) {
					$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$id_tabela.' AND id_cadastro='.$id_convenio);
					$valor_tabela = ($valor_convenio > 0) ? $valor_convenio : $valor_tabela;
				}				
				$valor_atendimento = $valor_tabela*$percentual;
				$valor_atendimento_desconto = $valor_tabela-$valor_atendimento;
				// echo "valor_total[$valor_total]<br/>";
				// echo "valor_desconto[$valor_desconto]<br/>";
				// echo "valor_pagar[$valor_pagar]<br/>";
				// echo "valor_tabela[$valor_tabela]<br/>";
				// echo "producao[$producao]<br/>";
				// echo "percentual[$percentual]<br/>";
				// echo "valor_atendimento[$valor_atendimento]<br/>";
				// echo "valor_atendimento_desconto[$valor_atendimento_desconto]<br/>";
				
				//VALOR DO REPASSE SEM DESCONTO
				$repasse = $this->getValorRepasse($id_tabela, $id_medico, $id_convenio);
				$valor_repasse = 0;
				if($producao == 2) {
					$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
					$percentual_repasse = ($percentual_repasse) ? $percentual_repasse : $row->percentual_repasse;
					$valor_repasse = $valor_tabela*$percentual_repasse/100;
				} elseif($producao == 1) {
					$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
					$valor_repasse = ($valor_repasse) ? $valor_repasse : $row->valor_repasse;
				}
				$id_pagamento = 0;
				$data = array(
					'id_empresa' => $id_empresa,
					'id_paciente' => $id_paciente,
					'id_atendimento' => $id_atendimento,
					'id_tabela' => $id_tabela,
					'tipo' => $tipo, 
					'valor' => $valor_tabela,
					'valor_desconto' => $valor_atendimento_desconto,
					'valor_pago' => $valor_atendimento,
					'id_banco' => post('id_banco'), 
					'numero_cartao' => post('numero_cartao'), 
					'total_parcelas' => $total_parcelas, 
					'nome_cheque' => post('nome_cheque'), 
					'banco_cheque' => post('banco_cheque'), 
					'agencia_cheque' => post('agencia_cheque'), 
					'numero_cheque' => post('numero_cheque'),
					'observacao' => sanitize(post('observacao')),
					'data_caixa' => "NOW()",
					'data_vencimento' => $data_vencimento,
					'data_pagamento' => "NOW()",
					'pago' => 1,
					'usuario_caixa' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				$id_pagamento = self::$db->insert("paciente_financeiro", $data);
				$data_atendimento = array(
					'id_pagamento' => $id_pagamento,
					'valor_tabela' => $valor_tabela,
					'valor_repasse' => $valor_repasse,
					'valor_pago' => $valor_atendimento,
					'pago' => 1,
					'data_pagamento' => "NOW()",
					'usuario_pagamento' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update("atendimento", $data_atendimento, "id=".$id_atendimento);
				
			  $row_cartoes = Core::getRowById("tipo_pagamento", $tipo);
			  $descricao = $row_cartoes->tipo;
			  $dias = $row_cartoes->dias;
			  $taxa = $row_cartoes->taxa;
			  $pago_receita = $row_cartoes->pago;
			  $prazo = $row_cartoes->prazo;
			  			
			  $valor_parcela = round($valor_atendimento/$total_parcelas, 2);
			  $valor_parcela_pago = $valor_parcela;	
			  $diferenca = $valor_atendimento - ($valor_parcela*$total_parcelas);
			  
			  if($taxa > 0) {
				$valor_taxa = $valor_parcela*$taxa/100;
				$valor_parcela_pago = $valor_parcela - $valor_taxa;
			  }
			  
			  $data_parcela = explode('-', $data_vencimento);
			  for($i=0;$i<$total_parcelas;$i++)
			  {
				  $fator = $i+$prazo;
				  if($dias == 30) {
					$newData = novadata($data_parcela[1] + $fator, $data_parcela[2], $data_parcela[0]);	
				  } else {
					$newData = novadata($data_parcela[1], $data_parcela[2] + ($fator*$dias), $data_parcela[0]);	
				  }	
				  $parc = ($i+1);
				  $p = $parc."/".$total_parcelas;		
					
				  $data_receita = array(
					'id_empresa' => session('idempresa'), 
					'id_conta' => 19, 
					'id_banco' => post('id_banco'), 
					'id_paciente' => $id_paciente, 
					'id_pagamento' => $id_pagamento, 
					'id_atendimento' => $id_atendimento, 
					'descricao' => $descricao." - PARCELA [$p]",
					'tipo' => $tipo, 
					'data_vencimento' => $newData,
					'data_caixa' => "NOW()",
					'pago' => $pago_receita,
					'parcela' => $parc,
					'total_parcelas' => $total_parcelas, 
					'usuario_caixa' => session('nomeusuario'),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				  );
				  if($pago_receita) {
					$data_receita['data_pagamento'] = $newData;
				  }
				  if($i == 0) {
					$data_receita['valor'] = $valor_parcela + $diferenca;
					$data_receita['valor_pago'] = $valor_parcela_pago + $diferenca;
				  } else {
					$data_receita['valor'] = $valor_parcela;
					$data_receita['valor_pago'] = $valor_parcela_pago;
				  }
				  self::$db->insert("receita", $data_receita);
			  }
			}
			$message = lang('PACIENTE_PAGAMENTO_OK');
			Filter::msgReload($message);
		  } else Filter::msgAlert(lang('NAOPROCESSADO'));
      }
	  
	  /**
       * Paciente::processarCancelarSelecionados()
       * @param 
       * @return
       */
	  public function processarCancelarSelecionados()
      {
		  $lista = post('lista');
		  $id_cancelamento = post('id_cancelamento');
		  $observacao = (empty($_POST['observacao'])) ? "CANCELAMENTO" : sanitize(post('observacao'));
		  $lista = substr($lista,0, -1);
		  $sql = "SELECT a.*, u.nome as medico, u.producao " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_medico "
		  . "\n WHERE a.pago = 0 AND a.realizado <> 1 AND a.realizado < 9 AND a.data_agenda <> '0000-00-00 00:00:00' AND a.id in ($lista) "
		  . "\n ORDER BY a.data_agenda DESC ";
          $retorno_row = self::$db->fetch_all($sql);
		  if($retorno_row) {	
			foreach ($retorno_row as $row) {				
				$id_atendimento = $row->id;
				$data = array(
					'id_lote' => 0,
					'observacao' => $observacao,
					'id_cancelamento' => $id_cancelamento,
					'realizado' => '9',
					'data_cancelamento' => "NOW()",
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
				);
				self::$db->update("atendimento", $data, "id=" . $id_atendimento);
			}
			$message = lang('AGENDA_CANCELAR_OK');
			Filter::msgReload($message);
		  } else Filter::msgAlert(lang('NAOPROCESSADO'));
      }
	  
	  /**
       * Paciente::getRecibos()
	   *
       * @return
       */
	  public function getRecibos($id_paciente)
      {
          $sql = "SELECT r.*, t.tipo AS pagamento, p.nome AS paciente, u.nome AS medico " 
		  . "\n FROM paciente_recibo as r "
		  . "\n LEFT JOIN paciente as p ON p.id = r.id_paciente"
		  . "\n LEFT JOIN usuario as u ON u.id = r.id_medico"
		  . "\n LEFT JOIN tipo_pagamento as t ON t.id = r.tipo"
		  . "\n WHERE r.inativo = 0 AND r.id_paciente = $id_paciente "
		  . "\n ORDER BY r.data_pagamento DESC ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Paciente::processarRecibo()
       * 
       * @return
       */
      public function processarRecibo()
      {
		  if (empty($_POST['id_medico']))
              Filter::$msgs['id_medico'] = lang('MSG_ERRO_MEDICO');
		  
          if (empty(Filter::$msgs)) {
			  
			  $id_empresa = session('idempresa');
			  $id_paciente = post('id_paciente');
			  $id_medico = post('id_medico');
			  $valor = converteMoeda(post('valor'));
			  $data_pagamento = (empty($_POST['data_pagamento'])) ? date('Y-m-d') : dataMySQL($_POST['data_pagamento']);
			  $data = array(
				'id_empresa' => $id_empresa,
				'id_paciente' => $id_paciente,
				'id_medico' => $id_medico,
				'descricao' => sanitize(post('descricao')),
				'tipo' => sanitize(post('tipo')),
				'valor' => $valor,
				'data_pagamento' => $data_pagamento,
				'usuario_pagamento' => session('nomeusuario'),
				'usuario' => session('nomeusuario'),
				'data' => "NOW()"
			  );

              (Filter::$id) ? self::$db->update("paciente_recibo", $data, "id=" . Filter::$id) : self::$db->insert("paciente_recibo", $data);
              
			  $message = (Filter::$id) ? lang('RECIBO_ALTERADO_OK') : lang('RECIBO_ADICIONADO_OK');

              if (self::$db->affected()) {		
				  Filter::msgReload($message); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
  }
?>