<?php
  /**
   * Classe Tabela
   *
   * @package Sistemas Divulgao Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe no  permitido.');

  class Tabela
  {
      const uTable = "tabela";
      private static $db;

      /**
       * Tabela::__construct()
       * 
       * @return
       */
      function __construct()
      {
          self::$db = Registry::get("Database");
      }
	  
	  /**
       * Tabela::getTabela()
	   *
       * @return
       */
	  public function getTabela($id_especialidade = false)
      {
		  $where = ($id_especialidade) ? " AND t.id_especialidade = $id_especialidade " : "";
          $sql = "SELECT t.*, e.nome as especialidade, c.nome as laboratorio " 
		  . "\n FROM tabela as t"
		  . "\n LEFT JOIN cadastro as c ON c.id = t.id_laboratorio"
		  . "\n LEFT JOIN especialidade as e ON e.id = t.id_especialidade"
		  . "\n WHERE t.inativo = 0 $where "
		  . "\n ORDER BY t.procedimento";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Tabela::getTabela()
	   *
       * @return
       */
	  public function getTabelaUsuario($id_usuario)
      {
          $sql = "SELECT t.*, e.nome as especialidade, c.nome as laboratorio " 
		  . "\n FROM tabela as t"
		  . "\n LEFT JOIN cadastro as c ON c.id = t.id_laboratorio"
		  . "\n LEFT JOIN especialidade as e ON e.id = t.id_especialidade"
		  . "\n LEFT JOIN usuario as u ON u.id = '$id_usuario' "
		  . "\n WHERE t.inativo = 0 AND ((u.id_especialidade = t.id_especialidade OR u.id_especialidade2 = t.id_especialidade OR u.id_especialidade3 = t.id_especialidade OR u.id_especialidade4 = t.id_especialidade OR u.id_especialidade5 = t.id_especialidade) OR e.medico = 1) "
		  . "\n ORDER BY t.procedimento";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Tabela::getTabelaMedico()
	   *
       * @return
       */
	  public function getTabelaMedico($id_medico, $id_especialidade = false)
      {
		  $where = ($id_especialidade) ? " AND t.id_especialidade = $id_especialidade " : "";
          $sql = "SELECT DISTINCT t.id, t.procedimento, t.codigo " 
		  . "\n FROM tabela as t"
		  . "\n LEFT JOIN cadastro as c ON c.id = t.id_laboratorio"
		  . "\n LEFT JOIN especialidade as e ON e.id = t.id_especialidade"
		  . "\n LEFT JOIN usuario as u ON u.id = '$id_medico' "
		  . "\n LEFT JOIN usuario_producao as p ON p.id_usuario = u.id"
		  . "\n WHERE t.inativo = 0 AND ( ( p.id_tabela = 0 AND (e.medico = 1 OR u.id_especialidade = t.id_especialidade OR u.id_especialidade2 = t.id_especialidade OR u.id_especialidade3 = t.id_especialidade OR u.id_especialidade4 = t.id_especialidade OR u.id_especialidade5 = t.id_especialidade) OR e.medico = 1 ) OR t.id = p.id_tabela) "
		  . "\n ORDER BY t.procedimento";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }

	  /**
       * Tabela::getListaTabela()
	   *
       * @return
       */
	  public function getListaTabela($procedimento = '')
      {
          $sql = "SELECT id, codigo, procedimento, retorno " 
		  . "\n FROM tabela as t"
		  . "\n WHERE t.inativo = 0 AND (t.procedimento LIKE '%$procedimento%' OR t.codigo LIKE '%$procedimento%')" 
		  . "\n ORDER BY t.procedimento ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Tabela::getTabelaTUSS()
	   *
       * @return
       */
	  public function getTabelaTUSS()
      {
          $sql = "SELECT t.id, t.codigo, t.procedimento, e.nome as especialidade " 
		  . "\n FROM tabela_tuss as t"
		  . "\n LEFT JOIN especialidade as e ON e.id = t.id_especialidade"
		  . "\n WHERE t.inativo = 0 "
		  . "\n ORDER BY t.codigo";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Tabela::getTabelaConvenios()
	   *
       * @return
       */
	  public function getTabelaConvenios($id_cadastro = false, $id_especialidade = false)
      {
		  $wespecialidade = ($id_especialidade) ? " AND t.id_especialidade = $id_especialidade " : "";
		  $wcadastro = ($id_cadastro) ? " AND c.id_cadastro = $id_cadastro " : "";
          $sql = "SELECT c.*, e.nome as especialidade, t.procedimento, t.codigo, t.valor, t.valor_cartao, t.valor_repasse, t.percentual_repasse, t.retorno, ca.nome AS convenio " 
		  . "\n FROM tabela_convenio as c"
		  . "\n LEFT JOIN tabela as t ON t.id = c.id_tabela"
		  . "\n LEFT JOIN cadastro as ca ON ca.id = c.id_cadastro"
		  . "\n LEFT JOIN especialidade as e ON e.id = c.id_especialidade"
		  . "\n WHERE t.inativo = 0 "
		  . "\n $wcadastro "
		  . "\n $wespecialidade "
		  . "\n ORDER BY t.procedimento, e.nome ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Tabela::getTabelaConvenios()
	   *
       * @return
       */
	  public function getTabelaTodosConvenios($id_cadastro = false, $id_especialidade = false)
      {
		  $wespecialidade = ($id_especialidade) ? " AND t.id_especialidade = $id_especialidade " : "";
		  $wcadastro = ($id_cadastro) ? " AND c.id_cadastro = $id_cadastro " : "";
		  $where = ($id_especialidade) ? " AND t.id_especialidade = $id_especialidade " : "";
          $sql = "SELECT c.*, e.nome as especialidade, t.codigo, t.procedimento, t.valor, t.valor_cartao, t.retorno " 
		  . "\n FROM tabela as t"
		  . "\n LEFT JOIN tabela_convenio as c ON t.id = c.id_tabela"
		  . "\n LEFT JOIN especialidade as e ON e.id = t.id_especialidade"
		  . "\n WHERE t.inativo = 0 "
		  . "\n $wcadastro "
		  . "\n $wespecialidade "
		  . "\n ORDER BY t.procedimento, e.nome ";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Tabela::processarTabela()
       * 
       * @return
       */
      public function processarTabela()
      {
		  $codigo = '';
		  if (!empty($_POST['codigo'])) {
			  $codigo = trim(post('codigo'));
			  $where = (Filter::$id) ? "AND id <> ".Filter::$id : "";
			  $sql = "SELECT procedimento FROM tabela WHERE codigo = '$codigo' $where ";
			  $row = self::$db->first($sql);
			  if ($row)
				  Filter::$msgs['codigo'] = str_replace("[PROCEDIMENTO]", $row->procedimento, lang('MSG_ERRO_PROCEDIMENTO_CADASTRADO'));
		  }
		  
		  if (empty($_POST['procedimento']))
              Filter::$msgs['procedimento'] = lang('MSG_ERRO_PROCEDIMENTO');	

          if (empty(Filter::$msgs)) {

              $data = array(
					'id_especialidade' => sanitize(post('id_especialidade')),
					'procedimento' => sanitize(post('procedimento')),
					'codigo' => $codigo,
					'valor' => converteMoeda(post('valor')),
					'valor_cartao' => converteMoeda(post('valor_cartao')),
					'id_laboratorio' => sanitize(post('id_laboratorio')),
					'valor_proc_lab' => converteMoeda(post('valor_proc_lab')),
					'valor_pago_lab' => converteMoeda(post('valor_pago_lab')),
					'valor_repasse' => converteMoeda(post('valor_repasse')),
					'percentual_repasse' => converteMoeda(post('percentual_repasse')),
					'retorno' => sanitize(post('retorno')),
					'guia' => sanitize(post('guia')),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );
			  if(Filter::$id) {
				  self::$db->update(self::uTable, $data, "id=" . Filter::$id);
			  } else {
				  Filter::$id = self::$db->insert(self::uTable, $data);
			  }		  
              $message = (Filter::$id) ? lang('TABELA_AlTERADO_OK') : lang('TABELA_ADICIONADO_OK');

              if (self::$db->affected()) {
			  
                  Filter::msgOk($message, "index.php?do=tabela&acao=listar"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
      /**
       * Tabela::processarTUSS()
       * 
       * @return
       */
      public function processarTUSS()
      {
		  if (empty($_POST['procedimento']))
              Filter::$msgs['procedimento'] = lang('MSG_ERRO_DESCRICAO');	

          if (empty(Filter::$msgs)) {

              $data = array(
					'codigo' => sanitize(post('codigo')),
					'procedimento' => sanitize(post('procedimento')),
					'id_especialidade' => sanitize(post('id_especialidade')),
					'usuario' => session('nomeusuario'),
					'data' => "NOW()"
			  );

              (Filter::$id) ? self::$db->update("tabela_tuss", $data, "id=" . Filter::$id) : self::$db->insert("tabela_tuss", $data);
              $message = (Filter::$id) ? lang('TABELA_AlTERADO_OK') : lang('TABELA_ADICIONADO_OK');

              if (self::$db->affected()) {
			  
                  Filter::msgOk($message, "index.php?do=tabela&acao=tuss"); 
              } else
                  Filter::msgAlert(lang('NAOPROCESSADO'));
          } else
              print Filter::msgStatus();
      }
	  
	  /**
       * Tabela::getCadastrosConvenio()
       * contrato: 1 - EXIGE CONTRATO
       * convenio: 1 - CONVENIO A PAGAR
       * convenio: 2 - CONVENIO A RECEBER
       * convenio: 3 - LABORATORIO
	   *
       * @return
       */
	  public function getCadastrosConvenio($convenio)
      {
          $sql = "SELECT c.id, c.nome, c.contrato " 
		  . "\n FROM cadastro as c"
		  . "\n WHERE c.inativo = 0 AND c.convenio in ($convenio)  "
		  . "\n ORDER BY c.nome";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
	  /**
       * Tabela::getCadastrosContrato()
       * contrato: 1 - EXIGE CONTRATO
       * convenio: 1 - CONVENIO A PAGAR
       * convenio: 2 - CONVENIO A RECEBER
       * convenio: 3 - LABORATORIO
	   *
       * @return
       */
	  public function getCadastrosContrato()
      {
          $sql = "SELECT c.id, c.nome " 
		  . "\n FROM cadastro as c"
		  . "\n WHERE c.inativo = 0 AND c.contrato = 1 "
		  . "\n ORDER BY c.nome";
          $row = self::$db->fetch_all($sql);

          return ($row) ? $row : 0;
      }
	  
      /**
       * Tabela::buscarProcedimentos()
       * 
       * @return
       */
      public function buscarProcedimentos()
      {
		$id_cadastro = post('id_cadastro');
		$wtabela = (empty($_POST['id_tabela'])) ? "" : " AND id = ".post('id_tabela');	
		$wespecialidade = (empty($_POST['id_especialidade'])) ? "" : " AND id_especialidade = ".post('id_especialidade');
		$nomeusuario = session('nomeusuario');
		$sql = "INSERT IGNORE INTO tabela_convenio SELECT 0, id, id_especialidade, $id_cadastro, valor, '$nomeusuario', NOW() FROM tabela WHERE inativo = 0 $wtabela $wespecialidade;";
		self::$db->query($sql);
        if (self::$db->affected())
		{
			print Filter::msgOk(lang('TABELA_CONVENIOS_ADICIONADO_OK'), "index.php?do=tabela&acao=tabela_convenio&id=".$id_cadastro);
		} else {
			print Filter::msgAlert(lang('TABELA_CONVENIOS_PROCEDIMENTOS_NAO_REGISTROS'));
		}
      }
  }
?>