<?php
  /**
   * Funcoes
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
   
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');
  
	/**
       * indicador()
       * 
       * @param $condicao
       * @return
       */
      function indicador($condicao)
      {
          return ($condicao) ? "<i class='fa fa-thumbs-up indicador font-green'></i>" : "<i class='fa fa-thumbs-down indicador font-red'></i>";
      }
	/**
       * nocaixa()
       * 
       * @param $nocaixa
       * @return
       */
      function nocaixa($banco)
      {
          return ($banco) ? $banco : "-";
      }
	/**
       * pagamento()
       * 
       * @param $pagamento
       * @return
       */
      function pagamento($tipo)
      {
          return ($tipo) ? $tipo : "CREDIARIO";
      }
	  
   /**
   * percentual()
   * 
   * @param $parte, $total
   * @return
   */
  function percentual($parte, $total)
  {
    return ($parte/$total);
  }
  
  /**
   * percentual()
   * 
   * @param $parte, $total
   * @return
   */
  function fpercentual($parte, $total)
  {
    if($total > 0 )
		return number_format(($parte/$total*100), 2, ',', '.')." %";
	else 
		return "0%";
  }
  
  /**
   * margem()
   * 
   * @param $parte, $total
   * @return
   */
  function margem($receita, $despesa)
  {
    if($receita > 0 )
		return number_format((($receita-$despesa)/$receita*100), 2, ',', '.')." %";
	else 
		return "0%";
  }
  
  /**
   * porcentagem()
   * 
   * @param $parte, $total
   * @return
   */
  function porcentagem($percentual)
  {
    return number_format(($percentual*100), 2, ',', '.')." %";
  }
  
  /**
       * percent()
       * 
       * @param $amount
       * @return
       */
      function percent($percentual)
      {
          return number_format($percentual, 2, ',', '.')." %";
      }
  
  /**
       * moeda()
       * 
       * @param $amount
       * @return
       */
      function moeda($amount)
      {
          return "R$ " . number_format($amount, 2, ',', '.');
      }
  
  /**
       * nodecimal()
       * 
       * @param $amount
       * @return
       */
      function nodecimal($amount)
      {
          return number_format($amount, 0, ',', '.');
      }
  
  /**
       * decimal()
       * 
       * @param $amount
       * @return
       */
      function decimal($amount)
      {
          return number_format($amount, 2, ',', '.');
      }
  
  /**
       * moedap()
       * 
       * @param $amount
       * @return
       */
      function moedap($amount)
      {
          return "R$ " . number_format($amount, 3, ',', '.');
      }
  
  /**
       * decimalp()
       * 
       * @param $amount
       * @return
       */
      function decimalp($amount)
      {
          return number_format($amount, 3, ',', '.');
      }
  
	  /**
       * capitalize()
       * 
       * @param $texto
       * @return
       */
      function capitalize($texto)
      {
          return ucwords(strtolower($texto));
      }
  
  /**
       * horas()
       * 
       * @param $amount
       * @return
       */
      function horas($amount)
      {
          return number_format($amount, 0, ',', '.');
      }

   /**
   * converteMoeda()
   * 
   * @param $moeda
   * @return
   */
  function converteMoeda($moeda = '')
  {
	  if (substr_count($moeda, "R$"))
	  {
		  $moeda = str_replace("R$","",$moeda);
		  $moeda = str_replace(".","",$moeda);
		  $moeda = str_replace(",",".",$moeda);
	  } elseif (substr_count($moeda, "$")) {
		  $moeda = str_replace("$","",$moeda);
		  $moeda = str_replace(",","",$moeda);
	  } else {
		  $moeda = str_replace(".","",$moeda);
		  $moeda = str_replace(",",".",$moeda);
	  }
	  $moeda = str_replace(" ","",$moeda);
      return $moeda;
  } 

	/**
   * telefoneSMS9()
   * 
   * Função para incluir o 9 no numero de telefone
   * @param mixed $tel
   * @return
   */
  function telefoneSMS9($tel)
  {
      $tel = str_replace("(","",$tel);
      $tel = str_replace(")","",$tel);
      $tel = str_replace("-","",$tel);
      $tel = str_replace(" ","",$tel);
	  if(strlen($tel) == 10) {
		  $ddd = substr($tel, 0,2);
		  $telefone = substr($tel, 2);
		  $tel = $ddd."9".$telefone;
	  } elseif(strlen($tel) == 9) {
		  $tel = "31".$tel;
	  } elseif(strlen($tel) == 12) {
		  $tel = substr($tel, -1);
	  }
	  $tel = "55".$tel;
      return (strlen($tel) == 13) ? $tel : 0;
  }

	/**
   * telefoneSMS()
   * 
   * Função para retirar o 9 no numero de telefone
   * @param mixed $tel
   * @return
   */
  function telefoneSMS($tel)
  {
      $tel = str_replace("(","",$tel);
      $tel = str_replace(")","",$tel);
      $tel = str_replace("-","",$tel);
      $tel = str_replace(" ","",$tel);
      $primeiro = substr($tel, 0,1);
	  if($primeiro == "0") {
		  if(strlen($tel) == 12) {//(031)99769-9900
			  $tel = substr($tel, -1);
			  $ddd = substr($tel, 0,2);
			  $telefone = substr($tel, 2);
			  $telefone = substr($telefone, 1);
			  $tel = $ddd.$telefone;
		  } elseif(strlen($tel) == 11) {//(031)9769-9900
			  $tel = substr($tel, -1);
		  }
	  } elseif(strlen($tel) == 10) { //(31)9769-9900
		  $ddd = substr($tel, 0,2);
		  $telefone = substr($tel, 2);
		  $tel = $ddd."9".$telefone;
	  } elseif(strlen($tel) == 9) {//99769-9900
		  $tel = substr($tel, -1);
		  $tel = "31".$tel;
	  } elseif(strlen($tel) == 11) {//(31)99769-9900
		  $ddd = substr($tel, 0,2);
		  $telefone = substr($tel, 2);
		  $telefone = substr($telefone, 1);
		  $tel = $ddd.$telefone;
	  }
	  $tel = "55".$tel;
      return (strlen($tel) == 12) ? $tel : 0;
  }

	/**
   * limpar()
   * 
   * @param mixed $tel
   * @return
   */
  function limpar($tel)
  {
      $tel = str_replace("(","",$tel);
      $tel = str_replace(")","",$tel);
      $tel = str_replace("-","",$tel);
      $tel = str_replace(" ","",$tel);
      $tel = str_replace(".","",$tel);
      return $tel;
  }  

	/**
   * dataAgendaSMS()
   * 
   * @param mixed $data
   * @return
   */
  function dataAgendaSMS($data)
  {
	  $retorno = "";
	  date_default_timezone_set('America/Argentina/Buenos_Aires');
	  $data_hoje = date('Y-m-d H:i:s');
	  $hoje = new DateTime( $data_hoje );
	  $data_agenda = new DateTime( $data );
	  $intervalo = $hoje->diff( $data_agenda );
	  if($intervalo->invert){
		  $retorno = "ERRO";
	  } else {
		  $dias = $intervalo->days;
		  if($dias > 1) {
			  $dias = $dias - 1;
			  $horas = $intervalo->h;
			  $minutos = $intervalo->i;
			  $segundos = $intervalo->s;
			  $retorno = "&dataagenda=".$dias."d".$horas."h".$minutos."m".$segundos."s";
		  }
	  }
	  return $retorno;	  
  }  

	/**
   * limpardata()
   * 
   * @param $data
   * @return
   */
  function limpardata($data)
  {
      return str_replace("-","",$data);
  }  
  
  /**
   * diasemana()
   * 
   * @param $data no formata Mysql (DD/MM/YYYY) para true
   * @param $data no formata Mysql (YYYY-MM-DD) para false
   * @return
   */
  function diasemana($data, $format = false, $numero = false, $feira = true) {
	$data = substr($data,0,10);
	if ($format) {
		$d = explode("/", $data);
		$ano =  $d[2];
		$mes =  $d[1];
		$dia =  $d[0];
	} else {
		$d = explode("-", $data);
		$ano =  $d[0];
		$mes =  $d[1];
		$dia =  $d[2];
	}
	$diasemana = date("w", mktime(0,0,0,$mes,$dia,$ano));
	
	if($numero) {
		return $diasemana;
	}

	switch($diasemana) {
		case 0: $diasemana = ($feira) ? lang('DOMINGOF') :lang('DOM'); break;
		case 1: $diasemana = ($feira) ? lang('SEGUNDAF') :lang('SEG'); break;
		case 2: $diasemana = ($feira) ? lang('TERCAF')   :lang('TER')  ; break;
		case 3: $diasemana = ($feira) ? lang('QUARTAF')  :lang('QUA') ; break;
		case 4: $diasemana = ($feira) ? lang('QUINTAF')  :lang('QUI') ; break;
		case 5: $diasemana = ($feira) ? lang('SEXTAF')   :lang('SEX')  ; break;
		case 6: $diasemana = ($feira) ? lang('SABADOF')  :lang('SAB') ; break;
	}

	return $diasemana;
}
  
  /**
   * redirect_to()
   * 
   * @param $location
   * @return
   */
  function redirect_to($location)
  {
      if (!headers_sent()) {
          header('Location: ' . $location);
		  exit;
	  } else
          echo '<script type="text/javascript">';
          echo 'window.location.href="' . $location . '";';
          echo '</script>';
          echo '<noscript>';
          echo '<meta http-equiv="refresh" content="0;url=' . $location . '" />';
          echo '</noscript>';
  }
  
  /**
   * redirecionar()
   * 
   * @param $location
   * @return
   */
  function redirecionar($location)
  {
    echo '';
  }
  
  /**
   * fecharjanela()
   * 
   * @return
   */
  function fecharjanela()
  {
    echo '<script type="text/javascript">';
    echo 'window.opener.location.reload();';
    echo 'window.close();';
    echo '</script>';
  }
  
  /**
   * countEntries()
   * 
   * @param $table
   * @param string $where
   * @param string $what
   * @return
   */
  function countEntries($table, $where = '', $what = '')
  {
      if (!empty($where) && isset($what)) {
          $q = "SELECT COUNT(*) FROM " . $table . "  WHERE " . $where . " = '" . $what . "' LIMIT 1";
      } else
          $q = "SELECT COUNT(*) FROM " . $table . " LIMIT 1";
      
      $record = Registry::get("Database")->query($q);
      $total = Registry::get("Database")->fetchrow($record);
      return $total[0];
  }
  
  /**
   * countEntries()
   * 
   * @param $table
   * @param string $where
   * @param string $what
   * @return
   */
  function contarEntradas($table, $where1 = '')
  {
      $q = "SELECT COUNT(*) FROM " . $table . "  WHERE " . $where1 . " LIMIT 1";
      
      $record = Registry::get("Database")->query($q);
      $total = Registry::get("Database")->fetchrow($record);
      return $total[0];
  }
  
  /**
   * getChecked()
   * 
   * @param $row
   * @param $status
   * @return
   */
  function getChecked($row, $status)
  {
      if ($row == $status) {
          echo "checked=\"checked\"";
      }
  }
  
  /**
   * session()
   * 
   * @param $var
   * @return
   */
  function session($var)
  {
      if (isset($_SESSION[$var]))
          return $_SESSION[$var];
  }
  
  /**
   * post()
   * 
   * @param $var
   * @return
   */
  function post($var)
  {
      if (isset($_POST[$var]))
          return $_POST[$var];
  }
  
  /**
   * get()
   * 
   * @param $var
   * @return
   */
  function get($var)
  {
      if (isset($_GET[$var]))
          return $_GET[$var];
  }
  
  /**
   * sanitize()
   * 
   * @param $string
   * @param bool $trim
   * @return
   */
  function sanitize($string, $trim = false, $int = false, $str = false)
  {
	  $string = retira_acentos($string);
	  $string = utf8_encode($string);
      $string = filter_var($string, FILTER_SANITIZE_STRING);
      $string = trim($string);
      $string = stripslashes($string);
      $string = strip_tags($string);
      $string = str_replace(array('‘', '’', '“', '”'), array("'", "'", '"', '"'), $string);
      
	  if ($trim)
          $string = substr($string, 0, $trim);
      if ($int)
		  $string = preg_replace("/[^0-9\s]/", "", $string);
      if ($str)
		  $string = preg_replace("/[^a-zA-Z\s]/", "", $string);
		  
      return retira_acentos($string);
  }

  /**
   * cleanSanitize()
   * 
   * @param $string
   * @param bool $trim
   * @return
   */
  function cleanSanitize($string, $trim = false)
  {
      require_once('URLify.php');
	  $string = URLify::filter($string);
	  $string = strtoupper($string);
	  $string = utf8_encode($string);
      $string = filter_var($string, FILTER_SANITIZE_STRING);
      $string = trim($string);
      $string = stripslashes($string);
      $string = strip_tags($string);
      $string = str_replace(array('‘', '’', '“', '”'), array("'", "'", '"', '"'), $string);
      
	  if ($trim)
          $string = substr($string, 0, $trim);
		  
      return retira_acentos($string);
  }
  
  /**
   * getValue()
   * 
   * @param $stwhatring
   * @param $table
   * @param $where
   * @return
   */
  function getValue($what, $table, $where)
  {
      $sql = "SELECT $what FROM $table WHERE $where";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->$what : '';
  }  
  
  /**
   * tooltip()
   * 
   * @param $tip
   * @return
   */
  function tooltip($tip)
  {
      return '<img src="' . SITEURL . '/images/tip.png" alt="" class="tooltip" title="' . $tip . '" style="margin-left:5px"/>';
  }
  
  /**
   * required()
   * 
   * @return
   */
  function required()
  {
      return '<img src="' . SITEURL . '/images/required.png" alt="Required Field" class="tooltip" title="Required Field" />';
  }
  
   /**
   * somarData()
   * @param data, dias, meses e ano
   * @return a soma na data
   */
  function somarData($data, $dias = 0, $meses = 0, $ano = 0)
  {
	//A data deve estar no formato dd/mm/yyyy
	$data = explode('/', $data);
	$newData = date('d/m/Y', mktime(0, 0, 0, $data[1] + $meses, $data[0] + $dias, $data[2] + $ano) );
	return $newData;
  }
  
  /**
   * somarMinutos()
   * @param data, dias, meses e ano
   * @return a soma na data
   */
  function somarMinutos($data, $minutos)
  {
	//A data deve estar no formato d/m/Y H:i
	
	$hora = substr($data,11,16);
	$hora = explode(":", $hora);
	$data = explode('/', $data);	
	$newData = date("d/m/Y H:i", mktime($hora[0],($hora[1]+$minutos),0, $data[1], $data[0], $data[2]));
	return $newData;
  }
  
  /**
   * contarDias()
   * @param $us_data - DATA INICIAL
   * @param $us_atual - DATA FINAL
   * @return quantidade de dias
   */
  function contarDias($us_data = "-", $us_atual = "-")
  {
	  $data_dias = ($us_data <> "-") ? $us_data : date('d/m/Y');
	  $novadata = ($us_atual <> "-") ? $us_atual : date('d/m/Y');
	  $ini = explode('/', $data_dias);
	  $fim = explode('/', $novadata);
	  $data_ini = mktime(0, 0, 0, $ini[1], $ini[0], $ini[2]);
	  $data_fim = mktime(0, 0, 0, $fim[1], $fim[0], $fim[2]);
	  
	  $diferenca = $data_fim - $data_ini; // 19522800 segundos
	  $dias = (int)floor( $diferenca / (60 * 60 * 24)); // 225 dias
	  return $dias;
  } 
  
  /**
   * novadata()
   * Retorna a nova data considerando final de semana.
   * @return
   */
  function novadata($mes,$dia,$ano, $fimdesemana = false) {
	  
	  $diasemana = date("w", mktime(0,0,0,$mes,$dia,$ano) );
	  if($fimdesemana) {
		  if($diasemana == 0)
			  $dia = $dia + 1;
		  if($diasemana == 6)
			  $dia = $dia + 2;
	  }	  
	  $newData = date("Y-m-d", mktime(0,0,0,$mes,$dia,$ano));
	  
	  return $newData;
  } 
  
  /**
   * validaData()
   * @param $us_data - DATA INICIAL
   * @param $us_atual - DATA FINAL
   * @return "mes" para datas no mesmo mês
   * @return "atrasado" para data inicial no mês posterior a data final
   * @return "adiantado" para data inicial no mês anterior a data final
   */
  function validaData($data_inicial = "-", $data_final = "-")
  {
	  if(($data_inicial == "-") or ($data_final == "-")) {
		return "mes";  		  
	  }
	  $ini = explode('/', $data_inicial);
	  $fim = explode('/', $data_final);
	  $data_ini = mktime(0, 0, 0, $ini[1], 1, $ini[2]);
	  $data_fim = mktime(0, 0, 0, $fim[1], 1, $fim[2]);
	  if ($data_ini > $data_fim) {
		  return "atrasado";
	  } elseif($data_ini < $data_fim) {
		  return "adiantado";
	  } else {
		return "mes";  
	  }
  }
  
  /**
   * atrasado()
   * @param $us_data - DATA INICIAL
   * @param $us_atual - DATA FINAL
   */
  function atrasado($data_inicial = "-", $data_final = false)
  {
	  $data_final = ($data_final) ? $data_final : date('d/m/Y');
	  if($data_inicial == "-") {
		return 1;  		  
	  }
	  $ini = explode('/', $data_inicial);
	  $fim = explode('/', $data_final);
	  $data_ini = mktime(0, 0, 0, $ini[1], $ini[0], $ini[2]);
	  $data_fim = mktime(0, 0, 0, $fim[1], $fim[0], $fim[2]);
	  if ($data_ini < $data_fim) {
		  return 1;
	  } else {
		return 0;  
	  }
  }
  
  /**
   * exibedata()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function exibedata($us_data)
  {
	  $us_data = ($us_data) ? $us_data : "0000-00-00 00:00:00";
	  return (($us_data == "0000-00-00 00:00:00") or ($us_data == "0000-00-00") or $us_data == null) ? "-" : date('d/m/Y',strtotime($us_data));
  }
  
  /**
   * hoje()
   * @param $us_data
   * @return verdadeiro para o dia de hoje
   */
  function hoje($us_data)
  {
	  $us_data = ($us_data) ? $us_data : "0000-00-00 00:00:00";
	  return ( date('d/m/Y') == date('d/m/Y',strtotime($us_data)));
  }
  
  /**
   * hojebr()
   * @param $br_data
   * @return verdadeiro para o dia de hoje
   */
  function hojebr($data)
  {
	  $data = ($data) ? $data : "00-00-0000";
	  return ( date('d/m/Y') == $data);
  }
  
  /**
   * exibedataHora()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function exibedataHora($us_data)
  {
	  $us_data = ($us_data) ? $us_data : "0000-00-00 00:00:00";
	  return ($us_data == "0000-00-00 00:00:00" or $us_data == null) ? "-" : date('d/m/Y - H:i',strtotime($us_data));
  }
  
  /**
   * exibedataSegundo()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function exibedataSMS($us_data)
  {
	  $us_data = ($us_data) ? $us_data : "0000-00-00 00:00:00";
	  return ($us_data == "0000-00-00 00:00:00" or $us_data == null) ? "-" : date('d-m-Y H:i:s',strtotime($us_data));
  }
  
  /**
   * exibeHora()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function exibeHora($us_data)
  {
	  return ($us_data == "0000-00-00 00:00:00" or $us_data == null) ? "-" : date('H:i',strtotime($us_data));
  }
  
  /**
   * exibeHoraSegundo()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function exibeHoraSegundo($us_data)
  {
	  return ($us_data == "0000-00-00 00:00:00" or $us_data == null) ? "-" : date('H:i:s',strtotime($us_data));
  }
  
  /**
   * dataMySQL()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function dataMySQL($us_data)
  {
	  return (strlen($us_data) > 11) ? substr($us_data,6,4)."-".substr($us_data,3,2)."-".substr($us_data,0,2)." ".substr($us_data,13) : substr($us_data,6,4)."-".substr($us_data,3,2)."-".substr($us_data,0,2);
  }
  
  /**
   * dataMySQL()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function dataMySQL2($us_data)
  {
	  return substr($us_data,6,4)."-".substr($us_data,3,2)."-".substr($us_data,0,2);
  }
  
  /**
   * dataExtrato()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function dataExtrato($us_data)
  {
	  return substr($us_data,0,4)."-".substr($us_data,4,2)."-".substr($us_data,6,2);
  }
  
  /**
   * datavencimento()
   * @param data no formato americano $us_data
   * @return data no formato brasileiro
   */
  function datavencimento($datavencimento, $meses)
  {
	  $anos = round($meses / 12);
	  $us_data = ($datavencimento) ? $datavencimento : date("d/m/Y");
	  $ano = substr($us_data,6,4);
	  $mes = substr($us_data,3,2);
	  $dia = substr($us_data,0,2);
	  $mes = $mes + $meses;
	  if ($mes > 12)
	  {
		$mes = $mes - 12;
		$ano = $ano + 1;
	  }
	  return $ano."-".$mes."-".$dia;
  }


  /**
   * getSize()
   * 
   * @param $size
   * @param integer $precision
   * @param bool $long_name
   * @param bool $real_size
   * @return
   */
  function getSize($size, $precision = 2, $long_name = false, $real_size = true)
  {
      $base = $real_size ? 1024 : 1000;
      $pos = 0;
      while ($size > $base) {
          $size /= $base;
          $pos++;
      }
      $prefix = _getSizePrefix($pos);
      $size_name = $long_name ? $prefix . "bytes" : $prefix[0] . 'B';
      return round($size, $precision) . ' ' . ucfirst($size_name);
  }

  /**
   * _getSizePrefix()
   * 
   * @param $pos
   * @return
   */  
  function _getSizePrefix($pos)
  {
      switch ($pos) {
          case 00:
              return "";
          case 01:
              return "kilo";
          case 02:
              return "mega";
          case 03:
              return "giga";
          default:
              return "?-";
      }
  }
    
  /**
   * stripTags()
   * 
   * @param $start
   * @param $end
   * @param $string
   * @return
   */
  function stripTags($start, $end, $string)
  {
	  $string = stristr($string, $start);
	  $doend = stristr($string, $end);
	  return substr($string, strlen($start), -strlen($doend));
  }
    
  /**
   * primeira()
   * 
   * @return
   */
  function primeira($texto)
  {
	  return stristr($texto, ' ', true);
  }

  /**
   * cleanOut()
   * 
   * @param $text
   * @return
   */
  function cleanOut($text) {
	 $text =  strtr($text, array('\r\n' => "", '\r' => "", '\n' => ""));
	 $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
	 $text = str_replace('<br>', '<br />', $text);
	 return stripslashes($text);
  }

  /**
   * randName()
   * 
   * @return
   */ 
  function randName() {
	  $code = '';
	  for($x = 0; $x<6; $x++) {
		  $code .= '-'.substr(strtoupper(sha1(rand(0,999999999999999))),2,6);
	  }
	  $code = substr($code,1);
	  return $code;
  }
  
  function retira_acentos($texto) { 
	$array1 = array( "á", "à", "â", "ã", "ä", "é", "è", "ê", "ë", "í", "ì", "î", "ï", "ó", "ò", "ô", "õ", "ö", "ú", "ù", "û", "ü", "ç" 
	, "Á", "À", "Â", "Ã", "Ä", "É", "È", "Ê", "Ë", "Í", "Ì", "Î", "Ï", "Ó", "Ò", "Ô", "Õ", "Ö", "Ú", "Ù", "Û", "Ü", "Ç", "'" ); 
	$array2 = array( "a", "a", "a", "a", "a", "e", "e", "e", "e", "i", "i", "i", "i", "o", "o", "o", "o", "o", "u", "u", "u", "u", "c" 
	, "A", "A", "A", "A", "A", "E", "E", "E", "E", "I", "I", "I", "I", "O", "O", "O", "O", "O", "U", "U", "U", "U", "C", " " ); 
	return str_replace( $array1, $array2, $texto); 
  }

  /**
   * exibeMesAno()
   * @param data no formato false yyyy-mm-dd
   * @return data no formato true mm/yyyy
   */
  function exibeMesAno($mes_ano, $completo = false, $formato = false)
  {
	  if($formato)
	  {
		$d = explode("/", $mes_ano);
		$mes =  $d[0];
		$ano =  $d[1];
	  } else {
		$d = explode("-", $mes_ano);
		$mes =  $d[1];
		$ano =  $d[0];
	  }
	  switch ($mes) {
          case "01":
			  return ($completo) ? "JAN/".$ano : "JAN";
          case "02":
			  return ($completo) ? "FEV/".$ano : "FEV";
          case "03":
			  return ($completo) ? "MAR/".$ano : "MAR";
          case "04":
			  return ($completo) ? "ABR/".$ano : "ABR";
          case "05":
			  return ($completo) ? "MAI/".$ano : "MAI";
          case "06":
			  return ($completo) ? "JUN/".$ano : "JUN";
          case "07":
			  return ($completo) ? "JUL/".$ano : "JUL";
          case "08":
			  return ($completo) ? "AGO/".$ano : "AGO";
          case "09":
			  return ($completo) ? "SET/".$ano : "SET";
          case "10":
			  return ($completo) ? "OUT/".$ano : "OUT";
          case "11":
			  return ($completo) ? "NOV/".$ano : "NOV";
          case "12":
			  return ($completo) ? "DEZ/".$ano : "DEZ";
          default:
              return $mes."/".$ano;
      }
	  return ;
  }

  /**
   * exibeMes()
   */
  function exibeMes($mes)
  {
	  switch ($mes) {
          case "01":
			  return "Janeiro";
          case "02":
			  return "Fevereiro";
          case "03":
			  return "Março";
          case "04":
			  return "Abril";
          case "05":
			  return "Maio";
          case "06":
			  return "Junho";
          case "07":
			  return "Julho";
          case "08":
			  return "Agosto";
          case "09":
			  return "Setembro";
          case "10":
			  return "Outubro";
          case "11":
			  return "Novembro";
          case "12":
			  return "Dezembro";
          default:
              return $mes;
      }
	  return ;
  }

  /**
   * getCorDias()
   *
   */  
  function getCorDias($dias)
  {
	if($dias > 90)
		return "e51400";
	elseif($dias > 30)
		return "f8a31f";
	else
		return "393";
  }
  
  /**
   * getCorMes()
   *
   */  
  function getCorMes($dias)
  {
	if($dias > 210)
		return "e51400";
	elseif($dias > 150)
		return "f8a31f";
	else
		return "393";
  }
  
   /**
   * getClasse()
   *
   */  
  function getClasse($status)
  {
      switch ($status) {
          case 10:
              return "orange";
          case 11:
              return "pink";
          default:
              return "lightgrey";
      }
  }
  
   /**
   * getRestricao()
   *
   */  
  function getRestricao($restricao)
  {
      return ($restricao) ? "style='color:#f8a31f';" : "";
  }
  
   /**
   * tipoConta()
   *
   */  
  function tipoConta($tipo)
  {
      switch ($tipo) {
          case "C":
              return lang('RECEITA');
          case "D":
              return lang('DESPESA');
          case "I":
              return lang('INVESTIMENTO_M');
          case "DF":
              return lang('DESPESA_FIXA');
          case "DV":
              return lang('DESPESA_VARIAVEL');
          default:
              return lang('NAOINFORMADO');
      }
  }
  
   /**
   * tipoVenda()
   *
   */  
  function tipoVenda($tipo)
  {
      switch ($tipo) {
          case 1:
              return lang('PRODUTO');
          case 2:
              return lang('SERVICO');
          case 3:
              return lang('PARCELA');
          case 4:
              return lang('CLIENTE_EMBELLEZE');
          default:
              return lang('NAOINFORMADO');
      }
  }
  
   /**
   * mesCompetencia()
   *
   */  
  function mesCompetencia()
  {
      $data_competencia = explode("/",date("m/Y"));
	  $mes = $data_competencia[0];
	  $ano = $data_competencia[1];
	  if($mes == 1)
	  {
		$mes = 12;
		$ano = $data_competencia[1] - 1;
	  } else {
		$mes = $data_competencia[0] - 1;
	  }
	  return $mes."/".$ano;
  } 
  
   /**
   * getMeses()
   *
   */  
  function getMeses($periodo)
  {
      switch ($periodo) {
          case "MENSAL":
              return 1;
          case "TRIMESTRAL":
              return 3;
          case "SEMESTRAL":
              return 6;
          case "ANUAL":
              return 12;
      }
  }

   /**
   * validaTexto()
   * 
   * @param mixed $texto, $palavra
   * @return
   */
  function validaTexto($texto, $palavra)
  {
		$texto = sanitize(strtolower($texto));
		$palavra = sanitize(strtolower($palavra));
		$valida =  substr_count($texto, $palavra);
		return $valida;
  }
  
  /**
   * getCorCurva()
   *
   */  
  function getCorCurva($curva)
  {
	if($curva == "A")
		return "class='bg-green'";
	elseif($curva == "B")
		return "class='bg-yellow'";
	else
		return "class='bg-red'";
  }
  
  /**
   * getCorStatus()
   *
   */  
  function getCorStatus($status)
  {
	if($status == 1)
		return "ffffff";
	elseif($status == 5)
		return "ff7e7e";
	elseif($status == 4)
		return "ffdaa0";
	elseif($status == 2)
		return "368ee0";
	elseif($status == 3)
		return "bbf9bb";
	elseif($status == 6)
		return "f9bbf2";
  }
  
	/**
       * unidades()
       * 
       * @param mixed $amount
       * @return
       */
      function unidades($amount, $un)
      {
          return number_format($amount, 2, ',', '.')." ".$un;
      }
  
   /**
   * getCorStatus()
   *
   */  
  function nivel($nivel)
  {
      switch ($nivel) {
          case 9:
              return lang('CONTROLLER');
          case 8:
              return lang('MASTER');
          case 7:
              return lang('GERENCIA_FINANCEIRO');
          case 6:
              return lang('ADMINISTRATIVO');
          case 5:
              return lang('COMERCIAL');
          case 4:
              return lang('COORDENACAO');
          case 3:
              return lang('RECEPCAO');
          case 2:
              return lang('ATENDIMENTO');
          case 1:
              return lang('MEDICO');
          case 0:
              return lang('SEM_ACESSO');
          default:
              return '-';
      }
  }
  
  /**
   * dataextenso()
   * @return data no formato extenso
   */
  function dataextenso($data = false)
  {
	  $data = ($data) ? $data : date("d/m/Y");
	  $d = explode("/", $data);
	  $dia =  $d[0];
	  $mes =  $d[1];
	  $ano =  $d[2];
	  $diasemana = date("w", mktime(0,0,0,$mes,$dia,$ano) );
	  switch($diasemana) {
		case 0: $semana = "Domingo, ";  		break;
		case 1: $semana = "Segunda-feira, "; 	break;
		case 2: $semana = "Terça-feira, ";   	break;
		case 3: $semana = "Quarta-feira, ";  	break;
		case 4: $semana = "Quinta-feira, ";  	break;
		case 5: $semana = "Sexta-feira, ";   	break;
		case 6: $semana = "Sábado, ";   		break;
	  }
	
	  switch ($mes) {
          case 1:  $mes = " de janeiro de ";  	break;
          case 2:  $mes = " de fevereiro de ";  break;
          case 3:  $mes = " de março de ";  	break;
          case 4:  $mes = " de abril de "; 	 	break;
          case 5:  $mes = " de maio de ";  		break;
          case 6:  $mes = " de junho de ";  	break;
          case 7:  $mes = " de julho de ";  	break;
          case 8:  $mes = " de agosto de ";  	break;
          case 9:  $mes = " de setembro de ";  	break;
          case 10: $mes = " de outubro de ";  	break;
          case 11: $mes = " de novembro de ";  	break;
          case 12: $mes = " de dezembro de ";  	break;
      }
	  return $semana.$dia.$mes.$ano;
  }
  
  /**
   * contarDomingos()
   * 
   * @param $mes_ano no formato (MM/YYYY) 
   * @return
   */
  function contarDomingos($mes_ano) {
	$cont = 0;
	$datames = explode("/", $mes_ano);
	$ultimo = cal_days_in_month(CAL_GREGORIAN, $datames[0], $datames[1]);
	for($i=1;$i<=$ultimo;$i++) {
		$diasemana = date("N", mktime(0,0,0,$datames[0],$i,$datames[1]) );
		if($diasemana == 7) {
		 $cont++;
		}
	}
	return $cont;
  }  
  
  /**
   * contarSabados()
   * 
   * @param $mes_ano no formato (MM/YYYY) 
   * @return
   */
  function contarSabados($mes_ano) {
	$cont = 0;
	$datames = explode("/", $mes_ano);
	$ultimo = cal_days_in_month(CAL_GREGORIAN, $datames[0], $datames[1]);
	for($i=1;$i<=$ultimo;$i++) {
		$diasemana = date("N", mktime(0,0,0,$datames[0],$i,$datames[1]) );
		if($diasemana == 6) {
		 $cont++;
		}
	}
	return $cont;
  }  
  
  /**
   * contarDiasUteis()
   * 
   * @param $mes_ano no formato (MM/YYYY) 
   * @return
   */
  function contarDiasUteis($mes_ano, $sabado = 0) {
	$cont = 0;
	$sabados = 0;
	$datames = explode("/", $mes_ano);
	$ultimo = cal_days_in_month(CAL_GREGORIAN, $datames[0], $datames[1]);
	for($i=1;$i<=$ultimo;$i++) {
		$diasemana = date("N", mktime(0,0,0,$datames[0],$i,$datames[1]) );
		if($diasemana < 7) {
		 $cont++;
		}
	}
	if($sabado == 0)
	{
		$sql = "SELECT COUNT(1) as quant FROM feriados WHERE DAYOFWEEK(data) > 1 AND DATE_FORMAT(data, '%m/%Y') = '$mes_ano' ";
	} else {
		$sabados = contarSabados($mes_ano);
		$sql = "SELECT COUNT(1) as quant FROM feriados WHERE DAYOFWEEK(data) BETWEEN 2 AND 6 AND DATE_FORMAT(data, '%m/%Y') = '$mes_ano' ";
	}
    $row = Registry::get("Database")->first($sql);
    $feriados = ($row) ? $row->quant : 0;
	$cont = $cont - $feriados - $sabados;
	return $cont;
  }  
  
  /**
   * contarDiasUteisData()
   * 
   * @param $data no formato (YYYY-MM-DD) 
   * @return
   */
  function contarDiasUteisData($data) {
	$hoje = date('Y-m-d');
	$data_ini = strtotime($hoje);
    $data_fim   = strtotime($data);
	$cont  = 0;
	$dias  = 0;
    $fimsemana = 0;
    while ($data_ini <= $data_fim) {
		$dias++;
		$dia_semana = date("N", $data_ini);
		if ($dia_semana > 6) { // Excluindo os domingos(7) e contando os sábados(6)
			$fimsemana++;
		};
		$data_ini += 86400; // +1 dia
    };
	$sql = "SELECT COUNT(1) as quant FROM feriados WHERE DAYOFWEEK(data) > 1 AND data BETWEEN CURDATE() AND STR_TO_DATE('$data','%Y-%m-%d') ";
    $row = Registry::get("Database")->first($sql);
    $feriados = ($row) ? $row->quant : 0;
	$cont = $dias - $fimsemana - $feriados - 2; //Retirar dois dias, o primeiro e o último.
	return $cont;
  }  
  
  /**
   * contarSemanas()
   * 
   * @param 
   * @return
   */
  function contarSemanas($diasemana, $numero_dias) {
	$semanas = 0;
	$diacorrente = 0;
	for( $linha = 0; $linha < 6; $linha++ )	{
		if($diacorrente == $numero_dias){
			break;
		}
		if($diasemana > 3 and $linha == 0){
			$semanas;	
		} else {
			++$semanas;
		}
		
		for( $coluna = 0; $coluna < 7; $coluna++ ) {
			if( $diacorrente + 1 <= $numero_dias ) {
				if( $coluna < $diasemana && $linha == 0) {
					$diacorrente;
				} else {					
					++$diacorrente;
				}
			} else {
				break;
			}
		}
	}
	return $semanas;
  }  
  
  /**
   * diaatual()
   * @param $data
   * @return verdadeiro para o dia de hoje no formato d/m/Y'
   */
  function diaatual($data)
  {
	  $d = explode("/", $data);
	  $dia =  $d[0];
	  $mes =  $d[1];
	  $ano =  $d[2];
	  return ( date('d/m/Y') == date('d/m/Y', mktime(0,0,0,$mes,$dia,$ano) ));
  }
  
   /**
   * motivo()
   *
   */  
  function motivo($motivo)
  {
      switch ($motivo) {
          case 1:
              return lang('ESTOQUE_MOTIVO_COMPRA');
          case 2:
              return lang('ESTOQUE_MOTIVO_TRANSFERENCIA');
          case 3:
              return lang('ESTOQUE_MOTIVO_VENDA');
          case 4:
              return lang('ESTOQUE_MOTIVO_CONSUMO');
          case 5:
              return lang('ESTOQUE_MOTIVO_PERDA');
          case 6:
              return lang('ESTOQUE_MOTIVO_AJUSTE');
          case 7:
              return lang('ESTOQUE_MOTIVO_CANCELAMENTO');
          default:
              return "-";
      }
  }
  
   /**
   * statusCaixa()
   *
   */  
  function statusCaixa($status)
  {
      switch ($status) {
          case 1:
              return lang('CAIXA_ABERTO');
          case 2:
              return lang('CAIXA_FECHADO');
          case 3:
              return lang('CAIXA_VALIDADO');
          default:
              return "-";
      }
  }
  
   /**
   * statusCaixaImpressao()
   *
   */  
  function statusCaixaImpressao($status)
  {
      switch ($status) {
          case 1:
              return lang('ABERTO');
          case 2:
              return lang('FECHADO');
          case 3:
              return lang('VALIDADO');
          default:
              return "-";
      }
  }
  
   /**
   * tipo_venda()
   *
   */  
  function tipo_venda($tipo)
  {
      switch ($tipo) {
          case 4:
              return lang('MENU_PARCELAS');
          case 3:
              return lang('VENDAS_NOVA');
          case 2:
              return lang('MODELO_NOVO');
          case 1:
              return lang('MENU_MATRICULA');
          default:
              return '';
      }
  }
  
   /**
   * statusOrcamento()
   *
   */  
  function statusOrcamento($status)
  {
      switch ($status) {
          case 1:
              return "<span class='label bg-green'>".lang('FECHADO')."</span>";
          case 0:
              return "<span class='label bg-blue'>".lang('ABERTO')."</span>";
          default:
              return "-";
      }
  }
  
   /**
   * statusContrato()
   *
   */  
  function statusContrato($status)
  {
      switch ($status) {
          case 1:
              return "<span class='label bg-green'>".lang('ATIVO')."</span>";
          case 2:
              return "<span class='label bg-yellow'>".lang('BLOQUEIO_MANUAL')."</span>";
          case 3:
              return "<span class='label bg-red'>".lang('CANCELADO')."</span>";
          case 9:
              return "<span class='label bg-yellow-gold'>".lang('BLOQUEIO_FINANCEIRO')."</span>";
          default:
              return "-";
      }
  }
  
   /**
   * statusFinanceiro()
   *
   */  
  function statusFinanceiro($status)
  {
      switch ($status) {
          case 1:
              return "<span class='label bg-green'>".lang('PAGO')."</span>";
          case 2:
              return "<span class='label bg-red'>".lang('ATRASADO')."</span>";
          default:
              return "-";
      }
  }
  
   /**
   * statusPagamento()
   *
   */  
  function statusPagamento($status)
  {
      switch ($status) {
          case 0:
              return "<span class='label bg-red'>".lang('NAO_PAGO')."</span>";
          case 1:
              return "<span class='label bg-green'>".lang('PAGO')."</span>";
          default:
              return "-";
      }
  }
  
   /**
   * statusAgenda()
   *
   */  
  function statusAgenda($status)
  {
      switch ($status) {
          case 0:
              return "<span class='label label-default'>".lang('ABERTA')."</span>";
          case 1:
              return "<span class='label label-verde'>".lang('REALIZADA')."</span>";
          case 2:
              return "<span class='label label-azul'>".lang('LIBERADA')."</span>";
          case 3:
              return "<span class='label label-preto'>".lang('CONFIRMADA')."</span>";
          case 4:
              return "<span class='label label-verde3'>".lang('PAGA')."</span>";
          case 5:
              return "<span class='label label-success'>".lang('PAGAMENTO_PARCIAL')."</span>";
          case 6:
              return "<span class='label label-roxo'>".lang('CHAMADA')."</span>";
          case 7:
              return "<span class='label label-verde3'>".lang('FATURAMENTO')."</span>";
          case 8:
              return "<span class='label label-cinza'>".lang('BLOQUEADO')."</span>";
          case 9:
              return "<span class='label label-vermelho'>".lang('CANCELADA')."</span>";
          case 10:
              return "<span class='label bg-yellow-gold'>".lang('RETORNO')."</span>";
          case 11:
              return "<span class='label label-warning'>".lang('PENDENTE_PAGAMENTO')."</span>";
          case 12:
              return "<span class='label label-vermelho'>".lang('PENDENTE_GUIA')."</span>";
          case 13:
              return "<span class='label label-amarelo'>".lang('ALERTA_GUIA')."</span>";
          case 14:
              return "<span class='label label-vermelho'>".lang('VENCIDA_GUIA')."</span>";
          case 20:
              return "<span class='label bg-yellow-casablanca'>".lang('ORCAMENTO')."</span>";
      }
  }
  
   /**
   * statusAgendaFundo()
   *
   */  
  function statusAgendaFundo($status)
  {
      switch ($status) {
          case 0:
              return "list-group-item list-group-item-cinza";
          case 1:
              return "list-group-item list-group-item-verde2 font-white";
          case 2:
              return "list-group-item list-group-item-azul font-white";
          case 3:
              return "list-group-item list-group-item-preto font-white";
          case 4:
              return "list-group-item list-group-item-verde3 font-white";
          case 5:
              return "list-group-item list-group-item-verde font-white";
          case 6:
              return "list-group-item list-group-item-roxo2 font-white";
          case 7:
              return "list-group-item list-group-item-verde3 font-white";
          case 8:
              return "list-group-item list-group-item-cinza2";
          case 9:
              return "list-group-item list-group-item-vermelho";
          case 10:
              return "list-group-item list-group-item-laranja font-white";
          case 11:
              return "list-group-item list-group-item-laranja2 font-white";
          case 12:
              return "list-group-item list-group-item-vermelho2 font-white";
          case 13:
              return "list-group-item list-group-item-amarelo2 font-white";
          case 14:
              return "list-group-item list-group-item-vermelho2 font-white";
      }
  }
  
   /**
   * calendarioAgenda()
   *
   */  
  function calendarioAgenda($status, $quant = 0)
  {
      switch ($status) {
          case 0:
              return "<span class='list-group-item list-group-item-default'>".lang('ABERTA').": ".$quant."</span>";
          case 1:
              return "<span class='list-group-item list-group-item-verde'>".lang('REALIZADA').": ".$quant."</span>";
          case 2:
              return "<span class='list-group-item list-group-item-azul'>".lang('LIBERADA').": ".$quant."</span>";
          case 3:
              return "<span class='list-group-item list-group-item-preto font-white'>".lang('CONFIRMADA').": ".$quant."</span>";
          case 6:
              return "<span class='list-group-item list-group-item-roxo2 font-white'>".lang('CHAMADA').": ".$quant."</span>";
          case 8:
              return "<span class='list-group-item list-group-item-cinza2 font-white'>".lang('BLOQUEADO').": ".$quant."</span>";
          case 9:
              return "<span class='list-group-item list-group-item-vermelho'>".lang('CANCELADA').": ".$quant."</span>";
      }
  }
  
   /**
   * statusAgendaPDF()
   *
   */  
  function statusAgendaPDF($status)
  {
      switch ($status) {
          case 0:
              return lang('ABERTA');
          case 1:
              return lang('REALIZADA');
          case 2:
              return lang('LIBERADA');
          case 3:
              return lang('CONFIRMADA');
          case 4:
              return lang('PAGA');
          case 5:
              return lang('PAGAMENTO_PARCIAL');
          case 6:
              return lang('CHAMADA');
          case 7:
              return lang('FATURAMENTO');
          case 8:
              return lang('BLOQUEADO');
          case 9:
              return lang('CANCELADA');
          case 10:
              return lang('RETORNO');
          case 11:
              return lang('PENDENTE_PAGAMENTO');
          case 12:
              return lang('PENDENTE_GUIA');
          case 13:
              return lang('ALERTA_GUIA');
          case 14:
              return lang('VENCIDA_GUIA');
          case 20:
              return lang('ORCAMENTO');
      }
  }
  
   /**
   * corAgenda()
   *
   */  
  function corAgenda($status)
  {
      switch ($status) {
          case 0:
              return "ebebeb";
          case 1:
              return "0a8f00";
          case 2:
              return "058bff";
          case 3:
              return "0027a6";
          case 4:
              return "46dc3c";
          case 5:
              return "c8f0cd";
          case 6:
              return "a400bd";
          case 7:
              return "46dc3c";
          case 8:
              return "5c5c5c";
          case 9:
              return "ffc8cd";
          case 10:
              return "fae6d7";
          case 11:
              return "f79b11";
          case 12:
              return "bd0000";
          case 13:
              return "bda400";
          case 14:
              return "bd0000";
      }
  }
  
   /**
   * tipoConvenio()
   *
   */  
  function tipoConvenio($tipo)
  {
      switch ($tipo) {
          case 1:
              return lang('CONVENIO_PAGAR_M');
          case 2:
              return lang('CONVENIO_RECEBER_M');
          case 3:
              return lang('LABORATORIO_M');
          default:
              return lang('NENHUM_M');
      }
  }
  
   /**
   * modeloDocumento()
   *
   */  
  function modeloDocumento($id)
  {
      $sql = "SELECT titulo FROM modelo WHERE id = '$id' ";
      $row = ($id) ? Registry::get("Database")->first($sql) : null;
      return ($row) ? $row->titulo : '';
  }
  
   /**
   * textoDocumento()
   *
   */  
  function textoDocumento($id)
  {
      $sql = "SELECT texto FROM modelo WHERE id = '$id' ";
      $row = ($id) ? Registry::get("Database")->first($sql) : null;
      return ($row) ? $row->texto : '';
  }

  /**
   * virgulas()
   * 
   * @param $text
   * @return
   */
  function virgulas($text) {
	 $text = str_replace(',', ' ', $text);
	 return stripslashes($text);
  }
  
  
  /**
   * lerNodes()
   * Função recursiva para ler todos os nodes de um XML
   * @param $childNodes
   * @return
   */
  function lerNodes($childNodes, &$array_nodes, $pref = false) {
        foreach($childNodes as $nodename)
        {
			if($nodename->hasChildNodes())
			{
				$childNodes2 = $nodename->childNodes;
                $name = $nodename->nodeName;
				$name = str_replace('ii:', '', $name);
				$chave = ($pref) ? $pref."_".$name : $name;
				lerNodes($childNodes2, $array_nodes, $chave);
			} else {
                $name = $nodename->nodeName;
				$name = str_replace('ii:', '', $name);
				$chave = ($pref) ? $pref : $name;
				$array_nodes[$chave] = $nodename->nodeValue;
				echo $nodename->nodeName." - ".$nodename->nodeValue."<br/>";				
			}
		}
	}
  
  /**
   * checkRegistro()
   * 
   * @param $campo
   * @param $tabela
   * @param $valor
   * @return
   */
  function checkRegistro($campo, $tabela, $valor)
  {
      $sql = "SELECT id FROM $tabela WHERE $campo = '$valor' ";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->id : 0;
  }  
  
  /**
   * gerarPIN()
   * 
   * @return
   */
  function gerarPIN()
  {
	  $pin = mt_rand(0, 99999);
	  $pin = str_pad($pin, 5, "0", STR_PAD_BOTH );
	  $sql = "SELECT id FROM paciente WHERE pin = '$pin'";
	  $row = $db->first($sql);
	  if($row and $row->id > 0) {
		  $pin = gerarPIN();
	  }
      return $pin;
  } 
  
  /**
   * checkEmpresa()
   * 
   * @param $cnpj
   * @return
   */
  function checkEmpresa($cnpj)
  {
      $sql = "SELECT id FROM empresa WHERE cnpj like '%$cnpj%' ";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->id : 0;
  }  
  
  /**
   * checkCondicao()
   * 
   * @param $tabela
   * @param $condicao
   * @return
   */
  function checkCondicao($tabela, $condicao)
  {
      $sql = "SELECT id FROM $tabela WHERE $condicao ";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->id : 0;
  }  

	/**
   * limparCPF_CNPJ()
   * 
   * @param $tel
   * @return
   */
  function limparCPF_CNPJ($numero)
  {
      $numero = str_replace(".","",$numero);
      $numero = str_replace("/","",$numero);
      $numero = str_replace("-","",$numero);
      $numero = str_replace(" ","",$numero);
      return $numero;
  }  
  
  /**
   * formatar_cpf_cnpj()
   * @param cpf_cnpj sem formato
   * @return campo formatado
   */
  function formatar_cpf_cnpj($cpf_cnpj)
  {
	  return (strlen($cpf_cnpj) > 12) ? substr($cpf_cnpj,0,2).".".substr($cpf_cnpj,2,3).".".substr($cpf_cnpj,5,3)."/".substr($cpf_cnpj,8,4)."-".substr($cpf_cnpj,12,2) : substr($cpf_cnpj,0,3).".".substr($cpf_cnpj,3,3).".".substr($cpf_cnpj,6,3)."-".substr($cpf_cnpj,9,2);
  }

	/**
   * hora()
   * 
   * @param $h
   * @param $m
   * @return
   */
  function hora($h, $m)
  {
      return str_pad($h,2,'0',STR_PAD_LEFT).":".str_pad($m,2,'0',STR_PAD_LEFT);
  } 

	/**
   * idade()
   * 
   * @param $date
   * @format Y-m-d
   * @return
   */
	function idade($data)
	{		
	  $retorno = "-";
	  if($data != "0000-00-00") {
		  date_default_timezone_set('America/Argentina/Buenos_Aires');
		  $data_hoje = date('Y-m-d H:i:s');
		  $hoje = new DateTime( $data_hoje );
		  $data_nasc = new DateTime( $data );
		  $intervalo = $hoje->diff( $data_nasc );	  
		  $anos = $intervalo->y;
		  $meses = $intervalo->m;
		  $dias = $intervalo->d;
		  $retorno = $anos." ano(s) e ".$meses." mes(es)";
	  }
	  return $retorno;
	}
	
	/**
   * validaIdade()
   * 
   * @param $date
   * @format Y-m-d
   * @return
   */
	function validaIdade($data)
	{		
	  $retorno = "";
	  if($data != "0000-00-00") {
		  date_default_timezone_set('America/Argentina/Buenos_Aires');
		  $data_hoje = date('Y-m-d H:i:s');
		  $hoje = new DateTime( $data_hoje );
		  $data_nasc = new DateTime( $data );
		  $intervalo = $hoje->diff( $data_nasc );	  
		  $anos = $intervalo->y;
		  $meses = $intervalo->m;
		  $dias = $intervalo->d;
		  $retorno = $anos;		  
	  }
	  return $retorno;
	}

	/**
   * anos()
   * 
   * @param $date
   * @format Y-m-d
   * @return
   */
  function anos($data)
  {
	  $retorno = "";
	  if($data != "0000-00-00") {
		  date_default_timezone_set('America/Argentina/Buenos_Aires');
		  $data_hoje = date('Y-m-d H:i:s');
		  $hoje = new DateTime( $data_hoje );
		  $data_nasc = new DateTime( $data );
		  $intervalo = $hoje->diff( $data_nasc );	  
		  $anos = $intervalo->y;
		  $meses = $intervalo->m;
		  $dias = $intervalo->d;
		  $retorno = $anos." anos";
	  }
	  return $retorno;
  } 

	/**
   * reduzir()
   * 
   * @param $texto
   * @param $tamanho
   * @return Reduz o texto com tamanho mínimo de 8 caracteres
   */
  function reduzir($texto = '', $tamanho = 0)
  {
      return (strlen($texto) > $tamanho and $tamanho > 8) ? substr($texto,0,$tamanho-3).'...' : $texto;
  } 
  
  function get_file_get_contents( $site_url ){
		$ch = curl_init();		
		$timeout = 0; // set to zero for no timeout
		curl_setopt ($ch, CURLOPT_URL, $site_url);
		curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		ob_start();
		curl_exec($ch);
		curl_close($ch);
		$file_contents = ob_get_contents();
		ob_end_clean();
		return $file_contents;
  }
  
  function xmlObjToArr(&$obj) { 
	echo "entrou";
        $namespace = $obj->getDocNamespaces(true); 
        $namespace[NULL] = NULL; 
        
        $children = array(); 
        $attributes = array(); 
        echo $name = strtolower((string)$obj->getName()); 
        
        $text = trim((string)$obj); 
        if( strlen($text) <= 0 ) { 
            $text = NULL; 
        } 
        
        // get info for all namespaces 
        // if(is_object($obj)) { 
            // foreach( $namespace as $ns=>$nsUrl ) { 
                // // atributes 
                // $objAttributes = $obj->attributes($ns, true); 
                // foreach( $objAttributes as $attributeName => $attributeValue ) { 
                    // $attribName = strtolower(trim((string)$attributeName)); 
                    // $attribVal = trim((string)$attributeValue); 
                    // if (!empty($ns)) { 
                        // $attribName = $ns . ':' . $attribName; 
                    // } 
                    // $attributes[$attribName] = $attribVal; 
                // } 
                
                // // children 
                // $objChildren = $obj->children($ns, true); 
                // foreach( $objChildren as $childName=>$child ) { 
                    // $childName = strtolower((string)$childName); 
                    // if( !empty($ns) ) { 
                        // $childName = $ns.':'.$childName; 
                    // } 
                    // $children[$childName][] = xmlObjToArr($child); 
                // } 
            // } 
        // } 
        
        return array( 
            'name'=>$name, 
            'text'=>$text, 
            'attributes'=>$attributes, 
            'children'=>$children 
        ); 
    }
	
  /**
   * is_session_started()
   * @return true
   */
  function is_session_started()
  {
	if ( php_sapi_name() !== 'cli' ) {
		if ( version_compare(phpversion(), '5.4.0', '>=') ) {
			return session_status() === PHP_SESSION_ACTIVE ? true : false;
		} else {
			return session_id() === '' ? false : true;
		}
	}
	return true;
  }
  
   /**
   * validarCPF_CNPJ()
   * 
   * @param $cnpj
   * @return
   */
	function validarCPF_CNPJ($cpf_cnpj)
	{
		$cpf_cnpj = preg_replace('/[^0-9]/', '', (string) $cpf_cnpj);
		
		// Valida tamanho
		if (strlen($cpf_cnpj) == 14) {
			// Verifica se todos os digitos são iguais
			if (preg_match('/(\d)\1{13}/', $cpf_cnpj))
				return false;	
			// Valida primeiro dígito verificador
			for ($i = 0, $j = 5, $soma = 0; $i < 12; $i++)
			{
				$soma += $cpf_cnpj{$i} * $j;
				$j = ($j == 2) ? 9 : $j - 1;
			}
			$resto = $soma % 11;
			if ($cpf_cnpj{12} != ($resto < 2 ? 0 : 11 - $resto))
				return false;
			// Valida segundo dígito verificador
			for ($i = 0, $j = 6, $soma = 0; $i < 13; $i++)
			{
				$soma += $cpf_cnpj{$i} * $j;
				$j = ($j == 2) ? 9 : $j - 1;
			}
			$resto = $soma % 11;
			return $cpf_cnpj{13} == ($resto < 2 ? 0 : 11 - $resto);
		} elseif(strlen($cpf_cnpj) == 11) {
			// Extrai somente os números
			$cpf_cnpj = preg_replace( '/[^0-9]/is', '', $cpf_cnpj );
			 
			// Verifica se foi informada uma sequência de digitos repetidos. Ex: 111.111.111-11
			if (preg_match('/(\d)\1{10}/', $cpf_cnpj)) {
				return false;
			}
			// Faz o calculo para validar o CPF
			for ($t = 9; $t < 11; $t++) {
				for ($d = 0, $c = 0; $c < $t; $c++) {
					$d += $cpf_cnpj{$c} * (($t + 1) - $c);
				}
				$d = ((10 * $d) % 11) % 10;
				if ($cpf_cnpj{$c} != $d) {
					return false;
				}
			}
			return true;
		} else {
			return false;
		}
	}
  
   /**
   * validarCNPJ()
   * 
   * @param $cnpj
   * @return
   */
	function validarCNPJ($cnpj)
	{
		$cnpj = preg_replace('/[^0-9]/', '', (string) $cnpj);
		
		// Valida tamanho
		if (strlen($cnpj) != 14)
			return false;
		// Verifica se todos os digitos são iguais
		if (preg_match('/(\d)\1{13}/', $cnpj))
			return false;	
		// Valida primeiro dígito verificador
		for ($i = 0, $j = 5, $soma = 0; $i < 12; $i++)
		{
			$soma += $cnpj{$i} * $j;
			$j = ($j == 2) ? 9 : $j - 1;
		}
		$resto = $soma % 11;
		if ($cnpj{12} != ($resto < 2 ? 0 : 11 - $resto))
			return false;
		// Valida segundo dígito verificador
		for ($i = 0, $j = 6, $soma = 0; $i < 13; $i++)
		{
			$soma += $cnpj{$i} * $j;
			$j = ($j == 2) ? 9 : $j - 1;
		}
		$resto = $soma % 11;
		return $cnpj{13} == ($resto < 2 ? 0 : 11 - $resto);
	}
	
   /**
   * validaCPF()
   * 
   * @param $cpf
   * @return
   */
	function validaCPF($cpf)
	{
		// Extrai somente os números
		$cpf = preg_replace( '/[^0-9]/is', '', $cpf );
		 
		// Verifica se foi informado todos os digitos corretamente
		if (strlen($cpf) != 11) {
			return false;
		}
		// Verifica se foi informada uma sequência de digitos repetidos. Ex: 111.111.111-11
		if (preg_match('/(\d)\1{10}/', $cpf)) {
			return false;
		}
		// Faz o calculo para validar o CPF
		for ($t = 9; $t < 11; $t++) {
			for ($d = 0, $c = 0; $c < $t; $c++) {
				$d += $cpf{$c} * (($t + 1) - $c);
			}
			$d = ((10 * $d) % 11) % 10;
			if ($cpf{$c} != $d) {
				return false;
			}
		}
		return true;
	}

    /**
     * @param string|array $regIds
     * @param string $data
     * @throws \Exception
     */
    function chamarVoz($data = "")
    {
        $headers = [
            'Authorization: key=AAAA2tXaGUc:APA91bF7F3MZvWd01rAJA5UCWhgwUEXvzU16jPhpM3c12UtF3lDaai3ep1ZZxmg9SOXkDqz2mG4YI7ZeWajqpwMOz0LSw0InLLVv3jFZWaAWbk8WjiAUBbioTQ_6_fmOt2Kl4Ie-_sbk',
            'Content-Type: application/json'
        ];
		if($data) {
			$fields = [
				'body' => is_string($data) ?  '"'.$data.'"' : strval('"'.$data.'"')
			];
			$dados = [
				'to' => '/topics/all',
				'data' => $fields
			];
			$mensagem =  json_encode($dados, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, "https://android.googleapis.com/gcm/send");
			curl_setopt($ch, CURLOPT_POST, true);
			curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $mensagem);
			$result = curl_exec($ch);
			if ($result === false) {
				throw new Exception(curl_error($ch));
			}
			curl_close($ch);

			echo $result;
		} else {
			echo "Erro no envio da notificacao. Mensagem=[$data]";
		}
    }
  
   /**
   * verifica()
   *
   */  
  function verifica($status)
  {
      switch ($status) {
          case 9:
              return "<span class='label bg-green-jungle'>".lang('CONVENIO')."</span>";
          case 2:
              return "<span class='label bg-yellow'>".lang('PENDENTE')."</span>";
          case 1:
              return "<span class='label bg-green'>".lang('SIM')."</span>";
          case 0:
              return "<span class='label bg-red'>".lang('NAO')."</span>";
      }
  }
  
  /**
   * paciente()
   * 
   * @param $id
   * @return
   */
  function paciente($id)
  {
      $sql = "SELECT nome FROM paciente WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : '';
  }  
  
  /**
   * empresa()
   * 
   * @param $id
   * @return
   */
  function empresa($id)
  {
      $sql = "SELECT nome FROM empresa WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : '';
  } 
  
  /**
   * medico()
   * 
   * @param $id
   * @return
   */
  function medico($id)
  {
      $sql = "SELECT nome FROM usuario WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : '';
  } 
  
  /**
   * procedimento()
   * 
   * @param $id
   * @return
   */
  function procedimento($id)
  {
      $sql = "SELECT nome FROM tabela WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : '';
  } 
  
  /**
   * convenio()
   * 
   * @param $id
   * @return
   */
  function convenio($id)
  {
      $sql = "SELECT nome FROM cadastro WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : 'PARTICULAR';
  } 
  
  /**
   * cadastro()
   * 
   * @param $id
   * @return
   */
  function cadastro($id)
  {
      $sql = "SELECT nome FROM cadastro WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : '';
  } 
  
  /**
   * especialidade()
   * 
   * @param $id
   * @return
   */
  function especialidade($id)
  {
      $sql = "SELECT nome FROM especialidade WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->nome : '';
  } 
  
  /**
   * consultorio()
   * 
   * @param $id
   * @return
   */
  function consultorio($id)
  {
      $sql = "SELECT consultorio FROM especialidade WHERE id='$id'";
      $row = Registry::get("Database")->first($sql);
      return ($row) ? $row->consultorio : '';
  }  
	
  /**
   * enviarURL()
   * 
   * @return
   */  
  function enviarURL( $token, $params, $enviar = true ){
	  $url = 'https://api.touswhatsapp.com.br/send/'.$token.'/?'.$params;
	  // $url = 'https://api.touschat.pro/token/'.$token.'/send/'.$params;
	  if($enviar) {
		  $curl = curl_init();
			curl_setopt_array($curl, array(
			 CURLOPT_URL => $url,
			 CURLOPT_RETURNTRANSFER => true,
			 CURLOPT_ENCODING => "",
			 CURLOPT_MAXREDIRS => 10,
			 CURLOPT_TIMEOUT => 120,
			 CURLOPT_SSL_VERIFYPEER=> false,
			 CURLOPT_FOLLOWLOCATION => false,
			 CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			 CURLOPT_CUSTOMREQUEST => 'GET',
		  ));
		  $response = curl_exec($curl);
		  $err = curl_error($curl);
		  curl_close($curl);
		  if ($err) {
			  echo $err;
		  } else {
			  return $response;
          }
	    }  
  }
	
  /**
   * saudacao()
   * 
   * @return
   */
  function saudacao()
  {
	  date_default_timezone_set('America/Argentina/Buenos_Aires');
	  $hora = date('H');
	  if($hora > 4 and $hora < 12) {
		  return 'bom dia';
	  } elseif($hora > 11 and $hora < 18) {
		  return 'boa tarde';
	  } else {
		  return 'boa noite';
	  }
  }

    /**
     * agendamento()
     * @param array $dados
     * @throws \Exception
     */
    function agendamento($dados)
    {
		$json =  json_encode($dados, JSON_HEX_TAG | JSON_HEX_APOS | JSON_HEX_QUOT | JSON_HEX_AMP | JSON_UNESCAPED_UNICODE);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, "https://controle.sis.net.br/webservices/agendamento.php");
		curl_setopt($ch, CURLOPT_POST, true);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
		$result = curl_exec($ch);
		if ($result === false) {
			throw new Exception(curl_error($ch));
		}
		curl_close($ch);
	
		return $result;
    }
  
  /**
   * contarAgendas()
   * @return quantidade de agendas
   */
  function contarAgendas($horainicial, $horafinal, $tempo, $quantidade = 0)
  {
		$horarios = array();
		$contar = 0;
		$ini = explode(':', $horainicial);
		$fim = explode(':', $horafinal);
		$seg_ini = ($ini[0]*60)+$ini[1];
		$seg_fim = ($fim[0]*60)+$fim[1];
		$q = 0;
		$quantidade = ($quantidade) ? $quantidade : 99;
		for($i=$seg_ini;($i<=$seg_fim and $q < $quantidade);$i+=$tempo) {
			$q++;
			$hora = floor($i/60);
			$hora = str_pad($hora, 2, '0', STR_PAD_LEFT);
			$minutos = $i % 60;
			$minutos = str_pad($minutos, 2, '0', STR_PAD_LEFT);
			$horario = $hora.':'.$minutos;										
			if (!in_array($horario, $horarios)) { 
				$contar++;
			}
		}
	  return $contar;
  } 
  
?>