<?php
  /**
   * Webservices: Painel
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */

	set_time_limit(0);
	ini_set('memory_limit', '-1');
	ini_set('max_execution_time', 6000);
	ini_set('fastcgi_read_timeout', 6000);
	ini_set('default_socket_timeout', 9000);	
	define('_VALID_PHP', true);
	require_once("../init.php");

try {
	$retorno = 0;
	$status = "";
	$id_empresa = get('id_empresa');
	$nomeempresa = '';
	$row_agenda = $atendimento->getAgendaTV(false, $id_empresa);
	if($row_agenda) {
		foreach ($row_agenda as $exrow){
			$nomeempresa = $exrow->empresa;
			$indice = strtotime($exrow->data_chamada);
			$agendas[$indice] = array(
				"origem" => "MEDICO",
				"id" => $exrow->id,
				"profissional" => $exrow->profissional,
				"paciente" => $exrow->paciente,
				"telefone" => $exrow->telefone,
				"celular" => $exrow->celular,
				"consultorio" => $exrow->consultorio,
				"data_agenda" => exibedata($exrow->data_agenda),
				"data_chamada" => exibedata($exrow->data_chamada),
				"hora_agenda" => exibeHora($exrow->data_agenda),
				"hora_chamada" => $exrow->data_chamada
			);
		}
		unset($exrow);
		// print("<pre>".print_r($agendas, true)."</pre>");
		$retorno = 1;
		$status .= "Sucesso - Agenda retornadas.";
	} else {
		$agendas = [];
		$status .= "Erro - Agenda nao encontrada.";
	}
	if (defined("DB_SERVER_PAINEL")) {
		  $db_painel = new mysqli(DB_SERVER_PAINEL, DB_USER_PAINEL, DB_PASS_PAINEL, DB_DATABASE_PAINEL);
		  $db_painel->query('SET NAMES utf8');
		  $data = date('d/m/Y');
          $sql = "SELECT a.*, t.procedimento, u.nome as profissional, p.nome as paciente, p.telefone, p.celular, c.consultorio, e.nome as empresa " 
		  . "\n FROM atendimento as a "
		  . "\n LEFT JOIN usuario AS u ON u.id = a.id_dentista "
		  . "\n LEFT JOIN consultorio AS c ON c.id = a.id_consultorio "
		  . "\n LEFT JOIN paciente AS p ON p.id = a.id_paciente "
		  . "\n LEFT JOIN empresa AS e ON e.id = a.id_empresa "
		  . "\n LEFT JOIN tabela AS t ON t.id = a.id_tabela "
		  . "\n WHERE a.realizado = 6 AND a.id_empresa = '$id_empresa' AND DATE_FORMAT(a.data_agenda,'%d/%m/%Y') = '$data' "
		  . "\n ORDER BY a.data_chamada DESC LIMIT 0,5; ";		  
		  $row = $db_painel->query($sql);
		  if($row->num_rows) {	
			while ($exrow = $row->fetch_object()){
				$nomeempresa = $exrow->empresa;
				$indice = strtotime($exrow->data_chamada);
				$agendas[$indice] = array(
					"origem" => "DENTISTA",
					"id" => $exrow->id,
					"profissional" => $exrow->profissional,
					"paciente" => $exrow->paciente,
					"telefone" => $exrow->telefone,
					"celular" => $exrow->celular,
					"consultorio" => $exrow->consultorio,
					"data_agenda" => exibedata($exrow->data_agenda),
					"data_chamada" => exibedata($exrow->data_chamada),
					"hora_agenda" => exibeHora($exrow->data_agenda),
					"hora_chamada" => $exrow->data_chamada
				);
			}
			unset($exrow);
			$retorno = 1;
			$status .= "[PAINEL] Sucesso - Agenda retornadas.";
		}
	}
} catch (Exception $e) {
	$status .= "Erro - EXCEÇÃO: ".$e->getMessage();
}
if($retorno) {
	krsort($agendas);
	foreach ($agendas as $key => $val) {
		$agendas_sort[] = $val;
	}
} else {
	$agendas_sort = [];
}
$jsonRetorno = array(
	"nomeempresa" => $nomeempresa,
	"retorno" => $retorno,
	"agendas" => $agendas_sort,
	"status" => $status
);
echo json_encode($jsonRetorno, JSON_UNESCAPED_UNICODE);
?>