<?php
  /**
   * Imprimir Lista Agenda
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
   
   //TOTAL DO CABECALHO DEVE SER = 277 PARA PAGINA Landscape (L)
   //TOTAL DO CABECALHO DEVE SER = 190 PARA PAGINA Retrait (P)
	
	require_once("impressao.php");
	require_once("init.php");
	
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	
	$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y'); 
	$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
	$id_medico = (get('id_medico')) ? get('id_medico') : 0;  
	$nome_medico = (get('id_medico')) ? getValue('nome', 'usuario', 'id='.$id_medico) : 'TODOS'; 
	
	$titulo = utf8_decode(lang('AGENDA_LISTAR'));	
	$inicio = 35;
  
	$pdf = new PDF_Impressao( 'P', 'mm', 'A4' );
	$pdf->AddPage();
	$pdf->tamanho(-2);
	$pdf->addEmpresa($nome_medico);
	
	$pdf->subtitulo($titulo, $dataini.' - '.$datafim, 6);
	//$pdf->rascunho( "RASCUNHO" );

	$tabela_inicio = $inicio;
	$linha_inicio = $tabela_inicio + 10;
	$cabecalho=array( 
				 utf8_decode(lang('DATA_AGENDA'))    => 40,
				 utf8_decode(lang('MEDICO'))  => 40,
				 utf8_decode(lang('PACIENTE'))  => 40,
				 utf8_decode(lang('PROCEDIMENTO'))  => 40,
				 utf8_decode(lang('TELEFONE'))  => 30);
				 
	$pdf->definirCols($cabecalho, "C", true, 1);
	
	$cols=array( utf8_decode(lang('DATA_AGENDA'))  => "L",
				 utf8_decode(lang('MEDICO'))  => "L",
				 utf8_decode(lang('PACIENTE'))  => "L",
				 utf8_decode(lang('PROCEDIMENTO'))  => "L",
				 utf8_decode(lang('TELEFONE'))  => "L");
				 
	$pdf->addLineFormat($cols);
	$y    = $linha_inicio;
	
	$retorno_row = $atendimento->getAgendaPeriodoImpressao($dataini, $datafim, $id_medico);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$status = 0;
			if($exrow->realizado == 1) {
				if($exrow->pago == 1 or $exrow->pago == 9) {
					$status = 1;
				} else {
					$status = 11;
				}
			}elseif($exrow->realizado == 2) {
				$status = 2;
			}elseif($exrow->realizado == 6) {
				$status = 6;
			}elseif($exrow->retorno == 2) {
				$status = 10;
			}elseif($exrow->pago == 1) {
				$status = 4;
			}elseif($exrow->pago == 2) {
				$status = 5;
			}elseif($exrow->realizado == 3) {
				$status = 3;
			}
			if($exrow->guia > 0) {
				$class = 'class="info"';
				if(!$exrow->numero_guia) {
					$status = 12;
					$class = 'class="warning"';
				}
			}
			if($exrow->realizado == 9) {
				$class = 'class="danger"';
				$status = 9;
			}		   
			$linha=array( 
				 utf8_decode(lang('DATA_AGENDA'))    => utf8_decode(exibedataHora($exrow->data_agenda)),
				 utf8_decode(lang('MEDICO'))  => utf8_decode($exrow->medico),
				 utf8_decode(lang('PACIENTE'))  => utf8_decode($exrow->paciente),
				 utf8_decode(lang('PROCEDIMENTO'))  => utf8_decode($exrow->procedimento),
				 utf8_decode(lang('TELEFONE'))  => utf8_decode($exrow->celular.' '.$exrow->telefone) );
				 
			$size = $pdf->addLine( $y, $linha, false, 1 );
			$y   += $size + 2;
			if($y > 260) {		
				$tabela_final = $y - 30;
				$tabela_inicio = $inicio;
				$linha_inicio = $tabela_inicio + 10;
				$y    = $linha_inicio;
				$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
				$pdf->AddPage();
				$pdf->addEmpresa($nome_medico,$dataini,$datafim);
				$pdf->subtitulo($titulo, date('d/m/Y'), 6);
			}
		}		
		unset($exrow);
		$tabela_final = $y-28;
		$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
	}
	$pdf->Output();
?>