<?php
  /**
   * Imprimir Caixa
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
   
   //TOTAL DO CABECALHO DEVE SER = 277 PARA PAGINA Landscape
   //TOTAL DO CABECALHO DEVE SER = 190 PARA PAGINA Retrait
	
	require_once("impressao.php");
	require_once("init.php");
	
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	$id_caixa = get('id_caixa');
	$detalhes_row = $faturamento->getDetalhesCaixa($id_caixa);
	
	$titulo = utf8_decode(lang('CAIXA_DETALHES'));	
	$inicio = 35;
	
	$nome_empresa = $core->empresa;
	// $razao_empresa = $row_empresa->responsavel;
	// $dados1_empresa = $row_empresa->endereco.", ".$row_empresa->numero."\n";
	// $dados2_empresa = $row_empresa->bairro." - ".$row_empresa->cidade."\n";
	// $dados3_empresa = $row_empresa->telefone.", ".$row_empresa->cnpj;
  
	$pdf = new PDF_Impressao( 'P', 'mm', 'A4' );
	$pdf->AddPage();
	$pdf->addEmpresa( $nome_empresa," ");
				  
	$pdf->titulo( $titulo );
	$pdf->subtitulo($id_caixa,  exibedata($detalhes_row->data_abrir));
	//$pdf->rascunho( "RASCUNHO" );
	
	$y = $pdf->destaques( $inicio , utf8_decode(lang('RESPONSAVEL_ABERTO')) , utf8_decode($detalhes_row->aberto) );
	$y = $pdf->destaques( $y , utf8_decode(lang('DATA_ABERTO')) , utf8_decode(exibedataHora($detalhes_row->data_abrir)) );
	$y = $pdf->destaques( $y , utf8_decode(lang('RESPONSAVEL_FECHADO')) , utf8_decode($detalhes_row->fechado) );
	$y = $pdf->destaques( $y , utf8_decode(lang('DATA_FECHADO')) , utf8_decode(exibedataHora($detalhes_row->data_fechar)) );
	$y = $pdf->destaques( $y , utf8_decode(lang('RESPONSAVEL_VALIDADO')) , utf8_decode($detalhes_row->validado) );
	$y = $pdf->destaques( $y , utf8_decode(lang('DATA_VALIDADO')) , utf8_decode(exibedataHora($detalhes_row->data_validar)) );
	$y = $pdf->destaques( $y , utf8_decode(lang('STATUS')) , utf8_decode(statusCaixaImpressao($detalhes_row->status)) );
	$y = $pdf->destaques( $y , utf8_decode(lang('USUARIO')) , utf8_decode($detalhes_row->usuario) );
	$y = $pdf->destaques( $y , utf8_decode(lang('DATA')) , utf8_decode(exibedataHora($detalhes_row->data)) );
	
	$y = $pdf->minititulo( $y+5 , utf8_decode(lang('VENDAS_TITULO')) );

	$tabela_inicio = $y;
	$linha_inicio = $tabela_inicio + 10;
	$cabecalho=array( 
				 utf8_decode(lang('CODIGO'))    => 20,
				 utf8_decode(lang('CLIENTE'))  => 70,
				 utf8_decode(lang('VALOR'))  => 30,
				 utf8_decode(lang('VALOR_DESCONTO'))  => 30,
				 utf8_decode(lang('VALOR_TOTAL'))  => 40 );
				 
	$pdf->definirCols($cabecalho);
	
	$cols=array( utf8_decode(lang('CODIGO'))    => "R",
				 utf8_decode(lang('CLIENTE'))  => "L",
				 utf8_decode(lang('VALOR'))  => "C",
				 utf8_decode(lang('VALOR_DESCONTO'))  => "C",
				 utf8_decode(lang('VALOR_TOTAL'))  => "C" );
				 
	$pdf->addLineFormat($cols);
	$y    = $linha_inicio;
	
	$retorno_row = $faturamento->getVendasCaixa($id_caixa);
	$total = 0;
	$desconto = 0;
	$pago = 0;
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$total += $exrow->valor_total;
			$desconto += $exrow->valor_desconto;
			$pago += $exrow->valor_pago;				   
			$linha=array( 
				 utf8_decode(lang('CODIGO'))    => utf8_decode($exrow->id),
				 utf8_decode(lang('CLIENTE'))  => utf8_decode($exrow->cliente),
				 utf8_decode(lang('VALOR'))  => utf8_decode(moeda($exrow->valor_total)),
				 utf8_decode(lang('VALOR_DESCONTO'))  => utf8_decode(moeda($exrow->valor_desconto)),
				 utf8_decode(lang('VALOR_TOTAL'))  => utf8_decode(moeda($exrow->valor_pago)) );
				 
			$size = $pdf->addLine( $y, $linha );
			$y   += $size + 2;
			if($y > 220) {		
				$tabela_final = $y - 30;
				$tabela_inicio = $inicio;
				$linha_inicio = $tabela_inicio + 10;
				$y    = $linha_inicio;
				$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
				$pdf->AddPage();
				$pdf->addEmpresa( $nome_empresa," ");
							  
				$pdf->titulo( $titulo );
				$pdf->subtitulo($id_caixa,  exibedata($detalhes_row->data_abrir));
			}
		}
		unset($exrow);
		$linha=array( 
				 utf8_decode(lang('CODIGO'))    => "-",
				 utf8_decode(lang('CLIENTE'))  => "-",
				 utf8_decode(lang('VALOR'))  => "-",
				 utf8_decode(lang('VALOR_DESCONTO'))  => "-",
				 utf8_decode(lang('VALOR_TOTAL'))  => "-" );
		$size = $pdf->addLine( $y, $linha );
		$y   += $size + 2;
		$linha=array( 
				 utf8_decode(lang('CODIGO'))    => "-",
				 utf8_decode(lang('CLIENTE'))  => utf8_decode(lang('VALOR_TOTAL')),
				 utf8_decode(lang('VALOR'))  => utf8_decode(moeda($total)),
				 utf8_decode(lang('VALOR_DESCONTO'))  => utf8_decode(moeda($desconto)),
				 utf8_decode(lang('VALOR_TOTAL'))  => utf8_decode(moeda($pago)) );
				 
		$size = $pdf->addLine( $y, $linha );
		$tabela_final = $y-60;
		$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
	}
	
	
	$y = $pdf->minititulo( $y+55 , utf8_decode(lang('PAGAMENTO_LISTA')) );

	$tabela_inicio = $y;
	$linha_inicio = $tabela_inicio + 10;
	$cabecalho=array( 
				 utf8_decode(lang('PAGAMENTO'))    => 95,
				 utf8_decode(lang('VALOR'))  => 95 );
				 
	$pdf->definirCols($cabecalho);
	
	$cols=array( utf8_decode(lang('PAGAMENTO'))    => "L",
				 utf8_decode(lang('VALOR'))  => "L" );
				 
	$pdf->addLineFormat($cols);
	$y    = $linha_inicio;
	
	$retorno_row = $faturamento->getFinanceiroCaixa($id_caixa);
	$pago = 0;
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$pago += $exrow->valor_pago;				   
			$linha=array( 
				 utf8_decode(lang('PAGAMENTO'))    => utf8_decode($exrow->pagamento),
				 utf8_decode(lang('VALOR'))  => utf8_decode(moeda($exrow->valor_pago)) );
				 
			$size = $pdf->addLine( $y, $linha );
			$y   += $size + 2;
			if($y > 220) {
				$tabela_final = $y - 30;
				$tabela_inicio = $inicio;
				$linha_inicio = $tabela_inicio + 10;
				$y    = $linha_inicio;
				$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
				$pdf->AddPage();
				$pdf->addEmpresa( $nome_empresa,"");
							  
				$pdf->titulo( $titulo );
				$pdf->subtitulo($id_caixa,  exibedata($detalhes_row->data_abrir));
			}
		}
		unset($exrow);
		$linha=array( 
				 utf8_decode(lang('PAGAMENTO'))    => "-",
				 utf8_decode(lang('VALOR'))  => "-" );
		$size = $pdf->addLine( $y, $linha );
		$y   += $size + 2;
		$linha=array( 
				 utf8_decode(lang('PAGAMENTO'))  => utf8_decode(lang('VALOR_TOTAL')),
				 utf8_decode(lang('VALOR'))  => utf8_decode(moeda($pago)) );
				 
		$size = $pdf->addLine( $y, $linha );
		$tabela_final = $y-150;
		$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
	}
	$pdf->Output();
?>