<?php
  /**
   * PDF Laboratorio
   *
   * @package SIGE - Sistemas de Gestão
   * @author Geandro Bessa
   * @copyleft 2019
   * @version 1
   */
  define("_VALID_PHP", true);
  
	require_once("impressao_tcpdf.php");
	require_once("init.php");
	
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	
	$retorno_row = null;
	$id_laboratorio = get('id_laboratorio');	
	$id_empresa = get('id_empresa');	
	$nome_laboratorio = ($id_laboratorio) ? getValue('nome', 'cadastro', 'id='.$id_laboratorio) : "-";
	$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y'); 
	$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
	$subtitulo = $dataini.' - '.$datafim;
	$retorno_row = $atendimento->getListaLaboratorioPeriodo($id_laboratorio, $dataini, $datafim, $id_empresa);
	
	$pdf = new Impressao_PDF();
	$pdf->Titulo($nome_laboratorio);
	$pdf->SubTitulo($subtitulo);
	$pdf->HeaderEmpresa('logo-empresa.jpg',$nome_laboratorio,'',$subtitulo);

	// set font
	$pdf->SetFont('helvetica', '', 7, '', false);

	// add a page
	$pdf->AddPage();
		
	ob_start();
		require(BASEPATH . 'pdf_laboratorio_html.php');
		$pdfhtml = ob_get_contents();
	ob_end_clean();
	$pdf->writeHTMLSyle($pdfhtml);
	
	$pdf->Output($nome_laboratorio.".pdf", "I");

?>