<?php
  /**
   * PDF Orçamento
   *
   * @package SIGE - Sistemas de Gestão
   * @author Geandro Bessa
   * @copyleft 2019
   * @version 1
   */
  define("_VALID_PHP", true);
  
	require_once("impressao_tcpdf.php");
	require_once("init.php");
	
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	 
	if (isset($_GET['id_paciente'])) {	 
	
		$data = date('d/m/Y - H:i');
		$id_paciente = get('id_paciente');
		$id_empresa = session('idempresa');
		$atendente = capitalize(session('nomeusuario'));
		$row_empresa = Core::getRowById("empresa", $id_empresa);
		$row_paciente = Core::getRowById("paciente", $id_paciente);
		$retorno_row = $atendimento->getAtendimentosOrcamentoPaciente($row_paciente->id);
		
		$nomeempresa = capitalize($row_empresa->endereco.', '.$row_empresa->numero.' - '.$row_empresa->bairro.' - '.$row_empresa->cidade).'/'.$row_empresa->estado.' - Tel.: '.$row_empresa->telefone;
		
		$nome_paciente = $row_paciente->nome;
		$telefone_paciente = $row_paciente->celular;
		$telefone_paciente .= ($row_paciente->celular and $row_paciente->telefone) ? ' / ' : '';
		$telefone_paciente .= ($row_paciente->telefone) ? $row_paciente->telefone : '';
		
		$pdf = new Impressao_PDF();
		$titulo = 'Orçamento';
		$pdf->titulo($titulo);		
		$pdf->setFooterTexto($nomeempresa);
		$pdf->HeaderCabecalho();
		
		// set font
		$pdf->SetFont('helvetica', '', 9, '', false);

		// add a page
		$pdf->AddPage();
			
		ob_start();
			require(BASEPATH . 'pdf_orcamento_html.php');
			$pdfhtml = ob_get_contents();
		ob_end_clean();
		$pdf->writeHTMLSyle($pdfhtml);
		$pdf->Output("orcamento_".$nome_paciente.".pdf", "I");
	
	} else {
		$pdf = new Impressao_PDF();
		$titulo = 'rascunho';
		$pdf->titulo($titulo);		
		$pdf->AddPage();
		$pdf->rascunho( lang('MSG_ERRO_DOCUMENTO') );
		$pdf->Output("rascunho.pdf", "I");
	}
	

?>