<?php
  /**
   * Imprimir Produção
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
	
	require_once("impressao_header.php");
	require_once("init.php");
	
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	
	$pdf = new PDF_Impressao( 'P', 'mm', 'A4' );
	$pdf->setHeader($core->linha1,$core->linha2,$core->linha3);
	$pdf->tamanho(2);
	
	if (isset($_GET['id_medico'])) {	  
		
		$id_medico = get('id_medico');
		$data_caixa = get('data_caixa');
		$total_repasse = 0;
		$row = Core::getRowById("usuario", $id_medico);
		$pdf->AddPage();
		
		$pdf->Ln(15);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('DATA')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($data_caixa));
		
		$pdf->Ln(5);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('MEDICO')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($row->nome));
		$pdf->Ln(5);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('CPF')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($row->cpf));
		$pdf->Ln(5);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('BANCO')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($row->banco));
		$pdf->Ln(5);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('CODIGO')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($row->codigo));
		$pdf->Ln(5);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('AGENCIA')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($row->agencia));
		$pdf->Ln(5);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('CONTA')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("55");
		$pdf->Cell(0, 10, utf8_decode($row->conta));
		
		$pdf->Ln(20);
		$pdf->SetFont('arial', 'B', $pdf->tamanho);
		$pdf->SetX("10");
		$pdf->Cell(0, 10, utf8_decode(lang('PACIENTE_TITULO')), 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		
		$pdf->Ln(10);
		$row_procedimentos = $atendimento->getAgendaRealizada($data_caixa, $id_medico);
		if($row_procedimentos) {
			foreach ($row_procedimentos as $exrow) {
				$total_repasse += $exrow->valor_repasse;
				$pdf->SetX("10");
				$pdf->Cell(0,10,exibeHora($exrow->data_agenda),0,0,'L');
				$pdf->SetX("25");
				$pdf->Cell(0,10,$exrow->paciente,0,0,'L');
				$pdf->SetX("110");
				$pdf->MultiCell(45, 5,$exrow->procedimento, 0, 'L', 0, 0, '', '', true);
				$pdf->SetX("175");
				$pdf->Cell(0,10,moeda($exrow->valor_repasse),0,0,'L');
				$pdf->Ln(5);
			}
			unset($exrow);
		}
		
		$pdf->Ln(10);
		$pdf->SetFont('arial', 'B', $pdf->tamanho-1);
		$pdf->SetX("10");
		$pdf->Cell(35, 10, utf8_decode(lang('VALOR_TOTAL')).":", 0, 0, 'L');
		$pdf->SetFont('arial', '', $pdf->tamanho-2);
		$pdf->SetX("35");
		$pdf->Cell(0, 10, utf8_decode(moeda($total_repasse)));
	
		$pdf->assinatura($row->nome);
	} else {		
		$pdf->AddPage();
		$pdf->rascunho( lang('MSG_ERRO_MEDICO_SELECIONADO') );
	}
	
	$pdf->Output();
?>