<?php
  /**
   * Imprimir despesas
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
   
   //TOTAL DO CABECALHO DEVE SER = 277 PARA PAGINA Landscape
   //TOTAL DO CABECALHO DEVE SER = 190 PARA PAGINA Retrait
	
	require_once("impressao.php");
	require_once("init.php");
	
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	$tipo_pagamento = (get('tipo_pagamento')) ? get('tipo_pagamento') : 0; 
	$id_banco = (get('id_banco')) ? get('id_banco') : 0; 
	$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y', strtotime('-15 days')); 
	$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
	
	$titulo = utf8_decode(lang('FINANCEIRO_RECEITAS'));	
	$inicio = 35;
	
	$nome_empresa = $core->empresa;
  
	$pdf = new PDF_Impressao( 'L', 'mm', 'A4' );
	$pdf->AddPage();
	$pdf->setRodape();
	$pdf->tamanho(-2);
	$pdf->addEmpresa( $nome_empresa,$dataini,$datafim);
	
	$pdf->subtitulo($titulo, date('d/m/Y'), 6);
	//$pdf->rascunho( "RASCUNHO" );

	$tabela_inicio = $inicio;
	$linha_inicio = $tabela_inicio + 10;
	$cabecalho=array( 
				 utf8_decode(lang('DATA_CREDITO'))    => 27,
				 utf8_decode(lang('BANCO'))  => 40,
				 utf8_decode(lang('DESCRICAO'))  => 100,
				 utf8_decode(lang('PLANO_CONTAS'))  => 50,
				 utf8_decode(lang('DATA_TRANSACAO'))  => 30,
				 utf8_decode(lang('VALOR_PAGO'))  => 30);
				 
	$pdf->definirCols($cabecalho, "C", true, 1);
	
	$cols=array( utf8_decode(lang('DATA_CREDITO'))    => "L",
				 utf8_decode(lang('BANCO'))  => "L",
				 utf8_decode(lang('DESCRICAO'))  => "L",
				 utf8_decode(lang('PLANO_CONTAS'))  => "L",
				 utf8_decode(lang('DATA_TRANSACAO'))  => "L",
				 utf8_decode(lang('VALOR_PAGO'))  => "L");
				 
	$pdf->addLineFormat($cols);
	$y    = $linha_inicio;
	
	$retorno_row = $faturamento->getReceitas($dataini, $datafim, $id_banco, $tipo_pagamento);
	$total = 0;
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$total += $exrow->valor_pago;
											
			if(trim($exrow->descricao) != ''){
				$descricao = $exrow->descricao;
			} elseif($exrow->tipo == 0){
				$descricao = 'TRANSFERENCIA ENTRE BANCO';
			} elseif($exrow->tipo == 1) {
				$descricao = $exrow->pagamento.' - CAIXA ID:'.$exrow->id_caixa;
			} else {
				$nome = ($exrow->id_cliente) ? ' - '.getValue("nome","cliente","id = '".$exrow->id_cliente."'") : "";
				$descricao = $exrow->pagamento.$nome;
			}			   
			$linha=array( 
				 utf8_decode(lang('DATA_CREDITO'))    => utf8_decode(exibedata($exrow->data_recebido)),
				 utf8_decode(lang('BANCO'))  => utf8_decode($exrow->banco),
				 utf8_decode(lang('DESCRICAO'))  => utf8_decode($descricao),
				 utf8_decode(lang('PLANO_CONTAS'))  => utf8_decode($exrow->conta),
				 utf8_decode(lang('DATA_TRANSACAO'))  => utf8_decode(exibedata($exrow->data_pagamento)),
				 utf8_decode(lang('VALOR_PAGO'))  => utf8_decode(moeda($exrow->valor_pago)) );
				 
			$size = $pdf->addLine( $y, $linha, false, 1 );
			$y   += $size + 2;
			if($y > 180) {		
				$tabela_final = $y - 30;
				$tabela_inicio = $inicio;
				$linha_inicio = $tabela_inicio + 10;
				$y    = $linha_inicio;
				$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
				$pdf->AddPage();
				$pdf->addEmpresa( $nome_empresa,$dataini,$datafim);
				$pdf->subtitulo($titulo, date('d/m/Y'), 6);
			}
		}
		$linha=array( 
			utf8_decode(lang('DATA_CREDITO'))    => '',
			utf8_decode(lang('BANCO'))  => '',
			utf8_decode(lang('DESCRICAO'))  => '',
			utf8_decode(lang('PLANO_CONTAS'))  => '',
			utf8_decode(lang('DATA_TRANSACAO'))  => utf8_decode(lang('TOTAL')),
			utf8_decode(lang('VALOR_PAGO'))  => utf8_decode(moeda($total)) );
					 
		$size = $pdf->addLine( $y+2, $linha, false );
		
		unset($exrow);
		$tabela_final = $y-28;
		$pdf->addCols( $tabela_inicio , $tabela_final , $cabecalho);
	}
	$pdf->Output();
?>