<?php
 /**
   * PDF - Recibo
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
  define('_VALID_PHP', true);
  define('FPDF_FONTPATH', 'fpdf/font/');
  
  require_once("init.php");
  require_once('impressao_recibo.php');
  
  if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	  
	if (isset($_GET['id_receita'])) {	 
	
		$id = get('id_receita');
		$codigo = 'R'.$id;
		$row = Core::getRowById("receita", $id);
		$row_empresa = Core::getRowById("empresa", $row->id_empresa);
		$data_pagamento = exibedataHora($row->data_pagamento);
		$valor_pago = moeda($row->valor_pago);
		$id_atendimento = getValue('id_atendimento', 'paciente_financeiro', 'id='.$row->id_pagamento);
		$id_tabela = getValue('id_tabela', 'paciente_financeiro', 'id='.$row->id_pagamento);
		$tipopagamento = getValue('tipo', 'tipo_pagamento', 'id='.$row->tipo);
		$id_medico = getValue('id_medico', 'atendimento', 'id='.$id_atendimento);
		$row_medico = Core::getRowById("usuario", $id_medico);
		$data_agenda = getValue('data_agenda', 'atendimento', 'id='.$id_atendimento);
		$procedimento = getValue('procedimento', 'tabela', 'id='.$id_tabela);
		$atendente = $row->usuario_caixa;
	
	} elseif(isset($_GET['id_financeiro'])) {
	
		$id = get('id_financeiro');
		$codigo = 'F'.$id;
		$row = Core::getRowById("paciente_financeiro", $id);
		$row_empresa = Core::getRowById("empresa", $row->id_empresa);
		$data_pagamento = exibedataHora($row->data_pagamento);
		$valor_pago = moeda($row->valor_pago);
		$id_atendimento = $row->id_atendimento;
		$tipopagamento = getValue('tipo', 'tipo_pagamento', 'id='.$row->tipo);
		$id_medico = getValue('id_medico', 'atendimento', 'id='.$row->id_atendimento);
		$row_medico = Core::getRowById("usuario", $id_medico);
		$data_agenda = getValue('data_agenda', 'atendimento', 'id='.$row->id_atendimento);
		$procedimento = getValue('procedimento', 'tabela', 'id='.$row->id_tabela);
		$atendente = $row->usuario_caixa;	
	}
  
  $nome_empresa = $core->empresa;
  $razao_empresa = $row_empresa->razao_social;
  $dados1_empresa = $row_empresa->endereco.", ".$row_empresa->numero;
  $dados2_empresa = $row_empresa->bairro." - ".$row_empresa->cidade;
  $dados3_empresa = $row_empresa->telefone;
  $dados3_empresa .= ($row_empresa->celular) ? ' - '.$row_empresa->celular : '';
  
  $data_impressao = date('d/m/Y H:i:s');

/*
 * construtor da classe, que permite que seja definido o formato da pagina
 * P=Retrato, mm =tipo de medida utilizada no casso milimetros,
 * tipo de folha = 80 x 80 mm
 * tipo de folha = 58 x 80 mm (quando o ID_ORIGEM (configurações) igual a 58)
 */

$formatorecibo = array(80,280);
$pdf = new PDF_Impressao_Recibo('P', 'mm', $formatorecibo);
//Define as margens esquerda, superior e direita.
$pdf->SetMargins(5, 5, 5);
//define a fonte a ser usada, estilo e tamanho
$pdf->SetFont('arial', '', 10);
//define o titulo
$pdf->SetTitle("Recibo");
//assunto
$pdf->SetSubject($nome_empresa);
// posicao vertical no caso -1.. e o limite da margem
$pdf->SetY("-1");

//EXIBINDO DADOS DA EMPRESA
$pdf->SetFont('arial', 'B', 11);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode($nome_empresa));
$pdf->Ln(5);
$pdf->SetFont('arial', '', 9);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(substr($razao_empresa, 0,35)));
$pdf->Ln(4);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(substr($dados1_empresa, 0,35)));
$pdf->Ln(4);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(substr($dados2_empresa, 0,35)));
$pdf->Ln(4);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(substr($dados3_empresa, 0,35)));
$pdf->Ln(2);
$pdf->SetFont('arial', '', 10);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode("___________________________________"));

//EXIBINDO DADOS DA VENDA
$pdf->Ln(5);
$pdf->SetFont('arial', '', 8);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(lang('CODIGO').":"));
$pdf->SetFont('arial', 'B', 8);
$pdf->SetX("18");
$pdf->Cell(0, 10, utf8_decode($codigo));
$pdf->SetFont('arial', '', 8);
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode(lang('DATA').":"));
$pdf->SetFont('arial', 'B', 8);
$pdf->SetX("40");
$pdf->Cell(0, 10, utf8_decode(exibedataHora($data_agenda)));

//EXIBINDO DADOS DO CLIENTE
if($row->id_paciente) {
	$row_paciente = Core::getRowById("paciente", $row->id_paciente);
	$endereco = $row_paciente->endereco.','.$row_paciente->numero.' '.	$row_paciente->complemento;
	$endereco2 = $row_paciente->bairro.' - '.$row_paciente->cidade;
	$pdf->Ln(4);
	$pdf->SetFont('arial', '', 7);
	$pdf->SetX("5");
	$pdf->Cell(0, 10, utf8_decode(lang('NOME').":"));
	$pdf->SetX("20");
	$pdf->Cell(0, 10, utf8_decode(substr(capitalize($row_paciente->nome), 0,40)));
	$pdf->Ln(4);
	$pdf->SetFont('arial', '', 7);
	$pdf->SetX("5");
	$pdf->Cell(0, 10, utf8_decode(lang('CPF').":"));
	$pdf->SetX("20");
	$pdf->Cell(0, 10, utf8_decode(formatar_cpf_cnpj($row_paciente->cpf)));
	$pdf->Ln(4);
	$pdf->SetFont('arial', '', 7);
	$pdf->SetX("5");
	$pdf->Cell(0, 10, utf8_decode("Dt.Nasc.:"));
	$pdf->SetX("20");
	$pdf->Cell(0, 10, utf8_decode(exibedata($row_paciente->data_nasc).' - '.idade($row_paciente->data_nasc)));
	$pdf->Ln(4);
	$pdf->SetX("5");
	$pdf->Cell(0, 10, utf8_decode(lang('ENDERECO').":"));
	$pdf->SetFont('arial', '', 7);
	$pdf->SetX("20");
	$pdf->Cell(0, 10, utf8_decode(substr(capitalize($endereco), 0,45)));
	$pdf->Ln(4);
	$pdf->SetX("20");
	$pdf->Cell(0, 10, utf8_decode(substr(capitalize($endereco2), 0,45)));
}
$pdf->Ln(2);
$pdf->SetFont('arial', '', 10);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode("___________________________________"));
$pdf->Ln(5);
$pdf->SetFont('arial', 'B', 8);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(lang('INFORMACOES_ATENDIMENTO')));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->SetFont('arial', '', 7);
$pdf->Cell(0, 10, utf8_decode((sanitize(lang('CODIGO')).":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode($id_atendimento));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((lang('PROCEDIMENTO').":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode(substr($procedimento, 0,25)));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((lang('DATA_ATENDIMENTO').":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode(exibedata($data_agenda)));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((sanitize(lang('PROFISSIONAL')).":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode($row_medico->nome));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((lang('REGISTRO_PROF').":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode($row_medico->crm));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(lang('CPF').":"));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode(($row_medico->cpf)));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((lang('VALOR_PAGO').":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode($valor_pago));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((lang('PAGAMENTO').":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode($tipopagamento));
$pdf->Ln(5);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode((lang('DATA_PAGAMENTO').":")));
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode($data_pagamento));
$pdf->Ln(2);
$pdf->SetFont('arial', '', 10);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode("___________________________________"));

$pdf->Ln(5);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("5");
$pdf->Cell(0, 10, utf8_decode(lang('IMPRESSO_EM').$data_impressao." - ".$atendente));

/*
 * IMPRIMIR A SAIDA DO ARQUIVO
 * nome do arquivo
 * I: envia o arquivo diretamente para o browser,
 * Se o plug-in estiver instalado ele serao usado.
 * mais opcoes no final do artigo ou visite o manual fpdf.
 */
 $pdf->AutoPrint(true); 
 $pdf->Output("recibo_".$id.".pdf", "I");

?>
