<?php
 /**
   * PDF - Recibo
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
  define('_VALID_PHP', true);
  define('FPDF_FONTPATH', 'fpdf/font/');
  
  require_once("init.php");
  require_once("fpdf/fpdf.php");
  
  if (!$usuario->is_Todos())
	  redirect_to("login.php");
  
  $id_despesa = get('id_despesa');
  $row_despesa = $despesa->detalhesDespesa($id_despesa);
  $row_empresa = Core::getRowById("empresa", 1);
  $data_pagamento = ($row_despesa->data_pagamento == '0000-00-00 00:00:00') ? exibedataHora($row_despesa->data_vencimento) : exibedataHora($row_despesa->data_pagamento);
  $nome_fornecedor = $row_despesa->cadastro;
  $descricao = $row_despesa->descricao;
  $valor_pago = moeda($row_despesa->valor);
  
  $nome_empresa = $core->empresa;
  $razao_empresa = $row_empresa->nome;
  $dados1_empresa = $row_empresa->endereco.", ".$row_empresa->numero." - ".$row_empresa->bairro;
  $dados2_empresa = $row_empresa->cidade." - ".$row_empresa->telefone.", ".$row_empresa->cnpj;
  $dados2_empresa .= ($row_empresa->cnpj) ? ", ".formatar_cpf_cnpj($row_empresa->cnpj) : "";
  
  $data_impressao = date('d/m/Y H:i:s');

/*
 * construtor da classe, que permite que seja definido o formato da pagina
 * P=Retrato, mm =tipo de medida utilizada no casso milimetros,
 * tipo de folha = 80 x 80 mm
 */

$formatoenvelope = array(90,180);
$pdf = new FPDF("P", "mm", $formatoenvelope);
//Define as margens esquerda, superior e direita.
$pdf->SetMargins(5, 5, 5);
//define a fonte a ser usada, estilo e tamanho
$pdf->SetFont('arial', '', 10);
//define o titulo
$pdf->SetTitle("Recibo");
//assunto
$pdf->SetSubject("SIGE - ".$nome_empresa);
// posicao vertical no caso -1.. e o limite da margem
$pdf->SetY("-1");

//EXIBINDO DADOS DA EMPRESA
$pdf->SetFont('arial', 'B', 8);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode($nome_empresa));
$pdf->Ln(5);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode($razao_empresa));
$pdf->Ln(4);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode($dados1_empresa));
$pdf->Ln(4);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode($dados2_empresa));
$pdf->Ln(2);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode("_______________________________________________________________"));

//EXIBINDO DADOS DO PAGAMENTO
$pdf->Ln(5);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode(lang('CODIGO')));
$pdf->SetFont('arial', 'B', 9);
$pdf->SetX("10");
$pdf->Cell(0, 10, utf8_decode($id_despesa));
$pdf->SetFont('arial', '', 7);
$pdf->SetX("30");
$pdf->Cell(0, 10, utf8_decode(lang('DATA')));
$pdf->SetX("45");
$pdf->Cell(0, 10, utf8_decode($data_pagamento));
$pdf->Ln(2);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode("_______________________________________________________________"));

//EXIBINDO DADOS DO CLIENTE
$pdf->Ln(5);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode(lang('NOME')));
$pdf->SetX("10");
$pdf->Ln(5);
$pdf->SetFont('arial', 'B', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode($nome_fornecedor));
$pdf->Ln(8);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode(lang('VALOR_PAGO')));
$pdf->Ln(5);
$pdf->SetFont('arial', 'B', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode($valor_pago));
$pdf->Ln(8);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode(lang('DESCRICAO')));
$pdf->Ln(8);
$pdf->SetFont('arial', 'B', 7);
$pdf->SetX("1");
$pdf->MultiCell(0, 5, utf8_decode($descricao));
$pdf->Ln(10);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode("Assinatura:"));
$pdf->SetX("20");
$pdf->Cell(0, 10, utf8_decode("_____________________________________________________"));


//EXIBINDO OBSERVAÇÕES
$pdf->Ln(5);
$pdf->SetFont('arial', '', 7);
$pdf->SetX("1");
$pdf->Cell(0, 10, utf8_decode(lang('IMPRESSO_EM').$data_impressao));

/*
 * IMPRIMIR A SAIDA DO ARQUIVO
 * nome do arquivo
 * I: envia o arquivo diretamente para o browser,
 * Se o plug-in estiver instalado ele serao usado.
 * mais opcoes no final do artigo ou visite o manual fpdf.
 */
 
 $pdf->Output("recibo_despesa_".$id_despesa, "I");

?>
