<?php
  /**
   * Visualizar Atendimento
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
  define("_VALID_PHP", true);
  
	require_once("init.php");
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	$id = get('id');
	$row = Core::getRowById("atendimento", $id);
	$retorno = 'SEM RETORNO';
	if($row->retorno == 1) {
		$retorno = 'RETORNO DO ATENDIMENTO REALIZADO NO DIA '.exibedata($row->data_retorno);
	} elseif($row->retorno == 2) {
		$data_retorno = ($row->id_retorno > 0) ? getValue('data_agenda', 'atendimento', 'id='.$row->id_retorno) : '';
		$retorno = 'ATENDIMENTO FOI UM RETORNO DO DIA '.exibedataHora($data_retorno);
	} elseif($row->retorno == 9) {
		$retorno = 'ATENDIMENTO TEM UM RETORNO PARA REALIZAR ATÉ O DIA '.exibedata($row->data_retorno);
	}
	
	
?>
<!DOCTYPE html>
<!--[if IE 8]> <html lang="pt-BR" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]> <html lang="pt-BR" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="pt-BR">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>

<!-- Meta -->
<meta charset="utf-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta content="width=device-width, initial-scale=1.0" name="viewport"/>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<meta name="description" content="SIGE - Sistemas de Gestão - VOCÊ NO CONTROLE DA SUA EMPRESA, em qualquer lugar... a qualquer momento!"/>
<meta name="keywords" content="geandro bessa, divulgação online, divulgação, sistemas web, aplicativos, mobile, aplicativos vale do aço, aplicativos ipatinga, sistemas de gestão, sistemas web ipatinga, sistemas ipatinga, sistemas vale do aço, sites ipatinga, sites vale do aço, SIGE, TELECOM, sige, telecom" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="author" content="Geandro Bessa"/>

<!-- Title -->
<title><?php echo lang('ATENDIMENTO').': '.$id;?></title>

<!-- Favicons -->
<link rel="shortcut icon" href="./assets/img/favicon.png">
<link rel="apple-touch-icon" href="./assets/img//favicon_60x60.png">
<link rel="apple-touch-icon" sizes="76x76" href="./assets/img//favicon_76x76.png">
<link rel="apple-touch-icon" sizes="120x120" href="./assets/img//favicon_120x120.png">
<link rel="apple-touch-icon" sizes="152x152" href="./assets/img//favicon_152x152.png">

<!-- BEGIN GLOBAL MANDATORY STYLES -->
<link href="./assets/plugins/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/simple-line-icons/simple-line-icons.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css">
<!-- END GLOBAL MANDATORY STYLES -->
<!-- BEGIN PAGE LEVEL STYLES -->
<link rel="stylesheet" type="text/css" href="./assets/plugins/select2/select2.css"/>
<!-- END PAGE LEVEL SCRIPTS -->
<!-- BEGIN THEME STYLES -->
<link href="./assets/css/components-rounded.css" id="style_components" rel="stylesheet" type="text/css">
<link href="./assets/css/plugins.css" rel="stylesheet" type="text/css">
<link href="./assets/css/layout.css" rel="stylesheet" type="text/css">
<link href="./assets/css/themes/default.css" rel="stylesheet" type="text/css" id="style_color">
<link href="./assets/css/custom.css" rel="stylesheet" type="text/css">

<link rel="stylesheet" type="text/css" href="./assets/plugins/bootstrap-datepicker/css/datepicker3.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/extensions/Scroller/css/dataTables.scroller.min.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/extensions/ColReorder/css/dataTables.colReorder.min.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/plugins/bootstrap/dataTables.bootstrap.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/typeahead/typeahead.css">
<!-- END THEME STYLES -->
</head>
<script Language="JavaScript">
	function Imprimir(){
	window.print();
	window.close();
	}
</Script>
<style type="text/css">
    @media print {
      .noprint { display: none; margin: 30px;}
	  .quebra_pagina {page-break-after:always;}
    }
</style>
<body>
<div class="page-container">
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<div class="row">
					<div class="col-md-12">			
						<div class="portlet light">
							<div class='portlet-title'>
								<div class="caption">
									<i class="fa fa-inbox font-<?php echo $core->primeira_cor;?>"></i>								
									<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTO').": ".$id;?></span>
								</div>
								<div class='actions noprint'>								
									<a class="btn yellow-casablanca hidden-print margin-bottom-5" onclick="javascript:Imprimir();">
									<?php echo lang('IMPRIMIR');?>&nbsp;&nbsp;<i class="fa fa-print"></i>
									</a>
								</div>
							</div>
							<div class="portlet-body">
								<table width="100%">
									<tr>
										<td>
											<table class="table table-bordered table-advance table-condensed">
												<thead>
													<tr>
														<th colspan="2"><?php echo lang('PACIENTE_ATENDIMENTO');?></th>
													</tr>
												</thead>
												<tbody>
													<tr>
														<th><?php echo lang('ATENDIMENTO');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->id;?></td>
													</tr>
													<tr>
														<th><?php echo lang('STATUS');?>:&nbsp;&nbsp;</th>
														<td><?php echo statusAgenda($row->realizado);?></td>
													</tr>
													<?php if($row->id_cancelamento):?>
													<tr class="danger">
														<th><?php echo lang('DATA_AGENDA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_agenda_cancelada).' - '.$row->usuario_agenda;?></td>
													</tr>
													<tr class="danger">
														<th><?php echo lang('DATA_CANCELADO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_cancelamento).' - '.$row->usuario;?></td>
													</tr>
													<tr class="danger">
														<th><?php echo lang('MOTIVO');?>:&nbsp;&nbsp;</th>
														<td><?php echo getValue('cancelamento','cancelamento', 'id='.$row->id_cancelamento);?></td>
													</tr>
													<?php else:?>
													<tr>
														<th><?php echo lang('DATA_AGENDA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_agenda).' - '.$row->usuario_agenda;?></td>
													</tr>
													<?php endif;?>
													<tr>
														<th><?php echo lang('DATA_REALIZADA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_realizada).' - '.$row->usuario_realizada;?></td>
													</tr>
													<?php if($row->id_prontuario):?>
													<tr>
														<th><?php echo lang('PRONTUARIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica(1);?></td>
													</tr>
													<tr>
														<th><?php echo lang('DATA_PRONTUARIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora(getValue('data','paciente_atendimento', 'id='.$row->id_prontuario));?></td>
													</tr>
													<?php else:?>
													<tr>
														<th><?php echo lang('PRONTUARIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica(0);?></td>
													</tr>
													<?php endif;?>
													<tr>
														<th><?php echo lang('CLINICA');?>:&nbsp;&nbsp;</th>
														<td><?php echo empresa($row->id_empresa);?></td>
													</tr>
													<tr>
														<th><?php echo lang('CONSULTORIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo getValue('consultorio','consultorio', 'id='.$row->id_consultorio);?></td>
													</tr>
													<tr>
														<th><?php echo lang('PACIENTE');?>:&nbsp;&nbsp;</th>
														<td><?php echo paciente($row->id_paciente);?></td>
													</tr>
													<tr>
														<th><?php echo lang('MEDICO');?>:&nbsp;&nbsp;</th>
														<td><?php echo medico($row->id_medico);?></td>
													</tr>
													<tr>
														<th><?php echo lang('PROCEDIMENTO');?>:&nbsp;&nbsp;</th>
														<td><?php echo getValue('procedimento','tabela', 'id='.$row->id_tabela);?></td>
													</tr>
													<?php if($row->id_especialidade):?>
													<tr>
														<th><?php echo lang('ESPECIALIDADE');?>:&nbsp;&nbsp;</th>
														<td><?php echo especialidade($row->id_especialidade);?></td>
													</tr>
													<?php endif;?>
													<tr>
														<th><?php echo lang('CONVENIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo convenio($row->id_convenio);?></td>
													</tr>
													<tr>
														<th><?php echo lang('VALOR');?>:&nbsp;&nbsp;</th>
														<td><?php echo moeda($row->valor_tabela);?></td>
													</tr>
													<tr>
														<th><?php echo lang('PAGO');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica($row->pago);?></td>
													</tr>
													<tr>
														<th><?php echo lang('VALOR_PAGO');?>:&nbsp;&nbsp;</th>
														<td><?php echo moeda($row->valor_pago);?></td>
													</tr>
													<tr>
														<th><?php echo lang('DATA_PAGAMENTO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_pagamento).' - '.$row->usuario_pagamento;?></td>
													</tr>
													<tr>
														<th><?php echo lang('VALOR_REPASSE');?>:&nbsp;&nbsp;</th>
														<td><?php echo moeda($row->valor_repasse);?></td>
													</tr>
													<tr>
														<th><?php echo lang('REPASSE');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica($row->repasse);?></td>
													</tr>
													<tr>
														<th><?php echo lang('RETORNO');?>:&nbsp;&nbsp;</th>
														<td><?php echo $retorno;?></td>
													</tr>
													<tr>
														<th><?php echo lang('DATA_CONFIRMADO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_confirmado);?></td>
													</tr>
													<tr>
														<th><?php echo lang('DATA_CHEGADA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_chegada).' - '.$row->usuario_chegada;?></td>
													</tr>
													<tr>
														<th><?php echo lang('DATA_CHAMADA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_chamada);?></td>
													</tr>
													<?php if($row->guia):?>
													<tr class="info">
														<th><?php echo lang('NUMERO_GUIA');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->numero_guia;?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('AUTORIZACAO');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->autorizacao;?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('CID');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->cid;?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('DATA_GUIA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedata($row->data_receber_guia);?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('DATA_VENCIMENTO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedata($row->data_vencimento_guia);?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('DATA_CADASTRO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedata($row->data_guia).' - '.$row->usuario_guia;?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('LOTE');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->id_lote;?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('PAGO');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica($row->pago_lote);?></td>
													</tr>
													<tr class="info">
														<th><?php echo lang('GLOSA');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica($row->id_glosa);?></td>
													</tr>
													<?php endif;?>
													<?php if($row->id_laboratorio):?>
													<tr class="warning">
														<th><?php echo lang('LABORATORIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo cadastro($row->id_laboratorio);?></td>
													</tr>
													<tr class="warning">
														<th><?php echo lang('DATA');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_laboratorio).' - '.$row->usuario_laboratorio;?></td>
													</tr>
													<tr class="warning">
														<th><?php echo lang('PAGO');?>:&nbsp;&nbsp;</th>
														<td><?php echo verifica($row->pago_lab);?></td>
													</tr>
													<tr class="warning">
														<th><?php echo lang('VALOR_PAGO_LAB');?>:&nbsp;&nbsp;</th>
														<td><?php echo moeda($row->valor_pago_lab);?></td>
													</tr>
													<?php endif;?>
													<tr>
														<th><?php echo lang('DATA_CADASTRO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data_cadastro).' - '.$row->usuario_cadastro;?></td>
													</tr>
													<tr>
														<th><?php echo lang('USUARIO');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->usuario;?></td>
													</tr>
													<tr>
														<th><?php echo lang('ULTIMA_MODIFICACAO');?>:&nbsp;&nbsp;</th>
														<td><?php echo exibedataHora($row->data);?></td>
													</tr>
													<tr>
														<th><?php echo lang('OBSERVACAO');?>:&nbsp;&nbsp;</th>
														<td><?php echo $row->observacao;?></td>
													</tr>
												<tbody>
											</table>
										</td>
									</tr>
								</table>
							</div>
						</div>
					</div>
			</div>
		</div>
	</div>
</div>
<div class="quebra_pagina"></div>
<div class="noprint"></div>
</body>
</html>