<?php
  /**
   * Visualizar Caixa Diario
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
  define("_VALID_PHP", true);
  
	require_once("init.php");
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	$data_caixa = get('data_caixa');
	$id_empresa = get('id_empresa');
	$atendimento_row = $gestao->getAtendimentosDiario($data_caixa, $id_empresa);
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta charset="utf-8"/>
<title><?php echo lang('CAIXA_DIARIO')." ".$data_caixa;?></title>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta content="width=device-width, initial-scale=1.0" name="viewport"/>
<meta http-equiv="Content-type" content="text/html; charset=utf-8">
<meta content="Sistemas Divulgação Online" name="description"/>
<meta content="Geandro Bessa" name="author"/>
<link rel="shortcut icon" href="./assets/img/favicon.ico"/>
<!-- BEGIN GLOBAL MANDATORY STYLES -->
<link href="./assets/plugins/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css">
<!-- END GLOBAL MANDATORY STYLES -->
<!-- BEGIN PAGE LEVEL STYLES -->
<link rel="stylesheet" type="text/css" href="./assets/plugins/select2/select2.css"/>
<!-- END PAGE LEVEL SCRIPTS -->
<!-- BEGIN THEME STYLES -->
<link href="./assets/css/components-rounded.css" id="style_components" rel="stylesheet" type="text/css">
<link href="./assets/css/plugins.css" rel="stylesheet" type="text/css">
<link href="./assets/css/layout.css" rel="stylesheet" type="text/css">
<link href="./assets/css/themes/default.css" rel="stylesheet" type="text/css" id="style_color">
<link href="./assets/css/custom.css" rel="stylesheet" type="text/css">

<link rel="stylesheet" type="text/css" href="./assets/plugins/bootstrap-datepicker/css/datepicker3.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/extensions/Scroller/css/dataTables.scroller.min.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/extensions/ColReorder/css/dataTables.colReorder.min.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/plugins/bootstrap/dataTables.bootstrap.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/typeahead/typeahead.css">
<!-- END THEME STYLES -->
</head>
<script Language="JavaScript">
	function Imprimir(){
	window.print();
	window.close();
	}
</Script>
<style type="text/css">
    @media print {
      .noprint { display: none; margin: 30px;}
	  .quebra_pagina {page-break-after:always;}
    }
</style>
<body>
<div class="page-container">
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class='portlet-title'>
							<div class="caption">
								<i class="fa fa-calendar font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CAIXA_DIARIO').' - '.$data_caixa.' - '.$usuario->nomeempresa;?></span>
							</div>
							<div class='actions noprint'>								
								<a class="btn yellow-casablanca hidden-print margin-bottom-5" onclick="javascript:Imprimir();">
								<?php echo lang('IMPRIMIR');?>&nbsp;&nbsp;<i class="fa fa-print"></i>
								</a>
							</div>
						</div>
						<div class="portlet-body">
							<table width="100%">
								<tr>							
									<td width="40%" valign="top">									
										<h4 class="form-section"><?php echo lang('RESUMO');?></h4>
										<table class="table table-bordered table-striped table-condensed table-advance">
											<tbody>
												<tr>
													<td><strong><?php echo lang('IMPRESSO_EM');?></strong></td>
													<td><?php echo date('d/m/Y H:i');?></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('QUANT_CONSULTAS');?></strong></td>
													<td><?php echo $atendimento_row->quant;?></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('TOTAL_CONSULTAS');?></strong></td>
													<td><?php echo moeda($atendimento_row->valor_tabela);?></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('TOTAL_REPASSE');?></strong></td>
													<td><?php echo moeda($atendimento_row->valor_repasse);?></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('MARGEM');?></strong></td>
													<td><?php echo moeda($atendimento_row->valor_tabela-$atendimento_row->valor_repasse);?></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('PERCENTUAL');?></strong></td>
													<td><?php echo fpercentual($atendimento_row->valor_tabela-$atendimento_row->valor_repasse, $atendimento_row->valor_tabela);?></td>
												</tr>
											</tbody>
										</table>
									</td>		
									<td width="5%">										
									</td>					
									<td width="40%" valign="top">									
										<h4 class="form-section"><?php echo lang('CAIXA_MOVIMENTO');?></h4>
										<table class="table table-bordered table-striped table-condensed table-advance">
											<tbody>
											<?php 	
													$total = 0;
														$total_dinheiro = 0;
														$piereceitas = '';
														$retorno_row = $gestao->getCaixasTotalReceitaDiario($data_caixa, $id_empresa);
														if($retorno_row):
														foreach ($retorno_row as $exrow):
														$total += $exrow->valor_total;
														$total_dinheiro += ($exrow->id_tipo == 1) ? $exrow->valor_total : 0;
														$valor = moeda($exrow->valor_total);
														$piereceitas .= "{name: '".$exrow->tipo."', y: ".$exrow->valor_total.", z: '".moeda($exrow->valor_total)."'},";
											?>
												<tr>
													<td><?php echo ($exrow->tipo) ? $exrow->tipo : "-";?></td>
													<td><?php echo $valor;?></td>
												</tr>
											<?php   endforeach;?>
											<?php unset($exrow);
												  endif;
											?>
											<?php 	
													$total_retirada = $gestao->getCaixaTotalRetiradaDiario($data_caixa, $id_empresa);
													if($total_retirada > 0) {
														$total_dinheiro -= $total_retirada;
													}
											?>
												<tr>
													<td><?php echo lang('RETIRADAS_DIA');?></td>
													<td><?php echo " <span class='font-red'>- ".moeda($total_retirada)."</span>";?></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('TOTAL');?></strong></td>
													<td><strong><?php echo moeda($total);?></strong></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('CAIXA_TOTAL');?></strong></td>
													<td><strong><?php echo moeda($total-$total_retirada);?></strong></td>
												</tr>
												<tr>
													<td><strong><?php echo lang('CAIXA_DINHEIRO');?></strong></td>
													<td><strong><?php echo moeda($total_dinheiro);?></strong></td>
												</tr>
											</tbody>
										</table>
									</td>	
								</tr>
							</table>
						</div>
						<br/>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('CAIXA_USUARIO');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('USUARIO');?></strong></th>
										<th><strong><?php echo lang('VALOR');?></strong></th>
										<th><strong><?php echo lang('CAIXA_RETIRADAS');?></strong></th>
										<th><strong><?php echo lang('TOTAL');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$total = 0;
										$retorno_row = $gestao->getCaixasUsuarioDiario($data_caixa, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
											$retirada_caixa = $gestao->getCaixaUsuarioRetirada($data_caixa, $exrow->usuario_caixa, $id_empresa);
											$total += $exrow->valor_total-$retirada_caixa;
								?>
									<tr>
										<td><?php echo strtoupper($exrow->usuario_caixa);?></td>
										<td><?php echo moeda($exrow->valor_total);?></td>
										<td><?php echo moeda($retirada_caixa);?></td>
										<td><?php echo moeda($exrow->valor_total-$retirada_caixa);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td colspan="3"><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo moeda($total);?></strong></td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
						<br/>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('ATENDIMENTOS_COLABORADOR');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('COLABORADOR');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('VALOR_REPASSE');?></strong></th>
										<th><strong><?php echo lang('MARGEM');?></strong></th>
										<th><strong><?php echo lang('PERCENTUAL');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$total_repasse = 0;
										$piefaturamento = '';
										$pieparticipacao = '';
										$percentual = '';
										$colaborador = '';
										$retorno_row = $gestao->getColaboradoresDiario($data_caixa, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$total_repasse += $exrow->valor_repasse;
										$piefaturamento .= "{name: '".$exrow->nome."', y: ".$exrow->valor_repasse.", z: '".moeda($exrow->valor_repasse)."'},";
										$pieparticipacao .= "{name: '".$exrow->nome."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($colaborador) > 0) {
											$colaborador .= ",";
											$percentual .= ",";
										}
										$colaborador .= "'".$exrow->nome."'";
										$valor_percentual = ($exrow->valor_tabela > 0) ? ($exrow->valor_tabela-$exrow->valor_repasse)/ $exrow->valor_tabela*100 : 0;
										$percentual .= $valor_percentual;
								?>
									<tr>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo moeda($exrow->valor_repasse);?></td>
										<td><?php echo moeda($exrow->valor_tabela-$exrow->valor_repasse);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela-$exrow->valor_repasse, $exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td><strong><?php echo moeda($total_repasse);?></strong></td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>	
						<br/>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('CAIXA_CONVENIO');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('NOME');?></strong></th>
										<th><strong><?php echo lang('CONVENIO');?></strong></th>
										<th><strong><?php echo lang('PROCEDIMENTO');?></strong></th>
										<th><strong><?php echo lang('AGENDA');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('STATUS');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$total = 0;
										$retorno_row = $faturamento->getCaixasConvenioData($data_caixa, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
											$total += $exrow->valor_pago;
								?>
									<tr>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
										<td><?php echo $exrow->procedimento;?></td>
										<td><?php echo exibedata($exrow->data_agenda);?></td>
										<td><?php echo decimal($exrow->valor_pago);?></td>
										<td><?php echo statusAgenda($exrow->realizado);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td colspan="4"><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo decimal($total);?></strong></td>
										<td></td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>	
						<br/>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('CAIXA_MOVIMENTO');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('NOME');?></strong></th>
										<th><strong><?php echo lang('CONVENIO');?></strong></th>
										<th><strong><?php echo lang('PROCEDIMENTO');?></strong></th>
										<th><strong><?php echo lang('AGENDA');?></strong></th>
										<th><strong><?php echo lang('PAGAMENTO');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('USUARIO');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$total = 0;
										$retorno_row = $faturamento->getCaixasReceitaData($data_caixa, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
											$valor = ($exrow->inativo == 0) ? $exrow->valor_pago : 0;
											$total += $valor;
								?>
									<tr <?php echo ($exrow->inativo) ? "class='danger'" : "";?>>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
										<td><?php echo $exrow->procedimento;?></td>
										<td><?php echo exibedata($exrow->data_agenda);?></td>
										<td><?php echo ($exrow->inativo) ? 'CANCELADO' : $exrow->tipo;?></td>
										<td><?php echo decimal($valor);?></td>
										<td><?php echo $exrow->usuario;?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td colspan="5"><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo decimal($total);?></strong></td>
										<td></td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>	
						<br/>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('CAIXA_RETIRADAS_DIA');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><?php echo lang('FORNECEDOR');?></th>
										<th><?php echo lang('DESCRICAO');?></th>
										<th><?php echo lang('PLANO_CONTAS');?></th>
										<th><?php echo lang('VALOR');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$total_retirada = 0;
										$retorno_row = $despesa->getCaixaListaRetirada($data_caixa, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
											$total_retirada += $exrow->valor;
								?>
									<tr>
										<td><?php echo $exrow->cadastro;?></td>
										<td><?php echo $exrow->descricao;?></td>
										<td><?php echo $exrow->conta;?></td>
										<td><?php echo moeda($exrow->valor);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td colspan="3"><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo moeda($total_retirada);?></strong></td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>		
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<div class="quebra_pagina"></div>
<div class="noprint"></div>
</body>
</html>