<?php
  /**
   * Visualizar Caixa Mes
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
  define("_VALID_PHP", true);
  
	require_once("init.php");
	if (!$usuario->is_Todos())
	  redirect_to("login.php");
	  
	$mes = get('mes');
	$id_empresa = get('id_empresa');
	$nome_empresa = ($id_empresa) ? getValue('nome', 'empresa', 'id='.$id_empresa) : $usuario->nomeempresa;
	$atendimento_row = $gestao->getAtendimentos($mes, $id_empresa);
	
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta charset="utf-8"/>
<title><?php echo lang('CAIXA_MENSAL')." ".$mes;?></title>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta content="width=device-width, initial-scale=1.0" name="viewport"/>
<meta http-equiv="Content-type" content="text/html; charset=utf-8">
<meta content="Sistemas Divulgação Online" name="description"/>
<meta content="Geandro Bessa" name="author"/>
<link rel="shortcut icon" href="./assets/img/favicon.ico"/>
<!-- BEGIN GLOBAL MANDATORY STYLES -->
<link href="./assets/plugins/font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/bootstrap/css/bootstrap.min.css" rel="stylesheet" type="text/css">
<link href="./assets/plugins/uniform/css/uniform.default.css" rel="stylesheet" type="text/css">
<!-- END GLOBAL MANDATORY STYLES -->
<!-- BEGIN PAGE LEVEL STYLES -->
<link rel="stylesheet" type="text/css" href="./assets/plugins/select2/select2.css"/>
<!-- END PAGE LEVEL SCRIPTS -->
<!-- BEGIN THEME STYLES -->
<link href="./assets/css/components-rounded.css" id="style_components" rel="stylesheet" type="text/css">
<link href="./assets/css/plugins.css" rel="stylesheet" type="text/css">
<link href="./assets/css/layout.css" rel="stylesheet" type="text/css">
<link href="./assets/css/themes/default.css" rel="stylesheet" type="text/css" id="style_color">
<link href="./assets/css/custom.css" rel="stylesheet" type="text/css">

<link rel="stylesheet" type="text/css" href="./assets/plugins/bootstrap-datepicker/css/datepicker3.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/extensions/Scroller/css/dataTables.scroller.min.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/extensions/ColReorder/css/dataTables.colReorder.min.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/datatables/plugins/bootstrap/dataTables.bootstrap.css"/>
<link rel="stylesheet" type="text/css" href="./assets/plugins/typeahead/typeahead.css">
<!-- END THEME STYLES -->
</head>
<script Language="JavaScript">
	function Imprimir(){
	window.print();
	window.close();
	}
</Script>
<style type="text/css">
    @media print {
      .noprint { display: none; margin: 30px;}
	  .quebra_pagina {page-break-after:always;}
    }
</style>
<body>
<div class="page-container">
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class='portlet-title'>
							<div class="caption">
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CAIXA_MENSAL').': '.$mes.' - '.$nome_empresa;?></span>
							</div>
							<div class='actions noprint'>								
								<a class="btn yellow-casablanca hidden-print margin-bottom-5" onclick="javascript:Imprimir();">
								<?php echo lang('IMPRIMIR');?>&nbsp;&nbsp;<i class="fa fa-print"></i>
								</a>
							</div>
						</div>
						<div class="portlet-body">
								<table width="100%">
									<tr>							
										<td width="40%" valign="top">									
											<h4 class="form-section"><?php echo lang('RESUMO');?></h4>
											<table class="table table-bordered table-striped table-condensed table-advance">
												<thead>
													<tr class="disabled">
														<th colspan="3"><strong><?php echo lang('CAIXA_ATENDIMENTO');?></strong></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
														$quantidade_mensal = 0;
														$total_mensal = 0;
														$retorno_row = $gestao->getResumoAtendimentosMensal($mes, $id_empresa);
														if($retorno_row):
															foreach ($retorno_row as $exrow):
																$total_mensal += $exrow->valor;
																$quantidade_mensal += $exrow->quant;
												?>
													<tr>
														<td width="60%"><?php echo statusAgendaPDF($exrow->realizado);?></td>
														<td width="10%"><?php echo $exrow->quant;?></td>
														<td width="30%"><?php echo moeda($exrow->valor);?></td>
													</tr>
												<?php   	endforeach;?>
													<tr>
														<td><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo $quantidade_mensal;?></strong></td>
														<td><strong><?php echo moeda($total_mensal);?></strong></td>
													</tr>
												<?php 	unset($exrow);
														endif;
												?>
												</tbody>
											</table>
											<table class="table table-bordered table-striped table-condensed table-advance">
												
												<thead>
													<tr class="disabled">
														<th colspan="3"><strong><?php echo lang('CAIXA_CONVENIO');?></strong></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
														$quantidade_convenio = 0;
														$total_convenio = 0;
														$retorno_row = $faturamento->getResumoConvenioMes($mes, $id_empresa);
														if($retorno_row):
															foreach ($retorno_row as $exrow):
																$total_convenio += $exrow->valor;
																$quantidade_convenio += $exrow->quant;
												?>
													<tr>
														<td width="60%"><?php echo $exrow->convenio;?></td>
														<td width="10%"><?php echo $exrow->quant;?></td>
														<td width="30%"><?php echo moeda($exrow->valor);?></td>
													</tr>
												<?php   	endforeach;?>
													<tr>
														<td><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo $quantidade_convenio;?></strong></td>
														<td><strong><?php echo moeda($total_convenio);?></strong></td>
													</tr>
												<?php 	unset($exrow);
														endif;
												?>
												</tbody>
											</table>
										</td>		
										<td width="5%">										
										</td>					
										<td width="40%" valign="top">									
											<h4 class="form-section"><?php echo lang('CAIXA_MOVIMENTO');?></h4>
											<table class="table table-bordered table-striped table-condensed table-advance">
												<tbody>
												<?php 	
														$total = 0;
														$total_dinheiro = 0;
														$retorno_row = $gestao->getCaixasTotalReceita($mes, $id_empresa);
														if($retorno_row):
														foreach ($retorno_row as $exrow):
														$total += $exrow->valor_total;
														$total_dinheiro += ($exrow->id_tipo == 1) ? $exrow->valor_total : 0;
														$valor = moeda($exrow->valor_total);
												?>
													<tr>
														<td><?php echo ($exrow->tipo) ? $exrow->tipo : "-";?></td>
														<td><?php echo $valor;?></td>
													</tr>
												<?php   endforeach;?>
												<?php unset($exrow);
													  endif;
												?>
												<?php 	
														$total_retirada = $gestao->getCaixaTotalRetirada($mes, $id_empresa);
														if($total_retirada > 0) {
															$total_dinheiro -= $total_retirada;
														}
												?>
													<tr>
														<td><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total);?></strong></td>
													</tr>
													<tr>
														<td><?php echo lang('RETIRADAS_DIA');?></td>
														<td><?php echo " <span class='font-red'>- ".moeda($total_retirada)."</span>";?></td>
													</tr>
													<tr>
														<td><strong><?php echo lang('CAIXA_TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total-$total_retirada);?></strong></td>
													</tr>
													<tr>
														<td><strong><?php echo lang('CAIXA_DINHEIRO');?></strong></td>
														<td><strong><?php echo moeda($total_dinheiro);?></strong></td>
													</tr>
												</tbody>
											</table>
											<table class="table table-bordered table-striped table-condensed table-advance">
												<tbody>
													<tr>
														<td><span><?php echo lang('CONSULTAS_CONVENIO');?></span></td>
														<td><?php echo $quantidade_convenio;?></td>
														<td><?php echo moeda($total_convenio);?></td>
													</tr>
													<?php $pago = $gestao->getAtendimentosMensalPago($mes, $id_empresa);?>
													<tr>
														<td><span><?php echo lang('CONSULTAS_PAGAS');?></span></td>
														<td><?php echo $pago->quant;?></td>
														<td><?php echo moeda($pago->valor);?></td>
													</tr>
													<?php $parcial = $gestao->getAtendimentosMensalPagoParcial($mes, $id_empresa);?>
													<tr>
														<td><span><?php echo lang('CONSULTAS_PARCIAL');?></span></td>
														<td><?php echo $parcial->quant;?></td>
														<td><?php echo moeda($parcial->valor);?></td>
													</tr>
													<?php $naopago = $gestao->getAtendimentosMensalNaoPago($mes, $id_empresa);?>
													<tr>
														<td><span><?php echo lang('CONSULTAS_NAOPAGAS');?></span></td>
														<td><?php echo $naopago->quant;?></td>
														<td><?php echo moeda($naopago->valor);?></td>
													</tr>
													<tr>
														<td width="50%"><strong><?php echo lang('TOTAL_CONSULTAS');?></strong></td>
														<td width="20%"><strong><?php echo $quantidade_mensal;?></strong></td>
														<td width="30%"><strong><?php echo moeda($total_mensal);?></strong></td>
													</tr>
												</tbody>
											</table>
										</td>	
									</tr>
								</table>
						</div>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('ATENDIMENTOS_COLABORADOR');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('COLABORADOR');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('VALOR_REPASSE');?></strong></th>
										<th><strong><?php echo lang('MARGEM');?></strong></th>
										<th><strong><?php echo lang('PERCENTUAL');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$total_repasse = 0;
										$piefaturamento = '';
										$pieparticipacao = '';
										$percentual = '';
										$colaborador = '';
										$retorno_row = $gestao->getColaboradores($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$total_repasse += $exrow->valor_repasse;
										$piefaturamento .= "{name: '".$exrow->nome."', y: ".$exrow->valor_repasse.", z: '".moeda($exrow->valor_repasse)."'},";
										$pieparticipacao .= "{name: '".$exrow->nome."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($colaborador) > 0) {
											$colaborador .= ",";
											$percentual .= ",";
										}
										$colaborador .= "'".$exrow->nome."'";
										$valor_percentual = ($exrow->valor_tabela > 0) ? ($exrow->valor_tabela-$exrow->valor_repasse)/ $exrow->valor_tabela*100 : 0;
										$percentual .= $valor_percentual;
								?>
									<tr>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo moeda($exrow->valor_repasse);?></td>
										<td><?php echo moeda($exrow->valor_tabela-$exrow->valor_repasse);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela-$exrow->valor_repasse, $exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td><strong><?php echo moeda($total_repasse);?></strong></td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('ATENDIMENTOS_CONVENIO');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('CONVENIO');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('VALOR_REPASSE');?></strong></th>
										<th><strong><?php echo lang('MARGEM');?></strong></th>
										<th><strong><?php echo lang('PERCENTUAL');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$total_repasse = 0;
										$piefaturamentoconvenio = '';
										$pieparticipacaoconvenio = '';
										$percentualconvenio = '';
										$convenio = '';
										$retorno_row = $gestao->getConvenios($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$total_repasse += $exrow->valor_repasse;
										$piefaturamentoconvenio .= "{name: '".$exrow->nome."', y: ".$exrow->valor_repasse.", z: '".moeda($exrow->valor_repasse)."'},";
										$pieparticipacaoconvenio .= "{name: '".$exrow->nome."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($convenio) > 0) {
											$convenio .= ",";
											$percentualconvenio .= ",";
										}
										$convenio .= "'".$exrow->nome."'";
										$valor_percentual = ($exrow->valor_tabela > 0) ? ($exrow->valor_tabela-$exrow->valor_repasse)/ $exrow->valor_tabela*100 : 0;
										$percentualconvenio .= $valor_percentual;
								?>
									<tr>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo moeda($exrow->valor_repasse);?></td>
										<td><?php echo moeda($exrow->valor_tabela-$exrow->valor_repasse);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela-$exrow->valor_repasse, $exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td><strong><?php echo moeda($total_repasse);?></strong></td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('GESTAO_RECEITAS_DIA');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('DATA');?></strong></th>
										<th><strong><?php echo lang('RECEITAS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_receitas = 0;
										$valor_receita = '';
										$data_receita = '';
										$retorno_row = $gestao->getCaixasReceitaDia($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_receitas += $exrow->valor_pago;
										if(strlen($data_receita) > 0) {
											$data_receita .= ",";
											$valor_receita .= ",";
										}
										$data_receita .= "'".$exrow->data."'";
										$valor_receita .= $exrow->valor_pago;
								?>
									<tr>
										<td><?php echo $exrow->data." - (".diasemana($exrow->data, true).")";?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_pago);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_receitas);?></strong></td>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
						<div class="portlet-body">							
							<h4 class="form-section"><?php echo lang('ATENDIMENTOS_DIA');?></h4>
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('DATA');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$valor_pago = '';
										$data = '';
										$retorno_row = $gestao->getAtendimentosDia($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										if(strlen($data) > 0) {
											$data .= ",";
											$valor_pago .= ",";
										}
										$data .= "'".$exrow->data."'";
										$valor_pago .= $exrow->valor_tabela;
								?>
									<tr>
										<td><?php echo $exrow->data." - (".diasemana($exrow->data, true).")";?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>						
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<div class="quebra_pagina"></div>
<div class="noprint"></div>
</body>
</html>