<?php
  /**
   * Webservices: Agenda
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
   
	if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
		http_response_code(200);
	}
	  
	header("Access-Control-Allow-Origin: *");   
	header("Content-Type: application/json; charset=UTF-8");    
	header("Access-Control-Allow-Methods: POST, DELETE, OPTIONS");    
	header("Access-Control-Max-Age: 3600");    
	header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With"); 

	set_time_limit(0);
	ini_set('memory_limit', '-1');
	ini_set('max_execution_time', 6000);
	ini_set('fastcgi_read_timeout', 6000);
	ini_set('default_socket_timeout', 9000);	
	define('_VALID_PHP', true);
	require('../../init.php');
	
try {
	
	$json_string = file_get_contents('php://input');
	$json_array = json_decode($json_string,true);
	$id_medico = 0;
	$id_paciente = 0;
	$status = 0;
	$nome_medico = "";
	$nome_paciente = "";
	$mensagem = "";
	
	if ($json_array) {
		foreach($json_array as $nome_campo => $valor) {
			if($nome_campo == "id_medico")
				$id_medico = $valor;
			if($nome_campo == "id_paciente")
				$id_paciente = $valor;
		}
		if ($id_paciente != 0) {
			$row_agenda = $atendimento->getAgendaPacienteApp($id_paciente);
			if($row_agenda) {
				foreach ($row_agenda as $exrow){
					$nome_paciente = $exrow->paciente;
					if($exrow->realizado == 1) {
						if($exrow->pago == 1 or $exrow->pago == 9) {
							$status = 1;
							if($exrow->guia > 0) {
								if(!$exrow->numero_guia) {
									$status = 12;
								}
							}
						} else {
							$status = 11;
						}
					}elseif($exrow->realizado == 2) {
						$status = 2;
					}elseif($exrow->realizado == 6) {
						$status = 6;
					}elseif($exrow->retorno == 2) {
						$status = 10;
					}elseif($exrow->pago == 1) {
						$status = 4;
					}elseif($exrow->pago == 2) {
						$status = 5;
					}elseif($exrow->realizado == 3) {
						$status = 3;
					}
					if($exrow->realizado == 9) {
						$status = 9;
					}
					$data_agenda = explode(" ", $exrow->data_agenda);
					$data = $data_agenda[0];
					$hora_agenda = explode(":", $data_agenda[1]);
					$hora = $hora_agenda[0].":".$hora_agenda[1];
					$array_agenda[] = array(
						"id_atendimento" => $exrow->id,
						"id_paciente" => $exrow->id_paciente,
						"nome_paciente" => $exrow->paciente,
						"id_medico" => $exrow->id_medico,
						"nome_medico" => $exrow->medico,
						"procedimento" => $exrow->procedimento,
						"observacao" => $exrow->observacao,
						"id_status" => $status,
						"status" => statusAgendaPDF($status),
						"cor_status" => corAgenda($status),
						"data_agenda" => $exrow->data_agenda,
						"data" => $data,
						"hora" => $hora
					);
				}
				$mensagem .= "Sucesso. Retorno da agenda do paciente ".$nome_paciente;
			} else {
				$mensagem .= "Alerta - Nenhum agenda para o paciente encontrada. ";
				$array_agenda = "[]";
			}
		} elseif ($id_medico != 0) {
			$row_agenda = $atendimento->getAgendaMedicoApp($id_medico);
			if($row_agenda) {
				foreach ($row_agenda as $exrow){
					$nome_medico = $exrow->medico;					
					if($exrow->realizado == 1) {
						if($exrow->pago == 1 or $exrow->pago == 9) {
							$status = 1;
							if($exrow->guia > 0) {
								if(!$exrow->numero_guia) {
									$status = 12;
								}
							}
						} else {
							$status = 11;
						}
					}elseif($exrow->realizado == 2) {
						$status = 2;
					}elseif($exrow->realizado == 6) {
						$status = 6;
					}elseif($exrow->retorno == 2) {
						$status = 10;
					}elseif($exrow->pago == 1) {
						$status = 4;
					}elseif($exrow->pago == 2) {
						$status = 5;
					}elseif($exrow->realizado == 3) {
						$status = 3;
					}
					if($exrow->realizado == 9) {
						$status = 9;
					}
					$data_agenda = explode(" ", $exrow->data_agenda);
					$data = $data_agenda[0];
					$hora_agenda = explode(":", $data_agenda[1]);
					$hora = $hora_agenda[0].":".$hora_agenda[1];
					$array_agenda[] = array(
						"id_atendimento" => $exrow->id,
						"id_paciente" => $exrow->id_paciente,
						"nome_paciente" => $exrow->paciente,
						"id_medico" => $exrow->id_medico,
						"nome_medico" => $exrow->medico,
						"procedimento" => $exrow->procedimento,
						"observacao" => $exrow->observacao,
						"id_status" => $status,
						"status" => statusAgendaPDF($status),
						"cor_status" => corAgenda($status),
						"data_agenda" => $exrow->data_agenda,
						"data" => $data,
						"hora" => $hora
					);
				}
				$mensagem .= "Sucesso. Retorno da agenda do medico ".$nome_medico;
			} else {
				$mensagem .= "Alerta - Nenhum agenda para o medico encontrada. ";
				$array_agenda = "[]";
			}
		} else {
			$mensagem .= "Alerta - Medico ou Paciente nao informado. ";
			$array_agenda = "[]";
		}
	} else {
		$mensagem .= "Erro - JSON vazio. ";
		$array_agenda = "[]";
	}
} catch (Exception $e) {
	$mensagem .= "Erro - EXCEÇÃO: ".$e->getMessage();
	$array_agenda = array();
}

$id_medico = intval($id_medico);
$id_paciente = intval($id_paciente);
$jsonRetorno = array(
	"id_medico" => $id_medico,
	"id_paciente" => $id_paciente,
	"nome_medico" => $nome_medico,
	"nome_paciente" => $nome_paciente,
	"agenda" => $array_agenda,
	"mensagem" => $mensagem,
	"json" => $json_string
);
$retorno =  json_encode($jsonRetorno);
echo $retorno;

?>