<?php
  /**
   * Webservices: Login
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
   
	if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
		http_response_code(200);
	}
	  
	header("Access-Control-Allow-Origin: *");   
	header("Content-Type: application/json; charset=UTF-8");    
	header("Access-Control-Allow-Methods: POST, DELETE, OPTIONS");    
	header("Access-Control-Max-Age: 3600");    
	header("Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With"); 	

	set_time_limit(0);
	ini_set('memory_limit', '-1');
	ini_set('max_execution_time', 6000);
	ini_set('fastcgi_read_timeout', 6000);
	ini_set('default_socket_timeout', 9000);	
	define('_VALID_PHP', true);
	require('../../init.php');
	
	
try {
	$json_string = file_get_contents('php://input');
	$json_array = json_decode($json_string,true);
	$id_paciente = 0;
	$id_medico = 0;
	$nivel = 0;
	$retorno = 0;
	$nome_paciente = "";
	$nome_medico = "";
	$usuario = "";
	$senha = "";
	$cpf = "";
	$mensagem = "";
	
	if ($json_string) {
		foreach($json_array as $nome_campo => $valor) {
			if($nome_campo == "usuario")
				$usuario = $valor;	
			if($nome_campo == "senha")
				$senha = $valor;
			if($nome_campo == "cpf")
				$cpf = $valor;
		}
		$nomeusuario = sanitize(strtolower($usuario));
		$nomeusuario = $db->escape($nomeusuario);
		$senha = sanitize(strtolower($senha));
		$cpf = limparCPF_CNPJ($cpf);
		if ($cpf != "") {
			$sql = "SELECT id, id_empresa, nome, telefone, celular FROM paciente WHERE inativo = 0 AND cpf = '" . $cpf . "'";
			$result = $db->query($sql);
			if ($db->numrows($result) == 0) {
				$mensagem .= "Alerta - Paciente não encontrado. ";
				$retorno = 0;
			} else {
				$row = $db->fetch($result);
				$id_paciente = $row->id;
				$id_empresa = $row->id_empresa;
				$nome_paciente = $row->nome;
				$celular = $row->celular;
				$retorno = 1;
			}
		} elseif($usuario != ""){
			$sql = "SELECT id, id_empresa, usuario, nome, celular, senha, nivel, active FROM usuario WHERE active = 'y' AND usuario = '" . $nomeusuario . "'";
			$result = $db->query($sql);
			if ($db->numrows($result) == 0) {
				$mensagem .= "Alerta - Nenhum medico encontrado. ";
				$retorno = 0;
			} else {
				$row = $db->fetch($result);
				$entered_pass = sha1($senha);
				if($row->active == "y" && $entered_pass == $row->senha) {
					$id_medico = $row->id;
					$id_empresa = $row->id_empresa;
					$nome_medico = $row->nome;
					$celular = $row->celular;
					$retorno = 1;
				} else {
					$mensagem .= "Alerta - Medico bloqueado. ";
					$retorno = 0;
				}
			}
		} else {
			$mensagem .= "Erro - USUARIO nao informado.";
		}
	} else {
		$mensagem .= "Erro - JSON vazio. ";
	}
} catch (Exception $e) {
	$mensagem .= "Erro - EXCEÇÃO: ".$e->getMessage();
}

$id_medico = intval($id_medico);
$id_paciente = intval($id_paciente);
$jsonRetorno = array(
	"retorno" => $retorno,
	"id_medico" => $id_medico,
	"id_paciente" => $id_paciente,
	"nome_medico" => $nome_medico,
	"nome_paciente" => $nome_paciente,
	"mensagem" => $mensagem
);
$retorno =  json_encode($jsonRetorno);
echo $retorno;

?>