<?php
  /**
   * Whatsapp agenda
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyleft 2013
   * @version 2
   */
  define("_VALID_PHP", true);
	require_once("init.php");	
?>
<!DOCTYPE html>
<!--[if IE 8]> <html lang="pt-BR" class="ie8 no-js"> <![endif]-->
<!--[if IE 9]> <html lang="pt-BR" class="ie9 no-js"> <![endif]-->
<!--[if !IE]><!-->
<html lang="pt-BR">
<!--<![endif]-->
<!-- BEGIN HEAD -->
<head>

<!-- Meta -->
<meta charset="utf-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta content="width=device-width, initial-scale=1.0" name="viewport"/>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<meta name="description" content="SIGE - Sistemas de Gestão - VOCÊ NO CONTROLE DA SUA EMPRESA, em qualquer lugar... a qualquer momento!"/>
<meta name="keywords" content="geandro bessa, divulgação online, divulgação, sistemas web, aplicativos, mobile, aplicativos vale do aço, aplicativos ipatinga, sistemas de gestão, sistemas web ipatinga, sistemas ipatinga, sistemas vale do aço, sites ipatinga, sites vale do aço, SIGE, TELECOM, sige, telecom" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="author" content="Geandro Bessa"/>

<!-- Title -->
<title>SIGE :: Sistemas de Gestão</title>

<!-- Favicons -->
<link rel="shortcut icon" href="../assets/img/favicon.png">
<link rel="apple-touch-icon" href="../assets/img//favicon_60x60.png">
<link rel="apple-touch-icon" sizes="76x76" href="../assets/img//favicon_76x76.png">
<link rel="apple-touch-icon" sizes="120x120" href="../assets/img//favicon_120x120.png">
<link rel="apple-touch-icon" sizes="152x152" href="../assets/img//favicon_152x152.png">
</head>
<body>
<?php

$data = date('d/m/Y', strtotime('1 days'));
$hora_disparo = date('H:i'); 
$retorno_row = $atendimento->getAtendimentosAgendaTarde($data);
$total = ($retorno_row) ? count($retorno_row) : 0;
$sucesso = 0;
$erro = 0;
echo "-------------------------------------------------------------------------<br/>";	
echo "<strong>Total de registros: [$total].</strong><br/>";	
echo "-------------------------------------------------------------------------<br/>";	
if($retorno_row) {
	foreach ($retorno_row as $exrow) {
		$token_whatsapp = $exrow->whatsapp;
		$medico = $exrow->medico;
		$nome = ($exrow->id_paciente) ? capitalize($exrow->paciente) : '';
		$nomeempresa = $exrow->empresa;
		$data_agenda = limpar($exrow->data_agenda);
		$celular_empresa = limpar($exrow->celular_empresa);
		$hora = $exrow->hora;
		$saudacao = saudacao();	
		$texto = "Olá $nome, $saudacao, tudo bem 😉? \n
Estamos enviando esta mensagem para te avisar que você tem um agendamento amanhã, as *$hora*, com o medico *$medico*.\n
Chegue sempre com 10 minutos de antecedência.\n
*$nomeempresa*\n[$hora_disparo]\n\nDigite:\n*1 -* Para Confirmar\n*2 -* Para Cancelar\n*3 -* Para Alterações, favor entrar em contato pelo link https://api.whatsapp.com/send/?phone=55$celular_empresa&text&type=phone_number&app_absent=0";
		$celular = ($exrow->celular) ? telefoneSMS($exrow->celular) : telefoneSMS($exrow->telefone);
		$mensagem = urlencode($texto);
		$origem = $exrow->id;
		$params = 'cmd=chat&id='.$origem.'&to='.$celular.'@c.us&msg='.$mensagem;
		if($token_whatsapp == '') {
				$erro++;
				echo "Mensagem nao enviada, TOKEN_WHATSAPP não cadastrado.<br/>";
		} elseif($celular) {
			$retorno = enviarURL($token_whatsapp, $params);
			$json_array = json_decode($retorno,true);
			$status = (is_array($json_array) and array_key_exists('status',$json_array)) ? $json_array['status'] : 'OK';
			if($status == 'offline') {
				$erro++;
				echo "Mensagem nao enviada, retorno [offline] para o paciente [$nome].<br/>";
			} else {
				$sucesso++;
				echo "Mensagem enviada para telefone [$celular] [$nome]- Retorno: [$retorno].<br/>";	
			}
		} else {
			$erro++;
			echo "<span style='font-red'> >> ERRO! Mensagem nao enviada, celular não cadastrado para o cliente [$nome].</span><br/>";
		}
	 }
}
echo "-------------------------------------------------------------------------<br/>";	
echo "<strong>Total de sucesso: [$sucesso].</strong><br/>";	
echo "<strong>Total de erro: [$erro].</strong><br/>";	
?>
</body>
</html>