<?php
  /**
   * Gestão
   *
   * @package Sistemas Divulgação Online
   * @author Geandro Bessa
   * @copyright 2013
   * @version 2
   */
  if (!defined("_VALID_PHP"))
      die('Acesso direto a esta classe não é permitido.');
  if (!$usuario->is_Master())
	  redirect_to("login.php");
	  
  $datafiltro = (get('datafiltro')) ? get('datafiltro') : date("m/Y");
  
?>
<script src="./assets/scripts/highcharts.js" type="text/javascript"></script>
<script src="./assets/scripts/highcharts-exporting.js" type="text/javascript"></script>
<script src="./assets/scripts/highcharts-export-data.js" type="text/javascript"></script>
<script src="./assets/css/highcharts.css" type="text/css"></script>
<?php switch(Filter::$acao): case "mapa": 
	$endereco = "";
	$retorno_row = $gestao->getMapa();
	if($retorno_row) {
		foreach ($retorno_row as $exrow){
			$endereco .= "[".$exrow->lat.",".$exrow->lng."],";
		}
		unset($arow);
	}
?>
<script async defer
        src="https://maps.googleapis.com/maps/api/js?key=AIzaSyBBux0Uw6x65y7kJVllyFdCSZMppa20e1A&signed_in=true&callback=initMap"></script>
   <script src="./assets/scripts/markerclusterer.js" type="text/javascript"></script>
<script>
		
		function initMap() {

			var map = new google.maps.Map(document.getElementById('mapa'), {
				zoom: <?php print $core->zoom;?>,
				center: {lat: <?php print $core->lat;?>, lng: <?php print $core->lng;?>},
				mapTypeId: google.maps.MapTypeId.ROADMAP
			});
			var image = {
				url: './assets/img/pin.png',
				anchor: new google.maps.Point(10, 10),
				scaledSize: new google.maps.Size(20, 34)
			};
			var markers = [];
			var enderecos = [
			  <?php print $endereco;?>
			];
			
			for (var i = 0; i < enderecos.length; i++) {
				var local = enderecos[i];
				var marker = new google.maps.Marker({
				icon: image,
				position: {lat: local[0], lng: local[1]}
				});
				markers.push(marker);
			}
			var markerCluster = new MarkerClusterer(map, markers, {imagePath: './assets/img/m'});
		}
    </script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('MARKETING');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('MAPA');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-map-marker font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('MAPA');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<div id="mapa" class="gmap3"></div>
						</div>	
					</div>	
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "financeiro": 
$ano = (get('ano')) ? get('ano') : date('Y');
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=financeiro&ano='+ ano;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('PAINEL_ANALISEANUAL');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("receita", "data_pagamento", "DESC", true);
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php	
	$recebido = '';
	$despesa_pagas = '';
	$lucro = '';
	$mes = '';
	$trecebido = array();
	$treceber = array();
	$tfaturado = array();
	$tdespesa_pagas = array();
	$tdespesa_apagar = array();
	for($i=1;$i<13;$i++) {
		if(strlen($recebido) > 0) {
				$recebido .= ",";
				$despesa_pagas .= ",";
				$lucro .= ",";
				$mes .= ",";
		}
		$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
		$reb = $gestao->getRecebido($mes_ano);
		$recebido .= ($reb) ? $reb : 0;
		$trecebido[$i] = ($reb) ? $reb : 0;
		$areb = $gestao->getReceber($mes_ano);
		$treceber[$i] = ($areb) ? $areb : 0;
		$fat = $gestao->getFaturadoContratos($mes_ano);
		$tfaturado[$i] = ($fat) ? $fat : 0;
		$des_pg = $gestao->getDespesasPagas($mes_ano);
		$despesa_pagas .= ($des_pg) ? $des_pg : 0;
		$tdespesa_pagas[$i] = ($des_pg) ? $des_pg : 0;
		$lucro .= $reb-$des_pg;
		$des_apg = $gestao->getDespesasAPagar($mes_ano);
		$tdespesa_apagar[$i] = ($des_apg) ? $des_apg : 0;
		$mes .= "'".exibeMesAno($mes_ano, false, true)."'";		
	}
?>
<script type="text/javascript">
 $(document).ready(function(){
  var s1 = [<?php print $recebido;?>];
  var s2 = [<?php print $despesa_pagas;?>];
  var s3 = [<?php print $lucro;?>];
  var cat = [<?php print $mes;?>];
  chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                backgroundColor: '#F8F8F8',
				marginTop: 20,
				marginLeft: 80,
                marginBottom: 45,
				zoomType: 'xy'
            },
			credits: {
				enabled: false
			},
            title: {
                text: '',
                x: 0, //center
				y: 10
            },
            xAxis: {
                categories: cat
            },
            yAxis: {
                
				title: {
                    text: null
                },
				labels: {
                    align: 'left',
                    x: -60,
                    y: -3,
                    formatter: function() {
                        return 'R$ ' + Highcharts.numberFormat(this.value, 2, ',', '.');
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            tooltip: {
                formatter: function() {
                        return '<b>'+ this.series.name +'</b><br/>'+
                        this.x +': R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                }
            },
            legend: {
                layout: 'horizontal',
                backgroundColor: '#FFFFFF',
                align: 'left',
                verticalAlign: 'top',
                x: 100,
                y: 10,
                floating: true,
                shadow: true
            },
			plotOptions: {
                column: {
                    pointPadding: 0.2,
                    borderWidth: 0
                }
            },
            series: [{
                name: 'Receitas',
				color: '#3D979D',
				type: 'column',
                data: s1
            }, {
                name: 'Despesas',
				color: '#AA4643',
				type: 'column',
                data: s2
            }, {
                name: 'Lucro',
				color: '#89A54E',
				type: 'spline',
                data: s3
            }]
        }); 
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_ANALISE')." em ".$ano;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div class="note note-info note-bordered">
								<p>
									<?php echo lang('GESTAO_ANALISE_DESCRICAO');?>
								</p>
							</div>
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-table font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('FLUXO_CAIXA')." em ".$ano;?></span>
							</div>
						</div>	
						<!-- INICIO CONTEUDO DA PAGINA -->
						<div class="portlet-body">
							<table class="table table-bordered table-striped table-condensed table-advance">
								<thead>
									<tr>				
										<th>#</th>
										<th>JAN</th>
										<th>FEV</th>
										<th>MAR</th>
										<th>ABR</th>
										<th>MAI</th>
										<th>JUN</th>
										<th>JUL</th>
										<th>AGO</th>
										<th>SET</th>
										<th>OUT</th>
										<th>NOV</th>
										<th>DEZ</th>
										<th><?php echo lang('TOTAL');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 
										$totalfat = 0;
										$totaldespesas = 0;
										$totallucro = 0;
										$tabela = "";										
										$tabela .= "<tr><td>".lang('RECEITAS')."</td>";
										for($i=1;$i<13;$i++){
											$totalfat += $fat = $trecebido[$i];
											$tabela .= "<td>".decimal($fat)."</td>";
										}
										$tabela .= "<td>".moeda($totalfat)."</td>";
										$tabela .= "</tr><tr><td>".lang('DESPESAS')."</td>";
										for($i=1;$i<13;$i++){
											$totaldespesas += $despesas = $tdespesa_pagas[$i];
											$tabela .= "<td>".decimal($despesas)."</td>";
										}
										$tabela .= "<td>".moeda($totaldespesas)."</td>";
										$tabela .= "</tr><tr><td>".lang('LUCRO')."</td>";
										for($i=1;$i<13;$i++){
											$totallucro += $lucro = $trecebido[$i] - $tdespesa_pagas[$i];
											$tabela .= "<td>".decimal($lucro)."</td>";
										}
										$tabela .= "<td>".moeda($totallucro)."</td>";
										$tabela .= "</tr><tr><td>".lang('LUCRATIVIDADE')."</td>";
										for($i=1;$i<13;$i++){
											$lucro = $trecebido[$i] - $tdespesa_pagas[$i];
											$lucratividade = ($trecebido[$i] > 0 ) ? fpercentual($lucro,$trecebido[$i]) : "0,00 %";
											$tabela .= "<td>".$lucratividade."</td>";
										}
										$tabela .= "<td>-</td></tr>";
										echo $tabela;
								?>
								</tbody>
							</table>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-table font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('PAINEL_ANALISEANUAL');?></span>
							</div>
						</div>	
						<!-- INICIO CONTEUDO DA PAGINA -->
						<div class="portlet-body">
							<table class="table table-bordered table-striped table-condensed table-advance">
								<thead>
									<tr>				
										<th>#</th>
										<th><?php echo '< '.$ano;?></th>
										<th>JAN</th>
										<th>FEV</th>
										<th>MAR</th>
										<th>ABR</th>
										<th>MAI</th>
										<th>JUN</th>
										<th>JUL</th>
										<th>AGO</th>
										<th>SET</th>
										<th>OUT</th>
										<th>NOV</th>
										<th>DEZ</th>
										<th><?php echo lang('TOTAL');?></th>
										<th><?php echo $ano.' >';?></th>
									</tr>
								</thead>
								<tbody>
								<?php 
										$tabela = "";
										
										$tabela .= "<tr><td>".lang('RECORRENTE')."</td><td>-</td>";
										$total = 0;	
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$valor_anual = $gestao->getTotalContratoAnual($i);
											$valor_mensal = $gestao->getTotalContratoMensal();
											$valor = $valor_anual+$valor_mensal;
											$total += $valor;
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>-</td></tr>";
										
										$tabela .= "<tr><td>".lang('PREVISAO')."</td><td>-</td>";
										$total = 0;	
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$valor_anual = $gestao->getTotalContratoAnual($i);
											$valor_mensal = $gestao->getTotalContratoMensal();
											$valor_faturado = $gestao->getPrevisaoFaturado($mes_ano);
											$valor = $valor_anual+$valor_mensal+$valor_faturado;
											$total += $valor;
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>-</td></tr>";
										
										$tabela .= "<tr><td>".lang('CONTRATOS_FATURADOS')."</td><td>-</td>";
										$total = 0;	
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$total += $valor = $tfaturado[$i];
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>-</td></tr>";
										
										$tabela .= "<tr><td>(+) ".lang('CONTAS_RECEBIDAS')."</td>";
										$antes = $gestao->getAntesRecebido($ano);
										$total = 0;										
										$tabela .= "<td>".moeda($antes)."</td>";
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$total += $valor = $trecebido[$i];
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>-</td></tr>";							
										
										$tabela .= "<tr><td>(+) ".lang('CONTAS_A_RECEBER')."</td>";
										$antes = $gestao->getReceberAntes($ano);
										$depois = $gestao->getReceberDepois($ano);
										$total = 0;										
										$tabela .= "<td>".moeda($antes)."</td>";
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$total += $valor = $treceber[$i];
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>".moeda($depois)."</td></tr>";
										
										$tabela .= "</tr><tr><td>".lang('PERCENTUAL')."</td><td>-</td>";
										for($i=1;$i<13;$i++){
											$percentual = fpercentual($treceber[$i],$trecebido[$i]+$treceber[$i]);
											$tabela .= "<td>".$percentual."</td>";
										}
										$tabela .= "<td>-</td><td>-</td></tr>";
										
										$tabela .= "<tr><td>(-) ".lang('CONTAS_PAGAS')."</td>";
										$antes = $gestao->getDespesasPagasAntes($ano);
										$total = 0;										
										$tabela .= "<td>".moeda($antes)."</td>";
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$total += $valor = $tdespesa_pagas[$i];
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>-</td></tr>";
										
										$tabela .= "<tr><td>(-) ".lang('CONTAS_A_PAGAR')."</td>";
										$antes = $gestao->getDespesasAPagarAntes($ano);
										$depois = $gestao->getDespesasAPagarDepois($ano);
										$total = 0;										
										$tabela .= "<td>".moeda($antes)."</td>";
										for($i=1;$i<13;$i++){
											$mes_ano = ($i < 10) ? "0".$i."/".$ano : $i."/".$ano; 
											$total += $valor = $tdespesa_apagar[$i];
											$tabela .= "<td>".decimal($valor)."</td>";
										}
										$tabela .= "<td>".moeda($total)."</td><td>".moeda($depois)."</td></tr>";
										
										$tabela .= "</tr><tr><td>".lang('PERCENTUAL')."</td><td>-</td>";
										for($i=1;$i<13;$i++){
											$percentual = fpercentual($tdespesa_apagar[$i],$tdespesa_pagas[$i]+$tdespesa_apagar[$i]);
											$tabela .= "<td>".$percentual."</td>";
										}
										$tabela .= "<td>-</td><td>-</td></tr>";
										
										echo $tabela;
								?>
								</tbody>
							</table>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "despesasano": 
$ano = (get('ano')) ? get('ano') : date('Y');
$mes = (get('mes')) ? get('mes') : '';

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=despesasano&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=despesasmes&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_DESPESAANO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("despesa", "data_pagamento", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
									&nbsp;&nbsp;
									<?php 
												$retorno_row = $gestao->getListaMes("despesa", "data_pagamento", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php
	$tipodespesa = '';
	$retorno_row = $gestao->tipoDespesas($ano);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$tipodespesa .= "['".$exrow->conta."', ".$exrow->valor."],"; 
		}
	}
	unset($exrow);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Despesas</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Despesas',
                data: [
                    <?php print $tipodespesa;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-sign-out font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_DESPESAANO')." em ".$ano;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "despesasmes": 
$ano = (get('ano')) ? get('ano') : '';
$mes = (get('mes')) ? get('mes') : date('m/Y');

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=despesasano&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=despesasmes&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_DESPESAMES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("despesa", "data_pagamento", "DESC", true);
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
									&nbsp;&nbsp;
									<?php 
												$retorno_row = $gestao->getListaMes("despesa", "data_pagamento", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php
	$tipodespesa = '';
	$retorno_row = $gestao->tipoDespesas(false, $mes);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$tipodespesa .= "['".$exrow->conta."', ".$exrow->valor."],"; 
		}
	}
	unset($exrow);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Despesas</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Despesas',
                data: [
                    <?php print $tipodespesa;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-sign-out font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_DESPESAMES')." em ".$mes;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "receitasano": 
$ano = (get('ano')) ? get('ano') : date('Y');
$mes = (get('mes')) ? get('mes') : '';

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=receitasano&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=receitasmes&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_RECEITASANO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("receita", "data_recebido", "DESC", true);
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
									&nbsp;&nbsp;
									<?php 
												$retorno_row = $gestao->getListaMes("receita", "data_recebido", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php
	$tiporeceitas = '';
	$retorno_row = $gestao->tipoReceitas($ano, false);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$tiporeceitas .= "['".$exrow->tipo."', ".$exrow->valor."],"; 
		}
	}
	unset($exrow);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Receitas</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Receitas',
                data: [
                    <?php print $tiporeceitas;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-money font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_RECEITASANO')." em ".$ano;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "receitasmes": 
$ano = (get('ano')) ? get('ano') : '';
$mes = (get('mes')) ? get('mes') : date('m/Y');

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=receitasano&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=receitasmes&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_RECEITASMES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("receita", "data_recebido", "DESC", true);
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
									&nbsp;&nbsp;
									<?php 
												$retorno_row = $gestao->getListaMes("receita", "data_recebido", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php
	$tiporeceitas = '';
	$retorno_row = $gestao->tipoReceitas(false, $mes);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$tiporeceitas .= "['".$exrow->tipo."', ".$exrow->valor."],"; 
		}
	}
	unset($exrow);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Receitas</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Receitas',
                data: [
                    <?php print $tiporeceitas;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-money font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_RECEITASMES')." em ".$mes;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "faturamentoano": 
$ano = (get('ano')) ? get('ano') : date('Y');
$mes = (get('mes')) ? get('mes') : '';

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=faturamentoano&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=faturamentomes&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_FATURAMENTOANO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("profissional_vendas", "data", "DESC", true);
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
									&nbsp;&nbsp;
									<?php 
												$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php
	$tipofaturamento = '';
	$retorno_row = $gestao->tipoFaturamento($ano, false);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$tipofaturamento .= "['".($exrow->tipo)."', ".$exrow->valor."],"; 
		}
	}
	unset($exrow);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Faturamento</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Faturamento',
                data: [
                    <?php print $tipofaturamento;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-usd font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_FATURAMENTOANO')." em ".$ano;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "faturamentomes": 
$ano = (get('ano')) ? get('ano') : '';
$mes = (get('mes')) ? get('mes') : date('m/Y');

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=faturamentoano&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=faturamentomes&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_FATURAMENTOMES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaAno("profissional_vendas", "data", "DESC", true);
										?>
									<select class="select2me form-control input-large" name="ano" id="ano" data-placeholder="<?php echo lang('SELECIONE_ANO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $ano) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
									&nbsp;&nbsp;
									<?php 
												$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php
	$tipofaturamento = '';
	$retorno_row = $gestao->tipoFaturamento(false, $mes);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$tipofaturamento .= "['".tipoVenda($exrow->tipo)."', ".$exrow->valor."],"; 
		}
	}
	unset($exrow);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Faturamento</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Faturamento',
                data: [
                    <?php print $tipofaturamento;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-usd font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_FATURAMENTOMES')." em ".$mes;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "indicadores": ?>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('INDICADORES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->						
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-compass font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('INDICADORES');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<table class="table table-bordered table-striped table-condensed table-advance">
								<tbody>
									<tr>
										<th><?php echo lang('PMV');?></th>
										<td width="60%"><?php echo $pmv = $gestao->getPMV();?></td>
									</tr>
									<tr>
										<th><?php echo lang('AMR');?></th>
										<td width="60%"><?php echo $amv = $gestao->getAMR();?></td>
									</tr>
									<tr>
										<th><?php echo lang('PMR');?></th>
										<td width="60%"><?php echo $pmv + $amv;?></td>
									</tr>
								</tbody>
							</table>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case 'financeiromensal': ?>
<?php $data = (get('data')) ? get('data') : date("m/Y"); ?>
<script type="text/javascript"> 
	  
	$(document).ready(function () {
		$('#mes_ano').click(function() {
			var datafiltro = $("#mes_ano").val();
			window.location.href = 'index.php?do=gestao&acao=financeiromensal&data='+datafiltro;
		});
	});
	
</script>
<!-- INICIO BOX MODAL -->
<!-- INICIO CONTEUDO DA PAGINA -->
<div class='page-container'>
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class='page-head'>
		<div class='container'>
			<!-- INICIO TITULO DA PAGINA -->
			<div class='page-title'>
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('PAINEL_ANALISEMENSAL');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class='page-content'>
		<div class='container'>
			<!-- INICIO DO ROW TABELA -->
			<div class='row'>
				<div class='col-md-12'>
					<!-- INICIO TABELA -->						
					<div class='portlet light'>
						<div class='portlet-title'>
							<div class='caption'>
								<i class='fa fa-usd font-<?php echo $core->primeira_cor;?>'></i>								
								<span class='font-<?php echo $core->primeira_cor;?>'><?php echo lang('PAINEL_ANALISEMENSAL');?></span>
							</div>
						</div>
						<?php 
							 $retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
						?>	
						<div class="portlet-body form">
							<form class="form-inline">
								<div class="form-group">
									<select class="select2me form-control input-large" name="mes_ano" id="mes_ano" data-placeholder="<?php echo lang('SELECIONE_OPCAO');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $data) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
						<div class='portlet-body'>
							<table class='table table-bordered table-striped table-condensed table-advance'>
								<thead>
									<tr>
										<th>#</th>
										<th><?php echo lang('DIA_SEMANA');?></th>
										<th><?php echo lang('RECEITAS');?></th>
										<th><?php echo lang('RECEBIDO');?></th>
										<th><?php echo lang('DESPESAS');?></th>
										<th><?php echo lang('SALDO');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$data_mes = explode("/", $data);
										$total_recebido = 0;
										$total_receita = 0;
										$total_despesa = 0;
										$total_saldo = 0;
										$ultimo = cal_days_in_month(CAL_GREGORIAN, $data_mes[0], $data_mes[1]);
										for($i=1;$i<=$ultimo;$i++):
											$dia = ($i<10) ? "0".$i : $i;
											$diasemana = diasemana($dia."/".$data, true);
											$receber = $gestao->getReceberDia($dia."/".$data);
											$total_receita += $receber;
											$recebido = $gestao->getReceitasDia($dia."/".$data);
											$total_recebido += $recebido ;
											$despesaspagas = $gestao->getDespesasPagasDia($dia."/".$data);
											$total_despesa += $despesaspagas;
											$saldo = $recebido - $despesaspagas;
											$total_saldo += $saldo;
								?>
											<tr>
												<td><?php echo $dia;?></td>
												<td><?php echo $diasemana;?></td>
												<td><?php echo moeda($receber);?></td>
												<td><?php echo moeda($recebido);?></td>
												<td><?php echo moeda($despesaspagas);?></td>
												<td><?php echo moeda($total_saldo);?></td>
											</tr>
								<?php 
										endfor;
								?>
											<tr>
												<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
												<td><strong><?php echo moeda($total_receita);?></strong></td>
												<td><strong><?php echo moeda($total_recebido);?></strong></td>
												<td><strong><?php echo moeda($total_despesa);?></strong></td>
												<td><strong><?php echo moeda($total_saldo);?></strong></td>
											</tr>
								</tbody>
							</table>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "tarefas": ?>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('TAREFA_LISTAR_FINALIZADAS');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->		
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class='fa fa-tasks font-<?php echo $core->primeira_cor;?>'>&nbsp;&nbsp;</i><?php echo lang('TAREFA_LISTAR_FINALIZADAS');?>
							</div>
						</div>
						<div class="portlet-body">
							<table class="table table-bordered table-condensed table-advance dataTable-asc">
								<thead>
									<tr>
										<th>#</th>
										<th><?php echo lang('TAREFA_CRIACAO');?></th>
										<th><?php echo lang('TAREFA_PRAZO');?></th>
										<th><?php echo lang('DATA_FIM');?></th>
										<th><?php echo lang('TITULO');?></th>
										<th><?php echo lang('CONTRATO');?></th>
										<th><?php echo lang('CATEGORIA');?></th>
										<th><?php echo lang('RESPONSAVEL');?></th>
										<th><?php echo lang('ACOES');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$retorno_row = $ticket->getTarefasfinalizadas();
										if($retorno_row):
										foreach ($retorno_row as $exrow):
								?>
									<tr class="<?php echo $exrow->cor;?>">
										<td><?php echo $exrow->controle;?></td>
										<td><?php echo exibedata($exrow->data_criacao);?></td>
										<td><?php echo exibedata($exrow->prazo_entrega);?></td>
										<td><?php echo exibedata($exrow->data_fim_realizada);?></td>
										<td><?php echo $exrow->tarefa;?></td>
										<td><?php echo $exrow->url;?></td>
										<td><?php echo $exrow->categoria;?></td>
										<td><?php echo $exrow->responsavel;?></td>
										<td>
											<a href="index.php?do=gestao&acao=visualizarTarefa&id=<?php echo $exrow->id;?>" class="btn btn-icon-only grey-cascade" title="<?php echo lang('VISUALIZAR').': '.$exrow->tarefa;?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php endforeach;?>
								<?php unset($exrow);
									  endif;?>
								</tbody>
							</table>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "contasabertas": ?>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('FINANCEIRO_TITULO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_CONTASABERTO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
<?php
	$despesa_atrasada = $gestao->getTotalDespesaAtrasada();
	$despesa_pagar = $gestao->getTotalDespesaPagar();
	$receita_atrasada = $gestao->getTotalReceitaAtrasada();
	$receita_pagar = $gestao->getTotalReceitaPagar();
	$gdespesa = "['Despesa atrasada', ".$despesa_atrasada."],['Despesa a pagar', ".$despesa_pagar."]"; 
	$greceida = "['Receita atrasada', ".$receita_atrasada."],['Receita a receber', ".$receita_pagar."]"; 
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Despesas</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Despesas',
                data: [
                    <?php print $gdespesa;?>
                ]
            }]
        });
    });
    
});
</script>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart2',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: '<b>Receitas</b>'
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000',
                        formatter: function() {
                            return '<b>'+ this.point.name +'</b>: '+ ' R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                        }
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Receitas',
                data: [
                    <?php print $greceida;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-question font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_CONTASABERTO');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-6">
										<div id="chart" class="chart"></div>
									</div>
									<div class="col-md-6">
										<div id="chart2" class="chart2"></div>
									</div>
								</div>
							</div>
						</div>
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "curvaabc_trimestral": ?>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('CURVA_ABC_TRIMESTRAL');?></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->
<?php	
	$data = '';
	$nome_procedimento = '';
	$faturamento = '';
	$curva_faturamento_trimestral = '';
	$acumulado_faturamento = 0;
	$i = 0;
	$curvab = true;
	$curvac = true;
	$curva_a_faturamento = 0;
	$curva_b_faturamento = 0;
	$curva_c_faturamento = 0;
	$retorno_row = $gestao->curvaABCTrimestral('faturamento');
	if($retorno_row) {
		foreach ($retorno_row as $exrow){
			$data = exibedata($exrow->data);
			if(strlen($faturamento) > 0) {
					$nome_procedimento .= ",";
					$faturamento .= ",";
					$curva_faturamento_trimestral .= ",";
			}
			$nome_procedimento .= '"'.cleanSanitize($exrow->nome).'"';
			$faturamento .= $exrow->faturamento;
			$acumulado_faturamento += $exrow->faturamento;
			$curva_faturamento_trimestral .= $acumulado_faturamento;
			if($exrow->curva_abc_faturamento == 'B' and $curvab) {
				$curva_a_faturamento = $i;
				$curvab = false;
			}
			if($exrow->curva_abc_faturamento == 'C' and $curvac) {
				$curva_b_faturamento = $i;
				$curvac = false;
			}
			$i++;
		}
		$curva_c_faturamento = $i;
	}
?>
<script type="text/javascript">
 $(document).ready(function(){
  var s1 = [<?php print $faturamento;?>];
  var s2 = [<?php print $curva_faturamento_trimestral;?>];
  var cat = [<?php print $nome_procedimento;?>];
  chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart1',
                backgroundColor: '#F8F8F8',
				marginTop: 20,
				marginLeft: 80,
                marginBottom: 45,
				zoomType: 'xy'
            },
			credits: {
				enabled: false
			},
            title: {
                text: null,
                x: 0, //center
				y: 10
            },
            xAxis: {
                categories: cat,
				labels: {
					enabled: false
				},
				plotBands: [{
					from: 0,
					to: <?php print $curva_a_faturamento;?>,
					color: '#EFFFFF',
					label: {
						text: '<em>Procedimentos A</em>',
						style: {
							color: '#999999'
						},
						y: 180
					}
				}, {
					from: <?php print $curva_a_faturamento;?>,
					to: <?php print $curva_b_faturamento;?>,
					color: '#FFFFEF',
					label: {
						text: '<em>Procedimentos B</em>',
						style: {
							color: '#999999'
						},
						y: 100
					}
				}, {
					from: <?php print $curva_b_faturamento;?>,
					to: <?php print $curva_c_faturamento;?>,
					color: '#FFEFFF',
					label: {
						text: '<em>Procedimentos C</em>',
						style: {
							color: '#999999'
						},
						y: 30
					}
				}]
            },
            yAxis: {
                
				title: {
                    text: null
                },
				labels: {
                    align: 'left',
                    x: -60,
                    y: -3,
                    formatter: function() {
                        return Highcharts.numberFormat(this.value, 2, ',', '.')+ '%';
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
			tooltip: {
				formatter: function () {
					return this.points.reduce(function (s, point) {
						return s + '<br/>' + point.series.name + ': ' +
							Highcharts.numberFormat(point.y, 2, ',', '.') + ' %';
					}, '<b>' + this.x + '</b>');
				},
				shared: true
			},
            legend: {
                layout: 'horizontal',
                backgroundColor: '#FFFFFF',
                align: 'left',
                verticalAlign: 'top',
                x: 100,
                y: 10,
                floating: true,
                shadow: true
            },
			plotOptions: {
				line: {
					lineWidth: 2,
					states: {
						hover: {
							lineWidth: 3
						}
					},
					marker: {
						enabled: false
					}
				}
			},
            series: [{
                name: 'Faturamento',
				color: '#368EE0',
				type: 'column',
                data: s1
            },{
                name: 'Curva ABC Faturamento',
				color: '#2F8417',
				type: 'spline',
                data: s2
            }]
        }); 
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CURVA_ABC_FATURAMENTO').' - Apurado em '.$data;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart1" class="chart"></div>
						</div>
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CURVA_ABC_TRIMESTRAL').' - Apurado em '.$data;?></span>
							</div>
						</div>	
						<!-- INICIO CONTEUDO DA PAGINA -->
						<div class="portlet-body">
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-12">
										<table class='table table-bordered table-striped table-condensed table-advance'>
											<thead>
												<tr>
													<th colspan="4"><?php echo lang('CURVA_ABC_FATURAMENTO');?></th>
												</tr>
												<tr class="info">
													<th><?php echo lang('CLASSIFICACAO');?></th>
													<th><?php echo lang('PERCENTUAL');?></th>
													<th><?php echo lang('QUANTIDADE');?></th>
													<th><?php echo lang('PARTICIPACAO');?></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$total_a = $curva_a_faturamento;
													$total_b = $curva_b_faturamento - $curva_a_faturamento;
													$total_c = $curva_c_faturamento - $curva_b_faturamento;
											?>
														<tr class="success">
															<td><?php echo 'Procedimentos A';?></td>
															<td><?php echo '80%';?></td>
															<td><?php echo $total_a;?></td>
															<td><?php echo fpercentual($total_a,$curva_c_faturamento);?></td>
														</tr>
														<tr class="warning">
															<td><?php echo 'Procedimentos B';?></td>
															<td><?php echo '80% - 95%';?></td>
															<td><?php echo $total_b;?></td>
															<td><?php echo fpercentual($total_b,$curva_c_faturamento);?></td>
														</tr>
														<tr class="danger">
															<td><?php echo 'Procedimentos C';?></td>
															<td><?php echo '95% - 100%';?></td>
															<td><?php echo $total_c;?></td>
															<td><?php echo fpercentual($total_c,$curva_c_faturamento);?></td>
														</tr>
											</tbody>
										</table>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-12">
										<table class='table table-bordered table-striped table-condensed table-advance dataTable-nopage-desc'>
											<thead>
												<tr>
													<th>#</th>
													<th><?php echo lang('PROCEDIMENTO');?></th>
													<th width="70px"><?php echo lang('QUANTIDADE');?></th>
													<th width="90px"><?php echo lang('REPASSE');?></th>
													<th width="90px"><?php echo lang('VALOR');?></th>
													<th width="70px"><?php echo lang('FATURAMENTO');?></th>
													<th width="70px"><?php echo lang('FATURAMENTO');?></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$quant = 0;
													$total_lucro = 0;
													$total_custo = 0;
													$total_valor = 0;
													if($retorno_row):
														foreach ($retorno_row as $exrow):
														$quant += $exrow->quantidade;							
														$lucro = $exrow->valor_atendimento - $exrow->valor_repasse;		
														$total_lucro += $lucro;
														$total_custo += $exrow->valor_repasse;
														$total_valor += $exrow->valor_atendimento;
														$class_faturamento = '';
														if($exrow->curva_abc_faturamento == 'A') {
															$class_faturamento = "class='success'";
														} elseif($exrow->curva_abc_faturamento == 'B') {
															$class_faturamento = "class='warning'";
														} elseif($exrow->curva_abc_faturamento == 'C') {
															$class_faturamento = "class='danger'";
														}
											?>
														<tr>
															<td><?php echo $exrow->faturamento;?></td>
															<td><?php echo $exrow->nome;?></td>
															<td><?php echo nodecimal($exrow->quantidade);?></td>
															<td><?php echo moeda($exrow->valor_repasse);?></td>
															<td><?php echo moeda($exrow->valor_atendimento);?></td>
															<td><?php echo percent($exrow->faturamento);?></td>
															<td <?php echo $class_faturamento;?>><?php echo '#'.$exrow->curva_abc_faturamento;?></td>
														</tr>
											<?php 
														endforeach;
														unset($exrow);
													endif;
											?>
											</tbody>
											<tfoot>
												<tr>
													<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
													<td><strong><?php echo nodecimal($quant);?></strong></td>
													<td><strong><?php echo moeda($total_custo);?></strong></td>
													<td><strong><?php echo moeda($total_valor);?></strong></td>
													<td colspan="2"></td>
												</tr>
											</tfoot>
										</table>
									</div>
								</div>
							</div>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "curvaabc_anual": ?>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('CURVA_ABC_ANUAL');?></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->
<?php	
	$data = '';
	$nome_procedimento = '';
	$faturamento = '';
	$curva_faturamento_trimestral = '';
	$acumulado_faturamento = 0;
	$i = 0;
	$curvab = true;
	$curvac = true;
	$curva_a_faturamento = 0;
	$curva_b_faturamento = 0;
	$curva_c_faturamento = 0;
	$retorno_row = $gestao->curvaABCAnual('faturamento');
	if($retorno_row) {
		foreach ($retorno_row as $exrow){
			$data = exibedata($exrow->data);
			if(strlen($faturamento) > 0) {
					$nome_procedimento .= ",";
					$faturamento .= ",";
					$curva_faturamento_trimestral .= ",";
			}
			$nome_procedimento .= '"'.cleanSanitize($exrow->nome).'"';
			$faturamento .= $exrow->faturamento;
			$acumulado_faturamento += $exrow->faturamento;
			$curva_faturamento_trimestral .= $acumulado_faturamento;
			if($exrow->curva_abc_faturamento == 'B' and $curvab) {
				$curva_a_faturamento = $i;
				$curvab = false;
			}
			if($exrow->curva_abc_faturamento == 'C' and $curvac) {
				$curva_b_faturamento = $i;
				$curvac = false;
			}
			$i++;
		}
		$curva_c_faturamento = $i;
	}
?>

<script type="text/javascript">
 $(document).ready(function(){
  var s1 = [<?php print $faturamento;?>];
  var s2 = [<?php print $curva_faturamento_trimestral;?>];
  var cat = [<?php print $nome_procedimento;?>];
  chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart1',
                backgroundColor: '#F8F8F8',
				marginTop: 20,
				marginLeft: 80,
                marginBottom: 45,
				zoomType: 'xy'
            },
			credits: {
				enabled: false
			},
            title: {
                text: null,
                x: 0, //center
				y: 10
            },
            xAxis: {
                categories: cat,
				labels: {
					enabled: false
				},
				plotBands: [{
					from: 0,
					to: <?php print $curva_a_faturamento;?>,
					color: '#EFFFFF',
					label: {
						text: '<em>Procedimentos A</em>',
						style: {
							color: '#999999'
						},
						y: 180
					}
				}, {
					from: <?php print $curva_a_faturamento;?>,
					to: <?php print $curva_b_faturamento;?>,
					color: '#FFFFEF',
					label: {
						text: '<em>Procedimentos B</em>',
						style: {
							color: '#999999'
						},
						y: 100
					}
				}, {
					from: <?php print $curva_b_faturamento;?>,
					to: <?php print $curva_c_faturamento;?>,
					color: '#FFEFFF',
					label: {
						text: '<em>Procedimentos C</em>',
						style: {
							color: '#999999'
						},
						y: 30
					}
				}]
            },
            yAxis: {
                
				title: {
                    text: null
                },
				labels: {
                    align: 'left',
                    x: -60,
                    y: -3,
                    formatter: function() {
                        return Highcharts.numberFormat(this.value, 2, ',', '.')+ '%';
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
			tooltip: {
				formatter: function () {
					return this.points.reduce(function (s, point) {
						return s + '<br/>' + point.series.name + ': ' +
							Highcharts.numberFormat(point.y, 2, ',', '.') + ' %';
					}, '<b>' + this.x + '</b>');
				},
				shared: true
			},
            legend: {
                layout: 'horizontal',
                backgroundColor: '#FFFFFF',
                align: 'left',
                verticalAlign: 'top',
                x: 100,
                y: 10,
                floating: true,
                shadow: true
            },
			plotOptions: {
				line: {
					lineWidth: 2,
					states: {
						hover: {
							lineWidth: 3
						}
					},
					marker: {
						enabled: false
					}
				}
			},
            series: [{
                name: 'Faturamento',
				color: '#368EE0',
				type: 'column',
                data: s1
            },{
                name: 'Curva ABC Faturamento',
				color: '#2F8417',
				type: 'spline',
                data: s2
            }]
        }); 
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CURVA_ABC_FATURAMENTO').' - Apurado em '.$data;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart1" class="chart"></div>
						</div>
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CURVA_ABC_ANUAL').' - Apurado em '.$data;?></span>
							</div>
						</div>	
						<!-- INICIO CONTEUDO DA PAGINA -->
						<div class="portlet-body">
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-12">
										<table class='table table-bordered table-striped table-condensed table-advance'>
											<thead>
												<tr>
													<th colspan="4"><?php echo lang('CURVA_ABC_FATURAMENTO');?></th>
												</tr>
												<tr class="info">
													<th><?php echo lang('CLASSIFICACAO');?></th>
													<th><?php echo lang('PERCENTUAL');?></th>
													<th><?php echo lang('QUANTIDADE');?></th>
													<th><?php echo lang('PARTICIPACAO');?></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$total_a = $curva_a_faturamento;
													$total_b = $curva_b_faturamento - $curva_a_faturamento;
													$total_c = $curva_c_faturamento - $curva_b_faturamento;
											?>
														<tr class="success">
															<td><?php echo 'Procedimentos A';?></td>
															<td><?php echo '80%';?></td>
															<td><?php echo $total_a;?></td>
															<td><?php echo fpercentual($total_a,$curva_c_faturamento);?></td>
														</tr>
														<tr class="warning">
															<td><?php echo 'Procedimentos B';?></td>
															<td><?php echo '80% - 95%';?></td>
															<td><?php echo $total_b;?></td>
															<td><?php echo fpercentual($total_b,$curva_c_faturamento);?></td>
														</tr>
														<tr class="danger">
															<td><?php echo 'Procedimentos C';?></td>
															<td><?php echo '95% - 100%';?></td>
															<td><?php echo $total_c;?></td>
															<td><?php echo fpercentual($total_c,$curva_c_faturamento);?></td>
														</tr>
											</tbody>
										</table>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-12">
										<table class='table table-bordered table-striped table-condensed table-advance dataTable-nopage-desc'>
											<thead>
												<tr>
													<th>#</th>
													<th><?php echo lang('PROCEDIMENTO');?></th>
													<th width="70px"><?php echo lang('QUANTIDADE');?></th>
													<th width="90px"><?php echo lang('REPASSE');?></th>
													<th width="90px"><?php echo lang('VALOR');?></th>
													<th width="70px"><?php echo lang('FATURAMENTO');?></th>
													<th width="70px"><?php echo lang('FATURAMENTO');?></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$quant = 0;
													$total_lucro = 0;
													$total_custo = 0;
													$total_valor = 0;
													if($retorno_row):
														foreach ($retorno_row as $exrow):
														$quant += $exrow->quantidade;
														$lucro = $exrow->valor_atendimento - $exrow->valor_repasse;		
														$total_lucro += $lucro;
														$total_custo += $exrow->valor_repasse;
														$total_valor += $exrow->valor_atendimento;
														$class_faturamento = '';
														if($exrow->curva_abc_faturamento == 'A') {
															$class_faturamento = "class='success'";
														} elseif($exrow->curva_abc_faturamento == 'B') {
															$class_faturamento = "class='warning'";
														} elseif($exrow->curva_abc_faturamento == 'C') {
															$class_faturamento = "class='danger'";
														}
											?>
														<tr>
															<td><?php echo $exrow->faturamento;?></td>
															<td><?php echo $exrow->nome;?></td>
															<td><?php echo nodecimal($exrow->quantidade);?></td>
															<td><?php echo moeda($exrow->valor_repasse);?></td>
															<td><?php echo moeda($exrow->valor_atendimento);?></td>
															<td><?php echo percent($exrow->faturamento);?></td>
															<td <?php echo $class_faturamento;?>><?php echo '#'.$exrow->curva_abc_faturamento;?></td>
														</tr>
											<?php 
														endforeach;
														unset($exrow);
													endif;
											?>
											</tbody>
											<tfoot>
												<tr>
													<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
													<td><strong><?php echo nodecimal($quant);?></strong></td>
													<td><strong><?php echo moeda($total_custo);?></strong></td>
													<td><strong><?php echo moeda($total_valor);?></strong></td>
													<td colspan="2"></td>
												</tr>
											</tfoot>
										</table>
									</div>
								</div>
							</div>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "curvaabc_profissional": ?>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('CURVA_ABC_PROFISSIONAL_MESES');?></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->
<?php	
	$data = '';
	$nome_profissional = '';
	$faturamento = '';
	$curva_faturamento = '';
	$acumulado_faturamento = 0;
	$i = 0;
	$curvab = true;
	$curvac = true;
	$curva_a_faturamento = 0;
	$curva_b_faturamento = 0;
	$curva_c_faturamento = 0;
	$retorno_row = $gestao->curvaABCProfissional();
	if($retorno_row) {
		foreach ($retorno_row as $exrow){
			$data = exibedata($exrow->data);
			if(strlen($faturamento) > 0) {
					$nome_profissional .= ",";
					$faturamento .= ",";
					$curva_faturamento .= ",";
			}
			$nome_profissional .= '"'.cleanSanitize($exrow->nome).'"';
			$faturamento .= $exrow->faturamento;
			$acumulado_faturamento += $exrow->faturamento;
			$curva_faturamento .= $acumulado_faturamento;
			if($exrow->curva_abc_faturamento == 'B' and $curvab) {
				$curva_a_faturamento = $i;
				$curvab = false;
			}
			if($exrow->curva_abc_faturamento == 'C' and $curvac) {
				$curva_b_faturamento = $i;
				$curvac = false;
			}
			$i++;
		}
		$curva_c_faturamento = $i;
	}
?>

<script type="text/javascript">
 $(document).ready(function(){
  var s1 = [<?php print $faturamento;?>];
  var s2 = [<?php print $curva_faturamento;?>];
  var cat = [<?php print $nome_profissional;?>];
  chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart1',
                backgroundColor: '#F8F8F8',
				marginTop: 20,
				marginLeft: 80,
                marginBottom: 45,
				zoomType: 'xy'
            },
			credits: {
				enabled: false
			},
            title: {
                text: null,
                x: 0, //center
				y: 10
            },
            xAxis: {
                categories: cat,
				labels: {
					enabled: false
				},
				plotBands: [{
					from: 0,
					to: <?php print $curva_a_faturamento;?>,
					color: '#EFFFFF',
					label: {
						text: '<em>Profissional A</em>',
						style: {
							color: '#999999'
						},
						y: 180
					}
				}, {
					from: <?php print $curva_a_faturamento;?>,
					to: <?php print $curva_b_faturamento;?>,
					color: '#FFFFEF',
					label: {
						text: '<em>Profissional B</em>',
						style: {
							color: '#999999'
						},
						y: 100
					}
				}, {
					from: <?php print $curva_b_faturamento;?>,
					to: <?php print $curva_c_faturamento;?>,
					color: '#FFEFFF',
					label: {
						text: '<em>Profissional C</em>',
						style: {
							color: '#999999'
						},
						y: 30
					}
				}]
            },
            yAxis: {
                
				title: {
                    text: null
                },
				labels: {
                    align: 'left',
                    x: -60,
                    y: -3,
                    formatter: function() {
                        return Highcharts.numberFormat(this.value, 2, ',', '.')+ '%';
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
			tooltip: {
				formatter: function () {
					return this.points.reduce(function (s, point) {
						return s + '<br/>' + point.series.name + ': ' +
							Highcharts.numberFormat(point.y, 2, ',', '.') + ' %';
					}, '<b>' + this.x + '</b>');
				},
				shared: true
			},
            legend: {
                layout: 'horizontal',
                backgroundColor: '#FFFFFF',
                align: 'left',
                verticalAlign: 'top',
                x: 100,
                y: 10,
                floating: true,
                shadow: true
            },
			plotOptions: {
				line: {
					lineWidth: 2,
					states: {
						hover: {
							lineWidth: 3
						}
					},
					marker: {
						enabled: false
					}
				}
			},
            series: [{
                name: 'Faturamento',
				color: '#368EE0',
				type: 'column',
                data: s1
            },{
                name: 'Curva ABC Faturamento',
				color: '#2F8417',
				type: 'spline',
                data: s2
            }]
        }); 
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CURVA_ABC_FATURAMENTO').' - Apurado em '.$data;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart1" class="chart"></div>
						</div>
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CURVA_ABC_PROFISSIONAL_MESES').' - Apurado em '.$data;?></span>
							</div>
						</div>	
						<!-- INICIO CONTEUDO DA PAGINA -->
						<div class="portlet-body">
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-12">
										<table class='table table-bordered table-striped table-condensed table-advance'>
											<thead>
												<tr>
													<th><?php echo lang('CLASSIFICACAO');?></th>
													<th><?php echo lang('PERCENTUAL');?></th>
													<th><?php echo lang('QUANTIDADE');?></th>
													<th><?php echo lang('PARTICIPACAO');?></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$total_a = $curva_a_faturamento;
													$total_b = $curva_b_faturamento - $curva_a_faturamento;
													$total_c = $curva_c_faturamento - $curva_b_faturamento;
											?>
														<tr class="success">
															<td><?php echo 'Profissional A';?></td>
															<td><?php echo '80%';?></td>
															<td><?php echo $total_a;?></td>
															<td><?php echo fpercentual($total_a,$curva_c_faturamento);?></td>
														</tr>
														<tr class="warning">
															<td><?php echo 'Profissional B';?></td>
															<td><?php echo '80% - 95%';?></td>
															<td><?php echo $total_b;?></td>
															<td><?php echo fpercentual($total_b,$curva_c_faturamento);?></td>
														</tr>
														<tr class="danger">
															<td><?php echo 'Profissional C';?></td>
															<td><?php echo '95% - 100%';?></td>
															<td><?php echo $total_c;?></td>
															<td><?php echo fpercentual($total_c,$curva_c_faturamento);?></td>
														</tr>
											</tbody>
										</table>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-md-12">
									<div class="col-md-12">
										<table class='table table-bordered table-striped table-condensed table-advance dataTable-nopage-desc'>
											<thead>
												<tr>
													<th>#</th>
													<th><?php echo lang('PROFISSIONAL');?></th>
													<th width="70px"><?php echo lang('QUANTIDADE');?></th>
													<th width="90px"><?php echo lang('ATENDIMENTO');?></th>
													<th width="90px"><?php echo lang('MEDIA_ATENDIMENTOS');?></th>
													<th width="70px"><?php echo lang('FATURAMENTO');?></th>
													<th width="70px"><?php echo lang('FATURAMENTO');?></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$quant = 0;
													$total_valor = 0;
													if($retorno_row):
														foreach ($retorno_row as $exrow):
														$quant += $exrow->quantidade;
														$total_valor += $exrow->valor_atendimento;
														$class_faturamento = '';
														if($exrow->curva_abc_faturamento == 'A') {
															$class_faturamento = "class='success'";
														} elseif($exrow->curva_abc_faturamento == 'B') {
															$class_faturamento = "class='warning'";
														} elseif($exrow->curva_abc_faturamento == 'C') {
															$class_faturamento = "class='danger'";
														}	
											?>
														<tr>
															<td><?php echo $exrow->faturamento;?></td>
															<td><?php echo $exrow->nome;?></td>
															<td><?php echo $exrow->quantidade;?></td>
															<td><?php echo moeda($exrow->valor_atendimento);?></td>
															<td><?php echo ($exrow->quantidade > 0) ? moeda($exrow->valor_atendimento/$exrow->quantidade) : '-';?></td>
															<td><?php echo percent($exrow->faturamento);?></td>
															<td <?php echo $class_faturamento;?>><?php echo '#'.$exrow->curva_abc_faturamento;?></td>
														</tr>
											<?php 
														endforeach;
														unset($exrow);
													endif;
											?>
											</tbody>
											<tfoot>
												<tr>
													<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
													<td><strong><?php echo $quant;?></strong></td>
													<td><strong><?php echo moeda($total_valor);?></strong></td>
													<td><strong><?php echo ($quant > 0) ? moeda($total_valor/$quant) : '-';?></strong></td>
													<td colspan="2"></td>
												</tr>
											</tfoot>
										</table>
									</div>
								</div>
							</div>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "listamedico":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=listamedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('GESTAO_MEDICO_PRODUCAO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-check-square-o font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_MEDICO_PRODUCAO');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
								<div class="row">
									<div class="col-md-12">		
										<div class="note note-warning">
											<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
										</div>
									</div>	
								</div>
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance dataTable-nopage ">
												<thead>
													<tr>
														<th><?php echo lang('MEDICO');?></th>
														<th><?php echo lang('ATENDIMENTOS');?></th>
														<th><?php echo lang('VALOR');?></th>
														<th><?php echo lang('VALOR_REPASSE');?></th>
														<th><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_valor = 0;
													$total_repasse = 0;
													$retorno_row = $atendimento->getMedicoPeriodo($dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
														
															$array_retorno = $atendimento->getProducao($exrow->id_medico, $dataini, $datafim, $id_empresa);
															$quantidade_producao = $array_retorno['quantidade_producao'];
															if($exrow->salario == 0) {
																$valor_repasse = $array_retorno['valor_producao'];
															} else {
																$valor_repasse = $exrow->salario;	
															}
															$valor_pago = $exrow->valor_tabela;	
															$total_valor += $valor_pago;
															$total_repasse += $valor_repasse;
												?>
													<tr>
														<td><?php echo $exrow->medico;?></td>
														<td><?php echo $exrow->quant;?></td>
														<td><?php echo moeda($valor_pago);?></td>
														<td><?php echo moeda($valor_repasse);?></td>
														<td>
															<a target="_blank" href="index.php?do=gestao&acao=atendimentomedico&id_medico=<?php echo $exrow->id_medico;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>" class="btn btn-icon-only grey-cascade" title="<?php echo lang('VISUALIZAR').': '.$exrow->medico;?>"><i class="fa fa-search"></i></a>
															<a href="javascript:void(0);" class="btn btn-icon-only yellow-casablanca" onclick="javascript:void window.open('pdf_paciente.php?id_medico=<?php echo $exrow->id_medico;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>','<?php echo $exrow->medico;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('IMPRIMIR_PRODUCAO');?>"><i class="fa fa-print"></i></a>
														</td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total_valor);?></strong></td>
														<td><strong><?php echo moeda($total_repasse);?></strong></td>
														<td></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "agendas":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y', strtotime('-7 days')); 
$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=agendas&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('GESTAO_AGENDAS');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-calendar font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_AGENDAS');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance ">
												<thead>
													<tr>
														<th><?php echo lang('MEDICO');?></th>
														<th><?php echo lang('AGENDAS');?></th>
														<th><?php echo lang('ABERTOS');?></th>
														<th><?php echo lang('OCUPACAO');?></th>
														<th><?php echo lang('ATENDIMENTOS');?></th>
														<th><?php echo lang('PENDENTES');?></th>
														<th><?php echo lang('CANCELADOS');?></th>
														<th><?php echo lang('BLOQUEADOS');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_agenda = 0;
													$total_abertos = 0;
													$total_realizados = 0;
													$total_pendentes = 0;
													$total_cancelados = 0;
													$total_bloqueados = 0;
													$retorno_row = $gestao->geAgendasMedicoTotal($dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$total_agenda += $exrow->agendas;
															$total_realizados += $realizados = $gestao->geAtendimentoMedicoRealizados($dataini, $datafim, $exrow->id_medico, $id_empresa);
															$total_pendentes += $pendentes = $gestao->geAtendimentoMedicoPendentes($dataini, $datafim, $exrow->id_medico, $id_empresa);
															$total_cancelados += $cancelados = $gestao->geAtendimentoMedicoCancelados($dataini, $datafim, $exrow->id_medico, $id_empresa);
															$total_bloqueados += $bloqueios = $gestao->geAtendimentoMedicoBloqueio($dataini, $datafim, $exrow->id_medico, $id_empresa);
															$total_abertos += $abertos = $exrow->agendas-$realizados-$pendentes;
												?>
													<tr>
														<td><?php echo $exrow->medico;?></td>
														<td><?php echo nodecimal($exrow->agendas);?></td>
														<td><?php echo $abertos;?></td>
														<td><?php echo fpercentual($realizados, $exrow->agendas);?></td>
														<td><?php echo $realizados;?></td>
														<td><?php echo $pendentes;?></td>
														<td><?php echo $cancelados;?></td>
														<td><?php echo $bloqueios;?></td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<td><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo $total_agenda;?></strong></td>
														<td><strong><?php echo $total_abertos;?></strong></td>
														<td><strong><?php echo fpercentual($total_realizados, $total_agenda);?></strong></td>
														<td><strong><?php echo $total_realizados;?></strong></td>
														<td><strong><?php echo $total_pendentes;?></strong></td>
														<td><strong><?php echo $total_cancelados;?></strong></td>
														<td><strong><?php echo $total_bloqueados;?></strong></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "atendimentomedico":
$id_medico = get('id_medico'); 
$id_convenio = get('id_convenio'); 
$id_empresa = (get('id_empresa')) ? get('id_empresa') : session('idempresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
$nome_medico = getValue('nome', 'usuario', 'id='.$id_medico);
$salario = getValue('salario', 'usuario', 'id='.$id_medico);
$valor_producao = $salario;
$array_retorno = $atendimento->getProducao($id_medico, $dataini, $datafim, $id_empresa, $id_convenio);
$quantidade_producao = $array_retorno['quantidade_producao'];
if($salario == 0) {
	$valor_producao = $array_retorno['valor_producao'];
}
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_convenio = $("#id_convenio").val();
			var id_medico = $("#id_medico").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=atendimentomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_medico = $("#id_medico").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=atendimentomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#id_convenio').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_medico = $("#id_medico").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=atendimentomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#id_medico').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_medico = $("#id_medico").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=atendimentomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#liberartodos').click(function() {
			var lista = '';
			$("input[name='id_atendimento[]']").each(function(){
				lista += ($(this).val()) + ',';
			});
			jQuery.ajax({
				type: 'POST',
				url: 'controller.php',
				data: 'liberarListaProducao=1&lista='+lista,
				success: function( data )
				{
					var response = data.split("#");
					$.bootstrapGrowl(response[0], {
						ele: "body", 
						type: response[1], 
						offset: {
							from: "top",
							amount: 50
						}, 
						align: "left", 
						width: "auto",
						stackup_spacing: 10 
					});
					setTimeout(function(){
						location.reload();
					}, 1000);
				}
			});  
			return false;
		});
		// MODAL SHOW - Pagar produção
		$('#pagarproducao').click(function() {
			var total_repasse = $("#total_repasse").val();
			$("#valor_producao").val(total_repasse);  
			$("#pagar-producao").modal('show');  
			return false;
		});
		// MODAL SHOW - Valor repasse
		if($('a.valorrepasse').length > 0) {
			$('a.valorrepasse').click(function(){
				var id = $(this).attr('id');
				$("#repasse_form").append('<input name="id" type="hidden" value="'+ id +'" />');
				$("#valor-repasse").modal('show');    
				return false;			
			});	
		};
	});
	// ]]>
</script>
<div id="valor-repasse" class="modal fade" role="dialog" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title"><i class="fa fa-usd">&nbsp;&nbsp;</i><?php echo lang('VALOR_REPASSE');?></h4>
			</div>
			<form action="" autocomplete="off" method="post" name="repasse_form" id="repasse_form" class="form-horizontal">
				<div class="modal-body">
					<div class="form-group">
						<label class="control-label col-md-3"><?php echo lang('VALOR_REPASSE');?></label>
						<div class="col-md-6">
							<input type="text" class="form-control moeda" name="valor_repasse">
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-submit <?php echo $core->primeira_cor;?>"><?php echo lang('SALVAR');?></button>
					<button type="button" data-dismiss="modal" class="btn default"><?php echo lang('VOLTAR');?></button>
				</div>
			</form>
		</div>
	</div>
	<?php echo $core->doForm("processarValorRepasse", "repasse_form");?>
</div>
<div id="pagar-producao" class="modal fade" role="dialog" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title"><i class="fa fa-check-square-o">&nbsp;&nbsp;</i><?php echo lang('PAGAR_PRODUCAO');?></span></h4>
			</div>
			<form action="" autocomplete="off" method="post" name="producao_form" id="producao_form" class="form-horizontal">
				<div class="modal-body">
					<div class="row">
						<div class="col-md-12">
							<div class="col-md-12">
								<div class="form-group">
									<label class="control-label col-md-3"></label>
									<label class="font-red col-md-8"><h5><?php echo lang('AVISO_PRODUCAO');?></h5></label>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo lang('MEDICO');?></label>
									<div class="col-md-8">
										<input readonly type="text" class="form-control caps" value="<?php echo $nome_medico;?>">
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo lang('QUANTIDADE');?></label>
									<div class="col-md-8">
										<input readonly type="text" class="form-control caps" id="quantidade_producao" value="<?php echo $quantidade_producao;?>">
									</div>
								</div>
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo lang('VALOR_PAGAR');?></label>
									<div class="col-md-8">
										<input readonly type="text" class="form-control caps" id="valor_producao">
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<input name="id_empresa" type="hidden" value="<?php echo $id_empresa;?>" />
				<input name="id_convenio" type="hidden" value="<?php echo $id_convenio;?>" />
				<input name="nome_medico" type="hidden" value="<?php echo $nome_medico;?>" />
				<input name="id_medico" type="hidden" value="<?php echo $id_medico;?>" />
				<input name="dataini" type="hidden" value="<?php echo $dataini;?>" />
				<input name="datafim" type="hidden" value="<?php echo $datafim;?>" />
				<div class="modal-footer">
					<button type="button" class="btn btn-submit green"><?php echo lang('PAGAR');?></button>
					<button type="button" data-dismiss="modal" class="btn default"><?php echo lang('VOLTAR');?></button>
				</div>
			</form>
		</div>
	</div>
	<?php echo $core->doForm("pagarProducao", "producao_form");?>
</div>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('GESTAO_MEDICO_PRODUCAO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-check-square-o font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_MEDICO_PRODUCAO').': '.$nome_medico;?></span>
							</div>
							<div class="actions btn-set">
								<?php if($quantidade_producao > 0):?>
									<?php if($id_empresa):?>
									<button type="button" id="pagarproducao" class="btn green"><i class="fa fa-check-square-o"/>&nbsp;&nbsp;</i> <?php echo lang('PAGAR_PRODUCAO');?></button>
									<?php else:?>
									<button type="button" class="btn grey-cascade"><?php echo lang('SELECIONE_PRODUCAO');?></button>
									<?php endif;?>
								<?php endif;?>
								<a href="javascript:void(0);" class="btn yellow-casablanca" onclick="javascript:void window.open('pdf_paciente.php?id_medico=<?php echo $id_medico;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>&id_convenio=<?php echo $id_convenio;?>','<?php echo $nome_medico;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('IMPRIMIR_PRODUCAO');?>"><i class="fa fa-print">&nbsp;&nbsp;</i><?php echo lang('IMPRIMIR_PRODUCAO');?></a>
								<a href="index.php?do=gestao&acao=listamedico" class="btn default"><?php echo lang('VOLTAR');?></a>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
								<div class="form-group">
									<div class="row">
										<div class="col-md-12">	
											<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
													<option value=""></option>
													<?php 
														$retorno_row = $empresa->getEmpresas();
														if ($retorno_row):
															foreach ($retorno_row as $srow):
													?>
																<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
													<?php
															endforeach;
															unset($srow);
														endif;
													?>
												</select>
											&nbsp;&nbsp;
											<select class="select2me bs-select form-control input-large" id="id_convenio" name="id_convenio" data-placeholder="<?php echo lang('SELECIONE_CONVENIO');?>" >
													<option value=""></option>
													<option value="-1" <?php if('-1' == $id_convenio) echo 'selected="selected"';?>>PARTICULAR</option>
													<?php 
														$retorno_row = $cadastro->getConvenios();
														if ($retorno_row):
															foreach ($retorno_row as $srow):
													?>
																<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_convenio) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
													<?php
															endforeach;
															unset($srow);
														endif;
													?>
												</select>
												&nbsp;&nbsp;	
												<select class="select2me bs-select form-control input-large " id="id_medico" name="id_medico" data-placeholder="<?php echo lang('SELECIONE_MEDICO');?>" >
													<option value=""></option>
												<?php 
													$retorno_row = $usuario->getMedicos();
													if ($retorno_row):
														foreach ($retorno_row as $srow):
												?>
															<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_medico) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
												<?php
														endforeach;
														unset($srow);
													endif;
												?>
												</select>
										</div>
									</div>
								<br/>
								</div>
								<div class="form-group">
									<div class="row">
										<div class="col-md-12">	
											<input type="text" class="form-control input-small calendario data" id="dataini" value="<?php echo $dataini;?>" >
											&nbsp;&nbsp;
											<input type="text" class="form-control input-small calendario data" id="datafim" value="<?php echo $datafim;?>" >
											&nbsp;&nbsp;
											<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/>&nbsp;&nbsp;</i> <?php echo lang('BUSCAR');?></button>
											<button type="button" id="liberartodos" class="btn green-turquoise"><i class="fa fa-unlock"/>&nbsp;&nbsp;</i> <?php echo lang('LIBERAR_TODOS');?></button>
											<input id="id_medico" type="hidden" value="<?php echo $id_medico;?>" />
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">	
										<table class="table table-bordered table-condensed">
											<thead>
												<tr class="disabled">
													<th><strong><?php echo lang('PROCEDIMENTO');?></strong></th>
													<th><strong><?php echo lang('CONVENIO');?></strong></th>
													<th><strong><?php echo lang('QUANTIDADE');?></strong></th>
													<th width="90px"><strong><?php echo lang('VALOR_PAGO');?></strong></th>
													<th width="90px"><strong><?php echo lang('REPASSE');?></strong></th>
												</tr>
											</thead>
											<tbody>
											<?php 	
													$quantidade = 0;
													$total = 0;
													$total_repasse = 0;
													$retorno_row = $atendimento->getTotalMedicoProducao($id_medico, $dataini, $datafim, $id_empresa, $id_convenio);
													if($retorno_row):
													foreach ($retorno_row as $exrow):
														$valor_repasse = 0;
														$producao = $exrow->producao;
														$valor = $exrow->valor_pago;
														$quantidade += $exrow->quant;
														$total += $exrow->valor_pago;
														$repasse = $atendimento->getValorRepasse($exrow->id_tabela, $id_medico, $exrow->id_convenio);
														if($producao == 2) {
															$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
															$valor_repasse = $valor*$percentual_repasse/100;
															if($valor_repasse == 0) {
																$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
															}
														} elseif($producao == 1) {
															$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
															if($valor_repasse == 0) {
																$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
																$valor_repasse = $valor*$percentual_repasse/100;
															}
														}
														$total_repasse += $valor_repasse;
											?>
												<tr>
													<td><?php echo $exrow->procedimento;?></td>
													<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
													<td><?php echo $exrow->quant;?></td>
													<td><?php echo moeda($exrow->valor_pago);?></td>
													<td><?php echo moeda($valor_repasse);?></td>
												</tr>
											<?php endforeach;?>
											<?php unset($exrow);
												  endif;
											?>
												<tr>
													<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
													<td><strong><?php echo $quantidade;?></strong></td>
													<td><strong><?php echo moeda($total);?></strong></td>
													<td><strong><?php echo moeda($total_repasse);?></strong></td>
												</tr>
											</tbody>
										</table>
									</div>
								</div>
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance ">
												<thead>
													<tr>
														<th><?php echo lang('DATA');?></th>
														<th><?php echo lang('PACIENTE_TITULO');?></th>
														<th><?php echo lang('CONVENIO');?></th>
														<th><?php echo lang('GUIA');?></th>
														<th><?php echo lang('PROCEDIMENTO');?></th>
														<th width="90px"><?php echo lang('VALOR_PAGO');?></th>
														<?php if($salario == 0):?>
														<th width="90px"><?php echo lang('REPASSE');?></th>
														<?php endif;?>
														<th><?php echo lang('STATUS');?></th>
														<th width="110px"><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 
													$quantidade = 0;
													$total_repasse = 0;
													$total_pago = 0;
													$retorno_row = $atendimento->getListaMedicoProducao($id_medico, $dataini, $datafim, $id_empresa, $id_convenio);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$total_pago += $exrow->valor_procedimento;	
															$producao = $exrow->producao;
															$valor = $exrow->valor_procedimento;	
															$label_repasse = '';
															$valor_repasse = 0;
															if($exrow->id_retorno == 0) {	
																$repasse = $atendimento->getValorRepasse($exrow->id_tabela, $exrow->id_medico, $exrow->id_convenio);
																if($producao == 2) {
																	$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
																	$valor_repasse = $valor*$percentual_repasse/100;
																	if($valor_repasse == 0) {
																		$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
																	}
																} elseif($producao == 1) {
																	$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
																	if($valor_repasse == 0) {
																		$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
																		$valor_repasse = $valor*$percentual_repasse/100;
																	}
																}
															}
															$class = '';
															$status = '';
															if($exrow->repasse == 1) {
																$class = 'class="sucess"';
																$status = "<span class='label bg-green'>".lang('PAGO')."</span>";
															} elseif($exrow->repasse == 0) {
																$class = 'class="danger"';
																$status = "<span class='label bg-red'>".lang('BLOQUEADO')."</span>";
															} else {
																$status = "<span class='label bg-green'>".lang('PAGAR')."</span>";
																$total_repasse += $valor_repasse;
																$quantidade++;
																$label_repasse = moeda($valor_repasse);
															}
												?>
													<tr <?php echo $class;?>>
														<td><?php echo exibedata($exrow->data_agenda);?></td>
														<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo $exrow->numero_guia;?></td>
														<td><?php echo $exrow->procedimento;?></td>
														<td><?php echo moeda($valor);?></td>
														<?php if($exrow->salario == 0):?>
														<td><?php echo $label_repasse;?></td>
														<?php endif;?>
														<td><?php echo $status;?></td>
														<td>
															<input name="id_atendimento[]" type="hidden" value="<?php echo $exrow->id;?>" />
															<?php if($exrow->repasse == 2):?>
																<a href="javascript:void(0);" class="btn btn-icon-only green-turquoise bloquearrepasse " id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_BLOQUEIO').$exrow->procedimento;?>"><i class="fa fa-unlock"></i></a>
															<?php elseif($exrow->repasse == 0):?>
																<a href="javascript:void(0);" class="btn btn-icon-only red-flamingo liberarrepasse" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_LIBERAR').$exrow->procedimento;?>"><i class="fa fa-lock"></i></a>
															<?php endif;?>
															<a href="javascript:void(0);" onclick="javascript:void window.open('ver_atendimento.php?id=<?php echo $exrow->id;?>','<?php echo lang('VISUALIZAR').$exrow->id;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=0,resizable=0,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>" class="btn btn-icon-only grey-cascade"><i class="fa fa-search"></i></a>
														</td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<?php 	
																$total_salario = '';
																if($salario > 0) {
																	$total_salario = ': Recebe salário mensal '.moeda($salario);
																}
														?>
														<td colspan="4"><strong><?php echo lang('TOTAL').$total_salario;?></strong></td>
														<td><strong><?php echo $quantidade;?></strong></td>
														<td><strong><?php echo moeda($total_pago);?></strong></td>							
														<?php if($salario == 0):?>
														<td><strong><?php echo moeda($total_repasse);?></strong></td>		
														<?php endif;?>
														<td></td>
														<td></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
								<input id="total_repasse" type="hidden" value="<?php echo moeda($total_repasse);?>" />
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "producaomedico":
$id_medico = get('id_medico'); 
$id_convenio = get('id_convenio'); 
$nome_medico = ($id_medico) ? getValue('nome', 'usuario', 'id='.$id_medico) : '-';
$salario = ($id_medico) ? getValue('salario', 'usuario', 'id='.$id_medico) : 0;
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_convenio = $("#id_convenio").val();
			var id_medico = $("#id_medico").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=producaomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_medico = $("#id_medico").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=producaomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#id_convenio').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_medico = $("#id_medico").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=producaomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
		$('#id_medico').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_medico = $("#id_medico").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=producaomedico&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_medico='+ id_medico + '&id_convenio='+ id_convenio;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('GESTAO_MEDICO_PAGOS');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-usd font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_MEDICO_PAGOS').': '.$nome_medico;?></span>
							</div>
							<div class="actions btn-set">
								<a href="javascript:void(0);" class="btn yellow-casablanca" onclick="javascript:void window.open('pdf_pagamentomedico.php?id_medico=<?php echo $id_medico;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>','<?php echo $nome_medico;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('IMPRIMIR_PRODUCAO');?>"><i class="fa fa-print">&nbsp;&nbsp;</i><?php echo lang('IMPRIMIR_PRODUCAO');?></a>
								<a href="index.php?do=gestao&acao=listamedico" class="btn default"><?php echo lang('VOLTAR');?></a>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
								<div class="row">
									<div class="col-md-12">		
										<div class="note note-warning">
											<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
										</div>
									</div>	
								</div>
								<div class="form-group">
									<div class="row">
										<div class="col-md-12">	
											<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
													<option value=""></option>
													<?php 
														$retorno_row = $empresa->getEmpresas();
														if ($retorno_row):
															foreach ($retorno_row as $srow):
													?>
																<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
													<?php
															endforeach;
															unset($srow);
														endif;
													?>
												</select>
											&nbsp;&nbsp;
											<select class="select2me bs-select form-control input-large" id="id_convenio" name="id_convenio" data-placeholder="<?php echo lang('SELECIONE_CONVENIO');?>" >
													<option value=""></option>
													<option value="-1" <?php if('-1' == $id_convenio) echo 'selected="selected"';?>>PARTICULAR</option>
													<?php 
														$retorno_row = $cadastro->getConvenios();
														if ($retorno_row):
															foreach ($retorno_row as $srow):
													?>
																<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_convenio) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
													<?php
															endforeach;
															unset($srow);
														endif;
													?>
												</select>
														&nbsp;&nbsp;	
															<select class="select2me bs-select form-control input-large " id="id_medico" name="id_medico" data-placeholder="<?php echo lang('SELECIONE_MEDICO');?>" >
															<option value=""></option>
															<?php 
																$retorno_row = $usuario->getMedicos();
																if ($retorno_row):
																	foreach ($retorno_row as $srow):
															?>
																		<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_medico) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
															<?php
																	endforeach;
																	unset($srow);
																endif;
															?>
															</select>
										</div>
									</div>
								<br/>
								</div>
								<div class="form-group">
									<div class="row">
										<div class="col-md-12">	
											<input type="text" class="form-control input-small calendario data" id="dataini" value="<?php echo $dataini;?>" >
											&nbsp;&nbsp;
											<input type="text" class="form-control input-small calendario data" id="datafim" value="<?php echo $datafim;?>" >
											&nbsp;&nbsp;
											<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/>&nbsp;&nbsp;</i> <?php echo lang('BUSCAR');?></button>
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance ">
												<thead>
													<tr>
														<th><?php echo lang('DATA');?></th>
														<th><?php echo lang('PACIENTE_TITULO');?></th>
														<th><?php echo lang('CONVENIO');?></th>
														<th><?php echo lang('GUIA');?></th>
														<th><?php echo lang('PROCEDIMENTO');?></th>
														<th width="90px"><?php echo lang('VALOR_PAGO');?></th>
														<?php if($salario == 0):?>
														<th><?php echo lang('VALOR');?></th>
														<?php endif;?>
														<th width="110px"><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 
													$quantidade = 0;
													$total_repasse = 0;
													$total_pago = 0;
													$retorno_row = ($id_medico) ? $atendimento->getListaMedicoPago($id_medico, $dataini, $datafim, $id_empresa, $id_convenio) : null;
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$total_pago += $exrow->valor_pago;	
															$quantidade++;
															$producao = $exrow->producao;
															$valor = $exrow->valor_pago;		
															$valor_repasse = $exrow->valor_repasse;	
															$total_repasse += $valor_repasse;
												?>
													<tr>
														<td><?php echo exibedata($exrow->data_agenda);?></td>
														<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo $exrow->numero_guia;?></td>
														<td><?php echo $exrow->procedimento;?></td>
														<td><?php echo moeda($exrow->valor_pago);?></td>
														<?php if($exrow->salario == 0):?>
														<td><?php echo moeda($valor_repasse);?></td>
														<?php endif;?>
														<td>
															<input name="id_atendimento[]" type="hidden" value="<?php echo $exrow->id;?>" />
															<?php if($exrow->repasse == 2):?>
																<a href="javascript:void(0);" class="btn btn-icon-only green-turquoise bloquearrepasse " id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_LIBERAR').$exrow->procedimento;?>"><i class="fa fa-unlock"></i></a>
															<?php elseif($exrow->repasse == 0):?>
																<a href="javascript:void(0);" class="btn btn-icon-only red-flamingo liberarrepasse" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_BLOQUEIO').$exrow->procedimento;?>"><i class="fa fa-lock"></i></a>
															<?php endif;?>
															<a href="javascript:void(0);" onclick="javascript:void window.open('ver_atendimento.php?id=<?php echo $exrow->id;?>','<?php echo lang('VISUALIZAR').$exrow->id;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=0,resizable=0,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>" class="btn btn-icon-only grey-cascade"><i class="fa fa-search"></i></a>
														</td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<?php 	
																$total_salario = '';
																if($salario > 0) {
																	$total_salario = ': Recebe salário mensal '.moeda($salario);
																}
														?>
														<td colspan="4"><strong><?php echo lang('TOTAL').$total_salario;?></strong></td>
														<td><strong><?php echo $quantidade;?></strong></td>
														<td><strong><?php echo moeda($total_pago);?></strong></td>							
														<?php if($salario == 0):?>
														<td><?php echo moeda($total_repasse);?></td>
														<?php endif;?>
														<td></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "listaconvenio":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=listaconvenio&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('CAIXA_CONVENIO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-medkit font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CAIXA_CONVENIO');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance ">
												<thead>
													<tr>
														<th><?php echo lang('CONVENIO');?></th>
														<th><?php echo lang('ATENDIMENTOS');?></th>
														<th><?php echo lang('VALOR');?></th>
														<th><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_valor = 0;
													$total_repasse = 0;
													$retorno_row = $atendimento->getConvenioPeriodo($dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$valor_pago = $exrow->valor_tabela;
															$total_valor += $valor_pago;
												?>
													<tr>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo $exrow->quant;?></td>
														<td><?php echo moeda($valor_pago);?></td>
														<td>
															<a href="index.php?do=gestao&acao=relatorioconvenio&id_convenio=<?php echo $exrow->id_convenio;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>" target="_blank" class="btn btn-icon-only grey-cascade" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
															<a href="javascript:void(0);" class="btn btn-icon-only yellow-casablanca" onclick="javascript:void window.open('pdf_convenio.php?id_convenio=<?php echo $exrow->id_convenio;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>','<?php echo $exrow->convenio;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('IMPRIMIR');?>"><i class="fa fa-print"></i></a>
														</td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total_valor);?></strong></td>
														<td></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "pacientesperiodo":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=pacientesperiodo&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ATENDIMENTOS_PACIENTE');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-users font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_PACIENTE');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									<br/>
									<br/>
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance dataTable ">
												<thead>
													<tr>
														<th><?php echo lang('PACIENTE_TITULO');?></th>
														<th><?php echo lang('TELEFONE');?></th>
														<th><?php echo lang('CIDADE');?></th>
														<th><?php echo lang('CONVENIO');?></th>
														<th width="120px"><?php echo lang('AGENDA_ULTIMA');?></th>
														<th><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_valor = 0;
													$total_repasse = 0;
													$retorno_row = $gestao->getListaPacientePeriodo($dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$valor_pago = $exrow->valor_tabela;
															$total_valor += $valor_pago;
												?>
													<tr>
														<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
														<td><?php echo $exrow->celular.' '.$exrow->telefone;?></td>
														<td><?php echo $exrow->cidade;?></td>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo exibedataHora($exrow->ultima);?></td>
														<td><a href="javascript:void(0);" onclick="javascript:void window.open('ver_paciente.php?id_paciente=<?php echo $exrow->id_paciente;?>','<?php echo lang('PACIENTE_DETALHES').$exrow->id_paciente;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=0,resizable=0,left=0,top=0');return false;" title="<?php echo lang('PACIENTE_DETALHES');?>" class="btn btn-icon-only blue-hoki"><i class="fa fa-user"></i></a></td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "relatorioconvenio":
$id_convenio = get('id_convenio'); 
$id_empresa = get('id_empresa'); 
$nome_convenio = ($id_convenio) ? getValue('nome', 'cadastro', 'id='.$id_convenio) : "PARTICULAR";
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=relatorioconvenio&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_convenio='+ id_convenio;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ATENDIMENTOS_PERIODO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_PERIODO').' - '.$nome_convenio;?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_convenio" name="id_convenio" data-placeholder="<?php echo lang('SELECIONE_CONVENIO');?>" >
											<option value=""></option>
											<option value="-1" <?php if('-1' == $id_convenio) echo 'selected="selected"';?>>PARTICULAR</option>
											<?php 
												$retorno_row = $cadastro->getConvenios();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_convenio) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									&nbsp;&nbsp;
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									<br/>
									<br/>
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance dataTable ">
												<thead>
													<tr>
														<th><?php echo lang('PACIENTE_TITULO');?></th>
														<th><?php echo lang('TELEFONE');?></th>
														<th><?php echo lang('CONVENIO');?></th>
														<th><?php echo lang('NUMERO');?></th>
														<th><?php echo lang('TITULAR');?></th>
														<th><?php echo lang('REFERENCIA');?></th>
														<th><?php echo lang('MEDICO');?></th>
														<th><?php echo lang('PROCEDIMENTO');?></th>
														<th width="70px"><?php echo lang('VALOR');?></th>
														<th width="100px"><?php echo lang('REALIZADO');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_valor = 0;
													$total_repasse = 0;
													$retorno_row = $atendimento->getListaConvenioPeriodo($id_convenio, $dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$valor_pago = $exrow->valor_tabela;
															$total_valor += $valor_pago;
												?>
													<tr>
														<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
														<td><?php echo $exrow->celular.' '.$exrow->telefone;?></td>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo $exrow->numero;?></td>
														<td><?php echo $exrow->titular;?></td>
														<td><?php echo $exrow->referencia;?></td>
														<td><?php echo $exrow->medico;?></td>
														<td><?php echo $exrow->procedimento;?></td>
														<td><?php echo moeda($exrow->valor_tabela);?></td>
														<td><?php echo exibedataHora($exrow->data_realizada);?></td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<td colspan="8"><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total_valor);?></strong></td>
														<td colspan="1"></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "relatorioisencao":
$id_convenio = get('id_convenio'); 
$id_empresa = get('id_empresa'); 
$nome_convenio = ($id_convenio) ? getValue('nome', 'cadastro', 'id='.$id_convenio) : "PARTICULAR";
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=relatorioisencao&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa + '&id_convenio='+ id_convenio;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('RELATORIO_ISENCAO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('RELATORIO_ISENCAO').' - '.$nome_convenio;?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_convenio" name="id_convenio" data-placeholder="<?php echo lang('SELECIONE_CONVENIO');?>" >
											<option value=""></option>
											<option value="-1" <?php if('-1' == $id_convenio) echo 'selected="selected"';?>>PARTICULAR</option>
											<?php 
												$retorno_row = $cadastro->getConvenios();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_convenio) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									&nbsp;&nbsp;
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									<br/>
									<br/>
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance dataTable ">
												<thead>
													<tr>
														<th><?php echo lang('CLINICA');?></th>
														<th><?php echo lang('DATA');?></th>
														<th><?php echo lang('PACIENTE_TITULO');?></th>
														<th><?php echo lang('TELEFONE');?></th>
														<th><?php echo lang('CONVENIO');?></th>
														<th><?php echo lang('TITULAR');?></th>
														<th><?php echo lang('PROCEDIMENTO');?></th>
														<th><?php echo lang('OBSERVACAO');?></th>
														<th width="70px"><?php echo lang('VALOR');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_valor = 0;
													$total_repasse = 0;
													$retorno_row = $atendimento->getListaAtendimentoIsencao($id_convenio, $dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$valor_pago = $exrow->valor_pago;
															$total_valor += $valor_pago;
												?>
													<tr>
														<td><?php echo $exrow->clinica;?></td>
														<td><?php echo exibedata($exrow->data_agenda);?></td>
														<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
														<td><?php echo $exrow->celular.' '.$exrow->telefone;?></td>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo $exrow->titular;?></td>
														<td><?php echo $exrow->procedimento;?></td>
														<td><?php echo $exrow->observacao;?></td>
														<td><?php echo moeda($exrow->valor_pago);?></td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<td colspan="8"><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total_valor);?></strong></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "listalaboratorio":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=listalaboratorio&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('CAIXA_LABORATORIO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-tasks font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('CAIXA_LABORATORIO');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance ">
												<thead>
													<tr>
														<th><?php echo lang('LABORATORIO');?></th>
														<th><?php echo lang('ATENDIMENTOS');?></th>
														<th><?php echo lang('VALOR');?></th>
														<th><?php echo lang('VALOR_REPASSE');?></th>
														<th><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$total_valor = 0;
													$total_repasse = 0;
													$retorno_row = $atendimento->getLaboratorioPeriodo($dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
															$valor_pago = $exrow->valor_tabela;	
															$valor_repasse = $exrow->valor_pago_lab*$exrow->quant;	
															$total_valor += $valor_pago;
															$total_repasse += $valor_repasse;
												?>
													<tr>
														<td><?php echo $exrow->laboratorio;?></td>
														<td><?php echo $exrow->quant;?></td>
														<td><?php echo moeda($valor_pago);?></td>
														<td><?php echo moeda($valor_repasse);?></td>
														<td>
															<a href="javascript:void(0);" class="btn btn-icon-only yellow-casablanca" onclick="javascript:void window.open('pdf_laboratorio.php?id_laboratorio=<?php echo $exrow->id_laboratorio;?>&dataini=<?php echo $dataini;?>&datafim=<?php echo $datafim;?>&id_empresa=<?php echo $id_empresa;?>','<?php echo $exrow->laboratorio;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('IMPRIMIR_PRODUCAO');?>"><i class="fa fa-print"></i></a>
														</td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<tfoot>
													<tr>
														<td colspan="2"><strong><?php echo lang('TOTAL');?></strong></td>
														<td><strong><?php echo moeda($total_valor);?></strong></td>
														<td><strong><?php echo moeda($total_repasse);?></strong></td>
														<td></td>
													</tr>
												</tfoot>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "pendentes":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
$id_medico = (get('id_medico')) ? get('id_medico') : 0; 
?>
<script type="text/javascript"> 
	// <![CDATA[ 
	$(document).ready(function () {
		$('#buscar').click(function() {
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			var id_medico = $("#id_medico").val();
			var id_empresa = $("#id_empresa").val();
			window.location.href = 'index.php?do=gestao&acao=pendentes&dataini='+ dataini +'&datafim='+ datafim +'&id_medico='+ id_medico +'&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>

<div id="cancelar-agenda" class="modal fade" role="dialog" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title"><i class="fa fa-ban">&nbsp;&nbsp;</i><?php echo lang('AGENDA_CANCELAR');?></span></h4>
			</div>
			<form action="" autocomplete="off" method="post" name="cancelar_form" id="cancelar_form" class="form-horizontal">
				<div class="modal-body">
					<div class="row">
						<div class="col-md-12">
							<div class="col-md-12">
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo lang('OBSERVACAO');?></label>
									<div class="col-md-8">
											<input type="text" class="form-control caps" name="observacao">
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-submit <?php echo $core->primeira_cor;?>"><?php echo lang('SALVAR');?></button>
					<button type="button" data-dismiss="modal" class="btn default"><?php echo lang('VOLTAR');?></button>
				</div>
			</form>
		</div>
	</div>
	<?php echo $core->doForm("cancelarAgenda", "cancelar_form");?>
</div>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ATENDIMENTO_PENDENTES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-question-circle font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTO_PENDENTES');?></span>
							</div>
							<div class='actions btn-set'>
								<small class="font-yellow-crusta"><i class='fa fa-square'>&nbsp;&nbsp;</i><?php echo lang('ATENDIMENTO_GUIAS_INCOMPLETO');?></small>&nbsp;&nbsp;
								<small class="font-blue"><i class='fa fa-check-square'>&nbsp;&nbsp;</i><?php echo lang('ATENDIMENTO_GUIAS_COMPLETO');?></small>
							</div>
						</div>
						<div class="portlet-body form">
							<!-- INICIO FORM-->
							<form action="" autocomplete="off" method="post" class="form-inline">
								<div class="form-body">
									<div class="row">
										<div class="col-md-12">									
											<div class="row">
												<div class="form-group">
													<div class="col-md-12">
														<input type="text" class="form-control input-medium calendario data" name="dataini" placeholder="Data inicial" id="dataini" value="<?php echo $dataini;?>" >
														&nbsp;
														<input type="text" class="form-control input-medium calendario data" name="datafim" placeholder="Data final" id="datafim" value="<?php echo $datafim;?>" >
														<br/><br/>	
														<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
																<option value=""></option>
																<?php 
																	$retorno_row = $empresa->getEmpresas();
																	if ($retorno_row):
																		foreach ($retorno_row as $srow):
																?>
																			<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
																<?php
																		endforeach;
																		unset($srow);
																	endif;
																?>
															</select>
														&nbsp;&nbsp;	
															<select class="select2me bs-select form-control input-medium " id="id_medico" name="id_medico" data-placeholder="<?php echo lang('SELECIONE_MEDICO');?>" >
															<option value=""></option>
															<?php 
																$retorno_row = $usuario->getMedicos();
																if ($retorno_row):
																	foreach ($retorno_row as $srow):
															?>
																		<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_medico) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
															<?php
																	endforeach;
																	unset($srow);
																endif;
															?>
															</select>
														&nbsp;&nbsp;
														<a href='javascript:void(0);' id="buscar" class='btn <?php echo $core->primeira_cor;?>' title='<?php echo lang('BUSCAR');?>'><i class='fa fa-search'>&nbsp;&nbsp;</i><?php echo lang('BUSCAR');?></a>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="portlet-body">
							<table class="table table-bordered table-condensed table-advance dataTable-asc">
								<thead>
									<tr>
										<th>#</th>
										<th>#</th>
										<th><?php echo lang('DATA');?></th>
										<th><?php echo lang('CLINICA');?></th>
										<th><?php echo lang('PACIENTE');?></th>
										<th><?php echo lang('MEDICO');?></th>
										<th width="100px"><?php echo lang('PROCEDIMENTO');?></th>
										<th><?php echo lang('STATUS');?></th>
										<th><?php echo lang('VALOR');?></th>
										<th><?php echo lang('PAGO');?></th>
										<th width="90px"><?php echo lang('ACOES');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
									$total_valor = 0;
									$total_repasse = 0;
									$retorno_row = $atendimento->getAgendaPendentes($dataini, $datafim, $id_medico, $id_empresa);
									if($retorno_row):
										foreach ($retorno_row as $exrow):									
											$class = 'warning';
											$status = 0;
											$valor_pago = $exrow->valor_tabela;	
											$valor_repasse = $exrow->valor_repasse;	
											if($exrow->realizado == 1) {
												if($exrow->pago == 1 or $exrow->pago == 9) {
													$status = 1;
													if($exrow->guia > 0) {
														$class = 'class="info"';
														if(!$exrow->numero_guia) {
															$status = 12;
															$class = 'class="warning"';
														}
													}
												} else {
													$status = 11;
												}
											}elseif($exrow->realizado == 2) {
												$status = 2;
											}elseif($exrow->realizado == 6) {
												$status = 6;
											}elseif($exrow->retorno == 2) {
												$status = 10;
											}elseif($exrow->pago == 1) {
												$status = 4;
											}elseif($exrow->pago == 2) {
												$status = 5;
											}elseif($exrow->realizado == 3) {
												$status = 3;
											}
											if($exrow->realizado == 9) {
												$class = 'class="danger"';
												$status = 9;
											}
											if($exrow->pago != 1) {
												if($exrow->id_convenio) {
													$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$exrow->id_tabela.' AND id_cadastro='.$exrow->id_convenio);
													$valor_pago = ($valor_convenio) ? $valor_convenio : $exrow->valor;
												} else {
													$valor_pago = $exrow->valor;				  
												}
											}
								?>
									<tr <?php echo $class;?>>
										<td><?php echo $exrow->controle;?></td>
										<td><?php echo $exrow->id;?></td>
										<td><?php echo exibedataHora($exrow->data_agenda);?></td>
										<td><?php echo $exrow->clinica;?></td>
										<td><a target="_blank" href="index.php?do=paciente&acao=editar&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
										<td><?php echo $exrow->medico;?></td>
										<td><?php echo $exrow->procedimento;?></td>
										<td><?php echo statusAgenda($status);?></td>
										<td><?php echo moeda($exrow->valor_atendimento);?></td>
										<td><?php echo verifica($exrow->pago);?></td>
										<td>	
										<?php if($exrow->pago > 0 and $exrow->realizado != 1):?>
											<a href="javascript:void(0);" class="btn btn-icon-only purple realizaragenda" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_REALIZAR').$exrow->procedimento;?>"><i class="fa fa-check-square-o"></i></a>
										<?php endif;?>														
										<?php if($usuario->is_Master() and $exrow->realizado != 9):?>
											<a href="javascript:void(0);" class="btn btn-icon-only red cancelaragenda" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_CANCELAR').$exrow->procedimento;?>"><i class="fa fa-ban"></i></a>
										<?php endif;?>
										</td>
									</tr>
								<?php 
										endforeach;?>
								<?php unset($exrow);
									 endif;?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "prontuario":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
$id_medico = (get('id_medico')) ? get('id_medico') : 0; 
?>
<script type="text/javascript"> 
	// <![CDATA[ 
	$(document).ready(function () {
		$('#buscar').click(function() {
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			var id_medico = $("#id_medico").val();
			var id_empresa = $("#id_empresa").val();
			window.location.href = 'index.php?do=gestao&acao=prontuario&dataini='+ dataini +'&datafim='+ datafim +'&id_medico='+ id_medico +'&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('RELATORIOS');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ATENDIMENTO_PRONTUARIO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-file-text-o font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTO_PRONTUARIO');?></span>
							</div>
						</div>
						<div class="portlet-body form">
							<!-- INICIO FORM-->
							<form action="" autocomplete="off" method="post" class="form-inline">
								<div class="form-body">
									<div class="row">
										<div class="col-md-12">									
											<div class="row">
												<div class="form-group">
													<div class="col-md-12">
														<input type="text" class="form-control input-medium calendario data" name="dataini" placeholder="Data inicial" id="dataini" value="<?php echo $dataini;?>" >
														&nbsp;
														<input type="text" class="form-control input-medium calendario data" name="datafim" placeholder="Data final" id="datafim" value="<?php echo $datafim;?>" >
														<br/><br/>	
														<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
																<option value=""></option>
																<?php 
																	$retorno_row = $empresa->getEmpresas();
																	if ($retorno_row):
																		foreach ($retorno_row as $srow):
																?>
																			<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
																<?php
																		endforeach;
																		unset($srow);
																	endif;
																?>
															</select>
														&nbsp;&nbsp;	
															<select class="select2me bs-select form-control input-medium " id="id_medico" name="id_medico" data-placeholder="<?php echo lang('SELECIONE_MEDICO');?>" >
															<option value=""></option>
															<?php 
																$retorno_row = $usuario->getMedicos();
																if ($retorno_row):
																	foreach ($retorno_row as $srow):
															?>
																		<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_medico) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
															<?php
																	endforeach;
																	unset($srow);
																endif;
															?>
															</select>
														&nbsp;&nbsp;
														<a href='javascript:void(0);' id="buscar" class='btn <?php echo $core->primeira_cor;?>' title='<?php echo lang('BUSCAR');?>'><i class='fa fa-search'>&nbsp;&nbsp;</i><?php echo lang('BUSCAR');?></a>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="portlet-body">
							<table class="table table-bordered table-condensed table-advance">
								<thead>
									<tr>
										<th>#</th>
										<th><?php echo lang('AGENDA');?></th>
										<th><?php echo lang('PACIENTE');?></th>
										<th><?php echo lang('MEDICO');?></th>
										<th><?php echo lang('PROCEDIMENTO');?></th>
										<th width="100px"><?php echo lang('PAGO');?></th>
										<th width="100px"><?php echo lang('REPASSE');?></th>
										<th><?php echo lang('STATUS');?></th>
										<th><?php echo lang('PRONTUARIO');?></th>
										<th><?php echo lang('REALIZADO');?></th>
										<th width="110px"><?php echo lang('ACOES');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
									$total_pago = 0;
									$total_repasse = 0;
									$quantidade_total = 0;
									$quantidade = 0;
									$retorno_row = $atendimento->getAgendaProntuario($dataini, $datafim, $id_medico, $id_empresa);
									if($retorno_row):
										foreach ($retorno_row as $exrow):
											$class = '';
											$status = 0;										
											$total_pago += $exrow->valor_pago;	
											$producao = $exrow->producao;
											$valor = $exrow->valor_pago;	
											$label_repasse = '';
											$valor_repasse = 0;
											if($exrow->id_retorno == 0) {	
												$repasse = $atendimento->getValorRepasse($exrow->id_tabela, $exrow->id_medico, $exrow->id_convenio);
												if($producao == 2) {
													$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
													$valor_repasse = $valor*$percentual_repasse/100;
													if($valor_repasse == 0) {
														$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
													}
												} elseif($producao == 1) {
													$valor_repasse = ($repasse) ? $repasse->valor_repasse : 0;
													if($valor_repasse == 0) {
														$percentual_repasse = ($repasse) ? $repasse->percentual_repasse : 0;
														$valor_repasse = $valor*$percentual_repasse/100;
													}
												}
											}
											if($exrow->repasse == 2) {
												$label_repasse = moeda($valor_repasse);
												$total_repasse += $valor_repasse;
												$quantidade++;
											} else {
												$label_repasse = "-";
											}
											$quantidade_total++;
											if($exrow->realizado == 1) {
												if($exrow->pago == 1 or $exrow->pago == 9) {
													$status = 1;
													if($exrow->guia > 0) {
														if(!$exrow->numero_guia) {
															$status = 12;
														}
													}
												} else {
													$status = 11;
												}
											}elseif($exrow->realizado == 2) {
												$status = 2;
											}elseif($exrow->realizado == 6) {
												$status = 6;
											}elseif($exrow->retorno == 2) {
												$status = 10;
											}elseif($exrow->pago == 1) {
												$status = 4;
											}elseif($exrow->pago == 2) {
												$status = 5;
											}elseif($exrow->realizado == 3) {
												$status = 3;
											}
											if(!$exrow->prontuario) {
												$class = 'class="danger"';
											}
								?>
									<tr <?php echo $class;?>>
										<td><?php echo $exrow->id;?></td>
										<td><?php echo exibedataHora($exrow->data_agenda);?></td>
										<td><a target="_blank" href="index.php?do=paciente&acao=prontuario&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
										<td><?php echo $exrow->medico;?></td>
										<td><?php echo $exrow->procedimento;?></td>
										<td><?php echo moeda($exrow->valor_pago);?></td>
										<td><?php echo $label_repasse;?></td>
										<td><?php echo statusAgenda($status);?></td>
										<td><?php echo verifica($exrow->prontuario);?></td>
										<td><?php echo exibedataHora($exrow->data_prontuario);?></td>
										<td>	
										<?php if($exrow->repasse == 2):?>
											<a href="javascript:void(0);" class="btn btn-icon-only green-turquoise bloquearrepasse " id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_BLOQUEIO').$exrow->procedimento;?>"><i class="fa fa-unlock"></i></a>
										<?php elseif($exrow->repasse == 0):?>
											<a href="javascript:void(0);" class="btn btn-icon-only red-flamingo liberarrepasse" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_LIBERAR').$exrow->procedimento;?>"><i class="fa fa-lock"></i></a>
										<?php endif;?>
											<a href="javascript:void(0);" class="btn btn-icon-only grey-cascade" onclick="javascript:void window.open('ver_atendimento.php?id=<?php echo $exrow->id;?>','<?php echo lang('ATENDIMENTOS_CONVENIO').' - '.$exrow->paciente;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php 
										endforeach;?>
								</tbody>
								<tfoot>
									<tr>
										<td colspan="5"><strong><?php echo lang('TOTAL').": ".$quantidade_total;?></strong></td>
										<td><strong><?php echo moeda($total_pago);?></strong></td>
										<td><strong><?php echo moeda($total_repasse);?></strong></td>
										<td><strong><?php echo $quantidade;?></strong></td>
										<td colspan="3"></td>
									</tr>
								</tfoot>
								<?php unset($exrow);
									 endif;?>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "naopagos":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
$id_medico = (get('id_medico')) ? get('id_medico') : 0; 
?>
<script type="text/javascript"> 
	// <![CDATA[ 
	$(document).ready(function () {
		$('#buscar').click(function() {
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			var id_medico = $("#id_medico").val();
			var id_empresa = $("#id_empresa").val();
			window.location.href = 'index.php?do=gestao&acao=naopagos&dataini='+ dataini +'&datafim='+ datafim +'&id_medico='+ id_medico +'&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>

<div id="cancelar-agenda" class="modal fade" role="dialog" aria-hidden="true">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal" aria-hidden="true"></button>
				<h4 class="modal-title"><i class="fa fa-ban">&nbsp;&nbsp;</i><?php echo lang('AGENDA_CANCELAR');?></span></h4>
			</div>
			<form action="" autocomplete="off" method="post" name="cancelar_form" id="cancelar_form" class="form-horizontal">
				<div class="modal-body">
					<div class="row">
						<div class="col-md-12">
							<div class="col-md-12">
								<div class="form-group">
									<label class="control-label col-md-3"><?php echo lang('OBSERVACAO');?></label>
									<div class="col-md-8">
											<input type="text" class="form-control caps" name="observacao">
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
				<div class="modal-footer">
					<button type="button" class="btn btn-submit <?php echo $core->primeira_cor;?>"><?php echo lang('SALVAR');?></button>
					<button type="button" data-dismiss="modal" class="btn default"><?php echo lang('VOLTAR');?></button>
				</div>
			</form>
		</div>
	</div>
	<?php echo $core->doForm("cancelarAgenda", "cancelar_form");?>
</div>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ATENDIMENTO_PENDENTES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-usd font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTO_NAOPAGAS');?></span>
							</div>
							<div class='actions btn-set'>
								<small class="font-yellow-crusta"><i class='fa fa-square'>&nbsp;&nbsp;</i><?php echo lang('ATENDIMENTO_GUIAS_INCOMPLETO');?></small>&nbsp;&nbsp;
								<small class="font-blue"><i class='fa fa-check-square'>&nbsp;&nbsp;</i><?php echo lang('ATENDIMENTO_GUIAS_COMPLETO');?></small>
							</div>
						</div>
						<div class="portlet-body form">
							<!-- INICIO FORM-->
							<form action="" autocomplete="off" method="post" class="form-inline">
								<div class="form-body">
									<div class="row">
										<div class="col-md-12">									
											<div class="row">
												<div class="form-group">
													<div class="col-md-12">
														<input type="text" class="form-control input-medium calendario data" name="dataini" placeholder="Data inicial" id="dataini" value="<?php echo $dataini;?>" >
														&nbsp;
														<input type="text" class="form-control input-medium calendario data" name="datafim" placeholder="Data final" id="datafim" value="<?php echo $datafim;?>" >
														<br/><br/>	
														<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
																<option value=""></option>
																<?php 
																	$retorno_row = $empresa->getEmpresas();
																	if ($retorno_row):
																		foreach ($retorno_row as $srow):
																?>
																			<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
																<?php
																		endforeach;
																		unset($srow);
																	endif;
																?>
															</select>
														&nbsp;&nbsp;	
															<select class="select2me bs-select form-control input-medium " id="id_medico" name="id_medico" data-placeholder="<?php echo lang('SELECIONE_MEDICO');?>" >
															<option value=""></option>
															<?php 
																$retorno_row = $usuario->getMedicos();
																if ($retorno_row):
																	foreach ($retorno_row as $srow):
															?>
																		<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_medico) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
															<?php
																	endforeach;
																	unset($srow);
																endif;
															?>
															</select>
														&nbsp;&nbsp;
														<a href='javascript:void(0);' id="buscar" class='btn <?php echo $core->primeira_cor;?>' title='<?php echo lang('BUSCAR');?>'><i class='fa fa-search'>&nbsp;&nbsp;</i><?php echo lang('BUSCAR');?></a>
													</div>
												</div>
											</div>
										</div>
									</div>
								</div>
							</form>
						</div>
						<div class="portlet-body">
							<table class="table table-bordered table-condensed table-advance dataTable-asc">
								<thead>
									<tr>
										<th>#</th>
										<th>#</th>
										<th><?php echo lang('DATA');?></th>
										<th><?php echo lang('CLINICA');?></th>
										<th><?php echo lang('PACIENTE');?></th>
										<th><?php echo lang('MEDICO');?></th>
										<th width="100px"><?php echo lang('PROCEDIMENTO');?></th>
										<th><?php echo lang('STATUS');?></th>
										<th><?php echo lang('VALOR');?></th>
										<th><?php echo lang('ACOES');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
									$total_valor = 0;
									$total_repasse = 0;
									$retorno_row = $atendimento->getAgendaNaoPagos($dataini, $datafim, $id_medico, $id_empresa);
									if($retorno_row):
										foreach ($retorno_row as $exrow):									
											$class = 'warning';
											$status = 0;
											$valor_pago = $exrow->valor_tabela;	
											$valor_repasse = $exrow->valor_repasse;	
											if($exrow->realizado == 1) {
												if($exrow->pago == 1 or $exrow->pago == 9) {
													$status = 1;
													if($exrow->guia > 0) {
														$class = 'class="info"';
														if(!$exrow->numero_guia) {
															$status = 12;
															$class = 'class="warning"';
														}
													}
												} else {
													$status = 11;
												}
											}elseif($exrow->realizado == 2) {
												$status = 2;
											}elseif($exrow->realizado == 6) {
												$status = 6;
											}elseif($exrow->retorno == 2) {
												$status = 10;
											}elseif($exrow->pago == 1) {
												$status = 4;
											}elseif($exrow->pago == 2) {
												$status = 5;
											}elseif($exrow->realizado == 3) {
												$status = 3;
											}
											if($exrow->realizado == 9) {
												$class = 'class="danger"';
												$status = 9;
											}
											if($exrow->pago != 1) {
												if($exrow->id_convenio) {
													$valor_convenio = getValue('valor_convenio', 'tabela_convenio', 'id_tabela='.$exrow->id_tabela.' AND id_cadastro='.$exrow->id_convenio);
													$valor_pago = ($valor_convenio) ? $valor_convenio : $exrow->valor;
												} else {
													$valor_pago = $exrow->valor;				  
												}
											}
								?>
									<tr <?php echo $class;?>>
										<td><?php echo $exrow->controle;?></td>
										<td><?php echo $exrow->id;?></td>
										<td><?php echo exibedataHora($exrow->data_agenda);?></td>
										<td><?php echo $exrow->clinica;?></td>
										<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
										<td><?php echo $exrow->medico;?></td>
										<td><?php echo $exrow->procedimento;?></td>
										<td><?php echo statusAgenda($status);?></td>
										<td><?php echo moeda($exrow->valor_atendimento);?></td>
										<td>	
										<?php if($exrow->pago == 1 and $exrow->realizado != 1):?>
											<a href="javascript:void(0);" class="btn btn-icon-only purple realizaragenda" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_REALIZAR').$exrow->procedimento;?>"><i class="fa fa-check-square-o"></i></a>
										<?php endif;?>														
										<?php if($usuario->is_Master() and $exrow->realizado != 9):?>
											<a href="javascript:void(0);" class="btn btn-icon-only red cancelaragenda" id="<?php echo $exrow->id;?>" title="<?php echo lang('AGENDA_CANCELAR').$exrow->procedimento;?>"><i class="fa fa-ban"></i></a>
										<?php endif;?>
										</td>
									</tr>
								<?php 
										endforeach;?>
								<?php unset($exrow);
									 endif;?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "dremensal": 
$ano = (get('ano')) ? get('ano') : '';
$mes = (get('mes')) ? get('mes') : date('m/Y');
$id_empresa = (get('id_empresa')) ? get('id_empresa') : 0;

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#ano').click(function() {
			var ano = $("#ano").val();
			window.location.href = 'index.php?do=gestao&acao=dreanual&ano='+ ano;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#mes').click(function() {
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=dremensal&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;&nbsp;<small><?php echo lang('GESTAO_DRE_MENSAL');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->				
					<div class="portlet light">
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<?php 
												$retorno_row = $gestao->getListaMes("despesa", "data_pagamento", false, "DESC");
										?>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
												if ($retorno_row):
													foreach ($retorno_row as $srow):
										?>				
														<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo $srow->mes_ano;?></option>
										<?php
													endforeach;
													unset($srow);
												endif;
										?>
									</select>
								</div>
							</form>
						</div>
					</div>
<?php		
	$conta = '';
	$valor = '';
	$valor_receita = '';
	$valor_despesa = '';
	$total_receita = $gestao->getDREReceitaMensalTotal($mes, $id_empresa);
	$total_receita = ($total_receita) ? $total_receita : 0;
	$total_despesa = 0;
	$conta .= "'RECEITAS'";
	$valor_receita .= $total_receita;
	$valor_despesa .= 0;
	$despesa_row = $gestao->getDREDespesaMensal($mes, $id_empresa);
	foreach ($despesa_row as $drow){
		if(strlen($conta) > 0) {
				$conta .= ",";
				$valor_receita .= ",";
				$valor_despesa .= ",";
		}
		$id_pai = $drow->id_pai;
		$pai = $drow->conta_pai;
		$total_despesa += $total = ($drow->total) ? $drow->total : 0;
		$conta .= "'".$pai."'";
		$valor_receita .= 0;
		$valor_despesa .= $total;
	}
	unset($drow);
	$outrasdespesas = $gestao->getDREDespesaMensalTotal($mes, $id_empresa);
	$outrasdespesas = ($outrasdespesas) ? $outrasdespesas : 0;
	$outrasdespesas = $outrasdespesas - $total_despesa;
	$conta .= ",'OUTRAS DESPESAS'";
	$valor_receita .= ',0';
	$valor_despesa .= ','.$outrasdespesas;
?>
<script type="text/javascript">
 $(document).ready(function(){
  var s1 = [<?php print $valor_receita;?>];
  var s2 = [<?php print $valor_despesa;?>];
  var cat = [<?php print $conta;?>];
		
  chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart',
                backgroundColor: '#F8F8F8',
				marginTop: 20,
				marginLeft: 80,
                marginBottom: 200,
				zoomType: 'xy'
            },
			credits: {
				enabled: false
			},
            title: {
                text: '',
                x: 0, //center
				y: 10
            },
			xAxis: {
				categories: cat,
				labels: {
					rotation: -45,
					style: {
						fontSize: '10px',
						fontFamily: 'Verdana, sans-serif'
					}
				}
			},
            yAxis: {		
				title: {
                    text: null
                },
				labels: {
                    align: 'left',
                    x: -60,
                    y: -3,
                    formatter: function() {
                        return 'R$ ' + Highcharts.numberFormat(this.value, 2, ',', '.');
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            tooltip: {
                formatter: function() {
                        return '<b>'+ this.series.name +'</b><br/>'+
                        this.x +': R$ '+ Highcharts.numberFormat(this.y, 2, ',', '.');
                }
            },
            legend: {
                layout: 'horizontal',
                backgroundColor: '#FFFFFF',
                align: 'left',
                verticalAlign: 'top',
                x: 100,
                y: 10,
                floating: true,
                shadow: true
            },
			plotOptions: {
                column: {
                    pointPadding: 0.2,
                    borderWidth: 0
                }
            },
            series: [{
                name: 'Receitas',
				color: '#2f8417',
				type: 'column',
                data: s1
            },{
                name: 'Despesas',
				color: '#e3000f',
				type: 'column',
                data: s2
            }]
        }); 
});
</script>
			

<?php
	$pieAnalise = "{name: 'Receitas', y: ".$total_receita.", color: '#2f8417'},";
	$pieAnalise .= "{name: 'Despesas', y: ".$total_despesa.", color: '#e3000f'}";
?>

<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart2',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: null
            },
            tooltip: {
        	    pointFormat: '{series.name}: <b>{point.percentage:.2f}%</b>',
            	percentageDecimals: 2
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: '<?php echo lang('GESTAO_RECEITA_DESPESA');?>',
                data: [
                    <?php print $pieAnalise;?>
                ]
            }]
        });
    });
    
});
</script>

<?php
	$pieDespesas = '';
	$retorno_row = $gestao->getDREDespesaAPagar($id_empresa);
	if($retorno_row) {
		foreach ($retorno_row as $exrow) {
			$pieDespesas .= "{name: '".exibeMesAno($exrow->mes_ano, true, true)."', y: ".$exrow->total.", z: '".moeda($exrow->total)."'},";
		}
	}
	unset($exrow);
	$pieDespesas = substr($pieDespesas, 0, -1);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
		
		// Radialize the colors
		Highcharts.setOptions({
			colors: Highcharts.map(Highcharts.getOptions().colors, function (color) {
				return {
					radialGradient: {
						cx: 0.5,
						cy: 0.3,
						r: 0.7
					},
					stops: [
						[0, color],
						[1, Highcharts.Color(color).brighten(-0.3).get('rgb')] // darken
					]
				};
			})
		});
		
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart3',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: null
            },
            tooltip: {
			headerFormat: '',
			pointFormat: '<span style="color:{point.color}">\u25CF</span> <b> {point.name}</b><br/>' +
				'Valor: <b>{point.z}</b><br/>' +
				'Percentual: <b>{point.percentage:.2f}%</b><br/>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: '<?php echo lang('GESTAO_DESPESAS_APAGAR');?>',
                data: [
                    <?php print $pieDespesas;?>
                ]
            }]
        });
    });
    
});
</script>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-bar-chart-o font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_DRE_MENSAL')." em ".$mes;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart" class="chart"></div>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
			<div class="row">
				<div class="col-md-6">
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-pie-chart font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_RECEITA_DESPESA')." em ".$mes;?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart2" class="chart"></div>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
				<div class="col-md-6">
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-pie-chart font-<?php echo $core->primeira_cor;?>"></i>								
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('GESTAO_DESPESAS_APAGAR');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<div id="chart3" class="chart"></div>
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "convenio": 
  $mes = (get('mes')) ? get('mes') : date('m/Y'); 
  $id_empresa = get('id_empresa');
  $atendimento_row = $gestao->getAtendimentosMensal($mes, $id_empresa);

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=convenio&id_empresa='+ id_empresa + '&mes='+ mes;
		});
		$('#mes').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=convenio&id_empresa='+ id_empresa + '&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;&nbsp;<small><?php echo lang('ATENDIMENTOS_CONVENIO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->				
					<div class="portlet light">						
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_TODOS');?></p>
											</div>
										</div>	
									</div>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
									&nbsp;&nbsp;
									<select class="select2me form-control input-large" id="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $empresa->getEmpresas();
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
							</form>
						</div>	
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_CONVENIO');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('CONVENIO');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
										<th><strong><?php echo lang('ACOES');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$pieparticipacao = '';
										$percentual = '';
										$convenio = '';
										$retorno_row = $gestao->getConvenios($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$pieparticipacao .= "{name: '".$exrow->nome."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($convenio) > 0) {
											$convenio .= ",";
											$percentual .= ",";
										}
										$convenio .= "'".$exrow->nome."'";
								?>
									<tr>
										<td><?php echo ($exrow->id_convenio > 0) ? $exrow->nome : "PARTICULAR";?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
										<td>
											<a href="javascript:void(0);" class="btn btn-icon-only grey-cascade" onclick="javascript:void window.open('ver_atendimento_convenio.php?data=<?php echo $mes;?>&id_empresa=<?php echo $id_empresa;?>&id_convenio=<?php echo $exrow->id_convenio;?>','<?php echo lang('ATENDIMENTOS_CONVENIO').' - '.$exrow->nome;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
<?php
	$pieparticipacao = substr($pieparticipacao, 0, -1);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
				
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart9',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: 'Participação no faturamento'
            },
            tooltip: {
			headerFormat: '',
			pointFormat: '<span style="color:{point.color}">\u25CF</span> <b> {point.name}</b><br/>' +
				'Valor: <b>{point.z}</b><br/>' +
				'Percentual: <b>{point.percentage:.2f}%</b><br/>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Participação no faturamento',
                data: [
                    <?php print $pieparticipacao;?>
                ]
            }]
        });
    });
    
});
</script>
						<div class="portlet-body">	
							<div class="row">
								<div class="col-md-12">
									<div id="chart9" class="chart" style="height: 500px"></div>	
								</div>	
							</div>	
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "colaborador": 
  $mes = (get('mes')) ? get('mes') : date('m/Y'); 
  $id_empresa = get('id_empresa');
  $atendimento_row = $gestao->getAtendimentosMensal($mes, $id_empresa);

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=colaborador&id_empresa='+ id_empresa + '&mes='+ mes;
		});
		$('#mes').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=colaborador&id_empresa='+ id_empresa + '&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;&nbsp;<small><?php echo lang('ATENDIMENTOS_COLABORADOR');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->				
					<div class="portlet light">						
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
									&nbsp;&nbsp;
									<select class="select2me form-control input-large" id="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $empresa->getEmpresas();
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
							</form>
						</div>	
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_COLABORADOR');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('COLABORADOR');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('VALOR_REPASSE');?></strong></th>
										<th><strong><?php echo lang('MARGEM');?></strong></th>
										<th><strong><?php echo lang('PERCENTUAL');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
										<th><strong><?php echo lang('ACOES');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$total_repasse = 0;
										$piefaturamento = '';
										$pieparticipacao = '';
										$percentual = '';
										$colaborador = '';
										$retorno_row = $gestao->getColaboradores($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$total_repasse += $exrow->valor_repasse;
										$piefaturamento .= "{name: '".$exrow->nome."', y: ".$exrow->valor_repasse.", z: '".moeda($exrow->valor_repasse)."'},";
										$pieparticipacao .= "{name: '".$exrow->nome."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($colaborador) > 0) {
											$colaborador .= ",";
											$percentual .= ",";
										}
										$colaborador .= "'".$exrow->nome."'";
										$valor_percentual = ($exrow->valor_tabela > 0) ? ($exrow->valor_tabela-$exrow->valor_repasse)/ $exrow->valor_tabela*100 : 0;
										$percentual .= $valor_percentual;
								?>
									<tr>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo moeda($exrow->valor_repasse);?></td>
										<td><?php echo moeda($exrow->valor_tabela-$exrow->valor_repasse);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela-$exrow->valor_repasse, $exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
										<td>
											<a href="javascript:void(0);" class="btn btn-icon-only grey-cascade" onclick="javascript:void window.open('ver_atendimento_colaborador.php?data=<?php echo $mes;?>&id_empresa=<?php echo $id_empresa;?>&id_medico=<?php echo $exrow->id_medico;?>','<?php echo lang('ATENDIMENTOS_COLABORADOR').' - '.$exrow->nome;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td><strong><?php echo moeda($total_repasse);?></strong></td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
<?php
	$pieparticipacao = substr($pieparticipacao, 0, -1);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
				
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart8',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: 'Participação no faturamento'
            },
            tooltip: {
			headerFormat: '',
			pointFormat: '<span style="color:{point.color}">\u25CF</span> <b> {point.name}</b><br/>' +
				'Valor: <b>{point.z}</b><br/>' +
				'Percentual: <b>{point.percentage:.2f}%</b><br/>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Participação no faturamento',
                data: [
                    <?php print $pieparticipacao;?>
                ]
            }]
        });
    });
    
});
</script>
						<div class="portlet-body">	
							<div class="row">
								<div class="col-md-12">
									<div id="chart8" class="chart" style="height: 500px"></div>	
								</div>	
							</div>	
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "agendausuario": 
  $mes = (get('mes')) ? get('mes') : date('m/Y'); 
  $id_empresa = get('id_empresa');
  $atendimento_row = $gestao->getAtendimentosMensal($mes, $id_empresa);

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=agendausuario&id_empresa='+ id_empresa + '&mes='+ mes;
		});
		$('#mes').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=agendausuario&id_empresa='+ id_empresa + '&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;&nbsp;<small><?php echo lang('ATENDIMENTOS_USUARIO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->				
					<div class="portlet light">						
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
									&nbsp;&nbsp;
									<select class="select2me form-control input-large" id="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $empresa->getEmpresas();
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
							</form>
						</div>	
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_USUARIO');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<table class="table table-bordered table-condensed dataTable">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('USUARIO');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
										<th><strong><?php echo lang('ACOES');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$pieparticipacao = '';
										$percentual = '';
										$usuario_agenda = '';
										$retorno_row = $gestao->getAtendimentosUsuario($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$pieparticipacao .= "{name: '".$exrow->nome."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($usuario_agenda) > 0) {
											$usuario_agenda .= ",";
											$percentual .= ",";
										}
										$usuario_agenda .= "'".$exrow->nome."'";
								?>
									<tr>
										<td><?php echo $exrow->nome;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
										<td>
											<a href="javascript:void(0);" class="btn btn-icon-only grey-cascade" onclick="javascript:void window.open('ver_atendimento_usuario.php?data=<?php echo $mes;?>&id_empresa=<?php echo $id_empresa;?>&usuario_agenda=<?php echo $exrow->usuario_agenda;?>','<?php echo lang('ATENDIMENTOS_USUARIO').' - '.$exrow->nome;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php   endforeach;?>
								</tbody>
								<tfoot>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tfoot>
							</table>
						</div>
<?php
	$pieparticipacao = substr($pieparticipacao, 0, -1);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
				
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart8',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: 'Participação no faturamento'
            },
            tooltip: {
			headerFormat: '',
			pointFormat: '<span style="color:{point.color}">\u25CF</span> <b> {point.name}</b><br/>' +
				'Valor: <b>{point.z}</b><br/>' +
				'Percentual: <b>{point.percentage:.2f}%</b><br/>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Participação no faturamento',
                data: [
                    <?php print $pieparticipacao;?>
                ]
            }]
        });
    });
    
});
</script>
						<div class="portlet-body">	
							<div class="row">
								<div class="col-md-12">
									<div id="chart8" class="chart" style="height: 500px"></div>	
								</div>	
							</div>	
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "pagamento": 
  $mes = (get('mes')) ? get('mes') : date('m/Y'); 
  $id_empresa = get('id_empresa');
  $atendimento_row = $gestao->getAtendimentosMensal($mes, $id_empresa);

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=pagamento&id_empresa='+ id_empresa + '&mes='+ mes;
		});
		$('#mes').click(function() {
			var id_empresa = $("#id_empresa").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=pagamento&id_empresa='+ id_empresa + '&mes='+ mes;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;&nbsp;<small><?php echo lang('ATENDIMENTOS_PAGAMENTO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->				
					<div class="portlet light">						
						<div class="portlet-body">
							<form class="form-inline">
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
									&nbsp;&nbsp;
									<select class="select2me form-control input-large" id="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $empresa->getEmpresas();
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
							</form>
						</div>	
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_PAGAMENTO');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('PAGAMENTO');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR');?></strong></th>
										<th><strong><?php echo lang('VALOR_DESCONTO');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('VALOR_TAXA');?></strong></th>
										<th><strong><?php echo lang('VALOR_LIQUIDO');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
										<th><strong><?php echo lang('ACOES');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_taxa = 0;
										$total_liquido = 0;
										$total_atendimentos = 0;
										$pieparticipacao = '';
										$percentual = '';
										$pagamento = '';
										$retorno_row = $gestao->getPagamentos($mes, $id_empresa);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_pago;
			  							$taxa = getValue('taxa', 'tipo_pagamento', 'id='.$exrow->id_tipo);
										$valor_taxa = 0;
										$valor_liquido = $exrow->valor_pago;
										if($taxa > 0) {
											$valor_taxa = $valor_liquido*$taxa/100;
											$valor_liquido = $valor_liquido - $valor_taxa;			
										}
										$total_taxa += $valor_taxa;
										$total_liquido += $valor_liquido;
										$pieparticipacao .= "{name: '".$exrow->pagamento."', y: ".$exrow->valor_pago.", z: '".moeda($exrow->valor_pago)."'},";
										if(strlen($pagamento) > 0) {
											$pagamento .= ",";
											$percentual .= ",";
										}
										$pagamento .= "'".$exrow->pagamento."'";
								?>
									<tr>
										<td><?php echo $exrow->pagamento;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor);?></td>
										<td><?php echo moeda($exrow->valor_desconto);?></td>
										<td><?php echo moeda($exrow->valor_pago);?></td>
										<td><?php echo moeda($valor_taxa);?></td>
										<td><?php echo moeda($valor_liquido);?></td>
										<td><?php echo fpercentual($exrow->valor_pago, $atendimento_row->valor_tabela);?></td>
										<td>
											<a href="javascript:void(0);" class="btn btn-icon-only grey-cascade" onclick="javascript:void window.open('ver_atendimento_pagamentos.php?data=<?php echo $mes;?>&id_empresa=<?php echo $id_empresa;?>&id_tipo=<?php echo $exrow->id_tipo;?>','<?php echo lang('ATENDIMENTOS_PAGAMENTO').' - '.$exrow->pagamento;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td><strong><?php echo $quant;?></strong></td>
										<td>-</td>
										<td>-</td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td><strong><?php echo moeda($total_taxa);?></strong></td>
										<td><strong><?php echo moeda($total_liquido);?></strong></td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
<?php
	$pieparticipacao = substr($pieparticipacao, 0, -1);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
				
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart8',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: 'Participação no faturamento'
            },
            tooltip: {
			headerFormat: '',
			pointFormat: '<span style="color:{point.color}">\u25CF</span> <b> {point.name}</b><br/>' +
				'Valor: <b>{point.z}</b><br/>' +
				'Percentual: <b>{point.percentage:.2f}%</b><br/>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Participação no faturamento',
                data: [
                    <?php print $pieparticipacao;?>
                ]
            }]
        });
    });
    
});
</script>
						<div class="portlet-body">	
							<div class="row">
								<div class="col-md-12">
									<div id="chart8" class="chart" style="height: 500px"></div>	
								</div>	
							</div>	
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "procedimento": 
  $mes = (get('mes')) ? get('mes') : date('m/Y'); 
  $id_empresa = get('id_empresa');
  $id_especialidade = get('id_especialidade');
  $atendimento_row = $gestao->getAtendimentosMensal($mes, $id_empresa);

?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#id_empresa').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_especialidade = $("#id_especialidade").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=procedimento&id_empresa='+ id_empresa + '&mes='+ mes + '&id_especialidade='+ id_especialidade;
		});
		$('#id_especialidade').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_especialidade = $("#id_especialidade").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=procedimento&id_empresa='+ id_empresa + '&mes='+ mes + '&id_especialidade='+ id_especialidade;
		});
		$('#mes').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_especialidade = $("#id_especialidade").val();
			var mes = $("#mes").val();
			window.location.href = 'index.php?do=gestao&acao=procedimento&id_empresa='+ id_empresa + '&mes='+ mes + '&id_especialidade='+ id_especialidade;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;&nbsp;<small><?php echo lang('ATENDIMENTOS_PROCEDIMENTO');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<!-- INICIO TABELA -->				
					<div class="portlet light">						
						<div class="portlet-body">
							<form class="form-inline">
									<div class="row">
										<div class="col-md-12">		
											<div class="note note-warning">
												<p><?php echo lang('AVISO_ATENDIMENTO_REALIZADOS');?></p>
											</div>
										</div>	
									</div>
									<select class="select2me form-control input-large" name="mes" id="mes" data-placeholder="<?php echo lang('SELECIONE_MES');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $gestao->getListaMes("receita", "data_pagamento", false, "DESC");
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->mes_ano;?>" <?php if($srow->mes_ano == $mes) echo 'selected="selected"';?>><?php echo exibeMesAno($srow->mes_ano, true, true);?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
									&nbsp;&nbsp;
									<select class="select2me form-control input-large" id="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $empresa->getEmpresas();
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
												<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
										<?php
												endforeach;
												unset($srow);
											endif;
										?>
									</select>
									&nbsp;&nbsp;
									<select class="select2me form-control input-large" id="id_especialidade" name="id_especialidade" data-placeholder="<?php echo lang('SELECIONE_ESPECIALIDADE');?>" >
										<option value=""></option>
										<?php 
											$retorno_row = $cadastro->getEspecialidades();
											if ($retorno_row):
												foreach ($retorno_row as $srow):
										?>
													<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_especialidade) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
										<?php
												endforeach;
												unset($srow);
												endif;
										?>
									</select>
							</form>
						</div>	
					</div>
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-list font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_PROCEDIMENTO');?></span>
							</div>
						</div>	
						<div class="portlet-body">
							<table class="table table-bordered table-condensed">
								<thead>
									<tr class="disabled">
										<th><strong><?php echo lang('PROCEDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('ESPECIALIDADE');?></strong></th>
										<th><strong><?php echo lang('ATENDIMENTOS');?></strong></th>
										<th><strong><?php echo lang('VALOR_PAGO');?></strong></th>
										<th><strong><?php echo lang('PARTICIPACAO');?></strong></th>
										<th><strong><?php echo lang('ACOES');?></strong></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$quant = 0;
										$total_atendimentos = 0;
										$pieparticipacao = '';
										$percentual = '';
										$procedimento = '';
										$retorno_row = $gestao->getProcedimentos($mes, $id_empresa, $id_especialidade);
										if($retorno_row):
										foreach ($retorno_row as $exrow):
										$quant += $exrow->quant;
										$total_atendimentos += $exrow->valor_tabela;
										$pieparticipacao .= "{name: '".$exrow->procedimento."', y: ".$exrow->valor_tabela.", z: '".moeda($exrow->valor_tabela)."'},";
										if(strlen($procedimento) > 0) {
											$procedimento .= ",";
											$percentual .= ",";
										}
										$procedimento .= "'".$exrow->procedimento."'";
										$valor_percentual = ($exrow->valor_tabela > 0) ? ($exrow->valor_tabela-$exrow->valor_repasse)/ $exrow->valor_tabela*100 : 0;
										$percentual .= $valor_percentual;
								?>
									<tr>
										<td><?php echo $exrow->procedimento;?></td>
										<td><?php echo $exrow->especialidade;?></td>
										<td><?php echo $exrow->quant;?></td>
										<td><?php echo moeda($exrow->valor_tabela);?></td>
										<td><?php echo fpercentual($exrow->valor_tabela, $atendimento_row->valor_tabela);?></td>
										<td>
											<a href="javascript:void(0);" class="btn btn-icon-only grey-cascade" onclick="javascript:void window.open('ver_atendimento_procedimento.php?data=<?php echo $mes;?>&id_empresa=<?php echo $id_empresa;?>&id_tabela=<?php echo $exrow->id_tabela;?>','<?php echo lang('ATENDIMENTOS_PROCEDIMENTO').' - '.$exrow->procedimento;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=1,resizable=1,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>"><i class="fa fa-search"></i></a>
										</td>
									</tr>
								<?php   endforeach;?>
									<tr>
										<td><strong><?php echo lang('TOTAL');?></strong></td>
										<td>-</td>
										<td><strong><?php echo $quant;?></strong></td>
										<td><strong><?php echo moeda($total_atendimentos);?></strong></td>
										<td>-</td>
										<td>-</td>
									</tr>
								<?php unset($exrow);
									  endif;
								?>
								</tbody>
							</table>
						</div>
<?php
	$pieparticipacao = substr($pieparticipacao, 0, -1);
?>
<script type="text/javascript">
 $(function () {
    var chart;
    $(document).ready(function() {
				
		// Build the chart
        chart = new Highcharts.Chart({
            chart: {
                renderTo: 'chart8',
                plotBackgroundColor: null,
                plotBorderWidth: null,
                plotShadow: false
            },
			credits: {
				enabled: false
			},
			title: {
                text: 'Participação no faturamento'
            },
            tooltip: {
			headerFormat: '',
			pointFormat: '<span style="color:{point.color}">\u25CF</span> <b> {point.name}</b><br/>' +
				'Valor: <b>{point.z}</b><br/>' +
				'Percentual: <b>{point.percentage:.2f}%</b><br/>'
            },
            plotOptions: {
                pie: {
                    allowPointSelect: true,
                    cursor: 'pointer',
                    dataLabels: {
                        enabled: true,
                        color: '#000000',
                        connectorColor: '#000000'
                    }
                }
            },
			lang: {
				downloadPNG: 'Download da imagem em PNG',
				downloadJPEG: 'Download da imagem em JPEG',
				downloadPDF: 'Download da imagem em PDF',
				downloadSVG: 'Download da imagem em SVG',
				exportButtonTitle: 'Exportar o traçado ou vetor da imagem',
				loading: 'Carregando...',
				months: ['Janeiro', 'Fevereiro', 'Março', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro'],
				shortMonths: ['Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez'],
				printButtonTitle: 'Imprimir o gráfico',
				resetZoom: 'Retirar zoom',
				resetZoomTitle: 'Retirar zoom 1:1',
				weekdays: ['Domingo', 'Segunda', 'Terça', 'Quarta', 'Quinta', 'Sexta', 'Sábado']
			},
            series: [{
                type: 'pie',
                name: 'Participação no faturamento',
                data: [
                    <?php print $pieparticipacao;?>
                ]
            }]
        });
    });
    
});
</script>
						<div class="portlet-body">	
							<div class="row">
								<div class="col-md-12">
									<div id="chart8" class="chart" style="height: 500px"></div>	
								</div>	
							</div>	
						</div>
						<!-- FINAL CONTEUDO DA PAGINA -->						
					</div>
					<!-- FINAL TABELA -->
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php case "aniversariantes":
$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
$whatsapp = (session('idempresa')) ? getValue('whatsapp', 'empresa', 'id='.session('idempresa')) : '';
?>
<?php if(!$usuario->is_Administrativo()): print Filter::warning(lang('NAOAUTORIZADO')); return; endif;?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=aniversariantes&dataini='+ dataini + '&datafim='+ datafim;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#whatsapp').click(function() {
			$.bootstrapGrowl("EM PROCESSAMENTO!", {
				ele: "body", 
				type: "warning", 
				offset: {
					from: "top",
					amount: 50
					}, 
					align: "left", 
					width: "auto",
					delay: 1000,
					delay: 10000,
					allow_dismiss: true,
					stackup_spacing: 10 
			});	
			jQuery.ajax({
				type: 'POST',
				url: 'controller.php',
				data: 'enviarWhatsappAniversario=1&dataini='+ dataini + '&datafim='+ datafim,
				success: function( data )
				{
					var response = data.split("#");
					$.bootstrapGrowl(response[0], {
						ele: "body", 
						type: response[1], // (null, 'info', 'danger', 'success', 'warning')
						offset: {
							from: "top",
							amount: 50
						}, 
						align: "left", 
						width: "auto",
						delay: 10000,
						allow_dismiss: true,
						stackup_spacing: 10 
					});
				}				
			});
			return false;	
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ANIVERSARIANTES');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-send font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ANIVERSARIANTES');?></span>
							</div>
							<div class="actions btn-set">
							<?php if ($whatsapp): ?>
								<button type="button" id="whatsapp" class="btn green-jungle"><i class='fa fa-whatsapp'>&nbsp;&nbsp;</i><?php echo lang('ENVIAR_WHATSAPP');?></button>
							<?php endif;?>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body">
							<table class="table table-striped table-condensed dataTable ">
								<thead >
									<tr>
										<th><?php echo lang('PACIENTE');?></th>
										<th><?php echo lang('IDADE');?></th>
										<th><?php echo lang('DATA_NASC');?></th>
										<th><?php echo lang('TELEFONE');?></th>
										<th><?php echo lang('BAIRRO');?></th>
										<th><?php echo lang('CIDADE');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$retorno_row = $paciente->getCelularAniversarios($dataini, $datafim);
										if($retorno_row):
										foreach ($retorno_row as $exrow):?>
									<tr>
										<td><a href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id;?>"><?php echo $exrow->nome;?></a></td>
										<td><?php echo anos($exrow->data_nasc);?></td>
										<td><?php echo exibedata($exrow->data_nasc);?></td>
										<td><?php echo $exrow->telefone." ".$exrow->celular;?></td>
										<td><?php echo $exrow->bairro;?></td>
										<td><?php echo $exrow->cidade;?></td>
									</tr>
								<?php endforeach;?>
								<?php unset($exrow);
									  endif;?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "boasvindas":
$dataini = (get('dataini')) ? get('dataini') : date('d/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('d/m/Y'); 
$whatsapp = (session('idempresa')) ? getValue('whatsapp', 'empresa', 'id='.session('idempresa')) : '';
?>
<?php if(!$usuario->is_Administrativo()): print Filter::warning(lang('NAOAUTORIZADO')); return; endif;?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=boasvindas&dataini='+ dataini + '&datafim='+ datafim;
		});
	});
	// ]]>
</script>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#whatsapp').click(function() {
			$.bootstrapGrowl("EM PROCESSAMENTO!", {
				ele: "body", 
				type: "warning", 
				offset: {
					from: "top",
					amount: 50
					}, 
					align: "left", 
					width: "auto",
					delay: 1000,
					delay: 10000,
					allow_dismiss: true,
					stackup_spacing: 10 
			});	
			jQuery.ajax({
				type: 'POST',
				url: 'controller.php',
				data: 'enviarWhatsappBemVindo=1&dataini='+ dataini + '&datafim='+ datafim,
				success: function( data )
				{
					var response = data.split("#");
					$.bootstrapGrowl(response[0], {
						ele: "body", 
						type: response[1], // (null, 'info', 'danger', 'success', 'warning')
						offset: {
							from: "top",
							amount: 50
						}, 
						align: "left", 
						width: "auto",
						delay: 10000,
						allow_dismiss: true,
						stackup_spacing: 10 
					});
				}				
			});
			return false;	
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ENVIAR_BOAS_VINDAS');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-send font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ENVIAR_BOAS_VINDAS');?></span>
							</div>
							<div class="actions btn-set">
							<?php if ($whatsapp): ?>
								<button type="button" id="whatsapp" class="btn green-jungle"><i class='fa fa-whatsapp'>&nbsp;&nbsp;</i><?php echo lang('ENVIAR_WHATSAPP');?></button>
							<?php endif;?>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body">
							<table class="table table-striped table-condensed dataTable ">
								<thead >
									<tr>
										<th><?php echo lang('PACIENTE');?></th>
										<th><?php echo lang('IDADE');?></th>
										<th><?php echo lang('DATA_NASC');?></th>
										<th><?php echo lang('TELEFONE');?></th>
										<th><?php echo lang('BAIRRO');?></th>
										<th><?php echo lang('CIDADE');?></th>
									</tr>
								</thead>
								<tbody>
								<?php 	
										$retorno_row = $paciente->getCelularBemVindo($dataini, $datafim);
										if($retorno_row):
										foreach ($retorno_row as $exrow):?>
									<tr>
										<td><a href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id;?>"><?php echo $exrow->nome;?></a></td>
										<td><?php echo anos($exrow->data_nasc);?></td>
										<td><?php echo exibedata($exrow->data_nasc);?></td>
										<td><?php echo $exrow->telefone." ".$exrow->celular;?></td>
										<td><?php echo $exrow->bairro;?></td>
										<td><?php echo $exrow->cidade;?></td>
									</tr>
								<?php endforeach;?>
								<?php unset($exrow);
									  endif;?>
								</tbody>
							</table>
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php case "cancelados":
$id_empresa = get('id_empresa'); 
$dataini = (get('dataini')) ? get('dataini') : date('01/m/Y'); 
$datafim = (get('datafim')) ? get('datafim') : date('31/m/Y'); 
?>
<script type="text/javascript"> 
	// <![CDATA[  
	$(document).ready(function () {
		$('#buscar').click(function() {
			var id_empresa = $("#id_empresa").val();
			var id_convenio = $("#id_convenio").val();
			var dataini = $("#dataini").val();
			var datafim = $("#datafim").val();
			window.location.href = 'index.php?do=gestao&acao=cancelados&dataini='+ dataini + '&datafim='+ datafim + '&id_empresa='+ id_empresa;
		});
	});
	// ]]>
</script>
<!-- INICIO CONTEUDO DA PAGINA -->
<div class="page-container">
	<!-- INICIO CABECALHO DA PAGINA -->
	<div class="page-head">
		<div class="container">
			<!-- INICIO TITULO DA PAGINA -->
			<div class="page-title">
				<h1><?php echo lang('GESTAO');?>&nbsp;<i class="fa fa-angle-right"></i>&nbsp;<small><?php echo lang('ATENDIMENTOS_CANCELADOS');?></small></h1>
			</div>
			<!-- FINAL TITULO DA PAGINA -->
		</div>
	</div>
	<!-- FINAL CABECALHO DA PAGINA -->
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW FORMULARIO -->
			<div class="row">
				<div class="col-md-12">			
					<div class="portlet light">
						<div class="portlet-title">
							<div class="caption">
								<i class="fa fa-ban font-<?php echo $core->primeira_cor;?>"></i>
								<span class="font-<?php echo $core->primeira_cor;?>"><?php echo lang('ATENDIMENTOS_CANCELADOS');?></span>
							</div>
						</div>
						<div class="portlet-body">
							<form class="form-inline">
								<div class="form-group">
									<select class="select2me bs-select form-control input-large" id="id_empresa" name="id_empresa" data-placeholder="<?php echo lang('SELECIONE_EMPRESA');?>" >
											<option value=""></option>
											<?php 
												$retorno_row = $empresa->getEmpresas();
												if ($retorno_row):
													foreach ($retorno_row as $srow):
											?>
														<option value="<?php echo $srow->id;?>" <?php if($srow->id == $id_empresa) echo 'selected="selected"';?>><?php echo $srow->nome;?></option>
											<?php
													endforeach;
													unset($srow);
												endif;
											?>
										</select>
									<br/>
									<br/>
									<input type="text" class="form-control input-medium calendario data" name="dataini" id="dataini" value="<?php echo $dataini;?>" >
									&nbsp;&nbsp;
									<input type="text" class="form-control input-medium calendario data" name="datafim" id="datafim" value="<?php echo $datafim;?>" >
									&nbsp;&nbsp;
									<button type="button" id="buscar" class="btn <?php echo $core->primeira_cor;?>"><i class="fa fa-search"/></i> <?php echo lang('BUSCAR');?></button>
								</div>
							</form>
						</div>
						<div class="portlet-body util-btn-margin-bottom-5">
							<!-- INICIO UTIL-BTN-MARGIN-BOTTOM-5-->
								<div class="row">							
									<div class="col-md-12 col-sm-12">										
										<div>
											<table class="table table-bordered table-striped table-condensed table-advance dataTable ">
												<thead>
													<tr>
														<th><?php echo lang('DATA_AGENDA');?></th>
														<th><?php echo lang('PACIENTE_TITULO');?></th>
														<th><?php echo lang('CONVENIO');?></th>
														<th><?php echo lang('MEDICO');?></th>
														<th><?php echo lang('PROCEDIMENTO');?></th>
														<th><?php echo lang('DATA_CANCELADO');?></th>
														<th><?php echo lang('USUARIO');?></th>
														<th><?php echo lang('ACOES');?></th>
													</tr>
												</thead>
												<tbody>
												<?php 	
													$retorno_row = $atendimento->getAtendimentosCancelados($dataini, $datafim, $id_empresa);
													if($retorno_row):
														foreach ($retorno_row as $exrow):
												?>
													<tr>
														<td><?php echo exibedataHora($exrow->data_agenda_cancelada);?></td>
														<td><a target="_blank" href="index.php?do=paciente&acao=agenda&id=<?php echo $exrow->id_paciente;?>"><?php echo $exrow->paciente;?></a></td>
														<td><?php echo ($exrow->convenio) ? $exrow->convenio : "PARTICULAR";?></td>
														<td><?php echo $exrow->medico;?></td>
														<td><?php echo $exrow->procedimento;?></td>
														<td><?php echo exibedataHora($exrow->data_cancelamento);?></td>
														<td><?php echo $exrow->usuario;?></td>
														<td>
															<a href="javascript:void(0);" onclick="javascript:void window.open('ver_atendimento.php?id=<?php echo $exrow->id;?>','<?php echo lang('VISUALIZAR').$exrow->id;?>','width=800,height=600,toolbar=0,menubar=0,location=0,status=0,scrollbars=0,resizable=0,left=0,top=0');return false;" title="<?php echo lang('VISUALIZAR');?>" class="btn btn-icon-only grey-cascade"><i class="fa fa-search"></i></a></td>
													</tr>
												<?php 
														endforeach;?>
												</tbody>
												<?php unset($exrow);
													  endif;?>
											</table>
										</div>
									</div>
								</div>
							<!-- FINAL UTIL-BTN-MARGIN-BOTTOM-5-->
						</div>
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW FORMULARIO -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<!-- FINAL CONTEUDO DA PAGINA -->
<?php break;?>
<?php default: ?>
<div class="page-container">
	<!-- INICIO DOS MODULOS DA PAGINA -->
	<div class="page-content">
		<div class="container">
			<!-- INICIO DO ROW TABELA -->
			<div class="row">
				<div class="col-md-12">
					<div class="imagem-fundo">
						<img src="assets/img/bg-white.png" border="0">
					</div>
				</div>
			</div>
			<!-- FINAL DO ROW TABELA -->
		</div>
	</div>
	<!-- FINAL DOS MODULOS DA PAGINA -->
</div>
<?php break;?>
<?php endswitch;?>